import vl, { useEffect as xr, useState as Ni } from "react";
import { WalletConnectModalSign as Vh } from "@walletconnect/modal-sign-html";
import _l from "events";
import { create as qh } from "zustand";
import { useQuery as Zh, QueryClient as Fh, QueryClientProvider as Wh } from "@tanstack/react-query";
import { getSdkError as bl } from "@walletconnect/utils";
import Kh from "debug";
import { ReactQueryDevtools as Hh } from "@tanstack/react-query-devtools";
const wl = [
  "decrypt",
  "disconnect",
  "getSelectedAccount",
  "getBalance",
  "getRecords",
  "requestCreateEvent",
  "getEvent",
  "getEvents",
  "createSharedState",
  "importSharedState",
  "requestSignature"
], Ao = ["aleo:1"], El = ["chainChanged", "accountSelected", "selectedAccountSynced", "sharedAccountSynced"], Bh = "f0aaeffe71b636da453fce042d79d723", Gh = {
  standaloneChains: Ao,
  enableExplorer: !1,
  enableAccountView: !0,
  enableNetworkView: !0,
  enableStandaloneMode: !0,
  mobileWallets: [
    {
      id: "puzzle",
      name: "Puzzle Wallet",
      links: {
        native: "puzzleapp://",
        universal: ""
      }
    }
  ],
  desktopWallets: [
    {
      id: "puzzle",
      name: "Puzzle Wallet",
      links: {
        native: "",
        universal: "https://walletconnect.puzzle.online/"
      }
    },
    {
      id: "avail",
      name: "Avail Wallet",
      links: {
        native: "avail://",
        universal: "https://avail.global"
      }
    }
  ],
  walletImages: {
    puzzle: "https://i.imgur.com/p9tHaFC.png",
    avail: "https://i.imgur.com/GxNn8BO.png"
  }
}, e5 = {
  requiredNamespaces: {
    aleo: {
      methods: wl,
      chains: Ao,
      events: El
    }
  }
}, Di = new _l();
let On;
function t5(t) {
  On = new Vh({
    projectId: Bh,
    metadata: {
      name: t.dAppName,
      description: t.dAppDescription,
      url: t.dAppUrl,
      icons: [t.dAppIconURL]
    },
    modalOptions: { ...Gh }
  }), window.localStorage.removeItem("WALLETCONNECT_DEEPLINK_CHOICE");
}
async function yt() {
  return new Promise((t) => {
    if (On)
      t(On);
    else {
      const e = setInterval(() => {
        On && (clearInterval(e), t(On));
      }, 200);
    }
    window.localStorage.removeItem("WALLETCONNECT_DEEPLINK_CHOICE");
  });
}
function Sl(t) {
  xr(() => (yt().then((e) => {
    e.onSessionDelete(t);
  }), () => {
    yt().then((e) => {
      e.offSessionDelete(t);
    });
  }), [t]);
}
function Yh(t) {
  xr(() => (yt().then((e) => {
    e.onSessionExpire(t);
  }), () => {
    yt().then((e) => {
      e.offSessionExpire(t);
    });
  }), [t]);
}
function Il(t) {
  xr(() => (yt().then((e) => {
    e.onSessionUpdate(t);
  }), () => {
    yt().then((e) => {
      e.offSessionUpdate(t);
    });
  }), [t]);
}
function pr() {
  const [t, e] = Ni(void 0);
  return Sl((r) => {
    r.topic === (t == null ? void 0 : t.topic) && e(void 0);
  }), Il((r) => {
    if (t && r.topic === (t == null ? void 0 : t.topic)) {
      const { namespaces: s } = r.params, n = { ...t, namespaces: s };
      e(n);
    }
  }), Yh((r) => {
    t && r.topic === (t == null ? void 0 : t.topic) && e(void 0);
  }), xr(() => {
    async function r() {
      const n = await (await yt()).getSession();
      e(n);
    }
    return r(), Di.on("session_change", r), () => {
      Di.off("session_change", r);
    };
  }, []), t;
}
function si(t) {
  xr(() => (yt().then((e) => {
    e.onSessionEvent(t);
  }), () => {
    yt().then((e) => {
      e.offSessionEvent(t);
    });
  }), [t]);
}
var Jh = { BASE_URL: "/", MODE: "production", DEV: !1, PROD: !0, SSR: !1 };
function Xh(t, e) {
  let r;
  try {
    r = t();
  } catch {
    return;
  }
  return {
    getItem: (n) => {
      var i;
      const o = (u) => u === null ? null : JSON.parse(u, e == null ? void 0 : e.reviver), a = (i = r.getItem(n)) != null ? i : null;
      return a instanceof Promise ? a.then(o) : o(a);
    },
    setItem: (n, i) => r.setItem(
      n,
      JSON.stringify(i, e == null ? void 0 : e.replacer)
    ),
    removeItem: (n) => r.removeItem(n)
  };
}
const kn = (t) => (e) => {
  try {
    const r = t(e);
    return r instanceof Promise ? r : {
      then(s) {
        return kn(s)(r);
      },
      catch(s) {
        return this;
      }
    };
  } catch (r) {
    return {
      then(s) {
        return this;
      },
      catch(s) {
        return kn(s)(r);
      }
    };
  }
}, Qh = (t, e) => (r, s, n) => {
  let i = {
    getStorage: () => localStorage,
    serialize: JSON.stringify,
    deserialize: JSON.parse,
    partialize: (C) => C,
    version: 0,
    merge: (C, M) => ({
      ...M,
      ...C
    }),
    ...e
  }, o = !1;
  const a = /* @__PURE__ */ new Set(), u = /* @__PURE__ */ new Set();
  let c;
  try {
    c = i.getStorage();
  } catch {
  }
  if (!c)
    return t(
      (...C) => {
        console.warn(
          `[zustand persist middleware] Unable to update item '${i.name}', the given storage is currently unavailable.`
        ), r(...C);
      },
      s,
      n
    );
  const h = kn(i.serialize), p = () => {
    const C = i.partialize({ ...s() });
    let M;
    const _ = h({ state: C, version: i.version }).then(
      (T) => c.setItem(i.name, T)
    ).catch((T) => {
      M = T;
    });
    if (M)
      throw M;
    return _;
  }, g = n.setState;
  n.setState = (C, M) => {
    g(C, M), p();
  };
  const v = t(
    (...C) => {
      r(...C), p();
    },
    s,
    n
  );
  let b;
  const S = () => {
    var C;
    if (!c)
      return;
    o = !1, a.forEach((_) => _(s()));
    const M = ((C = i.onRehydrateStorage) == null ? void 0 : C.call(i, s())) || void 0;
    return kn(c.getItem.bind(c))(i.name).then((_) => {
      if (_)
        return i.deserialize(_);
    }).then((_) => {
      if (_)
        if (typeof _.version == "number" && _.version !== i.version) {
          if (i.migrate)
            return i.migrate(
              _.state,
              _.version
            );
          console.error(
            "State loaded from storage couldn't be migrated since no migrate function was provided"
          );
        } else
          return _.state;
    }).then((_) => {
      var T;
      return b = i.merge(
        _,
        (T = s()) != null ? T : v
      ), r(b, !0), p();
    }).then(() => {
      M == null || M(b, void 0), o = !0, u.forEach((_) => _(b));
    }).catch((_) => {
      M == null || M(void 0, _);
    });
  };
  return n.persist = {
    setOptions: (C) => {
      i = {
        ...i,
        ...C
      }, C.getStorage && (c = C.getStorage());
    },
    clearStorage: () => {
      c == null || c.removeItem(i.name);
    },
    getOptions: () => i,
    rehydrate: () => S(),
    hasHydrated: () => o,
    onHydrate: (C) => (a.add(C), () => {
      a.delete(C);
    }),
    onFinishHydration: (C) => (u.add(C), () => {
      u.delete(C);
    })
  }, S(), b || v;
}, ep = (t, e) => (r, s, n) => {
  let i = {
    storage: Xh(() => localStorage),
    partialize: (S) => S,
    version: 0,
    merge: (S, C) => ({
      ...C,
      ...S
    }),
    ...e
  }, o = !1;
  const a = /* @__PURE__ */ new Set(), u = /* @__PURE__ */ new Set();
  let c = i.storage;
  if (!c)
    return t(
      (...S) => {
        console.warn(
          `[zustand persist middleware] Unable to update item '${i.name}', the given storage is currently unavailable.`
        ), r(...S);
      },
      s,
      n
    );
  const h = () => {
    const S = i.partialize({ ...s() });
    return c.setItem(i.name, {
      state: S,
      version: i.version
    });
  }, p = n.setState;
  n.setState = (S, C) => {
    p(S, C), h();
  };
  const g = t(
    (...S) => {
      r(...S), h();
    },
    s,
    n
  );
  let v;
  const b = () => {
    var S, C;
    if (!c)
      return;
    o = !1, a.forEach((_) => {
      var T;
      return _((T = s()) != null ? T : g);
    });
    const M = ((C = i.onRehydrateStorage) == null ? void 0 : C.call(i, (S = s()) != null ? S : g)) || void 0;
    return kn(c.getItem.bind(c))(i.name).then((_) => {
      if (_)
        if (typeof _.version == "number" && _.version !== i.version) {
          if (i.migrate)
            return i.migrate(
              _.state,
              _.version
            );
          console.error(
            "State loaded from storage couldn't be migrated since no migrate function was provided"
          );
        } else
          return _.state;
    }).then((_) => {
      var T;
      return v = i.merge(
        _,
        (T = s()) != null ? T : g
      ), r(v, !0), h();
    }).then(() => {
      M == null || M(v, void 0), v = s(), o = !0, u.forEach((_) => _(v));
    }).catch((_) => {
      M == null || M(void 0, _);
    });
  };
  return n.persist = {
    setOptions: (S) => {
      i = {
        ...i,
        ...S
      }, S.storage && (c = S.storage);
    },
    clearStorage: () => {
      c == null || c.removeItem(i.name);
    },
    getOptions: () => i,
    rehydrate: () => b(),
    hasHydrated: () => o,
    onHydrate: (S) => (a.add(S), () => {
      a.delete(S);
    }),
    onFinishHydration: (S) => (u.add(S), () => {
      u.delete(S);
    })
  }, i.skipHydration || b(), v || g;
}, tp = (t, e) => "getStorage" in e || "serialize" in e || "deserialize" in e ? ((Jh ? "production" : void 0) !== "production" && console.warn(
  "[DEPRECATED] `getStorage`, `serialize` and `deserialize` options are deprecated. Use `storage` option instead."
), Qh(t, e)) : ep(t, e), rp = tp, us = qh()(
  rp((t, e) => ({
    account: void 0,
    chainId: "aleo:1",
    // todo - figure out how to populate this from useConnect
    setAccount: (r) => {
      t({ account: r });
    },
    setChainId: (r) => {
      t({ chainId: r });
    },
    onDisconnect: () => {
      t({
        account: void 0,
        chainId: void 0
      }), lh.clear(), console.log("onDisconnect called!");
    }
  }), {
    name: "puzzle-wallet-store"
  })
);
function jo() {
  const [t, e] = Ni(void 0), [r, s] = Ni(void 0), [n, i] = Ni(!1);
  return { data: t, error: r, loading: n, setData: e, setError: s, setLoading: i };
}
async function xl(t, e) {
  const s = await (await yt()).request(t);
  if (s === void 0 && e)
    throw console.error("Result is undefined, retrying..."), new Error("Result is undefined, retrying...");
  return s;
}
function ni({ queryKey: t, wcParams: e, enabled: r, queryOptions: s }) {
  return Zh(
    t,
    async () => xl(e, t),
    s ?? {
      staleTime: t[0] === "getEvent" ? 7500 : 45e3,
      refetchInterval: t[0] === "getEvent" ? 5e3 : 3e4,
      refetchIntervalInBackground: !0,
      enabled: r,
      retry: !0
    }
  );
}
function ii(t) {
  const { data: e, error: r, loading: s, setData: n, setError: i, setLoading: o } = jo();
  async function a(u) {
    try {
      o(!0), i(void 0);
      const c = await xl(t ?? u);
      return n(c), c;
    } catch (c) {
      throw i(c), c;
    } finally {
      o(!1);
    }
  }
  return { data: e, error: r, loading: s, request: a };
}
const Za = (t, e = !0, r = 4, s = !0) => t ? t.length < r ? t : s ? `(...${t.slice(-r)})` : t.length < r * 2 ? t : `${t.slice(
  0,
  r + (e ? 5 : 0)
)}...${t.slice(t.length - r, t.length)}` : "", r5 = () => {
  const t = pr(), [e, r, s] = us((c) => [c.account, c.setAccount, c.onDisconnect]), { refetch: n, data: i, error: o, isLoading: a } = ni({
    queryKey: ["useAccount", t == null ? void 0 : t.topic],
    enabled: !!t,
    wcParams: {
      topic: t == null ? void 0 : t.topic,
      chainId: "aleo:1",
      request: {
        jsonrpc: "2.0",
        method: "getSelectedAccount"
      }
    }
  });
  si(({ params: c, topic: h }) => {
    if (c.event.name === "accountSelected" && t && t.topic === h) {
      const g = c.event.address ?? c.event.data.address, v = c.chainId.split(":")[0], b = c.chainId.split(":")[1];
      r({
        network: v,
        chainId: b,
        address: g,
        shortenedAddress: Za(g)
      });
    }
  }), Il(({ params: c, topic: h }) => {
    const p = c.event.address ?? c.event.data.address, g = c.chainId.split(":")[0], v = c.chainId.split(":")[1];
    r({
      network: g,
      chainId: v,
      address: p,
      shortenedAddress: Za(p)
    });
  }), Sl(({ params: c, topic: h }) => {
    s();
  }), xr(() => {
    t && !a && n();
  }, [t == null ? void 0 : t.topic]), xr(() => {
    if (i) {
      const c = i, h = c == null ? void 0 : c.account;
      h && r(h);
    }
  }, [i]);
  const u = o ? o.message : i && i.error;
  return {
    account: e,
    error: u,
    loading: a
  };
}, s5 = ({ address: t, multisig: e }) => {
  const r = pr(), [s] = us((p) => [p.account]), { refetch: n, data: i, error: o, isLoading: a } = ni({
    queryKey: ["useBalance", t, (s == null ? void 0 : s.address) ?? "", e, r == null ? void 0 : r.topic],
    enabled: !!r && !!s && (e ? !!t : !0),
    wcParams: {
      topic: r == null ? void 0 : r.topic,
      chainId: "aleo:1",
      request: {
        jsonrpc: "2.0",
        method: "getBalance",
        params: {
          assetId: void 0,
          address: t
        }
      }
    }
  });
  si(({ params: p, topic: g }) => {
    const v = p.event.name, b = p.event.address ?? p.event.data.address;
    (v === "selectedAccountSynced" && !e || v === "sharedAccountSynced" && e && b === t) && n();
  }), xr(() => {
    r && !a && n();
  }, [r == null ? void 0 : r.topic]);
  const u = o ? o.message : i && i.error, c = i;
  return { balances: c == null ? void 0 : c.balances, error: u, loading: a };
}, sp = Symbol(), mc = Object.getPrototypeOf, Fa = /* @__PURE__ */ new WeakMap(), np = (t) => t && (Fa.has(t) ? Fa.get(t) : mc(t) === Object.prototype || mc(t) === Array.prototype), ip = (t) => np(t) && t[sp] || null, yc = (t, e = !0) => {
  Fa.set(t, e);
};
var Ui = { BASE_URL: "/", MODE: "production", DEV: !1, PROD: !0, SSR: !1 };
const Pa = (t) => typeof t == "object" && t !== null, ns = /* @__PURE__ */ new WeakMap(), Si = /* @__PURE__ */ new WeakSet(), ap = (t = Object.is, e = (c, h) => new Proxy(c, h), r = (c) => Pa(c) && !Si.has(c) && (Array.isArray(c) || !(Symbol.iterator in c)) && !(c instanceof WeakMap) && !(c instanceof WeakSet) && !(c instanceof Error) && !(c instanceof Number) && !(c instanceof Date) && !(c instanceof String) && !(c instanceof RegExp) && !(c instanceof ArrayBuffer), s = (c) => {
  switch (c.status) {
    case "fulfilled":
      return c.value;
    case "rejected":
      throw c.reason;
    default:
      throw c;
  }
}, n = /* @__PURE__ */ new WeakMap(), i = (c, h, p = s) => {
  const g = n.get(c);
  if ((g == null ? void 0 : g[0]) === h)
    return g[1];
  const v = Array.isArray(c) ? [] : Object.create(Object.getPrototypeOf(c));
  return yc(v, !0), n.set(c, [h, v]), Reflect.ownKeys(c).forEach((b) => {
    if (Object.getOwnPropertyDescriptor(v, b))
      return;
    const S = Reflect.get(c, b), C = {
      value: S,
      enumerable: !0,
      // This is intentional to avoid copying with proxy-compare.
      // It's still non-writable, so it avoids assigning a value.
      configurable: !0
    };
    if (Si.has(S))
      yc(S, !1);
    else if (S instanceof Promise)
      delete C.value, C.get = () => p(S);
    else if (ns.has(S)) {
      const [M, _] = ns.get(
        S
      );
      C.value = i(
        M,
        _(),
        p
      );
    }
    Object.defineProperty(v, b, C);
  }), Object.preventExtensions(v);
}, o = /* @__PURE__ */ new WeakMap(), a = [1, 1], u = (c) => {
  if (!Pa(c))
    throw new Error("object required");
  const h = o.get(c);
  if (h)
    return h;
  let p = a[0];
  const g = /* @__PURE__ */ new Set(), v = (f, L = ++a[0]) => {
    p !== L && (p = L, g.forEach((A) => A(f, L)));
  };
  let b = a[1];
  const S = (f = ++a[1]) => (b !== f && !g.size && (b = f, M.forEach(([L]) => {
    const A = L[1](f);
    A > p && (p = A);
  })), p), C = (f) => (L, A) => {
    const V = [...L];
    V[1] = [f, ...V[1]], v(V, A);
  }, M = /* @__PURE__ */ new Map(), _ = (f, L) => {
    if ((Ui ? "production" : void 0) !== "production" && M.has(f))
      throw new Error("prop listener already exists");
    if (g.size) {
      const A = L[3](C(f));
      M.set(f, [L, A]);
    } else
      M.set(f, [L]);
  }, T = (f) => {
    var L;
    const A = M.get(f);
    A && (M.delete(f), (L = A[1]) == null || L.call(A));
  }, E = (f) => (g.add(f), g.size === 1 && M.forEach(([L, A], V) => {
    if ((Ui ? "production" : void 0) !== "production" && A)
      throw new Error("remove already exists");
    const J = L[3](C(V));
    M.set(V, [L, J]);
  }), () => {
    g.delete(f), g.size === 0 && M.forEach(([L, A], V) => {
      A && (A(), M.set(V, [L]));
    });
  }), I = Array.isArray(c) ? [] : Object.create(Object.getPrototypeOf(c)), m = e(I, {
    deleteProperty(f, L) {
      const A = Reflect.get(f, L);
      T(L);
      const V = Reflect.deleteProperty(f, L);
      return V && v(["delete", [L], A]), V;
    },
    set(f, L, A, V) {
      const J = Reflect.has(f, L), G = Reflect.get(f, L, V);
      if (J && (t(G, A) || o.has(A) && t(G, o.get(A))))
        return !0;
      T(L), Pa(A) && (A = ip(A) || A);
      let O = A;
      if (A instanceof Promise)
        A.then((k) => {
          A.status = "fulfilled", A.value = k, v(["resolve", [L], k]);
        }).catch((k) => {
          A.status = "rejected", A.reason = k, v(["reject", [L], k]);
        });
      else {
        !ns.has(A) && r(A) && (O = u(A));
        const k = !Si.has(O) && ns.get(O);
        k && _(L, k);
      }
      return Reflect.set(f, L, O, V), v(["set", [L], A, G]), !0;
    }
  });
  o.set(c, m);
  const l = [
    I,
    S,
    i,
    E
  ];
  return ns.set(m, l), Reflect.ownKeys(c).forEach((f) => {
    const L = Object.getOwnPropertyDescriptor(
      c,
      f
    );
    "value" in L && (m[f] = c[f], delete L.value, delete L.writable), Object.defineProperty(I, f, L);
  }), m;
}) => [
  // public functions
  u,
  // shared state
  ns,
  Si,
  // internal things
  t,
  e,
  r,
  s,
  n,
  i,
  o,
  a
], [op] = ap();
function ys(t = {}) {
  return op(t);
}
function Ms(t, e, r) {
  const s = ns.get(t);
  (Ui ? "production" : void 0) !== "production" && !s && console.warn("Please use proxy object");
  let n;
  const i = [], o = s[3];
  let a = !1;
  const u = o((c) => {
    if (i.push(c), r) {
      e(i.splice(0));
      return;
    }
    n || (n = Promise.resolve().then(() => {
      n = void 0, a && e(i.splice(0));
    }));
  });
  return a = !0, () => {
    a = !1, u();
  };
}
function cp(t, e) {
  const r = ns.get(t);
  (Ui ? "production" : void 0) !== "production" && !r && console.warn("Please use proxy object");
  const [s, n, i] = r;
  return i(s, n(), e);
}
const Pt = ys({ history: ["ConnectWallet"], view: "ConnectWallet", data: void 0 }), Ol = { state: Pt, subscribe(t) {
  return Ms(Pt, () => t(Pt));
}, push(t, e) {
  t !== Pt.view && (Pt.view = t, e && (Pt.data = e), Pt.history.push(t));
}, reset(t) {
  Pt.view = t, Pt.history = [t];
}, replace(t) {
  Pt.history.length > 1 && (Pt.history[Pt.history.length - 1] = t, Pt.view = t);
}, goBack() {
  if (Pt.history.length > 1) {
    Pt.history.pop();
    const [t] = Pt.history.slice(-1);
    Pt.view = t;
  }
}, setData(t) {
  Pt.data = t;
} }, qt = { WALLETCONNECT_DEEPLINK_CHOICE: "WALLETCONNECT_DEEPLINK_CHOICE", WCM_VERSION: "WCM_VERSION", RECOMMENDED_WALLET_AMOUNT: 9, isMobile() {
  return typeof window < "u" ? !!(window.matchMedia("(pointer:coarse)").matches || /Android|webOS|iPhone|iPad|iPod|BlackBerry|Opera Mini/u.test(navigator.userAgent)) : !1;
}, isAndroid() {
  return qt.isMobile() && navigator.userAgent.toLowerCase().includes("android");
}, isIos() {
  const t = navigator.userAgent.toLowerCase();
  return qt.isMobile() && (t.includes("iphone") || t.includes("ipad"));
}, isHttpUrl(t) {
  return t.startsWith("http://") || t.startsWith("https://");
}, isArray(t) {
  return Array.isArray(t) && t.length > 0;
}, formatNativeUrl(t, e, r) {
  if (qt.isHttpUrl(t))
    return this.formatUniversalUrl(t, e, r);
  let s = t;
  s.includes("://") || (s = t.replaceAll("/", "").replaceAll(":", ""), s = `${s}://`), s.endsWith("/") || (s = `${s}/`), this.setWalletConnectDeepLink(s, r);
  const n = encodeURIComponent(e);
  return `${s}wc?uri=${n}`;
}, formatUniversalUrl(t, e, r) {
  if (!qt.isHttpUrl(t))
    return this.formatNativeUrl(t, e, r);
  let s = t;
  s.endsWith("/") || (s = `${s}/`), this.setWalletConnectDeepLink(s, r);
  const n = encodeURIComponent(e);
  return `${s}wc?uri=${n}`;
}, async wait(t) {
  return new Promise((e) => {
    setTimeout(e, t);
  });
}, openHref(t, e) {
  window.open(t, e, "noreferrer noopener");
}, setWalletConnectDeepLink(t, e) {
  try {
    localStorage.setItem(qt.WALLETCONNECT_DEEPLINK_CHOICE, JSON.stringify({ href: t, name: e }));
  } catch {
    console.info("Unable to set WalletConnect deep link");
  }
}, setWalletConnectAndroidDeepLink(t) {
  try {
    const [e] = t.split("?");
    localStorage.setItem(qt.WALLETCONNECT_DEEPLINK_CHOICE, JSON.stringify({ href: e, name: "Android" }));
  } catch {
    console.info("Unable to set WalletConnect android deep link");
  }
}, removeWalletConnectDeepLink() {
  try {
    localStorage.removeItem(qt.WALLETCONNECT_DEEPLINK_CHOICE);
  } catch {
    console.info("Unable to remove WalletConnect deep link");
  }
}, setModalVersionInStorage() {
  try {
    typeof localStorage < "u" && localStorage.setItem(qt.WCM_VERSION, "2.6.2");
  } catch {
    console.info("Unable to set Web3Modal version in storage");
  }
}, getWalletRouterData() {
  var t;
  const e = (t = Ol.state.data) == null ? void 0 : t.Wallet;
  if (!e)
    throw new Error('Missing "Wallet" view data');
  return e;
} }, up = typeof location < "u" && (location.hostname.includes("localhost") || location.protocol.includes("https")), Ut = ys({ enabled: up, userSessionId: "", events: [], connectedWalletId: void 0 }), lp = { state: Ut, subscribe(t) {
  return Ms(Ut.events, () => t(cp(Ut.events[Ut.events.length - 1])));
}, initialize() {
  Ut.enabled && typeof (crypto == null ? void 0 : crypto.randomUUID) < "u" && (Ut.userSessionId = crypto.randomUUID());
}, setConnectedWalletId(t) {
  Ut.connectedWalletId = t;
}, click(t) {
  if (Ut.enabled) {
    const e = { type: "CLICK", name: t.name, userSessionId: Ut.userSessionId, timestamp: Date.now(), data: t };
    Ut.events.push(e);
  }
}, track(t) {
  if (Ut.enabled) {
    const e = { type: "TRACK", name: t.name, userSessionId: Ut.userSessionId, timestamp: Date.now(), data: t };
    Ut.events.push(e);
  }
}, view(t) {
  if (Ut.enabled) {
    const e = { type: "VIEW", name: t.name, userSessionId: Ut.userSessionId, timestamp: Date.now(), data: t };
    Ut.events.push(e);
  }
} }, Ar = ys({ chains: void 0, walletConnectUri: void 0, isAuth: !1, isCustomDesktop: !1, isCustomMobile: !1, isDataLoaded: !1, isUiLoaded: !1 }), vr = { state: Ar, subscribe(t) {
  return Ms(Ar, () => t(Ar));
}, setChains(t) {
  Ar.chains = t;
}, setWalletConnectUri(t) {
  Ar.walletConnectUri = t;
}, setIsCustomDesktop(t) {
  Ar.isCustomDesktop = t;
}, setIsCustomMobile(t) {
  Ar.isCustomMobile = t;
}, setIsDataLoaded(t) {
  Ar.isDataLoaded = t;
}, setIsUiLoaded(t) {
  Ar.isUiLoaded = t;
}, setIsAuth(t) {
  Ar.isAuth = t;
} }, Ii = ys({ projectId: "", mobileWallets: void 0, desktopWallets: void 0, walletImages: void 0, chains: void 0, enableAuthMode: !1, enableExplorer: !0, explorerExcludedWalletIds: void 0, explorerRecommendedWalletIds: void 0, termsOfServiceUrl: void 0, privacyPolicyUrl: void 0 }), sn = { state: Ii, subscribe(t) {
  return Ms(Ii, () => t(Ii));
}, setConfig(t) {
  var e, r;
  lp.initialize(), vr.setChains(t.chains), vr.setIsAuth(!!t.enableAuthMode), vr.setIsCustomMobile(!!((e = t.mobileWallets) != null && e.length)), vr.setIsCustomDesktop(!!((r = t.desktopWallets) != null && r.length)), qt.setModalVersionInStorage(), Object.assign(Ii, t);
} };
var dp = Object.defineProperty, vc = Object.getOwnPropertySymbols, hp = Object.prototype.hasOwnProperty, pp = Object.prototype.propertyIsEnumerable, _c = (t, e, r) => e in t ? dp(t, e, { enumerable: !0, configurable: !0, writable: !0, value: r }) : t[e] = r, fp = (t, e) => {
  for (var r in e || (e = {}))
    hp.call(e, r) && _c(t, r, e[r]);
  if (vc)
    for (var r of vc(e))
      pp.call(e, r) && _c(t, r, e[r]);
  return t;
};
const Wa = "https://explorer-api.walletconnect.com", Ka = "wcm", Ha = "js-2.6.2";
async function xi(t, e) {
  const r = fp({ sdkType: Ka, sdkVersion: Ha }, e), s = new URL(t, Wa);
  return s.searchParams.append("projectId", sn.state.projectId), Object.entries(r).forEach(([n, i]) => {
    i && s.searchParams.append(n, String(i));
  }), (await fetch(s)).json();
}
const ws = { async getDesktopListings(t) {
  return xi("/w3m/v1/getDesktopListings", t);
}, async getMobileListings(t) {
  return xi("/w3m/v1/getMobileListings", t);
}, async getInjectedListings(t) {
  return xi("/w3m/v1/getInjectedListings", t);
}, async getAllListings(t) {
  return xi("/w3m/v1/getAllListings", t);
}, getWalletImageUrl(t) {
  return `${Wa}/w3m/v1/getWalletImage/${t}?projectId=${sn.state.projectId}&sdkType=${Ka}&sdkVersion=${Ha}`;
}, getAssetImageUrl(t) {
  return `${Wa}/w3m/v1/getAssetImage/${t}?projectId=${sn.state.projectId}&sdkType=${Ka}&sdkVersion=${Ha}`;
} };
var gp = Object.defineProperty, bc = Object.getOwnPropertySymbols, mp = Object.prototype.hasOwnProperty, yp = Object.prototype.propertyIsEnumerable, wc = (t, e, r) => e in t ? gp(t, e, { enumerable: !0, configurable: !0, writable: !0, value: r }) : t[e] = r, vp = (t, e) => {
  for (var r in e || (e = {}))
    mp.call(e, r) && wc(t, r, e[r]);
  if (bc)
    for (var r of bc(e))
      yp.call(e, r) && wc(t, r, e[r]);
  return t;
};
const Ec = qt.isMobile(), jr = ys({ wallets: { listings: [], total: 0, page: 1 }, search: { listings: [], total: 0, page: 1 }, recomendedWallets: [] }), n5 = { state: jr, async getRecomendedWallets() {
  const { explorerRecommendedWalletIds: t, explorerExcludedWalletIds: e } = sn.state;
  if (t === "NONE" || e === "ALL" && !t)
    return jr.recomendedWallets;
  if (qt.isArray(t)) {
    const r = { recommendedIds: t.join(",") }, { listings: s } = await ws.getAllListings(r), n = Object.values(s);
    n.sort((i, o) => {
      const a = t.indexOf(i.id), u = t.indexOf(o.id);
      return a - u;
    }), jr.recomendedWallets = n;
  } else {
    const { chains: r, isAuth: s } = vr.state, n = r == null ? void 0 : r.join(","), i = qt.isArray(e), o = { page: 1, sdks: s ? "auth_v1" : void 0, entries: qt.RECOMMENDED_WALLET_AMOUNT, chains: n, version: 2, excludedIds: i ? e.join(",") : void 0 }, { listings: a } = Ec ? await ws.getMobileListings(o) : await ws.getDesktopListings(o);
    jr.recomendedWallets = Object.values(a);
  }
  return jr.recomendedWallets;
}, async getWallets(t) {
  const e = vp({}, t), { explorerRecommendedWalletIds: r, explorerExcludedWalletIds: s } = sn.state, { recomendedWallets: n } = jr;
  if (s === "ALL")
    return jr.wallets;
  n.length ? e.excludedIds = n.map((p) => p.id).join(",") : qt.isArray(r) && (e.excludedIds = r.join(",")), qt.isArray(s) && (e.excludedIds = [e.excludedIds, s].filter(Boolean).join(",")), vr.state.isAuth && (e.sdks = "auth_v1");
  const { page: i, search: o } = t, { listings: a, total: u } = Ec ? await ws.getMobileListings(e) : await ws.getDesktopListings(e), c = Object.values(a), h = o ? "search" : "wallets";
  return jr[h] = { listings: [...jr[h].listings, ...c], total: u, page: i ?? 1 }, { listings: c, total: u };
}, getWalletImageUrl(t) {
  return ws.getWalletImageUrl(t);
}, getAssetImageUrl(t) {
  return ws.getAssetImageUrl(t);
}, resetSearch() {
  jr.search = { listings: [], total: 0, page: 1 };
} }, qs = ys({ open: !1 }), Ca = { state: qs, subscribe(t) {
  return Ms(qs, () => t(qs));
}, async open(t) {
  return new Promise((e) => {
    const { isUiLoaded: r, isDataLoaded: s } = vr.state;
    if (qt.removeWalletConnectDeepLink(), vr.setWalletConnectUri(t == null ? void 0 : t.uri), vr.setChains(t == null ? void 0 : t.chains), Ol.reset("ConnectWallet"), r && s)
      qs.open = !0, e();
    else {
      const n = setInterval(() => {
        const i = vr.state;
        i.isUiLoaded && i.isDataLoaded && (clearInterval(n), qs.open = !0, e());
      }, 200);
    }
  });
}, close() {
  qs.open = !1;
} };
var _p = Object.defineProperty, Sc = Object.getOwnPropertySymbols, bp = Object.prototype.hasOwnProperty, wp = Object.prototype.propertyIsEnumerable, Ic = (t, e, r) => e in t ? _p(t, e, { enumerable: !0, configurable: !0, writable: !0, value: r }) : t[e] = r, Ep = (t, e) => {
  for (var r in e || (e = {}))
    bp.call(e, r) && Ic(t, r, e[r]);
  if (Sc)
    for (var r of Sc(e))
      wp.call(e, r) && Ic(t, r, e[r]);
  return t;
};
function Sp() {
  return typeof matchMedia < "u" && matchMedia("(prefers-color-scheme: dark)").matches;
}
const yn = ys({ themeMode: Sp() ? "dark" : "light" }), xc = { state: yn, subscribe(t) {
  return Ms(yn, () => t(yn));
}, setThemeConfig(t) {
  const { themeMode: e, themeVariables: r } = t;
  e && (yn.themeMode = e), r && (yn.themeVariables = Ep({}, r));
} }, Es = ys({ open: !1, message: "", variant: "success" }), i5 = { state: Es, subscribe(t) {
  return Ms(Es, () => t(Es));
}, openToast(t, e) {
  Es.open = !0, Es.message = t, Es.variant = e;
}, closeToast() {
  Es.open = !1;
} };
let Ip = class {
  constructor(t) {
    this.openModal = Ca.open, this.closeModal = Ca.close, this.subscribeModal = Ca.subscribe, this.setTheme = xc.setThemeConfig, xc.setThemeConfig(t), sn.setConfig(t), this.initUi();
  }
  async initUi() {
    if (typeof window < "u") {
      await import("./index-cNVqZlp_---nxIEKl.js");
      const t = document.createElement("wcm-modal");
      document.body.insertAdjacentElement("beforeend", t), vr.setIsUiLoaded(!0);
    }
  }
};
var cs = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {};
function da(t) {
  return t && t.__esModule && Object.prototype.hasOwnProperty.call(t, "default") ? t.default : t;
}
function ha(t) {
  if (t.__esModule)
    return t;
  var e = t.default;
  if (typeof e == "function") {
    var r = function s() {
      return this instanceof s ? Reflect.construct(e, arguments, this.constructor) : e.apply(this, arguments);
    };
    r.prototype = e.prototype;
  } else
    r = {};
  return Object.defineProperty(r, "__esModule", { value: !0 }), Object.keys(t).forEach(function(s) {
    var n = Object.getOwnPropertyDescriptor(t, s);
    Object.defineProperty(r, s, n.get ? n : {
      enumerable: !0,
      get: function() {
        return t[s];
      }
    });
  }), r;
}
var Lo = { exports: {} }, Xs = typeof Reflect == "object" ? Reflect : null, Oc = Xs && typeof Xs.apply == "function" ? Xs.apply : function(t, e, r) {
  return Function.prototype.apply.call(t, e, r);
}, ki;
Xs && typeof Xs.ownKeys == "function" ? ki = Xs.ownKeys : Object.getOwnPropertySymbols ? ki = function(t) {
  return Object.getOwnPropertyNames(t).concat(Object.getOwnPropertySymbols(t));
} : ki = function(t) {
  return Object.getOwnPropertyNames(t);
};
function xp(t) {
  console && console.warn && console.warn(t);
}
var Tl = Number.isNaN || function(t) {
  return t !== t;
};
function Je() {
  Je.init.call(this);
}
Lo.exports = Je;
Lo.exports.once = Cp;
Je.EventEmitter = Je;
Je.prototype._events = void 0;
Je.prototype._eventsCount = 0;
Je.prototype._maxListeners = void 0;
var Tc = 10;
function pa(t) {
  if (typeof t != "function")
    throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof t);
}
Object.defineProperty(Je, "defaultMaxListeners", {
  enumerable: !0,
  get: function() {
    return Tc;
  },
  set: function(t) {
    if (typeof t != "number" || t < 0 || Tl(t))
      throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + t + ".");
    Tc = t;
  }
});
Je.init = function() {
  (this._events === void 0 || this._events === Object.getPrototypeOf(this)._events) && (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
};
Je.prototype.setMaxListeners = function(t) {
  if (typeof t != "number" || t < 0 || Tl(t))
    throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + t + ".");
  return this._maxListeners = t, this;
};
function Pl(t) {
  return t._maxListeners === void 0 ? Je.defaultMaxListeners : t._maxListeners;
}
Je.prototype.getMaxListeners = function() {
  return Pl(this);
};
Je.prototype.emit = function(t) {
  for (var e = [], r = 1; r < arguments.length; r++)
    e.push(arguments[r]);
  var s = t === "error", n = this._events;
  if (n !== void 0)
    s = s && n.error === void 0;
  else if (!s)
    return !1;
  if (s) {
    var i;
    if (e.length > 0 && (i = e[0]), i instanceof Error)
      throw i;
    var o = new Error("Unhandled error." + (i ? " (" + i.message + ")" : ""));
    throw o.context = i, o;
  }
  var a = n[t];
  if (a === void 0)
    return !1;
  if (typeof a == "function")
    Oc(a, this, e);
  else
    for (var u = a.length, c = Al(a, u), r = 0; r < u; ++r)
      Oc(c[r], this, e);
  return !0;
};
function Cl(t, e, r, s) {
  var n, i, o;
  if (pa(r), i = t._events, i === void 0 ? (i = t._events = /* @__PURE__ */ Object.create(null), t._eventsCount = 0) : (i.newListener !== void 0 && (t.emit(
    "newListener",
    e,
    r.listener ? r.listener : r
  ), i = t._events), o = i[e]), o === void 0)
    o = i[e] = r, ++t._eventsCount;
  else if (typeof o == "function" ? o = i[e] = s ? [r, o] : [o, r] : s ? o.unshift(r) : o.push(r), n = Pl(t), n > 0 && o.length > n && !o.warned) {
    o.warned = !0;
    var a = new Error("Possible EventEmitter memory leak detected. " + o.length + " " + String(e) + " listeners added. Use emitter.setMaxListeners() to increase limit");
    a.name = "MaxListenersExceededWarning", a.emitter = t, a.type = e, a.count = o.length, xp(a);
  }
  return t;
}
Je.prototype.addListener = function(t, e) {
  return Cl(this, t, e, !1);
};
Je.prototype.on = Je.prototype.addListener;
Je.prototype.prependListener = function(t, e) {
  return Cl(this, t, e, !0);
};
function Op() {
  if (!this.fired)
    return this.target.removeListener(this.type, this.wrapFn), this.fired = !0, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
}
function Nl(t, e, r) {
  var s = { fired: !1, wrapFn: void 0, target: t, type: e, listener: r }, n = Op.bind(s);
  return n.listener = r, s.wrapFn = n, n;
}
Je.prototype.once = function(t, e) {
  return pa(e), this.on(t, Nl(this, t, e)), this;
};
Je.prototype.prependOnceListener = function(t, e) {
  return pa(e), this.prependListener(t, Nl(this, t, e)), this;
};
Je.prototype.removeListener = function(t, e) {
  var r, s, n, i, o;
  if (pa(e), s = this._events, s === void 0)
    return this;
  if (r = s[t], r === void 0)
    return this;
  if (r === e || r.listener === e)
    --this._eventsCount === 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete s[t], s.removeListener && this.emit("removeListener", t, r.listener || e));
  else if (typeof r != "function") {
    for (n = -1, i = r.length - 1; i >= 0; i--)
      if (r[i] === e || r[i].listener === e) {
        o = r[i].listener, n = i;
        break;
      }
    if (n < 0)
      return this;
    n === 0 ? r.shift() : Tp(r, n), r.length === 1 && (s[t] = r[0]), s.removeListener !== void 0 && this.emit("removeListener", t, o || e);
  }
  return this;
};
Je.prototype.off = Je.prototype.removeListener;
Je.prototype.removeAllListeners = function(t) {
  var e, r, s;
  if (r = this._events, r === void 0)
    return this;
  if (r.removeListener === void 0)
    return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : r[t] !== void 0 && (--this._eventsCount === 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete r[t]), this;
  if (arguments.length === 0) {
    var n = Object.keys(r), i;
    for (s = 0; s < n.length; ++s)
      i = n[s], i !== "removeListener" && this.removeAllListeners(i);
    return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
  }
  if (e = r[t], typeof e == "function")
    this.removeListener(t, e);
  else if (e !== void 0)
    for (s = e.length - 1; s >= 0; s--)
      this.removeListener(t, e[s]);
  return this;
};
function kl(t, e, r) {
  var s = t._events;
  if (s === void 0)
    return [];
  var n = s[e];
  return n === void 0 ? [] : typeof n == "function" ? r ? [n.listener || n] : [n] : r ? Pp(n) : Al(n, n.length);
}
Je.prototype.listeners = function(t) {
  return kl(this, t, !0);
};
Je.prototype.rawListeners = function(t) {
  return kl(this, t, !1);
};
Je.listenerCount = function(t, e) {
  return typeof t.listenerCount == "function" ? t.listenerCount(e) : Rl.call(t, e);
};
Je.prototype.listenerCount = Rl;
function Rl(t) {
  var e = this._events;
  if (e !== void 0) {
    var r = e[t];
    if (typeof r == "function")
      return 1;
    if (r !== void 0)
      return r.length;
  }
  return 0;
}
Je.prototype.eventNames = function() {
  return this._eventsCount > 0 ? ki(this._events) : [];
};
function Al(t, e) {
  for (var r = new Array(e), s = 0; s < e; ++s)
    r[s] = t[s];
  return r;
}
function Tp(t, e) {
  for (; e + 1 < t.length; e++)
    t[e] = t[e + 1];
  t.pop();
}
function Pp(t) {
  for (var e = new Array(t.length), r = 0; r < e.length; ++r)
    e[r] = t[r].listener || t[r];
  return e;
}
function Cp(t, e) {
  return new Promise(function(r, s) {
    function n(o) {
      t.removeListener(e, i), s(o);
    }
    function i() {
      typeof t.removeListener == "function" && t.removeListener("error", n), r([].slice.call(arguments));
    }
    jl(t, e, i, { once: !0 }), e !== "error" && Np(t, n, { once: !0 });
  });
}
function Np(t, e, r) {
  typeof t.on == "function" && jl(t, "error", e, r);
}
function jl(t, e, r, s) {
  if (typeof t.on == "function")
    s.once ? t.once(e, r) : t.on(e, r);
  else if (typeof t.addEventListener == "function")
    t.addEventListener(e, function n(i) {
      s.once && t.removeEventListener(e, n), r(i);
    });
  else
    throw new TypeError('The "emitter" argument must be of type EventEmitter. Received type ' + typeof t);
}
var Pr = Lo.exports;
const Mo = /* @__PURE__ */ da(Pr), kp = /"(?:_|\\u0{2}5[Ff]){2}(?:p|\\u0{2}70)(?:r|\\u0{2}72)(?:o|\\u0{2}6[Ff])(?:t|\\u0{2}74)(?:o|\\u0{2}6[Ff])(?:_|\\u0{2}5[Ff]){2}"\s*:/, Rp = /"(?:c|\\u0063)(?:o|\\u006[Ff])(?:n|\\u006[Ee])(?:s|\\u0073)(?:t|\\u0074)(?:r|\\u0072)(?:u|\\u0075)(?:c|\\u0063)(?:t|\\u0074)(?:o|\\u006[Ff])(?:r|\\u0072)"\s*:/, Ap = /^\s*["[{]|^\s*-?\d{1,16}(\.\d{1,17})?([Ee][+-]?\d+)?\s*$/;
function jp(t, e) {
  if (t === "__proto__" || t === "constructor" && e && typeof e == "object" && "prototype" in e) {
    Lp(t);
    return;
  }
  return e;
}
function Lp(t) {
  console.warn(`[destr] Dropping "${t}" key to prevent prototype pollution.`);
}
function Oi(t, e = {}) {
  if (typeof t != "string")
    return t;
  const r = t.trim();
  if (
    // eslint-disable-next-line unicorn/prefer-at
    t[0] === '"' && t.at(-1) === '"' && !t.includes("\\")
  )
    return r.slice(1, -1);
  if (r.length <= 9) {
    const s = r.toLowerCase();
    if (s === "true")
      return !0;
    if (s === "false")
      return !1;
    if (s === "undefined")
      return;
    if (s === "null")
      return null;
    if (s === "nan")
      return Number.NaN;
    if (s === "infinity")
      return Number.POSITIVE_INFINITY;
    if (s === "-infinity")
      return Number.NEGATIVE_INFINITY;
  }
  if (!Ap.test(t)) {
    if (e.strict)
      throw new SyntaxError("[destr] Invalid JSON");
    return t;
  }
  try {
    if (kp.test(t) || Rp.test(t)) {
      if (e.strict)
        throw new Error("[destr] Possible prototype pollution");
      return JSON.parse(t, jp);
    }
    return JSON.parse(t);
  } catch (s) {
    if (e.strict)
      throw s;
    return t;
  }
}
function Mp(t) {
  return !t || typeof t.then != "function" ? Promise.resolve(t) : t;
}
function Ct(t, ...e) {
  try {
    return Mp(t(...e));
  } catch (r) {
    return Promise.reject(r);
  }
}
function Dp(t) {
  const e = typeof t;
  return t === null || e !== "object" && e !== "function";
}
function Up(t) {
  const e = Object.getPrototypeOf(t);
  return !e || e.isPrototypeOf(Object);
}
function Ri(t) {
  if (Dp(t))
    return String(t);
  if (Up(t) || Array.isArray(t))
    return JSON.stringify(t);
  if (typeof t.toJSON == "function")
    return Ri(t.toJSON());
  throw new Error("[unstorage] Cannot stringify value!");
}
function Ll() {
  if (typeof Buffer === void 0)
    throw new TypeError("[unstorage] Buffer is not supported!");
}
const Ba = "base64:";
function zp(t) {
  if (typeof t == "string")
    return t;
  Ll();
  const e = Buffer.from(t).toString("base64");
  return Ba + e;
}
function $p(t) {
  return typeof t != "string" || !t.startsWith(Ba) ? t : (Ll(), Buffer.from(t.slice(Ba.length), "base64"));
}
function er(t) {
  return t ? t.split("?")[0].replace(/[/\\]/g, ":").replace(/:+/g, ":").replace(/^:|:$/g, "") : "";
}
function Vp(...t) {
  return er(t.join(":"));
}
function Ti(t) {
  return t = er(t), t ? t + ":" : "";
}
const qp = "memory", Zp = () => {
  const t = /* @__PURE__ */ new Map();
  return {
    name: qp,
    options: {},
    hasItem(e) {
      return t.has(e);
    },
    getItem(e) {
      return t.get(e) ?? null;
    },
    getItemRaw(e) {
      return t.get(e) ?? null;
    },
    setItem(e, r) {
      t.set(e, r);
    },
    setItemRaw(e, r) {
      t.set(e, r);
    },
    removeItem(e) {
      t.delete(e);
    },
    getKeys() {
      return Array.from(t.keys());
    },
    clear() {
      t.clear();
    },
    dispose() {
      t.clear();
    }
  };
};
function Fp(t = {}) {
  const e = {
    mounts: { "": t.driver || Zp() },
    mountpoints: [""],
    watching: !1,
    watchListeners: [],
    unwatch: {}
  }, r = (c) => {
    for (const h of e.mountpoints)
      if (c.startsWith(h))
        return {
          base: h,
          relativeKey: c.slice(h.length),
          driver: e.mounts[h]
        };
    return {
      base: "",
      relativeKey: c,
      driver: e.mounts[""]
    };
  }, s = (c, h) => e.mountpoints.filter(
    (p) => p.startsWith(c) || h && c.startsWith(p)
  ).map((p) => ({
    relativeBase: c.length > p.length ? c.slice(p.length) : void 0,
    mountpoint: p,
    driver: e.mounts[p]
  })), n = (c, h) => {
    if (e.watching) {
      h = er(h);
      for (const p of e.watchListeners)
        p(c, h);
    }
  }, i = async () => {
    if (!e.watching) {
      e.watching = !0;
      for (const c in e.mounts)
        e.unwatch[c] = await Pc(
          e.mounts[c],
          n,
          c
        );
    }
  }, o = async () => {
    if (e.watching) {
      for (const c in e.unwatch)
        await e.unwatch[c]();
      e.unwatch = {}, e.watching = !1;
    }
  }, a = (c, h, p) => {
    const g = /* @__PURE__ */ new Map(), v = (b) => {
      let S = g.get(b.base);
      return S || (S = {
        driver: b.driver,
        base: b.base,
        items: []
      }, g.set(b.base, S)), S;
    };
    for (const b of c) {
      const S = typeof b == "string", C = er(S ? b : b.key), M = S ? void 0 : b.value, _ = S || !b.options ? h : { ...h, ...b.options }, T = r(C);
      v(T).items.push({
        key: C,
        value: M,
        relativeKey: T.relativeKey,
        options: _
      });
    }
    return Promise.all([...g.values()].map((b) => p(b))).then(
      (b) => b.flat()
    );
  }, u = {
    // Item
    hasItem(c, h = {}) {
      c = er(c);
      const { relativeKey: p, driver: g } = r(c);
      return Ct(g.hasItem, p, h);
    },
    getItem(c, h = {}) {
      c = er(c);
      const { relativeKey: p, driver: g } = r(c);
      return Ct(g.getItem, p, h).then(
        (v) => Oi(v)
      );
    },
    getItems(c, h) {
      return a(c, h, (p) => p.driver.getItems ? Ct(
        p.driver.getItems,
        p.items.map((g) => ({
          key: g.relativeKey,
          options: g.options
        })),
        h
      ).then(
        (g) => g.map((v) => ({
          key: Vp(p.base, v.key),
          value: Oi(v.value)
        }))
      ) : Promise.all(
        p.items.map((g) => Ct(
          p.driver.getItem,
          g.relativeKey,
          g.options
        ).then((v) => ({
          key: g.key,
          value: Oi(v)
        })))
      ));
    },
    getItemRaw(c, h = {}) {
      c = er(c);
      const { relativeKey: p, driver: g } = r(c);
      return g.getItemRaw ? Ct(g.getItemRaw, p, h) : Ct(g.getItem, p, h).then(
        (v) => $p(v)
      );
    },
    async setItem(c, h, p = {}) {
      if (h === void 0)
        return u.removeItem(c);
      c = er(c);
      const { relativeKey: g, driver: v } = r(c);
      v.setItem && (await Ct(v.setItem, g, Ri(h), p), v.watch || n("update", c));
    },
    async setItems(c, h) {
      await a(c, h, async (p) => {
        p.driver.setItems && await Ct(
          p.driver.setItems,
          p.items.map((g) => ({
            key: g.relativeKey,
            value: Ri(g.value),
            options: g.options
          })),
          h
        ), p.driver.setItem && await Promise.all(
          p.items.map((g) => Ct(
            p.driver.setItem,
            g.relativeKey,
            Ri(g.value),
            g.options
          ))
        );
      });
    },
    async setItemRaw(c, h, p = {}) {
      if (h === void 0)
        return u.removeItem(c, p);
      c = er(c);
      const { relativeKey: g, driver: v } = r(c);
      if (v.setItemRaw)
        await Ct(v.setItemRaw, g, h, p);
      else if (v.setItem)
        await Ct(v.setItem, g, zp(h), p);
      else
        return;
      v.watch || n("update", c);
    },
    async removeItem(c, h = {}) {
      typeof h == "boolean" && (h = { removeMeta: h }), c = er(c);
      const { relativeKey: p, driver: g } = r(c);
      g.removeItem && (await Ct(g.removeItem, p, h), (h.removeMeta || h.removeMata) && await Ct(g.removeItem, p + "$", h), g.watch || n("remove", c));
    },
    // Meta
    async getMeta(c, h = {}) {
      typeof h == "boolean" && (h = { nativeOnly: h }), c = er(c);
      const { relativeKey: p, driver: g } = r(c), v = /* @__PURE__ */ Object.create(null);
      if (g.getMeta && Object.assign(v, await Ct(g.getMeta, p, h)), !h.nativeOnly) {
        const b = await Ct(
          g.getItem,
          p + "$",
          h
        ).then((S) => Oi(S));
        b && typeof b == "object" && (typeof b.atime == "string" && (b.atime = new Date(b.atime)), typeof b.mtime == "string" && (b.mtime = new Date(b.mtime)), Object.assign(v, b));
      }
      return v;
    },
    setMeta(c, h, p = {}) {
      return this.setItem(c + "$", h, p);
    },
    removeMeta(c, h = {}) {
      return this.removeItem(c + "$", h);
    },
    // Keys
    async getKeys(c, h = {}) {
      c = Ti(c);
      const p = s(c, !0);
      let g = [];
      const v = [];
      for (const b of p) {
        const S = (await Ct(
          b.driver.getKeys,
          b.relativeBase,
          h
        )).map((C) => b.mountpoint + er(C)).filter((C) => !g.some((M) => C.startsWith(M)));
        v.push(...S), g = [
          b.mountpoint,
          ...g.filter((C) => !C.startsWith(b.mountpoint))
        ];
      }
      return c ? v.filter((b) => b.startsWith(c) && !b.endsWith("$")) : v.filter((b) => !b.endsWith("$"));
    },
    // Utils
    async clear(c, h = {}) {
      c = Ti(c), await Promise.all(
        s(c, !1).map(async (p) => {
          if (p.driver.clear)
            return Ct(p.driver.clear, p.relativeBase, h);
          if (p.driver.removeItem) {
            const g = await p.driver.getKeys(p.relativeBase || "", h);
            return Promise.all(
              g.map((v) => p.driver.removeItem(v, h))
            );
          }
        })
      );
    },
    async dispose() {
      await Promise.all(
        Object.values(e.mounts).map((c) => Cc(c))
      );
    },
    async watch(c) {
      return await i(), e.watchListeners.push(c), async () => {
        e.watchListeners = e.watchListeners.filter(
          (h) => h !== c
        ), e.watchListeners.length === 0 && await o();
      };
    },
    async unwatch() {
      e.watchListeners = [], await o();
    },
    // Mount
    mount(c, h) {
      if (c = Ti(c), c && e.mounts[c])
        throw new Error(`already mounted at ${c}`);
      return c && (e.mountpoints.push(c), e.mountpoints.sort((p, g) => g.length - p.length)), e.mounts[c] = h, e.watching && Promise.resolve(Pc(h, n, c)).then((p) => {
        e.unwatch[c] = p;
      }).catch(console.error), u;
    },
    async unmount(c, h = !0) {
      c = Ti(c), !(!c || !e.mounts[c]) && (e.watching && c in e.unwatch && (e.unwatch[c](), delete e.unwatch[c]), h && await Cc(e.mounts[c]), e.mountpoints = e.mountpoints.filter((p) => p !== c), delete e.mounts[c]);
    },
    getMount(c = "") {
      c = er(c) + ":";
      const h = r(c);
      return {
        driver: h.driver,
        base: h.base
      };
    },
    getMounts(c = "", h = {}) {
      return c = er(c), s(c, h.parents).map((p) => ({
        driver: p.driver,
        base: p.mountpoint
      }));
    }
  };
  return u;
}
function Pc(t, e, r) {
  return t.watch ? t.watch((s, n) => e(s, r + n)) : () => {
  };
}
async function Cc(t) {
  typeof t.dispose == "function" && await Ct(t.dispose);
}
function Ds(t) {
  return new Promise((e, r) => {
    t.oncomplete = t.onsuccess = () => e(t.result), t.onabort = t.onerror = () => r(t.error);
  });
}
function Ml(t, e) {
  const r = indexedDB.open(t);
  r.onupgradeneeded = () => r.result.createObjectStore(e);
  const s = Ds(r);
  return (n, i) => s.then((o) => i(o.transaction(e, n).objectStore(e)));
}
let Na;
function ai() {
  return Na || (Na = Ml("keyval-store", "keyval")), Na;
}
function Nc(t, e = ai()) {
  return e("readonly", (r) => Ds(r.get(t)));
}
function Wp(t, e, r = ai()) {
  return r("readwrite", (s) => (s.put(e, t), Ds(s.transaction)));
}
function Kp(t, e = ai()) {
  return e("readwrite", (r) => (r.delete(t), Ds(r.transaction)));
}
function Hp(t = ai()) {
  return t("readwrite", (e) => (e.clear(), Ds(e.transaction)));
}
function Bp(t, e) {
  return t.openCursor().onsuccess = function() {
    this.result && (e(this.result), this.result.continue());
  }, Ds(t.transaction);
}
function Gp(t = ai()) {
  return t("readonly", (e) => {
    if (e.getAllKeys)
      return Ds(e.getAllKeys());
    const r = [];
    return Bp(e, (s) => r.push(s.key)).then(() => r);
  });
}
const Yp = (t) => JSON.stringify(t, (e, r) => typeof r == "bigint" ? r.toString() + "n" : r), Jp = (t) => {
  const e = /([\[:])?(\d{17,}|(?:[9](?:[1-9]07199254740991|0[1-9]7199254740991|00[8-9]199254740991|007[2-9]99254740991|007199[3-9]54740991|0071992[6-9]4740991|00719925[5-9]740991|007199254[8-9]40991|0071992547[5-9]0991|00719925474[1-9]991|00719925474099[2-9])))([,\}\]])/g, r = t.replace(e, '$1"$2n"$3');
  return JSON.parse(r, (s, n) => typeof n == "string" && n.match(/^\d+n$/) ? BigInt(n.substring(0, n.length - 1)) : n);
};
function fa(t) {
  if (typeof t != "string")
    throw new Error(`Cannot safe json parse value of type ${typeof t}`);
  try {
    return Jp(t);
  } catch {
    return t;
  }
}
function oi(t) {
  return typeof t == "string" ? t : Yp(t) || "";
}
const Xp = "idb-keyval";
var Qp = (t = {}) => {
  const e = t.base && t.base.length > 0 ? `${t.base}:` : "", r = (n) => e + n;
  let s;
  return t.dbName && t.storeName && (s = Ml(t.dbName, t.storeName)), { name: Xp, options: t, async hasItem(n) {
    return !(typeof await Nc(r(n), s) > "u");
  }, async getItem(n) {
    return await Nc(r(n), s) ?? null;
  }, setItem(n, i) {
    return Wp(r(n), i, s);
  }, removeItem(n) {
    return Kp(r(n), s);
  }, getKeys() {
    return Gp(s);
  }, clear() {
    return Hp(s);
  } };
};
const ef = "WALLET_CONNECT_V2_INDEXED_DB", tf = "keyvaluestorage";
let rf = class {
  constructor() {
    this.indexedDb = Fp({ driver: Qp({ dbName: ef, storeName: tf }) });
  }
  async getKeys() {
    return this.indexedDb.getKeys();
  }
  async getEntries() {
    return (await this.indexedDb.getItems(await this.indexedDb.getKeys())).map((t) => [t.key, t.value]);
  }
  async getItem(t) {
    const e = await this.indexedDb.getItem(t);
    if (e !== null)
      return e;
  }
  async setItem(t, e) {
    await this.indexedDb.setItem(t, oi(e));
  }
  async removeItem(t) {
    await this.indexedDb.removeItem(t);
  }
};
var ka = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {}, Ai = { exports: {} };
(function() {
  let t;
  function e() {
  }
  t = e, t.prototype.getItem = function(r) {
    return this.hasOwnProperty(r) ? String(this[r]) : null;
  }, t.prototype.setItem = function(r, s) {
    this[r] = String(s);
  }, t.prototype.removeItem = function(r) {
    delete this[r];
  }, t.prototype.clear = function() {
    const r = this;
    Object.keys(r).forEach(function(s) {
      r[s] = void 0, delete r[s];
    });
  }, t.prototype.key = function(r) {
    return r = r || 0, Object.keys(this)[r];
  }, t.prototype.__defineGetter__("length", function() {
    return Object.keys(this).length;
  }), typeof ka < "u" && ka.localStorage ? Ai.exports = ka.localStorage : typeof window < "u" && window.localStorage ? Ai.exports = window.localStorage : Ai.exports = new e();
})();
function sf(t) {
  var e;
  return [t[0], fa((e = t[1]) != null ? e : "")];
}
class nf {
  constructor() {
    this.localStorage = Ai.exports;
  }
  async getKeys() {
    return Object.keys(this.localStorage);
  }
  async getEntries() {
    return Object.entries(this.localStorage).map(sf);
  }
  async getItem(e) {
    const r = this.localStorage.getItem(e);
    if (r !== null)
      return fa(r);
  }
  async setItem(e, r) {
    this.localStorage.setItem(e, oi(r));
  }
  async removeItem(e) {
    this.localStorage.removeItem(e);
  }
}
const af = "wc_storage_version", kc = 1, of = async (t, e, r) => {
  const s = af, n = await e.getItem(s);
  if (n && n >= kc) {
    r(e);
    return;
  }
  const i = await t.getKeys();
  if (!i.length) {
    r(e);
    return;
  }
  const o = [];
  for (; i.length; ) {
    const a = i.shift();
    if (!a)
      continue;
    const u = a.toLowerCase();
    if (u.includes("wc@") || u.includes("walletconnect") || u.includes("wc_") || u.includes("wallet_connect")) {
      const c = await t.getItem(a);
      await e.setItem(a, c), o.push(a);
    }
  }
  await e.setItem(s, kc), r(e), cf(t, o);
}, cf = async (t, e) => {
  e.length && e.forEach(async (r) => {
    await t.removeItem(r);
  });
};
let uf = class {
  constructor() {
    this.initialized = !1, this.setInitialized = (e) => {
      this.storage = e, this.initialized = !0;
    };
    const t = new nf();
    this.storage = t;
    try {
      const e = new rf();
      of(t, e, this.setInitialized);
    } catch {
      this.initialized = !0;
    }
  }
  async getKeys() {
    return await this.initialize(), this.storage.getKeys();
  }
  async getEntries() {
    return await this.initialize(), this.storage.getEntries();
  }
  async getItem(t) {
    return await this.initialize(), this.storage.getItem(t);
  }
  async setItem(t, e) {
    return await this.initialize(), this.storage.setItem(t, e);
  }
  async removeItem(t) {
    return await this.initialize(), this.storage.removeItem(t);
  }
  async initialize() {
    this.initialized || await new Promise((t) => {
      const e = setInterval(() => {
        this.initialized && (clearInterval(e), t());
      }, 20);
    });
  }
};
var un = {};
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
var Ga = function(t, e) {
  return Ga = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(r, s) {
    r.__proto__ = s;
  } || function(r, s) {
    for (var n in s)
      s.hasOwnProperty(n) && (r[n] = s[n]);
  }, Ga(t, e);
};
function lf(t, e) {
  Ga(t, e);
  function r() {
    this.constructor = t;
  }
  t.prototype = e === null ? Object.create(e) : (r.prototype = e.prototype, new r());
}
var Ya = function() {
  return Ya = Object.assign || function(t) {
    for (var e, r = 1, s = arguments.length; r < s; r++) {
      e = arguments[r];
      for (var n in e)
        Object.prototype.hasOwnProperty.call(e, n) && (t[n] = e[n]);
    }
    return t;
  }, Ya.apply(this, arguments);
};
function df(t, e) {
  var r = {};
  for (var s in t)
    Object.prototype.hasOwnProperty.call(t, s) && e.indexOf(s) < 0 && (r[s] = t[s]);
  if (t != null && typeof Object.getOwnPropertySymbols == "function")
    for (var n = 0, s = Object.getOwnPropertySymbols(t); n < s.length; n++)
      e.indexOf(s[n]) < 0 && Object.prototype.propertyIsEnumerable.call(t, s[n]) && (r[s[n]] = t[s[n]]);
  return r;
}
function hf(t, e, r, s) {
  var n = arguments.length, i = n < 3 ? e : s === null ? s = Object.getOwnPropertyDescriptor(e, r) : s, o;
  if (typeof Reflect == "object" && typeof Reflect.decorate == "function")
    i = Reflect.decorate(t, e, r, s);
  else
    for (var a = t.length - 1; a >= 0; a--)
      (o = t[a]) && (i = (n < 3 ? o(i) : n > 3 ? o(e, r, i) : o(e, r)) || i);
  return n > 3 && i && Object.defineProperty(e, r, i), i;
}
function pf(t, e) {
  return function(r, s) {
    e(r, s, t);
  };
}
function ff(t, e) {
  if (typeof Reflect == "object" && typeof Reflect.metadata == "function")
    return Reflect.metadata(t, e);
}
function gf(t, e, r, s) {
  function n(i) {
    return i instanceof r ? i : new r(function(o) {
      o(i);
    });
  }
  return new (r || (r = Promise))(function(i, o) {
    function a(h) {
      try {
        c(s.next(h));
      } catch (p) {
        o(p);
      }
    }
    function u(h) {
      try {
        c(s.throw(h));
      } catch (p) {
        o(p);
      }
    }
    function c(h) {
      h.done ? i(h.value) : n(h.value).then(a, u);
    }
    c((s = s.apply(t, e || [])).next());
  });
}
function mf(t, e) {
  var r = { label: 0, sent: function() {
    if (i[0] & 1)
      throw i[1];
    return i[1];
  }, trys: [], ops: [] }, s, n, i, o;
  return o = { next: a(0), throw: a(1), return: a(2) }, typeof Symbol == "function" && (o[Symbol.iterator] = function() {
    return this;
  }), o;
  function a(c) {
    return function(h) {
      return u([c, h]);
    };
  }
  function u(c) {
    if (s)
      throw new TypeError("Generator is already executing.");
    for (; r; )
      try {
        if (s = 1, n && (i = c[0] & 2 ? n.return : c[0] ? n.throw || ((i = n.return) && i.call(n), 0) : n.next) && !(i = i.call(n, c[1])).done)
          return i;
        switch (n = 0, i && (c = [c[0] & 2, i.value]), c[0]) {
          case 0:
          case 1:
            i = c;
            break;
          case 4:
            return r.label++, { value: c[1], done: !1 };
          case 5:
            r.label++, n = c[1], c = [0];
            continue;
          case 7:
            c = r.ops.pop(), r.trys.pop();
            continue;
          default:
            if (i = r.trys, !(i = i.length > 0 && i[i.length - 1]) && (c[0] === 6 || c[0] === 2)) {
              r = 0;
              continue;
            }
            if (c[0] === 3 && (!i || c[1] > i[0] && c[1] < i[3])) {
              r.label = c[1];
              break;
            }
            if (c[0] === 6 && r.label < i[1]) {
              r.label = i[1], i = c;
              break;
            }
            if (i && r.label < i[2]) {
              r.label = i[2], r.ops.push(c);
              break;
            }
            i[2] && r.ops.pop(), r.trys.pop();
            continue;
        }
        c = e.call(t, r);
      } catch (h) {
        c = [6, h], n = 0;
      } finally {
        s = i = 0;
      }
    if (c[0] & 5)
      throw c[1];
    return { value: c[0] ? c[1] : void 0, done: !0 };
  }
}
function yf(t, e, r, s) {
  s === void 0 && (s = r), t[s] = e[r];
}
function vf(t, e) {
  for (var r in t)
    r !== "default" && !e.hasOwnProperty(r) && (e[r] = t[r]);
}
function Ja(t) {
  var e = typeof Symbol == "function" && Symbol.iterator, r = e && t[e], s = 0;
  if (r)
    return r.call(t);
  if (t && typeof t.length == "number")
    return {
      next: function() {
        return t && s >= t.length && (t = void 0), { value: t && t[s++], done: !t };
      }
    };
  throw new TypeError(e ? "Object is not iterable." : "Symbol.iterator is not defined.");
}
function Dl(t, e) {
  var r = typeof Symbol == "function" && t[Symbol.iterator];
  if (!r)
    return t;
  var s = r.call(t), n, i = [], o;
  try {
    for (; (e === void 0 || e-- > 0) && !(n = s.next()).done; )
      i.push(n.value);
  } catch (a) {
    o = { error: a };
  } finally {
    try {
      n && !n.done && (r = s.return) && r.call(s);
    } finally {
      if (o)
        throw o.error;
    }
  }
  return i;
}
function _f() {
  for (var t = [], e = 0; e < arguments.length; e++)
    t = t.concat(Dl(arguments[e]));
  return t;
}
function bf() {
  for (var t = 0, e = 0, r = arguments.length; e < r; e++)
    t += arguments[e].length;
  for (var s = Array(t), n = 0, e = 0; e < r; e++)
    for (var i = arguments[e], o = 0, a = i.length; o < a; o++, n++)
      s[n] = i[o];
  return s;
}
function Rn(t) {
  return this instanceof Rn ? (this.v = t, this) : new Rn(t);
}
function wf(t, e, r) {
  if (!Symbol.asyncIterator)
    throw new TypeError("Symbol.asyncIterator is not defined.");
  var s = r.apply(t, e || []), n, i = [];
  return n = {}, o("next"), o("throw"), o("return"), n[Symbol.asyncIterator] = function() {
    return this;
  }, n;
  function o(g) {
    s[g] && (n[g] = function(v) {
      return new Promise(function(b, S) {
        i.push([g, v, b, S]) > 1 || a(g, v);
      });
    });
  }
  function a(g, v) {
    try {
      u(s[g](v));
    } catch (b) {
      p(i[0][3], b);
    }
  }
  function u(g) {
    g.value instanceof Rn ? Promise.resolve(g.value.v).then(c, h) : p(i[0][2], g);
  }
  function c(g) {
    a("next", g);
  }
  function h(g) {
    a("throw", g);
  }
  function p(g, v) {
    g(v), i.shift(), i.length && a(i[0][0], i[0][1]);
  }
}
function Ef(t) {
  var e, r;
  return e = {}, s("next"), s("throw", function(n) {
    throw n;
  }), s("return"), e[Symbol.iterator] = function() {
    return this;
  }, e;
  function s(n, i) {
    e[n] = t[n] ? function(o) {
      return (r = !r) ? { value: Rn(t[n](o)), done: n === "return" } : i ? i(o) : o;
    } : i;
  }
}
function Sf(t) {
  if (!Symbol.asyncIterator)
    throw new TypeError("Symbol.asyncIterator is not defined.");
  var e = t[Symbol.asyncIterator], r;
  return e ? e.call(t) : (t = typeof Ja == "function" ? Ja(t) : t[Symbol.iterator](), r = {}, s("next"), s("throw"), s("return"), r[Symbol.asyncIterator] = function() {
    return this;
  }, r);
  function s(i) {
    r[i] = t[i] && function(o) {
      return new Promise(function(a, u) {
        o = t[i](o), n(a, u, o.done, o.value);
      });
    };
  }
  function n(i, o, a, u) {
    Promise.resolve(u).then(function(c) {
      i({ value: c, done: a });
    }, o);
  }
}
function If(t, e) {
  return Object.defineProperty ? Object.defineProperty(t, "raw", { value: e }) : t.raw = e, t;
}
function xf(t) {
  if (t && t.__esModule)
    return t;
  var e = {};
  if (t != null)
    for (var r in t)
      Object.hasOwnProperty.call(t, r) && (e[r] = t[r]);
  return e.default = t, e;
}
function Of(t) {
  return t && t.__esModule ? t : { default: t };
}
function Tf(t, e) {
  if (!e.has(t))
    throw new TypeError("attempted to get private field on non-instance");
  return e.get(t);
}
function Pf(t, e, r) {
  if (!e.has(t))
    throw new TypeError("attempted to set private field on non-instance");
  return e.set(t, r), r;
}
const Cf = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  get __assign() {
    return Ya;
  },
  __asyncDelegator: Ef,
  __asyncGenerator: wf,
  __asyncValues: Sf,
  __await: Rn,
  __awaiter: gf,
  __classPrivateFieldGet: Tf,
  __classPrivateFieldSet: Pf,
  __createBinding: yf,
  __decorate: hf,
  __exportStar: vf,
  __extends: lf,
  __generator: mf,
  __importDefault: Of,
  __importStar: xf,
  __makeTemplateObject: If,
  __metadata: ff,
  __param: pf,
  __read: Dl,
  __rest: df,
  __spread: _f,
  __spreadArrays: bf,
  __values: Ja
}, Symbol.toStringTag, { value: "Module" })), Vr = /* @__PURE__ */ ha(Cf);
var vn = {}, oe = {}, Rc = {}, _n = {}, Ac;
function Nf() {
  if (Ac)
    return _n;
  Ac = 1, Object.defineProperty(_n, "__esModule", { value: !0 }), _n.delay = void 0;
  function t(e) {
    return new Promise((r) => {
      setTimeout(() => {
        r(!0);
      }, e);
    });
  }
  return _n.delay = t, _n;
}
var Ss = {}, jc = {}, Zs = {}, Lc;
function kf() {
  return Lc || (Lc = 1, Object.defineProperty(Zs, "__esModule", { value: !0 }), Zs.ONE_THOUSAND = Zs.ONE_HUNDRED = void 0, Zs.ONE_HUNDRED = 100, Zs.ONE_THOUSAND = 1e3), Zs;
}
var Mc = {}, Dc;
function Rf() {
  return Dc || (Dc = 1, function(t) {
    Object.defineProperty(t, "__esModule", { value: !0 }), t.ONE_YEAR = t.FOUR_WEEKS = t.THREE_WEEKS = t.TWO_WEEKS = t.ONE_WEEK = t.THIRTY_DAYS = t.SEVEN_DAYS = t.FIVE_DAYS = t.THREE_DAYS = t.ONE_DAY = t.TWENTY_FOUR_HOURS = t.TWELVE_HOURS = t.SIX_HOURS = t.THREE_HOURS = t.ONE_HOUR = t.SIXTY_MINUTES = t.THIRTY_MINUTES = t.TEN_MINUTES = t.FIVE_MINUTES = t.ONE_MINUTE = t.SIXTY_SECONDS = t.THIRTY_SECONDS = t.TEN_SECONDS = t.FIVE_SECONDS = t.ONE_SECOND = void 0, t.ONE_SECOND = 1, t.FIVE_SECONDS = 5, t.TEN_SECONDS = 10, t.THIRTY_SECONDS = 30, t.SIXTY_SECONDS = 60, t.ONE_MINUTE = t.SIXTY_SECONDS, t.FIVE_MINUTES = t.ONE_MINUTE * 5, t.TEN_MINUTES = t.ONE_MINUTE * 10, t.THIRTY_MINUTES = t.ONE_MINUTE * 30, t.SIXTY_MINUTES = t.ONE_MINUTE * 60, t.ONE_HOUR = t.SIXTY_MINUTES, t.THREE_HOURS = t.ONE_HOUR * 3, t.SIX_HOURS = t.ONE_HOUR * 6, t.TWELVE_HOURS = t.ONE_HOUR * 12, t.TWENTY_FOUR_HOURS = t.ONE_HOUR * 24, t.ONE_DAY = t.TWENTY_FOUR_HOURS, t.THREE_DAYS = t.ONE_DAY * 3, t.FIVE_DAYS = t.ONE_DAY * 5, t.SEVEN_DAYS = t.ONE_DAY * 7, t.THIRTY_DAYS = t.ONE_DAY * 30, t.ONE_WEEK = t.SEVEN_DAYS, t.TWO_WEEKS = t.ONE_WEEK * 2, t.THREE_WEEKS = t.ONE_WEEK * 3, t.FOUR_WEEKS = t.ONE_WEEK * 4, t.ONE_YEAR = t.ONE_DAY * 365;
  }(Mc)), Mc;
}
var Uc;
function Ul() {
  return Uc || (Uc = 1, function(t) {
    Object.defineProperty(t, "__esModule", { value: !0 });
    const e = Vr;
    e.__exportStar(kf(), t), e.__exportStar(Rf(), t);
  }(jc)), jc;
}
var zc;
function Af() {
  if (zc)
    return Ss;
  zc = 1, Object.defineProperty(Ss, "__esModule", { value: !0 }), Ss.fromMiliseconds = Ss.toMiliseconds = void 0;
  const t = Ul();
  function e(s) {
    return s * t.ONE_THOUSAND;
  }
  Ss.toMiliseconds = e;
  function r(s) {
    return Math.floor(s / t.ONE_THOUSAND);
  }
  return Ss.fromMiliseconds = r, Ss;
}
var $c;
function jf() {
  return $c || ($c = 1, function(t) {
    Object.defineProperty(t, "__esModule", { value: !0 });
    const e = Vr;
    e.__exportStar(Nf(), t), e.__exportStar(Af(), t);
  }(Rc)), Rc;
}
var Fs = {}, Vc;
function Lf() {
  if (Vc)
    return Fs;
  Vc = 1, Object.defineProperty(Fs, "__esModule", { value: !0 }), Fs.Watch = void 0;
  class t {
    constructor() {
      this.timestamps = /* @__PURE__ */ new Map();
    }
    start(r) {
      if (this.timestamps.has(r))
        throw new Error(`Watch already started for label: ${r}`);
      this.timestamps.set(r, { started: Date.now() });
    }
    stop(r) {
      const s = this.get(r);
      if (typeof s.elapsed < "u")
        throw new Error(`Watch already stopped for label: ${r}`);
      const n = Date.now() - s.started;
      this.timestamps.set(r, { started: s.started, elapsed: n });
    }
    get(r) {
      const s = this.timestamps.get(r);
      if (typeof s > "u")
        throw new Error(`No timestamp found for label: ${r}`);
      return s;
    }
    elapsed(r) {
      const s = this.get(r);
      return s.elapsed || Date.now() - s.started;
    }
  }
  return Fs.Watch = t, Fs.default = t, Fs;
}
var qc = {}, bn = {}, Zc;
function Mf() {
  if (Zc)
    return bn;
  Zc = 1, Object.defineProperty(bn, "__esModule", { value: !0 }), bn.IWatch = void 0;
  class t {
  }
  return bn.IWatch = t, bn;
}
var Fc;
function Df() {
  return Fc || (Fc = 1, function(t) {
    Object.defineProperty(t, "__esModule", { value: !0 }), Vr.__exportStar(Mf(), t);
  }(qc)), qc;
}
(function(t) {
  Object.defineProperty(t, "__esModule", { value: !0 });
  const e = Vr;
  e.__exportStar(jf(), t), e.__exportStar(Lf(), t), e.__exportStar(Df(), t), e.__exportStar(Ul(), t);
})(oe);
var Wc = {}, wn = {};
let Us = class {
};
const Uf = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  IEvents: Us
}, Symbol.toStringTag, { value: "Module" })), zf = /* @__PURE__ */ ha(Uf);
var Kc;
function $f() {
  if (Kc)
    return wn;
  Kc = 1, Object.defineProperty(wn, "__esModule", { value: !0 }), wn.IHeartBeat = void 0;
  const t = zf;
  class e extends t.IEvents {
    constructor(s) {
      super();
    }
  }
  return wn.IHeartBeat = e, wn;
}
var Hc;
function zl() {
  return Hc || (Hc = 1, function(t) {
    Object.defineProperty(t, "__esModule", { value: !0 }), Vr.__exportStar($f(), t);
  }(Wc)), Wc;
}
var Bc = {}, Is = {}, Gc;
function Vf() {
  if (Gc)
    return Is;
  Gc = 1, Object.defineProperty(Is, "__esModule", { value: !0 }), Is.HEARTBEAT_EVENTS = Is.HEARTBEAT_INTERVAL = void 0;
  const t = oe;
  return Is.HEARTBEAT_INTERVAL = t.FIVE_SECONDS, Is.HEARTBEAT_EVENTS = {
    pulse: "heartbeat_pulse"
  }, Is;
}
var Yc;
function $l() {
  return Yc || (Yc = 1, function(t) {
    Object.defineProperty(t, "__esModule", { value: !0 }), Vr.__exportStar(Vf(), t);
  }(Bc)), Bc;
}
var Jc;
function qf() {
  if (Jc)
    return vn;
  Jc = 1, Object.defineProperty(vn, "__esModule", { value: !0 }), vn.HeartBeat = void 0;
  const t = Vr, e = Pr, r = oe, s = zl(), n = $l();
  class i extends s.IHeartBeat {
    constructor(a) {
      super(a), this.events = new e.EventEmitter(), this.interval = n.HEARTBEAT_INTERVAL, this.interval = (a == null ? void 0 : a.interval) || n.HEARTBEAT_INTERVAL;
    }
    static init(a) {
      return t.__awaiter(this, void 0, void 0, function* () {
        const u = new i(a);
        return yield u.init(), u;
      });
    }
    init() {
      return t.__awaiter(this, void 0, void 0, function* () {
        yield this.initialize();
      });
    }
    stop() {
      clearInterval(this.intervalRef);
    }
    on(a, u) {
      this.events.on(a, u);
    }
    once(a, u) {
      this.events.once(a, u);
    }
    off(a, u) {
      this.events.off(a, u);
    }
    removeListener(a, u) {
      this.events.removeListener(a, u);
    }
    initialize() {
      return t.__awaiter(this, void 0, void 0, function* () {
        this.intervalRef = setInterval(() => this.pulse(), r.toMiliseconds(this.interval));
      });
    }
    pulse() {
      this.events.emit(n.HEARTBEAT_EVENTS.pulse);
    }
  }
  return vn.HeartBeat = i, vn;
}
(function(t) {
  Object.defineProperty(t, "__esModule", { value: !0 });
  const e = Vr;
  e.__exportStar(qf(), t), e.__exportStar(zl(), t), e.__exportStar($l(), t);
})(un);
var Fe = {}, Ra, Xc;
function Zf() {
  if (Xc)
    return Ra;
  Xc = 1;
  function t(r) {
    try {
      return JSON.stringify(r);
    } catch {
      return '"[Circular]"';
    }
  }
  Ra = e;
  function e(r, s, n) {
    var i = n && n.stringify || t, o = 1;
    if (typeof r == "object" && r !== null) {
      var a = s.length + o;
      if (a === 1)
        return r;
      var u = new Array(a);
      u[0] = i(r);
      for (var c = 1; c < a; c++)
        u[c] = i(s[c]);
      return u.join(" ");
    }
    if (typeof r != "string")
      return r;
    var h = s.length;
    if (h === 0)
      return r;
    for (var p = "", g = 1 - o, v = -1, b = r && r.length || 0, S = 0; S < b; ) {
      if (r.charCodeAt(S) === 37 && S + 1 < b) {
        switch (v = v > -1 ? v : 0, r.charCodeAt(S + 1)) {
          case 100:
          case 102:
            if (g >= h || s[g] == null)
              break;
            v < S && (p += r.slice(v, S)), p += Number(s[g]), v = S + 2, S++;
            break;
          case 105:
            if (g >= h || s[g] == null)
              break;
            v < S && (p += r.slice(v, S)), p += Math.floor(Number(s[g])), v = S + 2, S++;
            break;
          case 79:
          case 111:
          case 106:
            if (g >= h || s[g] === void 0)
              break;
            v < S && (p += r.slice(v, S));
            var C = typeof s[g];
            if (C === "string") {
              p += "'" + s[g] + "'", v = S + 2, S++;
              break;
            }
            if (C === "function") {
              p += s[g].name || "<anonymous>", v = S + 2, S++;
              break;
            }
            p += i(s[g]), v = S + 2, S++;
            break;
          case 115:
            if (g >= h)
              break;
            v < S && (p += r.slice(v, S)), p += String(s[g]), v = S + 2, S++;
            break;
          case 37:
            v < S && (p += r.slice(v, S)), p += "%", v = S + 2, S++, g--;
            break;
        }
        ++g;
      }
      ++S;
    }
    return v === -1 ? r : (v < b && (p += r.slice(v)), p);
  }
  return Ra;
}
var Aa, Qc;
function Ff() {
  if (Qc)
    return Aa;
  Qc = 1;
  const t = Zf();
  Aa = n;
  const e = I().console || {}, r = {
    mapHttpRequest: b,
    mapHttpResponse: b,
    wrapRequestSerializer: S,
    wrapResponseSerializer: S,
    wrapErrorSerializer: S,
    req: b,
    res: b,
    err: g
  };
  function s(m, l) {
    return Array.isArray(m) ? m.filter(function(f) {
      return f !== "!stdSerializers.err";
    }) : m === !0 ? Object.keys(l) : !1;
  }
  function n(m) {
    m = m || {}, m.browser = m.browser || {};
    const l = m.browser.transmit;
    if (l && typeof l.send != "function")
      throw Error("pino: transmit option must have a send function");
    const f = m.browser.write || e;
    m.browser.write && (m.browser.asObject = !0);
    const L = m.serializers || {}, A = s(m.browser.serialize, L);
    let V = m.browser.serialize;
    Array.isArray(m.browser.serialize) && m.browser.serialize.indexOf("!stdSerializers.err") > -1 && (V = !1);
    const J = ["error", "fatal", "warn", "info", "debug", "trace"];
    typeof f == "function" && (f.error = f.fatal = f.warn = f.info = f.debug = f.trace = f), m.enabled === !1 && (m.level = "silent");
    const G = m.level || "info", O = Object.create(f);
    O.log || (O.log = C), Object.defineProperty(O, "levelVal", {
      get: Q
    }), Object.defineProperty(O, "level", {
      get: Z,
      set: z
    });
    const k = {
      transmit: l,
      serialize: A,
      asObject: m.browser.asObject,
      levels: J,
      timestamp: v(m)
    };
    O.levels = n.levels, O.level = G, O.setMaxListeners = O.getMaxListeners = O.emit = O.addListener = O.on = O.prependListener = O.once = O.prependOnceListener = O.removeListener = O.removeAllListeners = O.listeners = O.listenerCount = O.eventNames = O.write = O.flush = C, O.serializers = L, O._serialize = A, O._stdErrSerialize = V, O.child = q, l && (O._logEvent = p());
    function Q() {
      return this.level === "silent" ? 1 / 0 : this.levels.values[this.level];
    }
    function Z() {
      return this._level;
    }
    function z(U) {
      if (U !== "silent" && !this.levels.values[U])
        throw Error("unknown level " + U);
      this._level = U, i(k, O, "error", "log"), i(k, O, "fatal", "error"), i(k, O, "warn", "error"), i(k, O, "info", "log"), i(k, O, "debug", "log"), i(k, O, "trace", "log");
    }
    function q(U, F) {
      if (!U)
        throw new Error("missing bindings for child Pino");
      F = F || {}, A && U.serializers && (F.serializers = U.serializers);
      const me = F.serializers;
      if (A && me) {
        var W = Object.assign({}, L, me), de = m.browser.serialize === !0 ? Object.keys(W) : A;
        delete U.serializers, u([U], de, W, this._stdErrSerialize);
      }
      function se(le) {
        this._childLevel = (le._childLevel | 0) + 1, this.error = c(le, U, "error"), this.fatal = c(le, U, "fatal"), this.warn = c(le, U, "warn"), this.info = c(le, U, "info"), this.debug = c(le, U, "debug"), this.trace = c(le, U, "trace"), W && (this.serializers = W, this._serialize = de), l && (this._logEvent = p(
          [].concat(le._logEvent.bindings, U)
        ));
      }
      return se.prototype = this, new se(this);
    }
    return O;
  }
  n.levels = {
    values: {
      fatal: 60,
      error: 50,
      warn: 40,
      info: 30,
      debug: 20,
      trace: 10
    },
    labels: {
      10: "trace",
      20: "debug",
      30: "info",
      40: "warn",
      50: "error",
      60: "fatal"
    }
  }, n.stdSerializers = r, n.stdTimeFunctions = Object.assign({}, { nullTime: M, epochTime: _, unixTime: T, isoTime: E });
  function i(m, l, f, L) {
    const A = Object.getPrototypeOf(l);
    l[f] = l.levelVal > l.levels.values[f] ? C : A[f] ? A[f] : e[f] || e[L] || C, o(m, l, f);
  }
  function o(m, l, f) {
    !m.transmit && l[f] === C || (l[f] = /* @__PURE__ */ function(L) {
      return function() {
        const A = m.timestamp(), V = new Array(arguments.length), J = Object.getPrototypeOf && Object.getPrototypeOf(this) === e ? e : this;
        for (var G = 0; G < V.length; G++)
          V[G] = arguments[G];
        if (m.serialize && !m.asObject && u(V, this._serialize, this.serializers, this._stdErrSerialize), m.asObject ? L.call(J, a(this, f, V, A)) : L.apply(J, V), m.transmit) {
          const O = m.transmit.level || l.level, k = n.levels.values[O], Q = n.levels.values[f];
          if (Q < k)
            return;
          h(this, {
            ts: A,
            methodLevel: f,
            methodValue: Q,
            transmitLevel: O,
            transmitValue: n.levels.values[m.transmit.level || l.level],
            send: m.transmit.send,
            val: l.levelVal
          }, V);
        }
      };
    }(l[f]));
  }
  function a(m, l, f, L) {
    m._serialize && u(f, m._serialize, m.serializers, m._stdErrSerialize);
    const A = f.slice();
    let V = A[0];
    const J = {};
    L && (J.time = L), J.level = n.levels.values[l];
    let G = (m._childLevel | 0) + 1;
    if (G < 1 && (G = 1), V !== null && typeof V == "object") {
      for (; G-- && typeof A[0] == "object"; )
        Object.assign(J, A.shift());
      V = A.length ? t(A.shift(), A) : void 0;
    } else
      typeof V == "string" && (V = t(A.shift(), A));
    return V !== void 0 && (J.msg = V), J;
  }
  function u(m, l, f, L) {
    for (const A in m)
      if (L && m[A] instanceof Error)
        m[A] = n.stdSerializers.err(m[A]);
      else if (typeof m[A] == "object" && !Array.isArray(m[A]))
        for (const V in m[A])
          l && l.indexOf(V) > -1 && V in f && (m[A][V] = f[V](m[A][V]));
  }
  function c(m, l, f) {
    return function() {
      const L = new Array(1 + arguments.length);
      L[0] = l;
      for (var A = 1; A < L.length; A++)
        L[A] = arguments[A - 1];
      return m[f].apply(this, L);
    };
  }
  function h(m, l, f) {
    const L = l.send, A = l.ts, V = l.methodLevel, J = l.methodValue, G = l.val, O = m._logEvent.bindings;
    u(
      f,
      m._serialize || Object.keys(m.serializers),
      m.serializers,
      m._stdErrSerialize === void 0 ? !0 : m._stdErrSerialize
    ), m._logEvent.ts = A, m._logEvent.messages = f.filter(function(k) {
      return O.indexOf(k) === -1;
    }), m._logEvent.level.label = V, m._logEvent.level.value = J, L(V, m._logEvent, G), m._logEvent = p(O);
  }
  function p(m) {
    return {
      ts: 0,
      messages: [],
      bindings: m || [],
      level: { label: "", value: 0 }
    };
  }
  function g(m) {
    const l = {
      type: m.constructor.name,
      msg: m.message,
      stack: m.stack
    };
    for (const f in m)
      l[f] === void 0 && (l[f] = m[f]);
    return l;
  }
  function v(m) {
    return typeof m.timestamp == "function" ? m.timestamp : m.timestamp === !1 ? M : _;
  }
  function b() {
    return {};
  }
  function S(m) {
    return m;
  }
  function C() {
  }
  function M() {
    return !1;
  }
  function _() {
    return Date.now();
  }
  function T() {
    return Math.round(Date.now() / 1e3);
  }
  function E() {
    return new Date(Date.now()).toISOString();
  }
  function I() {
    function m(l) {
      return typeof l < "u" && l;
    }
    try {
      return typeof globalThis < "u" || Object.defineProperty(Object.prototype, "globalThis", {
        get: function() {
          return delete Object.prototype.globalThis, this.globalThis = this;
        },
        configurable: !0
      }), globalThis;
    } catch {
      return m(self) || m(window) || m(this) || {};
    }
  }
  return Aa;
}
var Ws = {}, eu;
function Vl() {
  return eu || (eu = 1, Object.defineProperty(Ws, "__esModule", { value: !0 }), Ws.PINO_CUSTOM_CONTEXT_KEY = Ws.PINO_LOGGER_DEFAULTS = void 0, Ws.PINO_LOGGER_DEFAULTS = {
    level: "info"
  }, Ws.PINO_CUSTOM_CONTEXT_KEY = "custom_context"), Ws;
}
var Kt = {}, tu;
function Wf() {
  if (tu)
    return Kt;
  tu = 1, Object.defineProperty(Kt, "__esModule", { value: !0 }), Kt.generateChildLogger = Kt.formatChildLoggerContext = Kt.getLoggerContext = Kt.setBrowserLoggerContext = Kt.getBrowserLoggerContext = Kt.getDefaultLoggerOptions = void 0;
  const t = Vl();
  function e(a) {
    return Object.assign(Object.assign({}, a), { level: (a == null ? void 0 : a.level) || t.PINO_LOGGER_DEFAULTS.level });
  }
  Kt.getDefaultLoggerOptions = e;
  function r(a, u = t.PINO_CUSTOM_CONTEXT_KEY) {
    return a[u] || "";
  }
  Kt.getBrowserLoggerContext = r;
  function s(a, u, c = t.PINO_CUSTOM_CONTEXT_KEY) {
    return a[c] = u, a;
  }
  Kt.setBrowserLoggerContext = s;
  function n(a, u = t.PINO_CUSTOM_CONTEXT_KEY) {
    let c = "";
    return typeof a.bindings > "u" ? c = r(a, u) : c = a.bindings().context || "", c;
  }
  Kt.getLoggerContext = n;
  function i(a, u, c = t.PINO_CUSTOM_CONTEXT_KEY) {
    const h = n(a, c);
    return h.trim() ? `${h}/${u}` : u;
  }
  Kt.formatChildLoggerContext = i;
  function o(a, u, c = t.PINO_CUSTOM_CONTEXT_KEY) {
    const h = i(a, u, c), p = a.child({ context: h });
    return s(p, h, c);
  }
  return Kt.generateChildLogger = o, Kt;
}
(function(t) {
  Object.defineProperty(t, "__esModule", { value: !0 }), t.pino = void 0;
  const e = Vr, r = e.__importDefault(Ff());
  Object.defineProperty(t, "pino", { enumerable: !0, get: function() {
    return r.default;
  } }), e.__exportStar(Vl(), t), e.__exportStar(Wf(), t);
})(Fe);
let Kf = class extends Us {
  constructor(t) {
    super(), this.opts = t, this.protocol = "wc", this.version = 2;
  }
}, Hf = class extends Us {
  constructor(t, e) {
    super(), this.core = t, this.logger = e, this.records = /* @__PURE__ */ new Map();
  }
}, Bf = class {
  constructor(t, e) {
    this.logger = t, this.core = e;
  }
}, Gf = class extends Us {
  constructor(t, e) {
    super(), this.relayer = t, this.logger = e;
  }
}, Yf = class extends Us {
  constructor(t) {
    super();
  }
}, Jf = class {
  constructor(t, e, r, s) {
    this.core = t, this.logger = e, this.name = r;
  }
};
class Xf extends Us {
  constructor(e, r) {
    super(), this.relayer = e, this.logger = r;
  }
}
class Qf extends Us {
  constructor(e, r) {
    super(), this.core = e, this.logger = r;
  }
}
let eg = class {
  constructor(t, e) {
    this.projectId = t, this.logger = e;
  }
}, tg = class {
  constructor(t, e) {
    this.projectId = t, this.logger = e;
  }
}, rg = class {
  constructor(t) {
    this.opts = t, this.protocol = "wc", this.version = 2;
  }
}, sg = class {
  constructor(t) {
    this.client = t;
  }
};
var Do = {}, ln = {}, ga = {}, ma = {};
Object.defineProperty(ma, "__esModule", { value: !0 });
ma.BrowserRandomSource = void 0;
const ru = 65536;
class ng {
  constructor() {
    this.isAvailable = !1, this.isInstantiated = !1;
    const e = typeof self < "u" ? self.crypto || self.msCrypto : null;
    e && e.getRandomValues !== void 0 && (this._crypto = e, this.isAvailable = !0, this.isInstantiated = !0);
  }
  randomBytes(e) {
    if (!this.isAvailable || !this._crypto)
      throw new Error("Browser random byte generator is not available.");
    const r = new Uint8Array(e);
    for (let s = 0; s < r.length; s += ru)
      this._crypto.getRandomValues(r.subarray(s, s + Math.min(r.length - s, ru)));
    return r;
  }
}
ma.BrowserRandomSource = ng;
function ig(t) {
  throw new Error('Could not dynamically require "' + t + '". Please configure the dynamicRequireTargets or/and ignoreDynamicRequires option of @rollup/plugin-commonjs appropriately for this require call to work.');
}
var ya = {}, or = {};
Object.defineProperty(or, "__esModule", { value: !0 });
function ag(t) {
  for (var e = 0; e < t.length; e++)
    t[e] = 0;
  return t;
}
or.wipe = ag;
const og = {}, cg = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: og
}, Symbol.toStringTag, { value: "Module" })), ug = /* @__PURE__ */ ha(cg);
Object.defineProperty(ya, "__esModule", { value: !0 });
ya.NodeRandomSource = void 0;
const lg = or;
class dg {
  constructor() {
    if (this.isAvailable = !1, this.isInstantiated = !1, typeof ig < "u") {
      const e = ug;
      e && e.randomBytes && (this._crypto = e, this.isAvailable = !0, this.isInstantiated = !0);
    }
  }
  randomBytes(e) {
    if (!this.isAvailable || !this._crypto)
      throw new Error("Node.js random byte generator is not available.");
    let r = this._crypto.randomBytes(e);
    if (r.length !== e)
      throw new Error("NodeRandomSource: got fewer bytes than requested");
    const s = new Uint8Array(e);
    for (let n = 0; n < s.length; n++)
      s[n] = r[n];
    return (0, lg.wipe)(r), s;
  }
}
ya.NodeRandomSource = dg;
Object.defineProperty(ga, "__esModule", { value: !0 });
ga.SystemRandomSource = void 0;
const hg = ma, pg = ya;
class fg {
  constructor() {
    if (this.isAvailable = !1, this.name = "", this._source = new hg.BrowserRandomSource(), this._source.isAvailable) {
      this.isAvailable = !0, this.name = "Browser";
      return;
    }
    if (this._source = new pg.NodeRandomSource(), this._source.isAvailable) {
      this.isAvailable = !0, this.name = "Node";
      return;
    }
  }
  randomBytes(e) {
    if (!this.isAvailable)
      throw new Error("System random byte generator is not available.");
    return this._source.randomBytes(e);
  }
}
ga.SystemRandomSource = fg;
var Ee = {}, ql = {};
(function(t) {
  Object.defineProperty(t, "__esModule", { value: !0 });
  function e(a, u) {
    var c = a >>> 16 & 65535, h = a & 65535, p = u >>> 16 & 65535, g = u & 65535;
    return h * g + (c * g + h * p << 16 >>> 0) | 0;
  }
  t.mul = Math.imul || e;
  function r(a, u) {
    return a + u | 0;
  }
  t.add = r;
  function s(a, u) {
    return a - u | 0;
  }
  t.sub = s;
  function n(a, u) {
    return a << u | a >>> 32 - u;
  }
  t.rotl = n;
  function i(a, u) {
    return a << 32 - u | a >>> u;
  }
  t.rotr = i;
  function o(a) {
    return typeof a == "number" && isFinite(a) && Math.floor(a) === a;
  }
  t.isInteger = Number.isInteger || o, t.MAX_SAFE_INTEGER = 9007199254740991, t.isSafeInteger = function(a) {
    return t.isInteger(a) && a >= -t.MAX_SAFE_INTEGER && a <= t.MAX_SAFE_INTEGER;
  };
})(ql);
Object.defineProperty(Ee, "__esModule", { value: !0 });
var Zl = ql;
function gg(t, e) {
  return e === void 0 && (e = 0), (t[e + 0] << 8 | t[e + 1]) << 16 >> 16;
}
Ee.readInt16BE = gg;
function mg(t, e) {
  return e === void 0 && (e = 0), (t[e + 0] << 8 | t[e + 1]) >>> 0;
}
Ee.readUint16BE = mg;
function yg(t, e) {
  return e === void 0 && (e = 0), (t[e + 1] << 8 | t[e]) << 16 >> 16;
}
Ee.readInt16LE = yg;
function vg(t, e) {
  return e === void 0 && (e = 0), (t[e + 1] << 8 | t[e]) >>> 0;
}
Ee.readUint16LE = vg;
function Fl(t, e, r) {
  return e === void 0 && (e = new Uint8Array(2)), r === void 0 && (r = 0), e[r + 0] = t >>> 8, e[r + 1] = t >>> 0, e;
}
Ee.writeUint16BE = Fl;
Ee.writeInt16BE = Fl;
function Wl(t, e, r) {
  return e === void 0 && (e = new Uint8Array(2)), r === void 0 && (r = 0), e[r + 0] = t >>> 0, e[r + 1] = t >>> 8, e;
}
Ee.writeUint16LE = Wl;
Ee.writeInt16LE = Wl;
function Xa(t, e) {
  return e === void 0 && (e = 0), t[e] << 24 | t[e + 1] << 16 | t[e + 2] << 8 | t[e + 3];
}
Ee.readInt32BE = Xa;
function Qa(t, e) {
  return e === void 0 && (e = 0), (t[e] << 24 | t[e + 1] << 16 | t[e + 2] << 8 | t[e + 3]) >>> 0;
}
Ee.readUint32BE = Qa;
function eo(t, e) {
  return e === void 0 && (e = 0), t[e + 3] << 24 | t[e + 2] << 16 | t[e + 1] << 8 | t[e];
}
Ee.readInt32LE = eo;
function to(t, e) {
  return e === void 0 && (e = 0), (t[e + 3] << 24 | t[e + 2] << 16 | t[e + 1] << 8 | t[e]) >>> 0;
}
Ee.readUint32LE = to;
function zi(t, e, r) {
  return e === void 0 && (e = new Uint8Array(4)), r === void 0 && (r = 0), e[r + 0] = t >>> 24, e[r + 1] = t >>> 16, e[r + 2] = t >>> 8, e[r + 3] = t >>> 0, e;
}
Ee.writeUint32BE = zi;
Ee.writeInt32BE = zi;
function $i(t, e, r) {
  return e === void 0 && (e = new Uint8Array(4)), r === void 0 && (r = 0), e[r + 0] = t >>> 0, e[r + 1] = t >>> 8, e[r + 2] = t >>> 16, e[r + 3] = t >>> 24, e;
}
Ee.writeUint32LE = $i;
Ee.writeInt32LE = $i;
function _g(t, e) {
  e === void 0 && (e = 0);
  var r = Xa(t, e), s = Xa(t, e + 4);
  return r * 4294967296 + s - (s >> 31) * 4294967296;
}
Ee.readInt64BE = _g;
function bg(t, e) {
  e === void 0 && (e = 0);
  var r = Qa(t, e), s = Qa(t, e + 4);
  return r * 4294967296 + s;
}
Ee.readUint64BE = bg;
function wg(t, e) {
  e === void 0 && (e = 0);
  var r = eo(t, e), s = eo(t, e + 4);
  return s * 4294967296 + r - (r >> 31) * 4294967296;
}
Ee.readInt64LE = wg;
function Eg(t, e) {
  e === void 0 && (e = 0);
  var r = to(t, e), s = to(t, e + 4);
  return s * 4294967296 + r;
}
Ee.readUint64LE = Eg;
function Kl(t, e, r) {
  return e === void 0 && (e = new Uint8Array(8)), r === void 0 && (r = 0), zi(t / 4294967296 >>> 0, e, r), zi(t >>> 0, e, r + 4), e;
}
Ee.writeUint64BE = Kl;
Ee.writeInt64BE = Kl;
function Hl(t, e, r) {
  return e === void 0 && (e = new Uint8Array(8)), r === void 0 && (r = 0), $i(t >>> 0, e, r), $i(t / 4294967296 >>> 0, e, r + 4), e;
}
Ee.writeUint64LE = Hl;
Ee.writeInt64LE = Hl;
function Sg(t, e, r) {
  if (r === void 0 && (r = 0), t % 8 !== 0)
    throw new Error("readUintBE supports only bitLengths divisible by 8");
  if (t / 8 > e.length - r)
    throw new Error("readUintBE: array is too short for the given bitLength");
  for (var s = 0, n = 1, i = t / 8 + r - 1; i >= r; i--)
    s += e[i] * n, n *= 256;
  return s;
}
Ee.readUintBE = Sg;
function Ig(t, e, r) {
  if (r === void 0 && (r = 0), t % 8 !== 0)
    throw new Error("readUintLE supports only bitLengths divisible by 8");
  if (t / 8 > e.length - r)
    throw new Error("readUintLE: array is too short for the given bitLength");
  for (var s = 0, n = 1, i = r; i < r + t / 8; i++)
    s += e[i] * n, n *= 256;
  return s;
}
Ee.readUintLE = Ig;
function xg(t, e, r, s) {
  if (r === void 0 && (r = new Uint8Array(t / 8)), s === void 0 && (s = 0), t % 8 !== 0)
    throw new Error("writeUintBE supports only bitLengths divisible by 8");
  if (!Zl.isSafeInteger(e))
    throw new Error("writeUintBE value must be an integer");
  for (var n = 1, i = t / 8 + s - 1; i >= s; i--)
    r[i] = e / n & 255, n *= 256;
  return r;
}
Ee.writeUintBE = xg;
function Og(t, e, r, s) {
  if (r === void 0 && (r = new Uint8Array(t / 8)), s === void 0 && (s = 0), t % 8 !== 0)
    throw new Error("writeUintLE supports only bitLengths divisible by 8");
  if (!Zl.isSafeInteger(e))
    throw new Error("writeUintLE value must be an integer");
  for (var n = 1, i = s; i < s + t / 8; i++)
    r[i] = e / n & 255, n *= 256;
  return r;
}
Ee.writeUintLE = Og;
function Tg(t, e) {
  e === void 0 && (e = 0);
  var r = new DataView(t.buffer, t.byteOffset, t.byteLength);
  return r.getFloat32(e);
}
Ee.readFloat32BE = Tg;
function Pg(t, e) {
  e === void 0 && (e = 0);
  var r = new DataView(t.buffer, t.byteOffset, t.byteLength);
  return r.getFloat32(e, !0);
}
Ee.readFloat32LE = Pg;
function Cg(t, e) {
  e === void 0 && (e = 0);
  var r = new DataView(t.buffer, t.byteOffset, t.byteLength);
  return r.getFloat64(e);
}
Ee.readFloat64BE = Cg;
function Ng(t, e) {
  e === void 0 && (e = 0);
  var r = new DataView(t.buffer, t.byteOffset, t.byteLength);
  return r.getFloat64(e, !0);
}
Ee.readFloat64LE = Ng;
function kg(t, e, r) {
  e === void 0 && (e = new Uint8Array(4)), r === void 0 && (r = 0);
  var s = new DataView(e.buffer, e.byteOffset, e.byteLength);
  return s.setFloat32(r, t), e;
}
Ee.writeFloat32BE = kg;
function Rg(t, e, r) {
  e === void 0 && (e = new Uint8Array(4)), r === void 0 && (r = 0);
  var s = new DataView(e.buffer, e.byteOffset, e.byteLength);
  return s.setFloat32(r, t, !0), e;
}
Ee.writeFloat32LE = Rg;
function Ag(t, e, r) {
  e === void 0 && (e = new Uint8Array(8)), r === void 0 && (r = 0);
  var s = new DataView(e.buffer, e.byteOffset, e.byteLength);
  return s.setFloat64(r, t), e;
}
Ee.writeFloat64BE = Ag;
function jg(t, e, r) {
  e === void 0 && (e = new Uint8Array(8)), r === void 0 && (r = 0);
  var s = new DataView(e.buffer, e.byteOffset, e.byteLength);
  return s.setFloat64(r, t, !0), e;
}
Ee.writeFloat64LE = jg;
(function(t) {
  Object.defineProperty(t, "__esModule", { value: !0 }), t.randomStringForEntropy = t.randomString = t.randomUint32 = t.randomBytes = t.defaultRandomSource = void 0;
  const e = ga, r = Ee, s = or;
  t.defaultRandomSource = new e.SystemRandomSource();
  function n(c, h = t.defaultRandomSource) {
    return h.randomBytes(c);
  }
  t.randomBytes = n;
  function i(c = t.defaultRandomSource) {
    const h = n(4, c), p = (0, r.readUint32LE)(h);
    return (0, s.wipe)(h), p;
  }
  t.randomUint32 = i;
  const o = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
  function a(c, h = o, p = t.defaultRandomSource) {
    if (h.length < 2)
      throw new Error("randomString charset is too short");
    if (h.length > 256)
      throw new Error("randomString charset is too long");
    let g = "";
    const v = h.length, b = 256 - 256 % v;
    for (; c > 0; ) {
      const S = n(Math.ceil(c * 256 / b), p);
      for (let C = 0; C < S.length && c > 0; C++) {
        const M = S[C];
        M < b && (g += h.charAt(M % v), c--);
      }
      (0, s.wipe)(S);
    }
    return g;
  }
  t.randomString = a;
  function u(c, h = o, p = t.defaultRandomSource) {
    const g = Math.ceil(c / (Math.log(h.length) / Math.LN2));
    return a(g, h, p);
  }
  t.randomStringForEntropy = u;
})(ln);
var Bl = {};
(function(t) {
  Object.defineProperty(t, "__esModule", { value: !0 });
  var e = Ee, r = or;
  t.DIGEST_LENGTH = 64, t.BLOCK_SIZE = 128;
  var s = (
    /** @class */
    function() {
      function a() {
        this.digestLength = t.DIGEST_LENGTH, this.blockSize = t.BLOCK_SIZE, this._stateHi = new Int32Array(8), this._stateLo = new Int32Array(8), this._tempHi = new Int32Array(16), this._tempLo = new Int32Array(16), this._buffer = new Uint8Array(256), this._bufferLength = 0, this._bytesHashed = 0, this._finished = !1, this.reset();
      }
      return a.prototype._initState = function() {
        this._stateHi[0] = 1779033703, this._stateHi[1] = 3144134277, this._stateHi[2] = 1013904242, this._stateHi[3] = 2773480762, this._stateHi[4] = 1359893119, this._stateHi[5] = 2600822924, this._stateHi[6] = 528734635, this._stateHi[7] = 1541459225, this._stateLo[0] = 4089235720, this._stateLo[1] = 2227873595, this._stateLo[2] = 4271175723, this._stateLo[3] = 1595750129, this._stateLo[4] = 2917565137, this._stateLo[5] = 725511199, this._stateLo[6] = 4215389547, this._stateLo[7] = 327033209;
      }, a.prototype.reset = function() {
        return this._initState(), this._bufferLength = 0, this._bytesHashed = 0, this._finished = !1, this;
      }, a.prototype.clean = function() {
        r.wipe(this._buffer), r.wipe(this._tempHi), r.wipe(this._tempLo), this.reset();
      }, a.prototype.update = function(u, c) {
        if (c === void 0 && (c = u.length), this._finished)
          throw new Error("SHA512: can't update because hash was finished.");
        var h = 0;
        if (this._bytesHashed += c, this._bufferLength > 0) {
          for (; this._bufferLength < t.BLOCK_SIZE && c > 0; )
            this._buffer[this._bufferLength++] = u[h++], c--;
          this._bufferLength === this.blockSize && (i(this._tempHi, this._tempLo, this._stateHi, this._stateLo, this._buffer, 0, this.blockSize), this._bufferLength = 0);
        }
        for (c >= this.blockSize && (h = i(this._tempHi, this._tempLo, this._stateHi, this._stateLo, u, h, c), c %= this.blockSize); c > 0; )
          this._buffer[this._bufferLength++] = u[h++], c--;
        return this;
      }, a.prototype.finish = function(u) {
        if (!this._finished) {
          var c = this._bytesHashed, h = this._bufferLength, p = c / 536870912 | 0, g = c << 3, v = c % 128 < 112 ? 128 : 256;
          this._buffer[h] = 128;
          for (var b = h + 1; b < v - 8; b++)
            this._buffer[b] = 0;
          e.writeUint32BE(p, this._buffer, v - 8), e.writeUint32BE(g, this._buffer, v - 4), i(this._tempHi, this._tempLo, this._stateHi, this._stateLo, this._buffer, 0, v), this._finished = !0;
        }
        for (var b = 0; b < this.digestLength / 8; b++)
          e.writeUint32BE(this._stateHi[b], u, b * 8), e.writeUint32BE(this._stateLo[b], u, b * 8 + 4);
        return this;
      }, a.prototype.digest = function() {
        var u = new Uint8Array(this.digestLength);
        return this.finish(u), u;
      }, a.prototype.saveState = function() {
        if (this._finished)
          throw new Error("SHA256: cannot save finished state");
        return {
          stateHi: new Int32Array(this._stateHi),
          stateLo: new Int32Array(this._stateLo),
          buffer: this._bufferLength > 0 ? new Uint8Array(this._buffer) : void 0,
          bufferLength: this._bufferLength,
          bytesHashed: this._bytesHashed
        };
      }, a.prototype.restoreState = function(u) {
        return this._stateHi.set(u.stateHi), this._stateLo.set(u.stateLo), this._bufferLength = u.bufferLength, u.buffer && this._buffer.set(u.buffer), this._bytesHashed = u.bytesHashed, this._finished = !1, this;
      }, a.prototype.cleanSavedState = function(u) {
        r.wipe(u.stateHi), r.wipe(u.stateLo), u.buffer && r.wipe(u.buffer), u.bufferLength = 0, u.bytesHashed = 0;
      }, a;
    }()
  );
  t.SHA512 = s;
  var n = new Int32Array([
    1116352408,
    3609767458,
    1899447441,
    602891725,
    3049323471,
    3964484399,
    3921009573,
    2173295548,
    961987163,
    4081628472,
    1508970993,
    3053834265,
    2453635748,
    2937671579,
    2870763221,
    3664609560,
    3624381080,
    2734883394,
    310598401,
    1164996542,
    607225278,
    1323610764,
    1426881987,
    3590304994,
    1925078388,
    4068182383,
    2162078206,
    991336113,
    2614888103,
    633803317,
    3248222580,
    3479774868,
    3835390401,
    2666613458,
    4022224774,
    944711139,
    264347078,
    2341262773,
    604807628,
    2007800933,
    770255983,
    1495990901,
    1249150122,
    1856431235,
    1555081692,
    3175218132,
    1996064986,
    2198950837,
    2554220882,
    3999719339,
    2821834349,
    766784016,
    2952996808,
    2566594879,
    3210313671,
    3203337956,
    3336571891,
    1034457026,
    3584528711,
    2466948901,
    113926993,
    3758326383,
    338241895,
    168717936,
    666307205,
    1188179964,
    773529912,
    1546045734,
    1294757372,
    1522805485,
    1396182291,
    2643833823,
    1695183700,
    2343527390,
    1986661051,
    1014477480,
    2177026350,
    1206759142,
    2456956037,
    344077627,
    2730485921,
    1290863460,
    2820302411,
    3158454273,
    3259730800,
    3505952657,
    3345764771,
    106217008,
    3516065817,
    3606008344,
    3600352804,
    1432725776,
    4094571909,
    1467031594,
    275423344,
    851169720,
    430227734,
    3100823752,
    506948616,
    1363258195,
    659060556,
    3750685593,
    883997877,
    3785050280,
    958139571,
    3318307427,
    1322822218,
    3812723403,
    1537002063,
    2003034995,
    1747873779,
    3602036899,
    1955562222,
    1575990012,
    2024104815,
    1125592928,
    2227730452,
    2716904306,
    2361852424,
    442776044,
    2428436474,
    593698344,
    2756734187,
    3733110249,
    3204031479,
    2999351573,
    3329325298,
    3815920427,
    3391569614,
    3928383900,
    3515267271,
    566280711,
    3940187606,
    3454069534,
    4118630271,
    4000239992,
    116418474,
    1914138554,
    174292421,
    2731055270,
    289380356,
    3203993006,
    460393269,
    320620315,
    685471733,
    587496836,
    852142971,
    1086792851,
    1017036298,
    365543100,
    1126000580,
    2618297676,
    1288033470,
    3409855158,
    1501505948,
    4234509866,
    1607167915,
    987167468,
    1816402316,
    1246189591
  ]);
  function i(a, u, c, h, p, g, v) {
    for (var b = c[0], S = c[1], C = c[2], M = c[3], _ = c[4], T = c[5], E = c[6], I = c[7], m = h[0], l = h[1], f = h[2], L = h[3], A = h[4], V = h[5], J = h[6], G = h[7], O, k, Q, Z, z, q, U, F; v >= 128; ) {
      for (var me = 0; me < 16; me++) {
        var W = 8 * me + g;
        a[me] = e.readUint32BE(p, W), u[me] = e.readUint32BE(p, W + 4);
      }
      for (var me = 0; me < 80; me++) {
        var de = b, se = S, le = C, j = M, R = _, P = T, d = E, x = I, B = m, ee = l, Ae = f, je = L, xe = A, qe = V, nt = J, Xe = G;
        if (O = I, k = G, z = k & 65535, q = k >>> 16, U = O & 65535, F = O >>> 16, O = (_ >>> 14 | A << 18) ^ (_ >>> 18 | A << 14) ^ (A >>> 9 | _ << 23), k = (A >>> 14 | _ << 18) ^ (A >>> 18 | _ << 14) ^ (_ >>> 9 | A << 23), z += k & 65535, q += k >>> 16, U += O & 65535, F += O >>> 16, O = _ & T ^ ~_ & E, k = A & V ^ ~A & J, z += k & 65535, q += k >>> 16, U += O & 65535, F += O >>> 16, O = n[me * 2], k = n[me * 2 + 1], z += k & 65535, q += k >>> 16, U += O & 65535, F += O >>> 16, O = a[me % 16], k = u[me % 16], z += k & 65535, q += k >>> 16, U += O & 65535, F += O >>> 16, q += z >>> 16, U += q >>> 16, F += U >>> 16, Q = U & 65535 | F << 16, Z = z & 65535 | q << 16, O = Q, k = Z, z = k & 65535, q = k >>> 16, U = O & 65535, F = O >>> 16, O = (b >>> 28 | m << 4) ^ (m >>> 2 | b << 30) ^ (m >>> 7 | b << 25), k = (m >>> 28 | b << 4) ^ (b >>> 2 | m << 30) ^ (b >>> 7 | m << 25), z += k & 65535, q += k >>> 16, U += O & 65535, F += O >>> 16, O = b & S ^ b & C ^ S & C, k = m & l ^ m & f ^ l & f, z += k & 65535, q += k >>> 16, U += O & 65535, F += O >>> 16, q += z >>> 16, U += q >>> 16, F += U >>> 16, x = U & 65535 | F << 16, Xe = z & 65535 | q << 16, O = j, k = je, z = k & 65535, q = k >>> 16, U = O & 65535, F = O >>> 16, O = Q, k = Z, z += k & 65535, q += k >>> 16, U += O & 65535, F += O >>> 16, q += z >>> 16, U += q >>> 16, F += U >>> 16, j = U & 65535 | F << 16, je = z & 65535 | q << 16, S = de, C = se, M = le, _ = j, T = R, E = P, I = d, b = x, l = B, f = ee, L = Ae, A = je, V = xe, J = qe, G = nt, m = Xe, me % 16 === 15)
          for (var W = 0; W < 16; W++)
            O = a[W], k = u[W], z = k & 65535, q = k >>> 16, U = O & 65535, F = O >>> 16, O = a[(W + 9) % 16], k = u[(W + 9) % 16], z += k & 65535, q += k >>> 16, U += O & 65535, F += O >>> 16, Q = a[(W + 1) % 16], Z = u[(W + 1) % 16], O = (Q >>> 1 | Z << 31) ^ (Q >>> 8 | Z << 24) ^ Q >>> 7, k = (Z >>> 1 | Q << 31) ^ (Z >>> 8 | Q << 24) ^ (Z >>> 7 | Q << 25), z += k & 65535, q += k >>> 16, U += O & 65535, F += O >>> 16, Q = a[(W + 14) % 16], Z = u[(W + 14) % 16], O = (Q >>> 19 | Z << 13) ^ (Z >>> 29 | Q << 3) ^ Q >>> 6, k = (Z >>> 19 | Q << 13) ^ (Q >>> 29 | Z << 3) ^ (Z >>> 6 | Q << 26), z += k & 65535, q += k >>> 16, U += O & 65535, F += O >>> 16, q += z >>> 16, U += q >>> 16, F += U >>> 16, a[W] = U & 65535 | F << 16, u[W] = z & 65535 | q << 16;
      }
      O = b, k = m, z = k & 65535, q = k >>> 16, U = O & 65535, F = O >>> 16, O = c[0], k = h[0], z += k & 65535, q += k >>> 16, U += O & 65535, F += O >>> 16, q += z >>> 16, U += q >>> 16, F += U >>> 16, c[0] = b = U & 65535 | F << 16, h[0] = m = z & 65535 | q << 16, O = S, k = l, z = k & 65535, q = k >>> 16, U = O & 65535, F = O >>> 16, O = c[1], k = h[1], z += k & 65535, q += k >>> 16, U += O & 65535, F += O >>> 16, q += z >>> 16, U += q >>> 16, F += U >>> 16, c[1] = S = U & 65535 | F << 16, h[1] = l = z & 65535 | q << 16, O = C, k = f, z = k & 65535, q = k >>> 16, U = O & 65535, F = O >>> 16, O = c[2], k = h[2], z += k & 65535, q += k >>> 16, U += O & 65535, F += O >>> 16, q += z >>> 16, U += q >>> 16, F += U >>> 16, c[2] = C = U & 65535 | F << 16, h[2] = f = z & 65535 | q << 16, O = M, k = L, z = k & 65535, q = k >>> 16, U = O & 65535, F = O >>> 16, O = c[3], k = h[3], z += k & 65535, q += k >>> 16, U += O & 65535, F += O >>> 16, q += z >>> 16, U += q >>> 16, F += U >>> 16, c[3] = M = U & 65535 | F << 16, h[3] = L = z & 65535 | q << 16, O = _, k = A, z = k & 65535, q = k >>> 16, U = O & 65535, F = O >>> 16, O = c[4], k = h[4], z += k & 65535, q += k >>> 16, U += O & 65535, F += O >>> 16, q += z >>> 16, U += q >>> 16, F += U >>> 16, c[4] = _ = U & 65535 | F << 16, h[4] = A = z & 65535 | q << 16, O = T, k = V, z = k & 65535, q = k >>> 16, U = O & 65535, F = O >>> 16, O = c[5], k = h[5], z += k & 65535, q += k >>> 16, U += O & 65535, F += O >>> 16, q += z >>> 16, U += q >>> 16, F += U >>> 16, c[5] = T = U & 65535 | F << 16, h[5] = V = z & 65535 | q << 16, O = E, k = J, z = k & 65535, q = k >>> 16, U = O & 65535, F = O >>> 16, O = c[6], k = h[6], z += k & 65535, q += k >>> 16, U += O & 65535, F += O >>> 16, q += z >>> 16, U += q >>> 16, F += U >>> 16, c[6] = E = U & 65535 | F << 16, h[6] = J = z & 65535 | q << 16, O = I, k = G, z = k & 65535, q = k >>> 16, U = O & 65535, F = O >>> 16, O = c[7], k = h[7], z += k & 65535, q += k >>> 16, U += O & 65535, F += O >>> 16, q += z >>> 16, U += q >>> 16, F += U >>> 16, c[7] = I = U & 65535 | F << 16, h[7] = G = z & 65535 | q << 16, g += 128, v -= 128;
    }
    return g;
  }
  function o(a) {
    var u = new s();
    u.update(a);
    var c = u.digest();
    return u.clean(), c;
  }
  t.hash = o;
})(Bl);
(function(t) {
  Object.defineProperty(t, "__esModule", { value: !0 }), t.convertSecretKeyToX25519 = t.convertPublicKeyToX25519 = t.verify = t.sign = t.extractPublicKeyFromSecretKey = t.generateKeyPair = t.generateKeyPairFromSeed = t.SEED_LENGTH = t.SECRET_KEY_LENGTH = t.PUBLIC_KEY_LENGTH = t.SIGNATURE_LENGTH = void 0;
  const e = ln, r = Bl, s = or;
  t.SIGNATURE_LENGTH = 64, t.PUBLIC_KEY_LENGTH = 32, t.SECRET_KEY_LENGTH = 64, t.SEED_LENGTH = 32;
  function n(j) {
    const R = new Float64Array(16);
    if (j)
      for (let P = 0; P < j.length; P++)
        R[P] = j[P];
    return R;
  }
  const i = new Uint8Array(32);
  i[0] = 9;
  const o = n(), a = n([1]), u = n([
    30883,
    4953,
    19914,
    30187,
    55467,
    16705,
    2637,
    112,
    59544,
    30585,
    16505,
    36039,
    65139,
    11119,
    27886,
    20995
  ]), c = n([
    61785,
    9906,
    39828,
    60374,
    45398,
    33411,
    5274,
    224,
    53552,
    61171,
    33010,
    6542,
    64743,
    22239,
    55772,
    9222
  ]), h = n([
    54554,
    36645,
    11616,
    51542,
    42930,
    38181,
    51040,
    26924,
    56412,
    64982,
    57905,
    49316,
    21502,
    52590,
    14035,
    8553
  ]), p = n([
    26200,
    26214,
    26214,
    26214,
    26214,
    26214,
    26214,
    26214,
    26214,
    26214,
    26214,
    26214,
    26214,
    26214,
    26214,
    26214
  ]), g = n([
    41136,
    18958,
    6951,
    50414,
    58488,
    44335,
    6150,
    12099,
    55207,
    15867,
    153,
    11085,
    57099,
    20417,
    9344,
    11139
  ]);
  function v(j, R) {
    for (let P = 0; P < 16; P++)
      j[P] = R[P] | 0;
  }
  function b(j) {
    let R = 1;
    for (let P = 0; P < 16; P++) {
      let d = j[P] + R + 65535;
      R = Math.floor(d / 65536), j[P] = d - R * 65536;
    }
    j[0] += R - 1 + 37 * (R - 1);
  }
  function S(j, R, P) {
    const d = ~(P - 1);
    for (let x = 0; x < 16; x++) {
      const B = d & (j[x] ^ R[x]);
      j[x] ^= B, R[x] ^= B;
    }
  }
  function C(j, R) {
    const P = n(), d = n();
    for (let x = 0; x < 16; x++)
      d[x] = R[x];
    b(d), b(d), b(d);
    for (let x = 0; x < 2; x++) {
      P[0] = d[0] - 65517;
      for (let ee = 1; ee < 15; ee++)
        P[ee] = d[ee] - 65535 - (P[ee - 1] >> 16 & 1), P[ee - 1] &= 65535;
      P[15] = d[15] - 32767 - (P[14] >> 16 & 1);
      const B = P[15] >> 16 & 1;
      P[14] &= 65535, S(d, P, 1 - B);
    }
    for (let x = 0; x < 16; x++)
      j[2 * x] = d[x] & 255, j[2 * x + 1] = d[x] >> 8;
  }
  function M(j, R) {
    let P = 0;
    for (let d = 0; d < 32; d++)
      P |= j[d] ^ R[d];
    return (1 & P - 1 >>> 8) - 1;
  }
  function _(j, R) {
    const P = new Uint8Array(32), d = new Uint8Array(32);
    return C(P, j), C(d, R), M(P, d);
  }
  function T(j) {
    const R = new Uint8Array(32);
    return C(R, j), R[0] & 1;
  }
  function E(j, R) {
    for (let P = 0; P < 16; P++)
      j[P] = R[2 * P] + (R[2 * P + 1] << 8);
    j[15] &= 32767;
  }
  function I(j, R, P) {
    for (let d = 0; d < 16; d++)
      j[d] = R[d] + P[d];
  }
  function m(j, R, P) {
    for (let d = 0; d < 16; d++)
      j[d] = R[d] - P[d];
  }
  function l(j, R, P) {
    let d, x, B = 0, ee = 0, Ae = 0, je = 0, xe = 0, qe = 0, nt = 0, Xe = 0, $e = 0, De = 0, Oe = 0, Ce = 0, Te = 0, we = 0, _e = 0, he = 0, Ne = 0, Le = 0, ye = 0, Ue = 0, Ze = 0, He = 0, Be = 0, We = 0, sr = 0, cr = 0, kr = 0, Rt = 0, Rr = 0, ur = 0, Qr = 0, it = P[0], tt = P[1], ht = P[2], ot = P[3], pt = P[4], rt = P[5], vt = P[6], St = P[7], It = P[8], _t = P[9], xt = P[10], bt = P[11], ft = P[12], Qe = P[13], w = P[14], D = P[15];
    d = R[0], B += d * it, ee += d * tt, Ae += d * ht, je += d * ot, xe += d * pt, qe += d * rt, nt += d * vt, Xe += d * St, $e += d * It, De += d * _t, Oe += d * xt, Ce += d * bt, Te += d * ft, we += d * Qe, _e += d * w, he += d * D, d = R[1], ee += d * it, Ae += d * tt, je += d * ht, xe += d * ot, qe += d * pt, nt += d * rt, Xe += d * vt, $e += d * St, De += d * It, Oe += d * _t, Ce += d * xt, Te += d * bt, we += d * ft, _e += d * Qe, he += d * w, Ne += d * D, d = R[2], Ae += d * it, je += d * tt, xe += d * ht, qe += d * ot, nt += d * pt, Xe += d * rt, $e += d * vt, De += d * St, Oe += d * It, Ce += d * _t, Te += d * xt, we += d * bt, _e += d * ft, he += d * Qe, Ne += d * w, Le += d * D, d = R[3], je += d * it, xe += d * tt, qe += d * ht, nt += d * ot, Xe += d * pt, $e += d * rt, De += d * vt, Oe += d * St, Ce += d * It, Te += d * _t, we += d * xt, _e += d * bt, he += d * ft, Ne += d * Qe, Le += d * w, ye += d * D, d = R[4], xe += d * it, qe += d * tt, nt += d * ht, Xe += d * ot, $e += d * pt, De += d * rt, Oe += d * vt, Ce += d * St, Te += d * It, we += d * _t, _e += d * xt, he += d * bt, Ne += d * ft, Le += d * Qe, ye += d * w, Ue += d * D, d = R[5], qe += d * it, nt += d * tt, Xe += d * ht, $e += d * ot, De += d * pt, Oe += d * rt, Ce += d * vt, Te += d * St, we += d * It, _e += d * _t, he += d * xt, Ne += d * bt, Le += d * ft, ye += d * Qe, Ue += d * w, Ze += d * D, d = R[6], nt += d * it, Xe += d * tt, $e += d * ht, De += d * ot, Oe += d * pt, Ce += d * rt, Te += d * vt, we += d * St, _e += d * It, he += d * _t, Ne += d * xt, Le += d * bt, ye += d * ft, Ue += d * Qe, Ze += d * w, He += d * D, d = R[7], Xe += d * it, $e += d * tt, De += d * ht, Oe += d * ot, Ce += d * pt, Te += d * rt, we += d * vt, _e += d * St, he += d * It, Ne += d * _t, Le += d * xt, ye += d * bt, Ue += d * ft, Ze += d * Qe, He += d * w, Be += d * D, d = R[8], $e += d * it, De += d * tt, Oe += d * ht, Ce += d * ot, Te += d * pt, we += d * rt, _e += d * vt, he += d * St, Ne += d * It, Le += d * _t, ye += d * xt, Ue += d * bt, Ze += d * ft, He += d * Qe, Be += d * w, We += d * D, d = R[9], De += d * it, Oe += d * tt, Ce += d * ht, Te += d * ot, we += d * pt, _e += d * rt, he += d * vt, Ne += d * St, Le += d * It, ye += d * _t, Ue += d * xt, Ze += d * bt, He += d * ft, Be += d * Qe, We += d * w, sr += d * D, d = R[10], Oe += d * it, Ce += d * tt, Te += d * ht, we += d * ot, _e += d * pt, he += d * rt, Ne += d * vt, Le += d * St, ye += d * It, Ue += d * _t, Ze += d * xt, He += d * bt, Be += d * ft, We += d * Qe, sr += d * w, cr += d * D, d = R[11], Ce += d * it, Te += d * tt, we += d * ht, _e += d * ot, he += d * pt, Ne += d * rt, Le += d * vt, ye += d * St, Ue += d * It, Ze += d * _t, He += d * xt, Be += d * bt, We += d * ft, sr += d * Qe, cr += d * w, kr += d * D, d = R[12], Te += d * it, we += d * tt, _e += d * ht, he += d * ot, Ne += d * pt, Le += d * rt, ye += d * vt, Ue += d * St, Ze += d * It, He += d * _t, Be += d * xt, We += d * bt, sr += d * ft, cr += d * Qe, kr += d * w, Rt += d * D, d = R[13], we += d * it, _e += d * tt, he += d * ht, Ne += d * ot, Le += d * pt, ye += d * rt, Ue += d * vt, Ze += d * St, He += d * It, Be += d * _t, We += d * xt, sr += d * bt, cr += d * ft, kr += d * Qe, Rt += d * w, Rr += d * D, d = R[14], _e += d * it, he += d * tt, Ne += d * ht, Le += d * ot, ye += d * pt, Ue += d * rt, Ze += d * vt, He += d * St, Be += d * It, We += d * _t, sr += d * xt, cr += d * bt, kr += d * ft, Rt += d * Qe, Rr += d * w, ur += d * D, d = R[15], he += d * it, Ne += d * tt, Le += d * ht, ye += d * ot, Ue += d * pt, Ze += d * rt, He += d * vt, Be += d * St, We += d * It, sr += d * _t, cr += d * xt, kr += d * bt, Rt += d * ft, Rr += d * Qe, ur += d * w, Qr += d * D, B += 38 * Ne, ee += 38 * Le, Ae += 38 * ye, je += 38 * Ue, xe += 38 * Ze, qe += 38 * He, nt += 38 * Be, Xe += 38 * We, $e += 38 * sr, De += 38 * cr, Oe += 38 * kr, Ce += 38 * Rt, Te += 38 * Rr, we += 38 * ur, _e += 38 * Qr, x = 1, d = B + x + 65535, x = Math.floor(d / 65536), B = d - x * 65536, d = ee + x + 65535, x = Math.floor(d / 65536), ee = d - x * 65536, d = Ae + x + 65535, x = Math.floor(d / 65536), Ae = d - x * 65536, d = je + x + 65535, x = Math.floor(d / 65536), je = d - x * 65536, d = xe + x + 65535, x = Math.floor(d / 65536), xe = d - x * 65536, d = qe + x + 65535, x = Math.floor(d / 65536), qe = d - x * 65536, d = nt + x + 65535, x = Math.floor(d / 65536), nt = d - x * 65536, d = Xe + x + 65535, x = Math.floor(d / 65536), Xe = d - x * 65536, d = $e + x + 65535, x = Math.floor(d / 65536), $e = d - x * 65536, d = De + x + 65535, x = Math.floor(d / 65536), De = d - x * 65536, d = Oe + x + 65535, x = Math.floor(d / 65536), Oe = d - x * 65536, d = Ce + x + 65535, x = Math.floor(d / 65536), Ce = d - x * 65536, d = Te + x + 65535, x = Math.floor(d / 65536), Te = d - x * 65536, d = we + x + 65535, x = Math.floor(d / 65536), we = d - x * 65536, d = _e + x + 65535, x = Math.floor(d / 65536), _e = d - x * 65536, d = he + x + 65535, x = Math.floor(d / 65536), he = d - x * 65536, B += x - 1 + 37 * (x - 1), x = 1, d = B + x + 65535, x = Math.floor(d / 65536), B = d - x * 65536, d = ee + x + 65535, x = Math.floor(d / 65536), ee = d - x * 65536, d = Ae + x + 65535, x = Math.floor(d / 65536), Ae = d - x * 65536, d = je + x + 65535, x = Math.floor(d / 65536), je = d - x * 65536, d = xe + x + 65535, x = Math.floor(d / 65536), xe = d - x * 65536, d = qe + x + 65535, x = Math.floor(d / 65536), qe = d - x * 65536, d = nt + x + 65535, x = Math.floor(d / 65536), nt = d - x * 65536, d = Xe + x + 65535, x = Math.floor(d / 65536), Xe = d - x * 65536, d = $e + x + 65535, x = Math.floor(d / 65536), $e = d - x * 65536, d = De + x + 65535, x = Math.floor(d / 65536), De = d - x * 65536, d = Oe + x + 65535, x = Math.floor(d / 65536), Oe = d - x * 65536, d = Ce + x + 65535, x = Math.floor(d / 65536), Ce = d - x * 65536, d = Te + x + 65535, x = Math.floor(d / 65536), Te = d - x * 65536, d = we + x + 65535, x = Math.floor(d / 65536), we = d - x * 65536, d = _e + x + 65535, x = Math.floor(d / 65536), _e = d - x * 65536, d = he + x + 65535, x = Math.floor(d / 65536), he = d - x * 65536, B += x - 1 + 37 * (x - 1), j[0] = B, j[1] = ee, j[2] = Ae, j[3] = je, j[4] = xe, j[5] = qe, j[6] = nt, j[7] = Xe, j[8] = $e, j[9] = De, j[10] = Oe, j[11] = Ce, j[12] = Te, j[13] = we, j[14] = _e, j[15] = he;
  }
  function f(j, R) {
    l(j, R, R);
  }
  function L(j, R) {
    const P = n();
    let d;
    for (d = 0; d < 16; d++)
      P[d] = R[d];
    for (d = 253; d >= 0; d--)
      f(P, P), d !== 2 && d !== 4 && l(P, P, R);
    for (d = 0; d < 16; d++)
      j[d] = P[d];
  }
  function A(j, R) {
    const P = n();
    let d;
    for (d = 0; d < 16; d++)
      P[d] = R[d];
    for (d = 250; d >= 0; d--)
      f(P, P), d !== 1 && l(P, P, R);
    for (d = 0; d < 16; d++)
      j[d] = P[d];
  }
  function V(j, R) {
    const P = n(), d = n(), x = n(), B = n(), ee = n(), Ae = n(), je = n(), xe = n(), qe = n();
    m(P, j[1], j[0]), m(qe, R[1], R[0]), l(P, P, qe), I(d, j[0], j[1]), I(qe, R[0], R[1]), l(d, d, qe), l(x, j[3], R[3]), l(x, x, c), l(B, j[2], R[2]), I(B, B, B), m(ee, d, P), m(Ae, B, x), I(je, B, x), I(xe, d, P), l(j[0], ee, Ae), l(j[1], xe, je), l(j[2], je, Ae), l(j[3], ee, xe);
  }
  function J(j, R, P) {
    for (let d = 0; d < 4; d++)
      S(j[d], R[d], P);
  }
  function G(j, R) {
    const P = n(), d = n(), x = n();
    L(x, R[2]), l(P, R[0], x), l(d, R[1], x), C(j, d), j[31] ^= T(P) << 7;
  }
  function O(j, R, P) {
    v(j[0], o), v(j[1], a), v(j[2], a), v(j[3], o);
    for (let d = 255; d >= 0; --d) {
      const x = P[d / 8 | 0] >> (d & 7) & 1;
      J(j, R, x), V(R, j), V(j, j), J(j, R, x);
    }
  }
  function k(j, R) {
    const P = [n(), n(), n(), n()];
    v(P[0], h), v(P[1], p), v(P[2], a), l(P[3], h, p), O(j, P, R);
  }
  function Q(j) {
    if (j.length !== t.SEED_LENGTH)
      throw new Error(`ed25519: seed must be ${t.SEED_LENGTH} bytes`);
    const R = (0, r.hash)(j);
    R[0] &= 248, R[31] &= 127, R[31] |= 64;
    const P = new Uint8Array(32), d = [n(), n(), n(), n()];
    k(d, R), G(P, d);
    const x = new Uint8Array(64);
    return x.set(j), x.set(P, 32), {
      publicKey: P,
      secretKey: x
    };
  }
  t.generateKeyPairFromSeed = Q;
  function Z(j) {
    const R = (0, e.randomBytes)(32, j), P = Q(R);
    return (0, s.wipe)(R), P;
  }
  t.generateKeyPair = Z;
  function z(j) {
    if (j.length !== t.SECRET_KEY_LENGTH)
      throw new Error(`ed25519: secret key must be ${t.SECRET_KEY_LENGTH} bytes`);
    return new Uint8Array(j.subarray(32));
  }
  t.extractPublicKeyFromSecretKey = z;
  const q = new Float64Array([
    237,
    211,
    245,
    92,
    26,
    99,
    18,
    88,
    214,
    156,
    247,
    162,
    222,
    249,
    222,
    20,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
    16
  ]);
  function U(j, R) {
    let P, d, x, B;
    for (d = 63; d >= 32; --d) {
      for (P = 0, x = d - 32, B = d - 12; x < B; ++x)
        R[x] += P - 16 * R[d] * q[x - (d - 32)], P = Math.floor((R[x] + 128) / 256), R[x] -= P * 256;
      R[x] += P, R[d] = 0;
    }
    for (P = 0, x = 0; x < 32; x++)
      R[x] += P - (R[31] >> 4) * q[x], P = R[x] >> 8, R[x] &= 255;
    for (x = 0; x < 32; x++)
      R[x] -= P * q[x];
    for (d = 0; d < 32; d++)
      R[d + 1] += R[d] >> 8, j[d] = R[d] & 255;
  }
  function F(j) {
    const R = new Float64Array(64);
    for (let P = 0; P < 64; P++)
      R[P] = j[P];
    for (let P = 0; P < 64; P++)
      j[P] = 0;
    U(j, R);
  }
  function me(j, R) {
    const P = new Float64Array(64), d = [n(), n(), n(), n()], x = (0, r.hash)(j.subarray(0, 32));
    x[0] &= 248, x[31] &= 127, x[31] |= 64;
    const B = new Uint8Array(64);
    B.set(x.subarray(32), 32);
    const ee = new r.SHA512();
    ee.update(B.subarray(32)), ee.update(R);
    const Ae = ee.digest();
    ee.clean(), F(Ae), k(d, Ae), G(B, d), ee.reset(), ee.update(B.subarray(0, 32)), ee.update(j.subarray(32)), ee.update(R);
    const je = ee.digest();
    F(je);
    for (let xe = 0; xe < 32; xe++)
      P[xe] = Ae[xe];
    for (let xe = 0; xe < 32; xe++)
      for (let qe = 0; qe < 32; qe++)
        P[xe + qe] += je[xe] * x[qe];
    return U(B.subarray(32), P), B;
  }
  t.sign = me;
  function W(j, R) {
    const P = n(), d = n(), x = n(), B = n(), ee = n(), Ae = n(), je = n();
    return v(j[2], a), E(j[1], R), f(x, j[1]), l(B, x, u), m(x, x, j[2]), I(B, j[2], B), f(ee, B), f(Ae, ee), l(je, Ae, ee), l(P, je, x), l(P, P, B), A(P, P), l(P, P, x), l(P, P, B), l(P, P, B), l(j[0], P, B), f(d, j[0]), l(d, d, B), _(d, x) && l(j[0], j[0], g), f(d, j[0]), l(d, d, B), _(d, x) ? -1 : (T(j[0]) === R[31] >> 7 && m(j[0], o, j[0]), l(j[3], j[0], j[1]), 0);
  }
  function de(j, R, P) {
    const d = new Uint8Array(32), x = [n(), n(), n(), n()], B = [n(), n(), n(), n()];
    if (P.length !== t.SIGNATURE_LENGTH)
      throw new Error(`ed25519: signature must be ${t.SIGNATURE_LENGTH} bytes`);
    if (W(B, j))
      return !1;
    const ee = new r.SHA512();
    ee.update(P.subarray(0, 32)), ee.update(j), ee.update(R);
    const Ae = ee.digest();
    return F(Ae), O(x, B, Ae), k(B, P.subarray(32)), V(x, B), G(d, x), !M(P, d);
  }
  t.verify = de;
  function se(j) {
    let R = [n(), n(), n(), n()];
    if (W(R, j))
      throw new Error("Ed25519: invalid public key");
    let P = n(), d = n(), x = R[1];
    I(P, a, x), m(d, a, x), L(d, d), l(P, P, d);
    let B = new Uint8Array(32);
    return C(B, P), B;
  }
  t.convertPublicKeyToX25519 = se;
  function le(j) {
    const R = (0, r.hash)(j.subarray(0, 32));
    R[0] &= 248, R[31] &= 127, R[31] |= 64;
    const P = new Uint8Array(R.subarray(0, 32));
    return (0, s.wipe)(R), P;
  }
  t.convertSecretKeyToX25519 = le;
})(Do);
const Lg = "EdDSA", Mg = "JWT", Gl = ".", Yl = "base64url", Dg = "utf8", Ug = "utf8", zg = ":", $g = "did", Vg = "key", su = "base58btc", qg = "z", Zg = "K36", Fg = 32;
function Uo(t) {
  return globalThis.Buffer != null ? new Uint8Array(t.buffer, t.byteOffset, t.byteLength) : t;
}
function Jl(t = 0) {
  return globalThis.Buffer != null && globalThis.Buffer.allocUnsafe != null ? Uo(globalThis.Buffer.allocUnsafe(t)) : new Uint8Array(t);
}
function ro(t, e) {
  e || (e = t.reduce((n, i) => n + i.length, 0));
  const r = Jl(e);
  let s = 0;
  for (const n of t)
    r.set(n, s), s += n.length;
  return Uo(r);
}
function Wg(t, e) {
  if (t.length >= 255)
    throw new TypeError("Alphabet too long");
  for (var r = new Uint8Array(256), s = 0; s < r.length; s++)
    r[s] = 255;
  for (var n = 0; n < t.length; n++) {
    var i = t.charAt(n), o = i.charCodeAt(0);
    if (r[o] !== 255)
      throw new TypeError(i + " is ambiguous");
    r[o] = n;
  }
  var a = t.length, u = t.charAt(0), c = Math.log(a) / Math.log(256), h = Math.log(256) / Math.log(a);
  function p(b) {
    if (b instanceof Uint8Array || (ArrayBuffer.isView(b) ? b = new Uint8Array(b.buffer, b.byteOffset, b.byteLength) : Array.isArray(b) && (b = Uint8Array.from(b))), !(b instanceof Uint8Array))
      throw new TypeError("Expected Uint8Array");
    if (b.length === 0)
      return "";
    for (var S = 0, C = 0, M = 0, _ = b.length; M !== _ && b[M] === 0; )
      M++, S++;
    for (var T = (_ - M) * h + 1 >>> 0, E = new Uint8Array(T); M !== _; ) {
      for (var I = b[M], m = 0, l = T - 1; (I !== 0 || m < C) && l !== -1; l--, m++)
        I += 256 * E[l] >>> 0, E[l] = I % a >>> 0, I = I / a >>> 0;
      if (I !== 0)
        throw new Error("Non-zero carry");
      C = m, M++;
    }
    for (var f = T - C; f !== T && E[f] === 0; )
      f++;
    for (var L = u.repeat(S); f < T; ++f)
      L += t.charAt(E[f]);
    return L;
  }
  function g(b) {
    if (typeof b != "string")
      throw new TypeError("Expected String");
    if (b.length === 0)
      return new Uint8Array();
    var S = 0;
    if (b[S] !== " ") {
      for (var C = 0, M = 0; b[S] === u; )
        C++, S++;
      for (var _ = (b.length - S) * c + 1 >>> 0, T = new Uint8Array(_); b[S]; ) {
        var E = r[b.charCodeAt(S)];
        if (E === 255)
          return;
        for (var I = 0, m = _ - 1; (E !== 0 || I < M) && m !== -1; m--, I++)
          E += a * T[m] >>> 0, T[m] = E % 256 >>> 0, E = E / 256 >>> 0;
        if (E !== 0)
          throw new Error("Non-zero carry");
        M = I, S++;
      }
      if (b[S] !== " ") {
        for (var l = _ - M; l !== _ && T[l] === 0; )
          l++;
        for (var f = new Uint8Array(C + (_ - l)), L = C; l !== _; )
          f[L++] = T[l++];
        return f;
      }
    }
  }
  function v(b) {
    var S = g(b);
    if (S)
      return S;
    throw new Error(`Non-${e} character`);
  }
  return {
    encode: p,
    decodeUnsafe: g,
    decode: v
  };
}
var Kg = Wg, Hg = Kg;
const Bg = (t) => {
  if (t instanceof Uint8Array && t.constructor.name === "Uint8Array")
    return t;
  if (t instanceof ArrayBuffer)
    return new Uint8Array(t);
  if (ArrayBuffer.isView(t))
    return new Uint8Array(t.buffer, t.byteOffset, t.byteLength);
  throw new Error("Unknown type, must be binary type");
}, Gg = (t) => new TextEncoder().encode(t), Yg = (t) => new TextDecoder().decode(t);
class Jg {
  constructor(e, r, s) {
    this.name = e, this.prefix = r, this.baseEncode = s;
  }
  encode(e) {
    if (e instanceof Uint8Array)
      return `${this.prefix}${this.baseEncode(e)}`;
    throw Error("Unknown type, must be binary type");
  }
}
class Xg {
  constructor(e, r, s) {
    if (this.name = e, this.prefix = r, r.codePointAt(0) === void 0)
      throw new Error("Invalid prefix character");
    this.prefixCodePoint = r.codePointAt(0), this.baseDecode = s;
  }
  decode(e) {
    if (typeof e == "string") {
      if (e.codePointAt(0) !== this.prefixCodePoint)
        throw Error(`Unable to decode multibase string ${JSON.stringify(e)}, ${this.name} decoder only supports inputs prefixed with ${this.prefix}`);
      return this.baseDecode(e.slice(this.prefix.length));
    } else
      throw Error("Can only multibase decode strings");
  }
  or(e) {
    return Xl(this, e);
  }
}
class Qg {
  constructor(e) {
    this.decoders = e;
  }
  or(e) {
    return Xl(this, e);
  }
  decode(e) {
    const r = e[0], s = this.decoders[r];
    if (s)
      return s.decode(e);
    throw RangeError(`Unable to decode multibase string ${JSON.stringify(e)}, only inputs prefixed with ${Object.keys(this.decoders)} are supported`);
  }
}
const Xl = (t, e) => new Qg({
  ...t.decoders || { [t.prefix]: t },
  ...e.decoders || { [e.prefix]: e }
});
class em {
  constructor(e, r, s, n) {
    this.name = e, this.prefix = r, this.baseEncode = s, this.baseDecode = n, this.encoder = new Jg(e, r, s), this.decoder = new Xg(e, r, n);
  }
  encode(e) {
    return this.encoder.encode(e);
  }
  decode(e) {
    return this.decoder.decode(e);
  }
}
const va = ({ name: t, prefix: e, encode: r, decode: s }) => new em(t, e, r, s), ci = ({ prefix: t, name: e, alphabet: r }) => {
  const { encode: s, decode: n } = Hg(r, e);
  return va({
    prefix: t,
    name: e,
    encode: s,
    decode: (i) => Bg(n(i))
  });
}, tm = (t, e, r, s) => {
  const n = {};
  for (let h = 0; h < e.length; ++h)
    n[e[h]] = h;
  let i = t.length;
  for (; t[i - 1] === "="; )
    --i;
  const o = new Uint8Array(i * r / 8 | 0);
  let a = 0, u = 0, c = 0;
  for (let h = 0; h < i; ++h) {
    const p = n[t[h]];
    if (p === void 0)
      throw new SyntaxError(`Non-${s} character`);
    u = u << r | p, a += r, a >= 8 && (a -= 8, o[c++] = 255 & u >> a);
  }
  if (a >= r || 255 & u << 8 - a)
    throw new SyntaxError("Unexpected end of data");
  return o;
}, rm = (t, e, r) => {
  const s = e[e.length - 1] === "=", n = (1 << r) - 1;
  let i = "", o = 0, a = 0;
  for (let u = 0; u < t.length; ++u)
    for (a = a << 8 | t[u], o += 8; o > r; )
      o -= r, i += e[n & a >> o];
  if (o && (i += e[n & a << r - o]), s)
    for (; i.length * r & 7; )
      i += "=";
  return i;
}, Lt = ({ name: t, prefix: e, bitsPerChar: r, alphabet: s }) => va({
  prefix: e,
  name: t,
  encode(n) {
    return rm(n, s, r);
  },
  decode(n) {
    return tm(n, s, r, t);
  }
}), sm = va({
  prefix: "\0",
  name: "identity",
  encode: (t) => Yg(t),
  decode: (t) => Gg(t)
}), nm = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  identity: sm
}, Symbol.toStringTag, { value: "Module" })), im = Lt({
  prefix: "0",
  name: "base2",
  alphabet: "01",
  bitsPerChar: 1
}), am = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  base2: im
}, Symbol.toStringTag, { value: "Module" })), om = Lt({
  prefix: "7",
  name: "base8",
  alphabet: "01234567",
  bitsPerChar: 3
}), cm = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  base8: om
}, Symbol.toStringTag, { value: "Module" })), um = ci({
  prefix: "9",
  name: "base10",
  alphabet: "0123456789"
}), lm = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  base10: um
}, Symbol.toStringTag, { value: "Module" })), dm = Lt({
  prefix: "f",
  name: "base16",
  alphabet: "0123456789abcdef",
  bitsPerChar: 4
}), hm = Lt({
  prefix: "F",
  name: "base16upper",
  alphabet: "0123456789ABCDEF",
  bitsPerChar: 4
}), pm = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  base16: dm,
  base16upper: hm
}, Symbol.toStringTag, { value: "Module" })), fm = Lt({
  prefix: "b",
  name: "base32",
  alphabet: "abcdefghijklmnopqrstuvwxyz234567",
  bitsPerChar: 5
}), gm = Lt({
  prefix: "B",
  name: "base32upper",
  alphabet: "ABCDEFGHIJKLMNOPQRSTUVWXYZ234567",
  bitsPerChar: 5
}), mm = Lt({
  prefix: "c",
  name: "base32pad",
  alphabet: "abcdefghijklmnopqrstuvwxyz234567=",
  bitsPerChar: 5
}), ym = Lt({
  prefix: "C",
  name: "base32padupper",
  alphabet: "ABCDEFGHIJKLMNOPQRSTUVWXYZ234567=",
  bitsPerChar: 5
}), vm = Lt({
  prefix: "v",
  name: "base32hex",
  alphabet: "0123456789abcdefghijklmnopqrstuv",
  bitsPerChar: 5
}), _m = Lt({
  prefix: "V",
  name: "base32hexupper",
  alphabet: "0123456789ABCDEFGHIJKLMNOPQRSTUV",
  bitsPerChar: 5
}), bm = Lt({
  prefix: "t",
  name: "base32hexpad",
  alphabet: "0123456789abcdefghijklmnopqrstuv=",
  bitsPerChar: 5
}), wm = Lt({
  prefix: "T",
  name: "base32hexpadupper",
  alphabet: "0123456789ABCDEFGHIJKLMNOPQRSTUV=",
  bitsPerChar: 5
}), Em = Lt({
  prefix: "h",
  name: "base32z",
  alphabet: "ybndrfg8ejkmcpqxot1uwisza345h769",
  bitsPerChar: 5
}), Sm = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  base32: fm,
  base32hex: vm,
  base32hexpad: bm,
  base32hexpadupper: wm,
  base32hexupper: _m,
  base32pad: mm,
  base32padupper: ym,
  base32upper: gm,
  base32z: Em
}, Symbol.toStringTag, { value: "Module" })), Im = ci({
  prefix: "k",
  name: "base36",
  alphabet: "0123456789abcdefghijklmnopqrstuvwxyz"
}), xm = ci({
  prefix: "K",
  name: "base36upper",
  alphabet: "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"
}), Om = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  base36: Im,
  base36upper: xm
}, Symbol.toStringTag, { value: "Module" })), Tm = ci({
  name: "base58btc",
  prefix: "z",
  alphabet: "123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz"
}), Pm = ci({
  name: "base58flickr",
  prefix: "Z",
  alphabet: "123456789abcdefghijkmnopqrstuvwxyzABCDEFGHJKLMNPQRSTUVWXYZ"
}), Cm = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  base58btc: Tm,
  base58flickr: Pm
}, Symbol.toStringTag, { value: "Module" })), Nm = Lt({
  prefix: "m",
  name: "base64",
  alphabet: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",
  bitsPerChar: 6
}), km = Lt({
  prefix: "M",
  name: "base64pad",
  alphabet: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
  bitsPerChar: 6
}), Rm = Lt({
  prefix: "u",
  name: "base64url",
  alphabet: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_",
  bitsPerChar: 6
}), Am = Lt({
  prefix: "U",
  name: "base64urlpad",
  alphabet: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_=",
  bitsPerChar: 6
}), jm = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  base64: Nm,
  base64pad: km,
  base64url: Rm,
  base64urlpad: Am
}, Symbol.toStringTag, { value: "Module" })), Ql = Array.from("🚀🪐☄🛰🌌🌑🌒🌓🌔🌕🌖🌗🌘🌍🌏🌎🐉☀💻🖥💾💿😂❤😍🤣😊🙏💕😭😘👍😅👏😁🔥🥰💔💖💙😢🤔😆🙄💪😉☺👌🤗💜😔😎😇🌹🤦🎉💞✌✨🤷😱😌🌸🙌😋💗💚😏💛🙂💓🤩😄😀🖤😃💯🙈👇🎶😒🤭❣😜💋👀😪😑💥🙋😞😩😡🤪👊🥳😥🤤👉💃😳✋😚😝😴🌟😬🙃🍀🌷😻😓⭐✅🥺🌈😈🤘💦✔😣🏃💐☹🎊💘😠☝😕🌺🎂🌻😐🖕💝🙊😹🗣💫💀👑🎵🤞😛🔴😤🌼😫⚽🤙☕🏆🤫👈😮🙆🍻🍃🐶💁😲🌿🧡🎁⚡🌞🎈❌✊👋😰🤨😶🤝🚶💰🍓💢🤟🙁🚨💨🤬✈🎀🍺🤓😙💟🌱😖👶🥴▶➡❓💎💸⬇😨🌚🦋😷🕺⚠🙅😟😵👎🤲🤠🤧📌🔵💅🧐🐾🍒😗🤑🌊🤯🐷☎💧😯💆👆🎤🙇🍑❄🌴💣🐸💌📍🥀🤢👅💡💩👐📸👻🤐🤮🎼🥵🚩🍎🍊👼💍📣🥂"), Lm = Ql.reduce((t, e, r) => (t[r] = e, t), []), Mm = Ql.reduce((t, e, r) => (t[e.codePointAt(0)] = r, t), []);
function Dm(t) {
  return t.reduce((e, r) => (e += Lm[r], e), "");
}
function Um(t) {
  const e = [];
  for (const r of t) {
    const s = Mm[r.codePointAt(0)];
    if (s === void 0)
      throw new Error(`Non-base256emoji character: ${r}`);
    e.push(s);
  }
  return new Uint8Array(e);
}
const zm = va({
  prefix: "🚀",
  name: "base256emoji",
  encode: Dm,
  decode: Um
}), $m = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  base256emoji: zm
}, Symbol.toStringTag, { value: "Module" }));
new TextEncoder();
new TextDecoder();
const nu = {
  ...nm,
  ...am,
  ...cm,
  ...lm,
  ...pm,
  ...Sm,
  ...Om,
  ...Cm,
  ...jm,
  ...$m
};
function ed(t, e, r, s) {
  return {
    name: t,
    prefix: e,
    encoder: {
      name: t,
      prefix: e,
      encode: r
    },
    decoder: { decode: s }
  };
}
const iu = ed("utf8", "u", (t) => "u" + new TextDecoder("utf8").decode(t), (t) => new TextEncoder().encode(t.substring(1))), ja = ed("ascii", "a", (t) => {
  let e = "a";
  for (let r = 0; r < t.length; r++)
    e += String.fromCharCode(t[r]);
  return e;
}, (t) => {
  t = t.substring(1);
  const e = Jl(t.length);
  for (let r = 0; r < t.length; r++)
    e[r] = t.charCodeAt(r);
  return e;
}), td = {
  utf8: iu,
  "utf-8": iu,
  hex: nu.base16,
  latin1: ja,
  ascii: ja,
  binary: ja,
  ...nu
};
function Jt(t, e = "utf8") {
  const r = td[e];
  if (!r)
    throw new Error(`Unsupported encoding "${e}"`);
  return (e === "utf8" || e === "utf-8") && globalThis.Buffer != null && globalThis.Buffer.from != null ? globalThis.Buffer.from(t.buffer, t.byteOffset, t.byteLength).toString("utf8") : r.encoder.encode(t).substring(1);
}
function rr(t, e = "utf8") {
  const r = td[e];
  if (!r)
    throw new Error(`Unsupported encoding "${e}"`);
  return (e === "utf8" || e === "utf-8") && globalThis.Buffer != null && globalThis.Buffer.from != null ? Uo(globalThis.Buffer.from(t, "utf-8")) : r.decoder.decode(`${r.prefix}${t}`);
}
function Vi(t) {
  return Jt(rr(oi(t), Dg), Yl);
}
function rd(t) {
  const e = rr(Zg, su), r = qg + Jt(ro([e, t]), su);
  return [$g, Vg, r].join(zg);
}
function Vm(t) {
  return Jt(t, Yl);
}
function qm(t) {
  return rr([Vi(t.header), Vi(t.payload)].join(Gl), Ug);
}
function Zm(t) {
  return [
    Vi(t.header),
    Vi(t.payload),
    Vm(t.signature)
  ].join(Gl);
}
function au(t = ln.randomBytes(Fg)) {
  return Do.generateKeyPairFromSeed(t);
}
async function Fm(t, e, r, s, n = oe.fromMiliseconds(Date.now())) {
  const i = { alg: Lg, typ: Mg }, o = rd(s.publicKey), a = n + r, u = { iss: o, sub: t, aud: e, iat: n, exp: a }, c = qm({ header: i, payload: u }), h = Do.sign(s.secretKey, c);
  return Zm({ header: i, payload: u, signature: h });
}
var zo = {}, _a = {};
Object.defineProperty(_a, "__esModule", { value: !0 });
var zt = Ee, so = or, Wm = 20;
function Km(t, e, r) {
  for (var s = 1634760805, n = 857760878, i = 2036477234, o = 1797285236, a = r[3] << 24 | r[2] << 16 | r[1] << 8 | r[0], u = r[7] << 24 | r[6] << 16 | r[5] << 8 | r[4], c = r[11] << 24 | r[10] << 16 | r[9] << 8 | r[8], h = r[15] << 24 | r[14] << 16 | r[13] << 8 | r[12], p = r[19] << 24 | r[18] << 16 | r[17] << 8 | r[16], g = r[23] << 24 | r[22] << 16 | r[21] << 8 | r[20], v = r[27] << 24 | r[26] << 16 | r[25] << 8 | r[24], b = r[31] << 24 | r[30] << 16 | r[29] << 8 | r[28], S = e[3] << 24 | e[2] << 16 | e[1] << 8 | e[0], C = e[7] << 24 | e[6] << 16 | e[5] << 8 | e[4], M = e[11] << 24 | e[10] << 16 | e[9] << 8 | e[8], _ = e[15] << 24 | e[14] << 16 | e[13] << 8 | e[12], T = s, E = n, I = i, m = o, l = a, f = u, L = c, A = h, V = p, J = g, G = v, O = b, k = S, Q = C, Z = M, z = _, q = 0; q < Wm; q += 2)
    T = T + l | 0, k ^= T, k = k >>> 16 | k << 16, V = V + k | 0, l ^= V, l = l >>> 20 | l << 12, E = E + f | 0, Q ^= E, Q = Q >>> 16 | Q << 16, J = J + Q | 0, f ^= J, f = f >>> 20 | f << 12, I = I + L | 0, Z ^= I, Z = Z >>> 16 | Z << 16, G = G + Z | 0, L ^= G, L = L >>> 20 | L << 12, m = m + A | 0, z ^= m, z = z >>> 16 | z << 16, O = O + z | 0, A ^= O, A = A >>> 20 | A << 12, I = I + L | 0, Z ^= I, Z = Z >>> 24 | Z << 8, G = G + Z | 0, L ^= G, L = L >>> 25 | L << 7, m = m + A | 0, z ^= m, z = z >>> 24 | z << 8, O = O + z | 0, A ^= O, A = A >>> 25 | A << 7, E = E + f | 0, Q ^= E, Q = Q >>> 24 | Q << 8, J = J + Q | 0, f ^= J, f = f >>> 25 | f << 7, T = T + l | 0, k ^= T, k = k >>> 24 | k << 8, V = V + k | 0, l ^= V, l = l >>> 25 | l << 7, T = T + f | 0, z ^= T, z = z >>> 16 | z << 16, G = G + z | 0, f ^= G, f = f >>> 20 | f << 12, E = E + L | 0, k ^= E, k = k >>> 16 | k << 16, O = O + k | 0, L ^= O, L = L >>> 20 | L << 12, I = I + A | 0, Q ^= I, Q = Q >>> 16 | Q << 16, V = V + Q | 0, A ^= V, A = A >>> 20 | A << 12, m = m + l | 0, Z ^= m, Z = Z >>> 16 | Z << 16, J = J + Z | 0, l ^= J, l = l >>> 20 | l << 12, I = I + A | 0, Q ^= I, Q = Q >>> 24 | Q << 8, V = V + Q | 0, A ^= V, A = A >>> 25 | A << 7, m = m + l | 0, Z ^= m, Z = Z >>> 24 | Z << 8, J = J + Z | 0, l ^= J, l = l >>> 25 | l << 7, E = E + L | 0, k ^= E, k = k >>> 24 | k << 8, O = O + k | 0, L ^= O, L = L >>> 25 | L << 7, T = T + f | 0, z ^= T, z = z >>> 24 | z << 8, G = G + z | 0, f ^= G, f = f >>> 25 | f << 7;
  zt.writeUint32LE(T + s | 0, t, 0), zt.writeUint32LE(E + n | 0, t, 4), zt.writeUint32LE(I + i | 0, t, 8), zt.writeUint32LE(m + o | 0, t, 12), zt.writeUint32LE(l + a | 0, t, 16), zt.writeUint32LE(f + u | 0, t, 20), zt.writeUint32LE(L + c | 0, t, 24), zt.writeUint32LE(A + h | 0, t, 28), zt.writeUint32LE(V + p | 0, t, 32), zt.writeUint32LE(J + g | 0, t, 36), zt.writeUint32LE(G + v | 0, t, 40), zt.writeUint32LE(O + b | 0, t, 44), zt.writeUint32LE(k + S | 0, t, 48), zt.writeUint32LE(Q + C | 0, t, 52), zt.writeUint32LE(Z + M | 0, t, 56), zt.writeUint32LE(z + _ | 0, t, 60);
}
function sd(t, e, r, s, n) {
  if (n === void 0 && (n = 0), t.length !== 32)
    throw new Error("ChaCha: key size must be 32 bytes");
  if (s.length < r.length)
    throw new Error("ChaCha: destination is shorter than source");
  var i, o;
  if (n === 0) {
    if (e.length !== 8 && e.length !== 12)
      throw new Error("ChaCha nonce must be 8 or 12 bytes");
    i = new Uint8Array(16), o = i.length - e.length, i.set(e, o);
  } else {
    if (e.length !== 16)
      throw new Error("ChaCha nonce with counter must be 16 bytes");
    i = e, o = n;
  }
  for (var a = new Uint8Array(64), u = 0; u < r.length; u += 64) {
    Km(a, i, t);
    for (var c = u; c < u + 64 && c < r.length; c++)
      s[c] = r[c] ^ a[c - u];
    Bm(i, 0, o);
  }
  return so.wipe(a), n === 0 && so.wipe(i), s;
}
_a.streamXOR = sd;
function Hm(t, e, r, s) {
  return s === void 0 && (s = 0), so.wipe(r), sd(t, e, r, r, s);
}
_a.stream = Hm;
function Bm(t, e, r) {
  for (var s = 1; r--; )
    s = s + (t[e] & 255) | 0, t[e] = s & 255, s >>>= 8, e++;
  if (s > 0)
    throw new Error("ChaCha: counter overflow");
}
var nd = {}, vs = {};
Object.defineProperty(vs, "__esModule", { value: !0 });
function Gm(t, e, r) {
  return ~(t - 1) & e | t - 1 & r;
}
vs.select = Gm;
function Ym(t, e) {
  return (t | 0) - (e | 0) - 1 >>> 31 & 1;
}
vs.lessOrEqual = Ym;
function id(t, e) {
  if (t.length !== e.length)
    return 0;
  for (var r = 0, s = 0; s < t.length; s++)
    r |= t[s] ^ e[s];
  return 1 & r - 1 >>> 8;
}
vs.compare = id;
function Jm(t, e) {
  return t.length === 0 || e.length === 0 ? !1 : id(t, e) !== 0;
}
vs.equal = Jm;
(function(t) {
  Object.defineProperty(t, "__esModule", { value: !0 });
  var e = vs, r = or;
  t.DIGEST_LENGTH = 16;
  var s = (
    /** @class */
    function() {
      function o(a) {
        this.digestLength = t.DIGEST_LENGTH, this._buffer = new Uint8Array(16), this._r = new Uint16Array(10), this._h = new Uint16Array(10), this._pad = new Uint16Array(8), this._leftover = 0, this._fin = 0, this._finished = !1;
        var u = a[0] | a[1] << 8;
        this._r[0] = u & 8191;
        var c = a[2] | a[3] << 8;
        this._r[1] = (u >>> 13 | c << 3) & 8191;
        var h = a[4] | a[5] << 8;
        this._r[2] = (c >>> 10 | h << 6) & 7939;
        var p = a[6] | a[7] << 8;
        this._r[3] = (h >>> 7 | p << 9) & 8191;
        var g = a[8] | a[9] << 8;
        this._r[4] = (p >>> 4 | g << 12) & 255, this._r[5] = g >>> 1 & 8190;
        var v = a[10] | a[11] << 8;
        this._r[6] = (g >>> 14 | v << 2) & 8191;
        var b = a[12] | a[13] << 8;
        this._r[7] = (v >>> 11 | b << 5) & 8065;
        var S = a[14] | a[15] << 8;
        this._r[8] = (b >>> 8 | S << 8) & 8191, this._r[9] = S >>> 5 & 127, this._pad[0] = a[16] | a[17] << 8, this._pad[1] = a[18] | a[19] << 8, this._pad[2] = a[20] | a[21] << 8, this._pad[3] = a[22] | a[23] << 8, this._pad[4] = a[24] | a[25] << 8, this._pad[5] = a[26] | a[27] << 8, this._pad[6] = a[28] | a[29] << 8, this._pad[7] = a[30] | a[31] << 8;
      }
      return o.prototype._blocks = function(a, u, c) {
        for (var h = this._fin ? 0 : 2048, p = this._h[0], g = this._h[1], v = this._h[2], b = this._h[3], S = this._h[4], C = this._h[5], M = this._h[6], _ = this._h[7], T = this._h[8], E = this._h[9], I = this._r[0], m = this._r[1], l = this._r[2], f = this._r[3], L = this._r[4], A = this._r[5], V = this._r[6], J = this._r[7], G = this._r[8], O = this._r[9]; c >= 16; ) {
          var k = a[u + 0] | a[u + 1] << 8;
          p += k & 8191;
          var Q = a[u + 2] | a[u + 3] << 8;
          g += (k >>> 13 | Q << 3) & 8191;
          var Z = a[u + 4] | a[u + 5] << 8;
          v += (Q >>> 10 | Z << 6) & 8191;
          var z = a[u + 6] | a[u + 7] << 8;
          b += (Z >>> 7 | z << 9) & 8191;
          var q = a[u + 8] | a[u + 9] << 8;
          S += (z >>> 4 | q << 12) & 8191, C += q >>> 1 & 8191;
          var U = a[u + 10] | a[u + 11] << 8;
          M += (q >>> 14 | U << 2) & 8191;
          var F = a[u + 12] | a[u + 13] << 8;
          _ += (U >>> 11 | F << 5) & 8191;
          var me = a[u + 14] | a[u + 15] << 8;
          T += (F >>> 8 | me << 8) & 8191, E += me >>> 5 | h;
          var W = 0, de = W;
          de += p * I, de += g * (5 * O), de += v * (5 * G), de += b * (5 * J), de += S * (5 * V), W = de >>> 13, de &= 8191, de += C * (5 * A), de += M * (5 * L), de += _ * (5 * f), de += T * (5 * l), de += E * (5 * m), W += de >>> 13, de &= 8191;
          var se = W;
          se += p * m, se += g * I, se += v * (5 * O), se += b * (5 * G), se += S * (5 * J), W = se >>> 13, se &= 8191, se += C * (5 * V), se += M * (5 * A), se += _ * (5 * L), se += T * (5 * f), se += E * (5 * l), W += se >>> 13, se &= 8191;
          var le = W;
          le += p * l, le += g * m, le += v * I, le += b * (5 * O), le += S * (5 * G), W = le >>> 13, le &= 8191, le += C * (5 * J), le += M * (5 * V), le += _ * (5 * A), le += T * (5 * L), le += E * (5 * f), W += le >>> 13, le &= 8191;
          var j = W;
          j += p * f, j += g * l, j += v * m, j += b * I, j += S * (5 * O), W = j >>> 13, j &= 8191, j += C * (5 * G), j += M * (5 * J), j += _ * (5 * V), j += T * (5 * A), j += E * (5 * L), W += j >>> 13, j &= 8191;
          var R = W;
          R += p * L, R += g * f, R += v * l, R += b * m, R += S * I, W = R >>> 13, R &= 8191, R += C * (5 * O), R += M * (5 * G), R += _ * (5 * J), R += T * (5 * V), R += E * (5 * A), W += R >>> 13, R &= 8191;
          var P = W;
          P += p * A, P += g * L, P += v * f, P += b * l, P += S * m, W = P >>> 13, P &= 8191, P += C * I, P += M * (5 * O), P += _ * (5 * G), P += T * (5 * J), P += E * (5 * V), W += P >>> 13, P &= 8191;
          var d = W;
          d += p * V, d += g * A, d += v * L, d += b * f, d += S * l, W = d >>> 13, d &= 8191, d += C * m, d += M * I, d += _ * (5 * O), d += T * (5 * G), d += E * (5 * J), W += d >>> 13, d &= 8191;
          var x = W;
          x += p * J, x += g * V, x += v * A, x += b * L, x += S * f, W = x >>> 13, x &= 8191, x += C * l, x += M * m, x += _ * I, x += T * (5 * O), x += E * (5 * G), W += x >>> 13, x &= 8191;
          var B = W;
          B += p * G, B += g * J, B += v * V, B += b * A, B += S * L, W = B >>> 13, B &= 8191, B += C * f, B += M * l, B += _ * m, B += T * I, B += E * (5 * O), W += B >>> 13, B &= 8191;
          var ee = W;
          ee += p * O, ee += g * G, ee += v * J, ee += b * V, ee += S * A, W = ee >>> 13, ee &= 8191, ee += C * L, ee += M * f, ee += _ * l, ee += T * m, ee += E * I, W += ee >>> 13, ee &= 8191, W = (W << 2) + W | 0, W = W + de | 0, de = W & 8191, W = W >>> 13, se += W, p = de, g = se, v = le, b = j, S = R, C = P, M = d, _ = x, T = B, E = ee, u += 16, c -= 16;
        }
        this._h[0] = p, this._h[1] = g, this._h[2] = v, this._h[3] = b, this._h[4] = S, this._h[5] = C, this._h[6] = M, this._h[7] = _, this._h[8] = T, this._h[9] = E;
      }, o.prototype.finish = function(a, u) {
        u === void 0 && (u = 0);
        var c = new Uint16Array(10), h, p, g, v;
        if (this._leftover) {
          for (v = this._leftover, this._buffer[v++] = 1; v < 16; v++)
            this._buffer[v] = 0;
          this._fin = 1, this._blocks(this._buffer, 0, 16);
        }
        for (h = this._h[1] >>> 13, this._h[1] &= 8191, v = 2; v < 10; v++)
          this._h[v] += h, h = this._h[v] >>> 13, this._h[v] &= 8191;
        for (this._h[0] += h * 5, h = this._h[0] >>> 13, this._h[0] &= 8191, this._h[1] += h, h = this._h[1] >>> 13, this._h[1] &= 8191, this._h[2] += h, c[0] = this._h[0] + 5, h = c[0] >>> 13, c[0] &= 8191, v = 1; v < 10; v++)
          c[v] = this._h[v] + h, h = c[v] >>> 13, c[v] &= 8191;
        for (c[9] -= 8192, p = (h ^ 1) - 1, v = 0; v < 10; v++)
          c[v] &= p;
        for (p = ~p, v = 0; v < 10; v++)
          this._h[v] = this._h[v] & p | c[v];
        for (this._h[0] = (this._h[0] | this._h[1] << 13) & 65535, this._h[1] = (this._h[1] >>> 3 | this._h[2] << 10) & 65535, this._h[2] = (this._h[2] >>> 6 | this._h[3] << 7) & 65535, this._h[3] = (this._h[3] >>> 9 | this._h[4] << 4) & 65535, this._h[4] = (this._h[4] >>> 12 | this._h[5] << 1 | this._h[6] << 14) & 65535, this._h[5] = (this._h[6] >>> 2 | this._h[7] << 11) & 65535, this._h[6] = (this._h[7] >>> 5 | this._h[8] << 8) & 65535, this._h[7] = (this._h[8] >>> 8 | this._h[9] << 5) & 65535, g = this._h[0] + this._pad[0], this._h[0] = g & 65535, v = 1; v < 8; v++)
          g = (this._h[v] + this._pad[v] | 0) + (g >>> 16) | 0, this._h[v] = g & 65535;
        return a[u + 0] = this._h[0] >>> 0, a[u + 1] = this._h[0] >>> 8, a[u + 2] = this._h[1] >>> 0, a[u + 3] = this._h[1] >>> 8, a[u + 4] = this._h[2] >>> 0, a[u + 5] = this._h[2] >>> 8, a[u + 6] = this._h[3] >>> 0, a[u + 7] = this._h[3] >>> 8, a[u + 8] = this._h[4] >>> 0, a[u + 9] = this._h[4] >>> 8, a[u + 10] = this._h[5] >>> 0, a[u + 11] = this._h[5] >>> 8, a[u + 12] = this._h[6] >>> 0, a[u + 13] = this._h[6] >>> 8, a[u + 14] = this._h[7] >>> 0, a[u + 15] = this._h[7] >>> 8, this._finished = !0, this;
      }, o.prototype.update = function(a) {
        var u = 0, c = a.length, h;
        if (this._leftover) {
          h = 16 - this._leftover, h > c && (h = c);
          for (var p = 0; p < h; p++)
            this._buffer[this._leftover + p] = a[u + p];
          if (c -= h, u += h, this._leftover += h, this._leftover < 16)
            return this;
          this._blocks(this._buffer, 0, 16), this._leftover = 0;
        }
        if (c >= 16 && (h = c - c % 16, this._blocks(a, u, h), u += h, c -= h), c) {
          for (var p = 0; p < c; p++)
            this._buffer[this._leftover + p] = a[u + p];
          this._leftover += c;
        }
        return this;
      }, o.prototype.digest = function() {
        if (this._finished)
          throw new Error("Poly1305 was finished");
        var a = new Uint8Array(16);
        return this.finish(a), a;
      }, o.prototype.clean = function() {
        return r.wipe(this._buffer), r.wipe(this._r), r.wipe(this._h), r.wipe(this._pad), this._leftover = 0, this._fin = 0, this._finished = !0, this;
      }, o;
    }()
  );
  t.Poly1305 = s;
  function n(o, a) {
    var u = new s(o);
    u.update(a);
    var c = u.digest();
    return u.clean(), c;
  }
  t.oneTimeAuth = n;
  function i(o, a) {
    return o.length !== t.DIGEST_LENGTH || a.length !== t.DIGEST_LENGTH ? !1 : e.equal(o, a);
  }
  t.equal = i;
})(nd);
(function(t) {
  Object.defineProperty(t, "__esModule", { value: !0 });
  var e = _a, r = nd, s = or, n = Ee, i = vs;
  t.KEY_LENGTH = 32, t.NONCE_LENGTH = 12, t.TAG_LENGTH = 16;
  var o = new Uint8Array(16), a = (
    /** @class */
    function() {
      function u(c) {
        if (this.nonceLength = t.NONCE_LENGTH, this.tagLength = t.TAG_LENGTH, c.length !== t.KEY_LENGTH)
          throw new Error("ChaCha20Poly1305 needs 32-byte key");
        this._key = new Uint8Array(c);
      }
      return u.prototype.seal = function(c, h, p, g) {
        if (c.length > 16)
          throw new Error("ChaCha20Poly1305: incorrect nonce length");
        var v = new Uint8Array(16);
        v.set(c, v.length - c.length);
        var b = new Uint8Array(32);
        e.stream(this._key, v, b, 4);
        var S = h.length + this.tagLength, C;
        if (g) {
          if (g.length !== S)
            throw new Error("ChaCha20Poly1305: incorrect destination length");
          C = g;
        } else
          C = new Uint8Array(S);
        return e.streamXOR(this._key, v, h, C, 4), this._authenticate(C.subarray(C.length - this.tagLength, C.length), b, C.subarray(0, C.length - this.tagLength), p), s.wipe(v), C;
      }, u.prototype.open = function(c, h, p, g) {
        if (c.length > 16)
          throw new Error("ChaCha20Poly1305: incorrect nonce length");
        if (h.length < this.tagLength)
          return null;
        var v = new Uint8Array(16);
        v.set(c, v.length - c.length);
        var b = new Uint8Array(32);
        e.stream(this._key, v, b, 4);
        var S = new Uint8Array(this.tagLength);
        if (this._authenticate(S, b, h.subarray(0, h.length - this.tagLength), p), !i.equal(S, h.subarray(h.length - this.tagLength, h.length)))
          return null;
        var C = h.length - this.tagLength, M;
        if (g) {
          if (g.length !== C)
            throw new Error("ChaCha20Poly1305: incorrect destination length");
          M = g;
        } else
          M = new Uint8Array(C);
        return e.streamXOR(this._key, v, h.subarray(0, h.length - this.tagLength), M, 4), s.wipe(v), M;
      }, u.prototype.clean = function() {
        return s.wipe(this._key), this;
      }, u.prototype._authenticate = function(c, h, p, g) {
        var v = new r.Poly1305(h);
        g && (v.update(g), g.length % 16 > 0 && v.update(o.subarray(g.length % 16))), v.update(p), p.length % 16 > 0 && v.update(o.subarray(p.length % 16));
        var b = new Uint8Array(8);
        g && n.writeUint64LE(g.length, b), v.update(b), n.writeUint64LE(p.length, b), v.update(b);
        for (var S = v.digest(), C = 0; C < S.length; C++)
          c[C] = S[C];
        v.clean(), s.wipe(S), s.wipe(b);
      }, u;
    }()
  );
  t.ChaCha20Poly1305 = a;
})(zo);
var ad = {}, ui = {}, $o = {};
Object.defineProperty($o, "__esModule", { value: !0 });
function Xm(t) {
  return typeof t.saveState < "u" && typeof t.restoreState < "u" && typeof t.cleanSavedState < "u";
}
$o.isSerializableHash = Xm;
Object.defineProperty(ui, "__esModule", { value: !0 });
var Lr = $o, Qm = vs, ey = or, od = (
  /** @class */
  function() {
    function t(e, r) {
      this._finished = !1, this._inner = new e(), this._outer = new e(), this.blockSize = this._outer.blockSize, this.digestLength = this._outer.digestLength;
      var s = new Uint8Array(this.blockSize);
      r.length > this.blockSize ? this._inner.update(r).finish(s).clean() : s.set(r);
      for (var n = 0; n < s.length; n++)
        s[n] ^= 54;
      this._inner.update(s);
      for (var n = 0; n < s.length; n++)
        s[n] ^= 106;
      this._outer.update(s), Lr.isSerializableHash(this._inner) && Lr.isSerializableHash(this._outer) && (this._innerKeyedState = this._inner.saveState(), this._outerKeyedState = this._outer.saveState()), ey.wipe(s);
    }
    return t.prototype.reset = function() {
      if (!Lr.isSerializableHash(this._inner) || !Lr.isSerializableHash(this._outer))
        throw new Error("hmac: can't reset() because hash doesn't implement restoreState()");
      return this._inner.restoreState(this._innerKeyedState), this._outer.restoreState(this._outerKeyedState), this._finished = !1, this;
    }, t.prototype.clean = function() {
      Lr.isSerializableHash(this._inner) && this._inner.cleanSavedState(this._innerKeyedState), Lr.isSerializableHash(this._outer) && this._outer.cleanSavedState(this._outerKeyedState), this._inner.clean(), this._outer.clean();
    }, t.prototype.update = function(e) {
      return this._inner.update(e), this;
    }, t.prototype.finish = function(e) {
      return this._finished ? (this._outer.finish(e), this) : (this._inner.finish(e), this._outer.update(e.subarray(0, this.digestLength)).finish(e), this._finished = !0, this);
    }, t.prototype.digest = function() {
      var e = new Uint8Array(this.digestLength);
      return this.finish(e), e;
    }, t.prototype.saveState = function() {
      if (!Lr.isSerializableHash(this._inner))
        throw new Error("hmac: can't saveState() because hash doesn't implement it");
      return this._inner.saveState();
    }, t.prototype.restoreState = function(e) {
      if (!Lr.isSerializableHash(this._inner) || !Lr.isSerializableHash(this._outer))
        throw new Error("hmac: can't restoreState() because hash doesn't implement it");
      return this._inner.restoreState(e), this._outer.restoreState(this._outerKeyedState), this._finished = !1, this;
    }, t.prototype.cleanSavedState = function(e) {
      if (!Lr.isSerializableHash(this._inner))
        throw new Error("hmac: can't cleanSavedState() because hash doesn't implement it");
      this._inner.cleanSavedState(e);
    }, t;
  }()
);
ui.HMAC = od;
function ty(t, e, r) {
  var s = new od(t, e);
  s.update(r);
  var n = s.digest();
  return s.clean(), n;
}
ui.hmac = ty;
ui.equal = Qm.equal;
Object.defineProperty(ad, "__esModule", { value: !0 });
var ou = ui, cu = or, ry = (
  /** @class */
  function() {
    function t(e, r, s, n) {
      s === void 0 && (s = new Uint8Array(0)), this._counter = new Uint8Array(1), this._hash = e, this._info = n;
      var i = ou.hmac(this._hash, s, r);
      this._hmac = new ou.HMAC(e, i), this._buffer = new Uint8Array(this._hmac.digestLength), this._bufpos = this._buffer.length;
    }
    return t.prototype._fillBuffer = function() {
      this._counter[0]++;
      var e = this._counter[0];
      if (e === 0)
        throw new Error("hkdf: cannot expand more");
      this._hmac.reset(), e > 1 && this._hmac.update(this._buffer), this._info && this._hmac.update(this._info), this._hmac.update(this._counter), this._hmac.finish(this._buffer), this._bufpos = 0;
    }, t.prototype.expand = function(e) {
      for (var r = new Uint8Array(e), s = 0; s < r.length; s++)
        this._bufpos === this._buffer.length && this._fillBuffer(), r[s] = this._buffer[this._bufpos++];
      return r;
    }, t.prototype.clean = function() {
      this._hmac.clean(), cu.wipe(this._buffer), cu.wipe(this._counter), this._bufpos = 0;
    }, t;
  }()
), sy = ad.HKDF = ry, ba = {};
(function(t) {
  Object.defineProperty(t, "__esModule", { value: !0 });
  var e = Ee, r = or;
  t.DIGEST_LENGTH = 32, t.BLOCK_SIZE = 64;
  var s = (
    /** @class */
    function() {
      function a() {
        this.digestLength = t.DIGEST_LENGTH, this.blockSize = t.BLOCK_SIZE, this._state = new Int32Array(8), this._temp = new Int32Array(64), this._buffer = new Uint8Array(128), this._bufferLength = 0, this._bytesHashed = 0, this._finished = !1, this.reset();
      }
      return a.prototype._initState = function() {
        this._state[0] = 1779033703, this._state[1] = 3144134277, this._state[2] = 1013904242, this._state[3] = 2773480762, this._state[4] = 1359893119, this._state[5] = 2600822924, this._state[6] = 528734635, this._state[7] = 1541459225;
      }, a.prototype.reset = function() {
        return this._initState(), this._bufferLength = 0, this._bytesHashed = 0, this._finished = !1, this;
      }, a.prototype.clean = function() {
        r.wipe(this._buffer), r.wipe(this._temp), this.reset();
      }, a.prototype.update = function(u, c) {
        if (c === void 0 && (c = u.length), this._finished)
          throw new Error("SHA256: can't update because hash was finished.");
        var h = 0;
        if (this._bytesHashed += c, this._bufferLength > 0) {
          for (; this._bufferLength < this.blockSize && c > 0; )
            this._buffer[this._bufferLength++] = u[h++], c--;
          this._bufferLength === this.blockSize && (i(this._temp, this._state, this._buffer, 0, this.blockSize), this._bufferLength = 0);
        }
        for (c >= this.blockSize && (h = i(this._temp, this._state, u, h, c), c %= this.blockSize); c > 0; )
          this._buffer[this._bufferLength++] = u[h++], c--;
        return this;
      }, a.prototype.finish = function(u) {
        if (!this._finished) {
          var c = this._bytesHashed, h = this._bufferLength, p = c / 536870912 | 0, g = c << 3, v = c % 64 < 56 ? 64 : 128;
          this._buffer[h] = 128;
          for (var b = h + 1; b < v - 8; b++)
            this._buffer[b] = 0;
          e.writeUint32BE(p, this._buffer, v - 8), e.writeUint32BE(g, this._buffer, v - 4), i(this._temp, this._state, this._buffer, 0, v), this._finished = !0;
        }
        for (var b = 0; b < this.digestLength / 4; b++)
          e.writeUint32BE(this._state[b], u, b * 4);
        return this;
      }, a.prototype.digest = function() {
        var u = new Uint8Array(this.digestLength);
        return this.finish(u), u;
      }, a.prototype.saveState = function() {
        if (this._finished)
          throw new Error("SHA256: cannot save finished state");
        return {
          state: new Int32Array(this._state),
          buffer: this._bufferLength > 0 ? new Uint8Array(this._buffer) : void 0,
          bufferLength: this._bufferLength,
          bytesHashed: this._bytesHashed
        };
      }, a.prototype.restoreState = function(u) {
        return this._state.set(u.state), this._bufferLength = u.bufferLength, u.buffer && this._buffer.set(u.buffer), this._bytesHashed = u.bytesHashed, this._finished = !1, this;
      }, a.prototype.cleanSavedState = function(u) {
        r.wipe(u.state), u.buffer && r.wipe(u.buffer), u.bufferLength = 0, u.bytesHashed = 0;
      }, a;
    }()
  );
  t.SHA256 = s;
  var n = new Int32Array([
    1116352408,
    1899447441,
    3049323471,
    3921009573,
    961987163,
    1508970993,
    2453635748,
    2870763221,
    3624381080,
    310598401,
    607225278,
    1426881987,
    1925078388,
    2162078206,
    2614888103,
    3248222580,
    3835390401,
    4022224774,
    264347078,
    604807628,
    770255983,
    1249150122,
    1555081692,
    1996064986,
    2554220882,
    2821834349,
    2952996808,
    3210313671,
    3336571891,
    3584528711,
    113926993,
    338241895,
    666307205,
    773529912,
    1294757372,
    1396182291,
    1695183700,
    1986661051,
    2177026350,
    2456956037,
    2730485921,
    2820302411,
    3259730800,
    3345764771,
    3516065817,
    3600352804,
    4094571909,
    275423344,
    430227734,
    506948616,
    659060556,
    883997877,
    958139571,
    1322822218,
    1537002063,
    1747873779,
    1955562222,
    2024104815,
    2227730452,
    2361852424,
    2428436474,
    2756734187,
    3204031479,
    3329325298
  ]);
  function i(a, u, c, h, p) {
    for (; p >= 64; ) {
      for (var g = u[0], v = u[1], b = u[2], S = u[3], C = u[4], M = u[5], _ = u[6], T = u[7], E = 0; E < 16; E++) {
        var I = h + E * 4;
        a[E] = e.readUint32BE(c, I);
      }
      for (var E = 16; E < 64; E++) {
        var m = a[E - 2], l = (m >>> 17 | m << 15) ^ (m >>> 19 | m << 13) ^ m >>> 10;
        m = a[E - 15];
        var f = (m >>> 7 | m << 25) ^ (m >>> 18 | m << 14) ^ m >>> 3;
        a[E] = (l + a[E - 7] | 0) + (f + a[E - 16] | 0);
      }
      for (var E = 0; E < 64; E++) {
        var l = (((C >>> 6 | C << 26) ^ (C >>> 11 | C << 21) ^ (C >>> 25 | C << 7)) + (C & M ^ ~C & _) | 0) + (T + (n[E] + a[E] | 0) | 0) | 0, f = ((g >>> 2 | g << 30) ^ (g >>> 13 | g << 19) ^ (g >>> 22 | g << 10)) + (g & v ^ g & b ^ v & b) | 0;
        T = _, _ = M, M = C, C = S + l | 0, S = b, b = v, v = g, g = l + f | 0;
      }
      u[0] += g, u[1] += v, u[2] += b, u[3] += S, u[4] += C, u[5] += M, u[6] += _, u[7] += T, h += 64, p -= 64;
    }
    return h;
  }
  function o(a) {
    var u = new s();
    u.update(a);
    var c = u.digest();
    return u.clean(), c;
  }
  t.hash = o;
})(ba);
var Vo = {};
(function(t) {
  Object.defineProperty(t, "__esModule", { value: !0 }), t.sharedKey = t.generateKeyPair = t.generateKeyPairFromSeed = t.scalarMultBase = t.scalarMult = t.SHARED_KEY_LENGTH = t.SECRET_KEY_LENGTH = t.PUBLIC_KEY_LENGTH = void 0;
  const e = ln, r = or;
  t.PUBLIC_KEY_LENGTH = 32, t.SECRET_KEY_LENGTH = 32, t.SHARED_KEY_LENGTH = 32;
  function s(E) {
    const I = new Float64Array(16);
    if (E)
      for (let m = 0; m < E.length; m++)
        I[m] = E[m];
    return I;
  }
  const n = new Uint8Array(32);
  n[0] = 9;
  const i = s([56129, 1]);
  function o(E) {
    let I = 1;
    for (let m = 0; m < 16; m++) {
      let l = E[m] + I + 65535;
      I = Math.floor(l / 65536), E[m] = l - I * 65536;
    }
    E[0] += I - 1 + 37 * (I - 1);
  }
  function a(E, I, m) {
    const l = ~(m - 1);
    for (let f = 0; f < 16; f++) {
      const L = l & (E[f] ^ I[f]);
      E[f] ^= L, I[f] ^= L;
    }
  }
  function u(E, I) {
    const m = s(), l = s();
    for (let f = 0; f < 16; f++)
      l[f] = I[f];
    o(l), o(l), o(l);
    for (let f = 0; f < 2; f++) {
      m[0] = l[0] - 65517;
      for (let A = 1; A < 15; A++)
        m[A] = l[A] - 65535 - (m[A - 1] >> 16 & 1), m[A - 1] &= 65535;
      m[15] = l[15] - 32767 - (m[14] >> 16 & 1);
      const L = m[15] >> 16 & 1;
      m[14] &= 65535, a(l, m, 1 - L);
    }
    for (let f = 0; f < 16; f++)
      E[2 * f] = l[f] & 255, E[2 * f + 1] = l[f] >> 8;
  }
  function c(E, I) {
    for (let m = 0; m < 16; m++)
      E[m] = I[2 * m] + (I[2 * m + 1] << 8);
    E[15] &= 32767;
  }
  function h(E, I, m) {
    for (let l = 0; l < 16; l++)
      E[l] = I[l] + m[l];
  }
  function p(E, I, m) {
    for (let l = 0; l < 16; l++)
      E[l] = I[l] - m[l];
  }
  function g(E, I, m) {
    let l, f, L = 0, A = 0, V = 0, J = 0, G = 0, O = 0, k = 0, Q = 0, Z = 0, z = 0, q = 0, U = 0, F = 0, me = 0, W = 0, de = 0, se = 0, le = 0, j = 0, R = 0, P = 0, d = 0, x = 0, B = 0, ee = 0, Ae = 0, je = 0, xe = 0, qe = 0, nt = 0, Xe = 0, $e = m[0], De = m[1], Oe = m[2], Ce = m[3], Te = m[4], we = m[5], _e = m[6], he = m[7], Ne = m[8], Le = m[9], ye = m[10], Ue = m[11], Ze = m[12], He = m[13], Be = m[14], We = m[15];
    l = I[0], L += l * $e, A += l * De, V += l * Oe, J += l * Ce, G += l * Te, O += l * we, k += l * _e, Q += l * he, Z += l * Ne, z += l * Le, q += l * ye, U += l * Ue, F += l * Ze, me += l * He, W += l * Be, de += l * We, l = I[1], A += l * $e, V += l * De, J += l * Oe, G += l * Ce, O += l * Te, k += l * we, Q += l * _e, Z += l * he, z += l * Ne, q += l * Le, U += l * ye, F += l * Ue, me += l * Ze, W += l * He, de += l * Be, se += l * We, l = I[2], V += l * $e, J += l * De, G += l * Oe, O += l * Ce, k += l * Te, Q += l * we, Z += l * _e, z += l * he, q += l * Ne, U += l * Le, F += l * ye, me += l * Ue, W += l * Ze, de += l * He, se += l * Be, le += l * We, l = I[3], J += l * $e, G += l * De, O += l * Oe, k += l * Ce, Q += l * Te, Z += l * we, z += l * _e, q += l * he, U += l * Ne, F += l * Le, me += l * ye, W += l * Ue, de += l * Ze, se += l * He, le += l * Be, j += l * We, l = I[4], G += l * $e, O += l * De, k += l * Oe, Q += l * Ce, Z += l * Te, z += l * we, q += l * _e, U += l * he, F += l * Ne, me += l * Le, W += l * ye, de += l * Ue, se += l * Ze, le += l * He, j += l * Be, R += l * We, l = I[5], O += l * $e, k += l * De, Q += l * Oe, Z += l * Ce, z += l * Te, q += l * we, U += l * _e, F += l * he, me += l * Ne, W += l * Le, de += l * ye, se += l * Ue, le += l * Ze, j += l * He, R += l * Be, P += l * We, l = I[6], k += l * $e, Q += l * De, Z += l * Oe, z += l * Ce, q += l * Te, U += l * we, F += l * _e, me += l * he, W += l * Ne, de += l * Le, se += l * ye, le += l * Ue, j += l * Ze, R += l * He, P += l * Be, d += l * We, l = I[7], Q += l * $e, Z += l * De, z += l * Oe, q += l * Ce, U += l * Te, F += l * we, me += l * _e, W += l * he, de += l * Ne, se += l * Le, le += l * ye, j += l * Ue, R += l * Ze, P += l * He, d += l * Be, x += l * We, l = I[8], Z += l * $e, z += l * De, q += l * Oe, U += l * Ce, F += l * Te, me += l * we, W += l * _e, de += l * he, se += l * Ne, le += l * Le, j += l * ye, R += l * Ue, P += l * Ze, d += l * He, x += l * Be, B += l * We, l = I[9], z += l * $e, q += l * De, U += l * Oe, F += l * Ce, me += l * Te, W += l * we, de += l * _e, se += l * he, le += l * Ne, j += l * Le, R += l * ye, P += l * Ue, d += l * Ze, x += l * He, B += l * Be, ee += l * We, l = I[10], q += l * $e, U += l * De, F += l * Oe, me += l * Ce, W += l * Te, de += l * we, se += l * _e, le += l * he, j += l * Ne, R += l * Le, P += l * ye, d += l * Ue, x += l * Ze, B += l * He, ee += l * Be, Ae += l * We, l = I[11], U += l * $e, F += l * De, me += l * Oe, W += l * Ce, de += l * Te, se += l * we, le += l * _e, j += l * he, R += l * Ne, P += l * Le, d += l * ye, x += l * Ue, B += l * Ze, ee += l * He, Ae += l * Be, je += l * We, l = I[12], F += l * $e, me += l * De, W += l * Oe, de += l * Ce, se += l * Te, le += l * we, j += l * _e, R += l * he, P += l * Ne, d += l * Le, x += l * ye, B += l * Ue, ee += l * Ze, Ae += l * He, je += l * Be, xe += l * We, l = I[13], me += l * $e, W += l * De, de += l * Oe, se += l * Ce, le += l * Te, j += l * we, R += l * _e, P += l * he, d += l * Ne, x += l * Le, B += l * ye, ee += l * Ue, Ae += l * Ze, je += l * He, xe += l * Be, qe += l * We, l = I[14], W += l * $e, de += l * De, se += l * Oe, le += l * Ce, j += l * Te, R += l * we, P += l * _e, d += l * he, x += l * Ne, B += l * Le, ee += l * ye, Ae += l * Ue, je += l * Ze, xe += l * He, qe += l * Be, nt += l * We, l = I[15], de += l * $e, se += l * De, le += l * Oe, j += l * Ce, R += l * Te, P += l * we, d += l * _e, x += l * he, B += l * Ne, ee += l * Le, Ae += l * ye, je += l * Ue, xe += l * Ze, qe += l * He, nt += l * Be, Xe += l * We, L += 38 * se, A += 38 * le, V += 38 * j, J += 38 * R, G += 38 * P, O += 38 * d, k += 38 * x, Q += 38 * B, Z += 38 * ee, z += 38 * Ae, q += 38 * je, U += 38 * xe, F += 38 * qe, me += 38 * nt, W += 38 * Xe, f = 1, l = L + f + 65535, f = Math.floor(l / 65536), L = l - f * 65536, l = A + f + 65535, f = Math.floor(l / 65536), A = l - f * 65536, l = V + f + 65535, f = Math.floor(l / 65536), V = l - f * 65536, l = J + f + 65535, f = Math.floor(l / 65536), J = l - f * 65536, l = G + f + 65535, f = Math.floor(l / 65536), G = l - f * 65536, l = O + f + 65535, f = Math.floor(l / 65536), O = l - f * 65536, l = k + f + 65535, f = Math.floor(l / 65536), k = l - f * 65536, l = Q + f + 65535, f = Math.floor(l / 65536), Q = l - f * 65536, l = Z + f + 65535, f = Math.floor(l / 65536), Z = l - f * 65536, l = z + f + 65535, f = Math.floor(l / 65536), z = l - f * 65536, l = q + f + 65535, f = Math.floor(l / 65536), q = l - f * 65536, l = U + f + 65535, f = Math.floor(l / 65536), U = l - f * 65536, l = F + f + 65535, f = Math.floor(l / 65536), F = l - f * 65536, l = me + f + 65535, f = Math.floor(l / 65536), me = l - f * 65536, l = W + f + 65535, f = Math.floor(l / 65536), W = l - f * 65536, l = de + f + 65535, f = Math.floor(l / 65536), de = l - f * 65536, L += f - 1 + 37 * (f - 1), f = 1, l = L + f + 65535, f = Math.floor(l / 65536), L = l - f * 65536, l = A + f + 65535, f = Math.floor(l / 65536), A = l - f * 65536, l = V + f + 65535, f = Math.floor(l / 65536), V = l - f * 65536, l = J + f + 65535, f = Math.floor(l / 65536), J = l - f * 65536, l = G + f + 65535, f = Math.floor(l / 65536), G = l - f * 65536, l = O + f + 65535, f = Math.floor(l / 65536), O = l - f * 65536, l = k + f + 65535, f = Math.floor(l / 65536), k = l - f * 65536, l = Q + f + 65535, f = Math.floor(l / 65536), Q = l - f * 65536, l = Z + f + 65535, f = Math.floor(l / 65536), Z = l - f * 65536, l = z + f + 65535, f = Math.floor(l / 65536), z = l - f * 65536, l = q + f + 65535, f = Math.floor(l / 65536), q = l - f * 65536, l = U + f + 65535, f = Math.floor(l / 65536), U = l - f * 65536, l = F + f + 65535, f = Math.floor(l / 65536), F = l - f * 65536, l = me + f + 65535, f = Math.floor(l / 65536), me = l - f * 65536, l = W + f + 65535, f = Math.floor(l / 65536), W = l - f * 65536, l = de + f + 65535, f = Math.floor(l / 65536), de = l - f * 65536, L += f - 1 + 37 * (f - 1), E[0] = L, E[1] = A, E[2] = V, E[3] = J, E[4] = G, E[5] = O, E[6] = k, E[7] = Q, E[8] = Z, E[9] = z, E[10] = q, E[11] = U, E[12] = F, E[13] = me, E[14] = W, E[15] = de;
  }
  function v(E, I) {
    g(E, I, I);
  }
  function b(E, I) {
    const m = s();
    for (let l = 0; l < 16; l++)
      m[l] = I[l];
    for (let l = 253; l >= 0; l--)
      v(m, m), l !== 2 && l !== 4 && g(m, m, I);
    for (let l = 0; l < 16; l++)
      E[l] = m[l];
  }
  function S(E, I) {
    const m = new Uint8Array(32), l = new Float64Array(80), f = s(), L = s(), A = s(), V = s(), J = s(), G = s();
    for (let Z = 0; Z < 31; Z++)
      m[Z] = E[Z];
    m[31] = E[31] & 127 | 64, m[0] &= 248, c(l, I);
    for (let Z = 0; Z < 16; Z++)
      L[Z] = l[Z];
    f[0] = V[0] = 1;
    for (let Z = 254; Z >= 0; --Z) {
      const z = m[Z >>> 3] >>> (Z & 7) & 1;
      a(f, L, z), a(A, V, z), h(J, f, A), p(f, f, A), h(A, L, V), p(L, L, V), v(V, J), v(G, f), g(f, A, f), g(A, L, J), h(J, f, A), p(f, f, A), v(L, f), p(A, V, G), g(f, A, i), h(f, f, V), g(A, A, f), g(f, V, G), g(V, L, l), v(L, J), a(f, L, z), a(A, V, z);
    }
    for (let Z = 0; Z < 16; Z++)
      l[Z + 16] = f[Z], l[Z + 32] = A[Z], l[Z + 48] = L[Z], l[Z + 64] = V[Z];
    const O = l.subarray(32), k = l.subarray(16);
    b(O, O), g(k, k, O);
    const Q = new Uint8Array(32);
    return u(Q, k), Q;
  }
  t.scalarMult = S;
  function C(E) {
    return S(E, n);
  }
  t.scalarMultBase = C;
  function M(E) {
    if (E.length !== t.SECRET_KEY_LENGTH)
      throw new Error(`x25519: seed must be ${t.SECRET_KEY_LENGTH} bytes`);
    const I = new Uint8Array(E);
    return {
      publicKey: C(I),
      secretKey: I
    };
  }
  t.generateKeyPairFromSeed = M;
  function _(E) {
    const I = (0, e.randomBytes)(32, E), m = M(I);
    return (0, r.wipe)(I), m;
  }
  t.generateKeyPair = _;
  function T(E, I, m = !1) {
    if (E.length !== t.PUBLIC_KEY_LENGTH)
      throw new Error("X25519: incorrect secret key length");
    if (I.length !== t.PUBLIC_KEY_LENGTH)
      throw new Error("X25519: incorrect public key length");
    const l = S(E, I);
    if (m) {
      let f = 0;
      for (let L = 0; L < l.length; L++)
        f |= l[L];
      if (f === 0)
        throw new Error("X25519: invalid shared key");
    }
    return l;
  }
  t.sharedKey = T;
})(Vo);
var uu = function(t, e, r) {
  if (r || arguments.length === 2)
    for (var s = 0, n = e.length, i; s < n; s++)
      (i || !(s in e)) && (i || (i = Array.prototype.slice.call(e, 0, s)), i[s] = e[s]);
  return t.concat(i || Array.prototype.slice.call(e));
}, ny = (
  /** @class */
  /* @__PURE__ */ function() {
    function t(e, r, s) {
      this.name = e, this.version = r, this.os = s, this.type = "browser";
    }
    return t;
  }()
), iy = (
  /** @class */
  /* @__PURE__ */ function() {
    function t(e) {
      this.version = e, this.type = "node", this.name = "node", this.os = process.platform;
    }
    return t;
  }()
), ay = (
  /** @class */
  /* @__PURE__ */ function() {
    function t(e, r, s, n) {
      this.name = e, this.version = r, this.os = s, this.bot = n, this.type = "bot-device";
    }
    return t;
  }()
), oy = (
  /** @class */
  /* @__PURE__ */ function() {
    function t() {
      this.type = "bot", this.bot = !0, this.name = "bot", this.version = null, this.os = null;
    }
    return t;
  }()
), cy = (
  /** @class */
  /* @__PURE__ */ function() {
    function t() {
      this.type = "react-native", this.name = "react-native", this.version = null, this.os = null;
    }
    return t;
  }()
), uy = /alexa|bot|crawl(er|ing)|facebookexternalhit|feedburner|google web preview|nagios|postrank|pingdom|slurp|spider|yahoo!|yandex/, ly = /(nuhk|curl|Googlebot|Yammybot|Openbot|Slurp|MSNBot|Ask\ Jeeves\/Teoma|ia_archiver)/, lu = 3, dy = [
  ["aol", /AOLShield\/([0-9\._]+)/],
  ["edge", /Edge\/([0-9\._]+)/],
  ["edge-ios", /EdgiOS\/([0-9\._]+)/],
  ["yandexbrowser", /YaBrowser\/([0-9\._]+)/],
  ["kakaotalk", /KAKAOTALK\s([0-9\.]+)/],
  ["samsung", /SamsungBrowser\/([0-9\.]+)/],
  ["silk", /\bSilk\/([0-9._-]+)\b/],
  ["miui", /MiuiBrowser\/([0-9\.]+)$/],
  ["beaker", /BeakerBrowser\/([0-9\.]+)/],
  ["edge-chromium", /EdgA?\/([0-9\.]+)/],
  [
    "chromium-webview",
    /(?!Chrom.*OPR)wv\).*Chrom(?:e|ium)\/([0-9\.]+)(:?\s|$)/
  ],
  ["chrome", /(?!Chrom.*OPR)Chrom(?:e|ium)\/([0-9\.]+)(:?\s|$)/],
  ["phantomjs", /PhantomJS\/([0-9\.]+)(:?\s|$)/],
  ["crios", /CriOS\/([0-9\.]+)(:?\s|$)/],
  ["firefox", /Firefox\/([0-9\.]+)(?:\s|$)/],
  ["fxios", /FxiOS\/([0-9\.]+)/],
  ["opera-mini", /Opera Mini.*Version\/([0-9\.]+)/],
  ["opera", /Opera\/([0-9\.]+)(?:\s|$)/],
  ["opera", /OPR\/([0-9\.]+)(:?\s|$)/],
  ["pie", /^Microsoft Pocket Internet Explorer\/(\d+\.\d+)$/],
  ["pie", /^Mozilla\/\d\.\d+\s\(compatible;\s(?:MSP?IE|MSInternet Explorer) (\d+\.\d+);.*Windows CE.*\)$/],
  ["netfront", /^Mozilla\/\d\.\d+.*NetFront\/(\d.\d)/],
  ["ie", /Trident\/7\.0.*rv\:([0-9\.]+).*\).*Gecko$/],
  ["ie", /MSIE\s([0-9\.]+);.*Trident\/[4-7].0/],
  ["ie", /MSIE\s(7\.0)/],
  ["bb10", /BB10;\sTouch.*Version\/([0-9\.]+)/],
  ["android", /Android\s([0-9\.]+)/],
  ["ios", /Version\/([0-9\._]+).*Mobile.*Safari.*/],
  ["safari", /Version\/([0-9\._]+).*Safari/],
  ["facebook", /FB[AS]V\/([0-9\.]+)/],
  ["instagram", /Instagram\s([0-9\.]+)/],
  ["ios-webview", /AppleWebKit\/([0-9\.]+).*Mobile/],
  ["ios-webview", /AppleWebKit\/([0-9\.]+).*Gecko\)$/],
  ["curl", /^curl\/([0-9\.]+)$/],
  ["searchbot", uy]
], du = [
  ["iOS", /iP(hone|od|ad)/],
  ["Android OS", /Android/],
  ["BlackBerry OS", /BlackBerry|BB10/],
  ["Windows Mobile", /IEMobile/],
  ["Amazon OS", /Kindle/],
  ["Windows 3.11", /Win16/],
  ["Windows 95", /(Windows 95)|(Win95)|(Windows_95)/],
  ["Windows 98", /(Windows 98)|(Win98)/],
  ["Windows 2000", /(Windows NT 5.0)|(Windows 2000)/],
  ["Windows XP", /(Windows NT 5.1)|(Windows XP)/],
  ["Windows Server 2003", /(Windows NT 5.2)/],
  ["Windows Vista", /(Windows NT 6.0)/],
  ["Windows 7", /(Windows NT 6.1)/],
  ["Windows 8", /(Windows NT 6.2)/],
  ["Windows 8.1", /(Windows NT 6.3)/],
  ["Windows 10", /(Windows NT 10.0)/],
  ["Windows ME", /Windows ME/],
  ["Windows CE", /Windows CE|WinCE|Microsoft Pocket Internet Explorer/],
  ["Open BSD", /OpenBSD/],
  ["Sun OS", /SunOS/],
  ["Chrome OS", /CrOS/],
  ["Linux", /(Linux)|(X11)/],
  ["Mac OS", /(Mac_PowerPC)|(Macintosh)/],
  ["QNX", /QNX/],
  ["BeOS", /BeOS/],
  ["OS/2", /OS\/2/]
];
function hy(t) {
  return t ? hu(t) : typeof document > "u" && typeof navigator < "u" && navigator.product === "ReactNative" ? new cy() : typeof navigator < "u" ? hu(navigator.userAgent) : gy();
}
function py(t) {
  return t !== "" && dy.reduce(function(e, r) {
    var s = r[0], n = r[1];
    if (e)
      return e;
    var i = n.exec(t);
    return !!i && [s, i];
  }, !1);
}
function hu(t) {
  var e = py(t);
  if (!e)
    return null;
  var r = e[0], s = e[1];
  if (r === "searchbot")
    return new oy();
  var n = s[1] && s[1].split(".").join("_").split("_").slice(0, 3);
  n ? n.length < lu && (n = uu(uu([], n, !0), my(lu - n.length), !0)) : n = [];
  var i = n.join("."), o = fy(t), a = ly.exec(t);
  return a && a[1] ? new ay(r, i, o, a[1]) : new ny(r, i, o);
}
function fy(t) {
  for (var e = 0, r = du.length; e < r; e++) {
    var s = du[e], n = s[0], i = s[1], o = i.exec(t);
    if (o)
      return n;
  }
  return null;
}
function gy() {
  var t = typeof process < "u" && process.version;
  return t ? new iy(process.version.slice(1)) : null;
}
function my(t) {
  for (var e = [], r = 0; r < t; r++)
    e.push("0");
  return e;
}
var et = {};
Object.defineProperty(et, "__esModule", { value: !0 });
et.getLocalStorage = et.getLocalStorageOrThrow = et.getCrypto = et.getCryptoOrThrow = cd = et.getLocation = et.getLocationOrThrow = Zo = et.getNavigator = et.getNavigatorOrThrow = qo = et.getDocument = et.getDocumentOrThrow = et.getFromWindowOrThrow = et.getFromWindow = void 0;
function zs(t) {
  let e;
  return typeof window < "u" && typeof window[t] < "u" && (e = window[t]), e;
}
et.getFromWindow = zs;
function dn(t) {
  const e = zs(t);
  if (!e)
    throw new Error(`${t} is not defined in Window`);
  return e;
}
et.getFromWindowOrThrow = dn;
function yy() {
  return dn("document");
}
et.getDocumentOrThrow = yy;
function vy() {
  return zs("document");
}
var qo = et.getDocument = vy;
function _y() {
  return dn("navigator");
}
et.getNavigatorOrThrow = _y;
function by() {
  return zs("navigator");
}
var Zo = et.getNavigator = by;
function wy() {
  return dn("location");
}
et.getLocationOrThrow = wy;
function Ey() {
  return zs("location");
}
var cd = et.getLocation = Ey;
function Sy() {
  return dn("crypto");
}
et.getCryptoOrThrow = Sy;
function Iy() {
  return zs("crypto");
}
et.getCrypto = Iy;
function xy() {
  return dn("localStorage");
}
et.getLocalStorageOrThrow = xy;
function Oy() {
  return zs("localStorage");
}
et.getLocalStorage = Oy;
var Fo = {};
Object.defineProperty(Fo, "__esModule", { value: !0 });
var ud = Fo.getWindowMetadata = void 0;
const pu = et;
function Ty() {
  let t, e;
  try {
    t = pu.getDocumentOrThrow(), e = pu.getLocationOrThrow();
  } catch {
    return null;
  }
  function r() {
    const h = t.getElementsByTagName("link"), p = [];
    for (let g = 0; g < h.length; g++) {
      const v = h[g], b = v.getAttribute("rel");
      if (b && b.toLowerCase().indexOf("icon") > -1) {
        const S = v.getAttribute("href");
        if (S)
          if (S.toLowerCase().indexOf("https:") === -1 && S.toLowerCase().indexOf("http:") === -1 && S.indexOf("//") !== 0) {
            let C = e.protocol + "//" + e.host;
            if (S.indexOf("/") === 0)
              C += S;
            else {
              const M = e.pathname.split("/");
              M.pop();
              const _ = M.join("/");
              C += _ + "/" + S;
            }
            p.push(C);
          } else if (S.indexOf("//") === 0) {
            const C = e.protocol + S;
            p.push(C);
          } else
            p.push(S);
      }
    }
    return p;
  }
  function s(...h) {
    const p = t.getElementsByTagName("meta");
    for (let g = 0; g < p.length; g++) {
      const v = p[g], b = ["itemprop", "property", "name"].map((S) => v.getAttribute(S)).filter((S) => S ? h.includes(S) : !1);
      if (b.length && b) {
        const S = v.getAttribute("content");
        if (S)
          return S;
      }
    }
    return "";
  }
  function n() {
    let h = s("name", "og:site_name", "og:title", "twitter:title");
    return h || (h = t.title), h;
  }
  function i() {
    return s("description", "og:description", "twitter:description", "keywords");
  }
  const o = n(), a = i(), u = e.origin, c = r();
  return {
    description: a,
    url: u,
    icons: c,
    name: o
  };
}
ud = Fo.getWindowMetadata = Ty;
var An = {}, Py = (t) => encodeURIComponent(t).replace(/[!'()*]/g, (e) => `%${e.charCodeAt(0).toString(16).toUpperCase()}`), ld = "%[a-f0-9]{2}", fu = new RegExp("(" + ld + ")|([^%]+?)", "gi"), gu = new RegExp("(" + ld + ")+", "gi");
function no(t, e) {
  try {
    return [decodeURIComponent(t.join(""))];
  } catch {
  }
  if (t.length === 1)
    return t;
  e = e || 1;
  var r = t.slice(0, e), s = t.slice(e);
  return Array.prototype.concat.call([], no(r), no(s));
}
function Cy(t) {
  try {
    return decodeURIComponent(t);
  } catch {
    for (var e = t.match(fu) || [], r = 1; r < e.length; r++)
      t = no(e, r).join(""), e = t.match(fu) || [];
    return t;
  }
}
function Ny(t) {
  for (var e = {
    "%FE%FF": "��",
    "%FF%FE": "��"
  }, r = gu.exec(t); r; ) {
    try {
      e[r[0]] = decodeURIComponent(r[0]);
    } catch {
      var s = Cy(r[0]);
      s !== r[0] && (e[r[0]] = s);
    }
    r = gu.exec(t);
  }
  e["%C2"] = "�";
  for (var n = Object.keys(e), i = 0; i < n.length; i++) {
    var o = n[i];
    t = t.replace(new RegExp(o, "g"), e[o]);
  }
  return t;
}
var ky = function(t) {
  if (typeof t != "string")
    throw new TypeError("Expected `encodedURI` to be of type `string`, got `" + typeof t + "`");
  try {
    return t = t.replace(/\+/g, " "), decodeURIComponent(t);
  } catch {
    return Ny(t);
  }
}, Ry = (t, e) => {
  if (!(typeof t == "string" && typeof e == "string"))
    throw new TypeError("Expected the arguments to be of type `string`");
  if (e === "")
    return [t];
  const r = t.indexOf(e);
  return r === -1 ? [t] : [
    t.slice(0, r),
    t.slice(r + e.length)
  ];
}, Ay = function(t, e) {
  for (var r = {}, s = Object.keys(t), n = Array.isArray(e), i = 0; i < s.length; i++) {
    var o = s[i], a = t[o];
    (n ? e.indexOf(o) !== -1 : e(o, a, t)) && (r[o] = a);
  }
  return r;
};
(function(t) {
  const e = Py, r = ky, s = Ry, n = Ay, i = (_) => _ == null, o = Symbol("encodeFragmentIdentifier");
  function a(_) {
    switch (_.arrayFormat) {
      case "index":
        return (T) => (E, I) => {
          const m = E.length;
          return I === void 0 || _.skipNull && I === null || _.skipEmptyString && I === "" ? E : I === null ? [...E, [h(T, _), "[", m, "]"].join("")] : [
            ...E,
            [h(T, _), "[", h(m, _), "]=", h(I, _)].join("")
          ];
        };
      case "bracket":
        return (T) => (E, I) => I === void 0 || _.skipNull && I === null || _.skipEmptyString && I === "" ? E : I === null ? [...E, [h(T, _), "[]"].join("")] : [...E, [h(T, _), "[]=", h(I, _)].join("")];
      case "colon-list-separator":
        return (T) => (E, I) => I === void 0 || _.skipNull && I === null || _.skipEmptyString && I === "" ? E : I === null ? [...E, [h(T, _), ":list="].join("")] : [...E, [h(T, _), ":list=", h(I, _)].join("")];
      case "comma":
      case "separator":
      case "bracket-separator": {
        const T = _.arrayFormat === "bracket-separator" ? "[]=" : "=";
        return (E) => (I, m) => m === void 0 || _.skipNull && m === null || _.skipEmptyString && m === "" ? I : (m = m === null ? "" : m, I.length === 0 ? [[h(E, _), T, h(m, _)].join("")] : [[I, h(m, _)].join(_.arrayFormatSeparator)]);
      }
      default:
        return (T) => (E, I) => I === void 0 || _.skipNull && I === null || _.skipEmptyString && I === "" ? E : I === null ? [...E, h(T, _)] : [...E, [h(T, _), "=", h(I, _)].join("")];
    }
  }
  function u(_) {
    let T;
    switch (_.arrayFormat) {
      case "index":
        return (E, I, m) => {
          if (T = /\[(\d*)\]$/.exec(E), E = E.replace(/\[\d*\]$/, ""), !T) {
            m[E] = I;
            return;
          }
          m[E] === void 0 && (m[E] = {}), m[E][T[1]] = I;
        };
      case "bracket":
        return (E, I, m) => {
          if (T = /(\[\])$/.exec(E), E = E.replace(/\[\]$/, ""), !T) {
            m[E] = I;
            return;
          }
          if (m[E] === void 0) {
            m[E] = [I];
            return;
          }
          m[E] = [].concat(m[E], I);
        };
      case "colon-list-separator":
        return (E, I, m) => {
          if (T = /(:list)$/.exec(E), E = E.replace(/:list$/, ""), !T) {
            m[E] = I;
            return;
          }
          if (m[E] === void 0) {
            m[E] = [I];
            return;
          }
          m[E] = [].concat(m[E], I);
        };
      case "comma":
      case "separator":
        return (E, I, m) => {
          const l = typeof I == "string" && I.includes(_.arrayFormatSeparator), f = typeof I == "string" && !l && p(I, _).includes(_.arrayFormatSeparator);
          I = f ? p(I, _) : I;
          const L = l || f ? I.split(_.arrayFormatSeparator).map((A) => p(A, _)) : I === null ? I : p(I, _);
          m[E] = L;
        };
      case "bracket-separator":
        return (E, I, m) => {
          const l = /(\[\])$/.test(E);
          if (E = E.replace(/\[\]$/, ""), !l) {
            m[E] = I && p(I, _);
            return;
          }
          const f = I === null ? [] : I.split(_.arrayFormatSeparator).map((L) => p(L, _));
          if (m[E] === void 0) {
            m[E] = f;
            return;
          }
          m[E] = [].concat(m[E], f);
        };
      default:
        return (E, I, m) => {
          if (m[E] === void 0) {
            m[E] = I;
            return;
          }
          m[E] = [].concat(m[E], I);
        };
    }
  }
  function c(_) {
    if (typeof _ != "string" || _.length !== 1)
      throw new TypeError("arrayFormatSeparator must be single character string");
  }
  function h(_, T) {
    return T.encode ? T.strict ? e(_) : encodeURIComponent(_) : _;
  }
  function p(_, T) {
    return T.decode ? r(_) : _;
  }
  function g(_) {
    return Array.isArray(_) ? _.sort() : typeof _ == "object" ? g(Object.keys(_)).sort((T, E) => Number(T) - Number(E)).map((T) => _[T]) : _;
  }
  function v(_) {
    const T = _.indexOf("#");
    return T !== -1 && (_ = _.slice(0, T)), _;
  }
  function b(_) {
    let T = "";
    const E = _.indexOf("#");
    return E !== -1 && (T = _.slice(E)), T;
  }
  function S(_) {
    _ = v(_);
    const T = _.indexOf("?");
    return T === -1 ? "" : _.slice(T + 1);
  }
  function C(_, T) {
    return T.parseNumbers && !Number.isNaN(Number(_)) && typeof _ == "string" && _.trim() !== "" ? _ = Number(_) : T.parseBooleans && _ !== null && (_.toLowerCase() === "true" || _.toLowerCase() === "false") && (_ = _.toLowerCase() === "true"), _;
  }
  function M(_, T) {
    T = Object.assign({
      decode: !0,
      sort: !0,
      arrayFormat: "none",
      arrayFormatSeparator: ",",
      parseNumbers: !1,
      parseBooleans: !1
    }, T), c(T.arrayFormatSeparator);
    const E = u(T), I = /* @__PURE__ */ Object.create(null);
    if (typeof _ != "string" || (_ = _.trim().replace(/^[?#&]/, ""), !_))
      return I;
    for (const m of _.split("&")) {
      if (m === "")
        continue;
      let [l, f] = s(T.decode ? m.replace(/\+/g, " ") : m, "=");
      f = f === void 0 ? null : ["comma", "separator", "bracket-separator"].includes(T.arrayFormat) ? f : p(f, T), E(p(l, T), f, I);
    }
    for (const m of Object.keys(I)) {
      const l = I[m];
      if (typeof l == "object" && l !== null)
        for (const f of Object.keys(l))
          l[f] = C(l[f], T);
      else
        I[m] = C(l, T);
    }
    return T.sort === !1 ? I : (T.sort === !0 ? Object.keys(I).sort() : Object.keys(I).sort(T.sort)).reduce((m, l) => {
      const f = I[l];
      return f && typeof f == "object" && !Array.isArray(f) ? m[l] = g(f) : m[l] = f, m;
    }, /* @__PURE__ */ Object.create(null));
  }
  t.extract = S, t.parse = M, t.stringify = (_, T) => {
    if (!_)
      return "";
    T = Object.assign({
      encode: !0,
      strict: !0,
      arrayFormat: "none",
      arrayFormatSeparator: ","
    }, T), c(T.arrayFormatSeparator);
    const E = (f) => T.skipNull && i(_[f]) || T.skipEmptyString && _[f] === "", I = a(T), m = {};
    for (const f of Object.keys(_))
      E(f) || (m[f] = _[f]);
    const l = Object.keys(m);
    return T.sort !== !1 && l.sort(T.sort), l.map((f) => {
      const L = _[f];
      return L === void 0 ? "" : L === null ? h(f, T) : Array.isArray(L) ? L.length === 0 && T.arrayFormat === "bracket-separator" ? h(f, T) + "[]" : L.reduce(I(f), []).join("&") : h(f, T) + "=" + h(L, T);
    }).filter((f) => f.length > 0).join("&");
  }, t.parseUrl = (_, T) => {
    T = Object.assign({
      decode: !0
    }, T);
    const [E, I] = s(_, "#");
    return Object.assign(
      {
        url: E.split("?")[0] || "",
        query: M(S(_), T)
      },
      T && T.parseFragmentIdentifier && I ? { fragmentIdentifier: p(I, T) } : {}
    );
  }, t.stringifyUrl = (_, T) => {
    T = Object.assign({
      encode: !0,
      strict: !0,
      [o]: !0
    }, T);
    const E = v(_.url).split("?")[0] || "", I = t.extract(_.url), m = t.parse(I, { sort: !1 }), l = Object.assign(m, _.query);
    let f = t.stringify(l, T);
    f && (f = `?${f}`);
    let L = b(_.url);
    return _.fragmentIdentifier && (L = `#${T[o] ? h(_.fragmentIdentifier, T) : _.fragmentIdentifier}`), `${E}${f}${L}`;
  }, t.pick = (_, T, E) => {
    E = Object.assign({
      parseFragmentIdentifier: !0,
      [o]: !1
    }, E);
    const { url: I, query: m, fragmentIdentifier: l } = t.parseUrl(_, E);
    return t.stringifyUrl({
      url: I,
      query: n(m, T),
      fragmentIdentifier: l
    }, E);
  }, t.exclude = (_, T, E) => {
    const I = Array.isArray(T) ? (m) => !T.includes(m) : (m, l) => !T(m, l);
    return t.pick(_, I, E);
  };
})(An);
const jy = {
  waku: {
    publish: "waku_publish",
    batchPublish: "waku_batchPublish",
    subscribe: "waku_subscribe",
    batchSubscribe: "waku_batchSubscribe",
    subscription: "waku_subscription",
    unsubscribe: "waku_unsubscribe",
    batchUnsubscribe: "waku_batchUnsubscribe"
  },
  irn: {
    publish: "irn_publish",
    batchPublish: "irn_batchPublish",
    subscribe: "irn_subscribe",
    batchSubscribe: "irn_batchSubscribe",
    subscription: "irn_subscription",
    unsubscribe: "irn_unsubscribe",
    batchUnsubscribe: "irn_batchUnsubscribe"
  },
  iridium: {
    publish: "iridium_publish",
    batchPublish: "iridium_batchPublish",
    subscribe: "iridium_subscribe",
    batchSubscribe: "iridium_batchSubscribe",
    subscription: "iridium_subscription",
    unsubscribe: "iridium_unsubscribe",
    batchUnsubscribe: "iridium_batchUnsubscribe"
  }
};
function dd(t, e) {
  return t.includes(":") ? [t] : e.chains || [];
}
const hd = "base10", Yt = "base16", io = "base64pad", Wo = "utf8", pd = 0, $s = 1, Ly = 0, mu = 1, ao = 12, Ko = 32;
function My() {
  const t = Vo.generateKeyPair();
  return { privateKey: Jt(t.secretKey, Yt), publicKey: Jt(t.publicKey, Yt) };
}
function oo() {
  const t = ln.randomBytes(Ko);
  return Jt(t, Yt);
}
function Dy(t, e) {
  const r = Vo.sharedKey(rr(t, Yt), rr(e, Yt), !0), s = new sy(ba.SHA256, r).expand(Ko);
  return Jt(s, Yt);
}
function Uy(t) {
  const e = ba.hash(rr(t, Yt));
  return Jt(e, Yt);
}
function Qs(t) {
  const e = ba.hash(rr(t, Wo));
  return Jt(e, Yt);
}
function zy(t) {
  return rr(`${t}`, hd);
}
function li(t) {
  return Number(Jt(t, hd));
}
function $y(t) {
  const e = zy(typeof t.type < "u" ? t.type : pd);
  if (li(e) === $s && typeof t.senderPublicKey > "u")
    throw new Error("Missing sender public key for type 1 envelope");
  const r = typeof t.senderPublicKey < "u" ? rr(t.senderPublicKey, Yt) : void 0, s = typeof t.iv < "u" ? rr(t.iv, Yt) : ln.randomBytes(ao), n = new zo.ChaCha20Poly1305(rr(t.symKey, Yt)).seal(s, rr(t.message, Wo));
  return qy({ type: e, sealed: n, iv: s, senderPublicKey: r });
}
function Vy(t) {
  const e = new zo.ChaCha20Poly1305(rr(t.symKey, Yt)), { sealed: r, iv: s } = qi(t.encoded), n = e.open(s, r);
  if (n === null)
    throw new Error("Failed to decrypt");
  return Jt(n, Wo);
}
function qy(t) {
  if (li(t.type) === $s) {
    if (typeof t.senderPublicKey > "u")
      throw new Error("Missing sender public key for type 1 envelope");
    return Jt(ro([t.type, t.senderPublicKey, t.iv, t.sealed]), io);
  }
  return Jt(ro([t.type, t.iv, t.sealed]), io);
}
function qi(t) {
  const e = rr(t, io), r = e.slice(Ly, mu), s = mu;
  if (li(r) === $s) {
    const a = s + Ko, u = a + ao, c = e.slice(s, a), h = e.slice(a, u), p = e.slice(u);
    return { type: r, sealed: p, iv: h, senderPublicKey: c };
  }
  const n = s + ao, i = e.slice(s, n), o = e.slice(n);
  return { type: r, sealed: o, iv: i };
}
function Zy(t, e) {
  const r = qi(t);
  return fd({ type: li(r.type), senderPublicKey: typeof r.senderPublicKey < "u" ? Jt(r.senderPublicKey, Yt) : void 0, receiverPublicKey: e == null ? void 0 : e.receiverPublicKey });
}
function fd(t) {
  const e = (t == null ? void 0 : t.type) || pd;
  if (e === $s) {
    if (typeof (t == null ? void 0 : t.senderPublicKey) > "u")
      throw new Error("missing sender public key");
    if (typeof (t == null ? void 0 : t.receiverPublicKey) > "u")
      throw new Error("missing receiver public key");
  }
  return { type: e, senderPublicKey: t == null ? void 0 : t.senderPublicKey, receiverPublicKey: t == null ? void 0 : t.receiverPublicKey };
}
function yu(t) {
  return t.type === $s && typeof t.senderPublicKey == "string" && typeof t.receiverPublicKey == "string";
}
var Fy = Object.defineProperty, vu = Object.getOwnPropertySymbols, Wy = Object.prototype.hasOwnProperty, Ky = Object.prototype.propertyIsEnumerable, _u = (t, e, r) => e in t ? Fy(t, e, { enumerable: !0, configurable: !0, writable: !0, value: r }) : t[e] = r, bu = (t, e) => {
  for (var r in e || (e = {}))
    Wy.call(e, r) && _u(t, r, e[r]);
  if (vu)
    for (var r of vu(e))
      Ky.call(e, r) && _u(t, r, e[r]);
  return t;
};
const Hy = "ReactNative", ar = { reactNative: "react-native", node: "node", browser: "browser", unknown: "unknown" }, By = "js";
function Ho() {
  return typeof process < "u" && typeof process.versions < "u" && typeof process.versions.node < "u";
}
function hn() {
  return !qo() && !!Zo() && navigator.product === Hy;
}
function pn() {
  return !Ho() && !!Zo() && !!qo();
}
function di() {
  return hn() ? ar.reactNative : Ho() ? ar.node : pn() ? ar.browser : ar.unknown;
}
function Gy() {
  var t;
  try {
    return hn() && typeof global < "u" && typeof (global == null ? void 0 : global.Application) < "u" ? (t = global.Application) == null ? void 0 : t.applicationId : void 0;
  } catch {
    return;
  }
}
function Yy(t, e) {
  let r = An.parse(t);
  return r = bu(bu({}, r), e), t = An.stringify(r), t;
}
function Jy() {
  return ud() || { name: "", description: "", url: "", icons: [""] };
}
function Xy() {
  if (di() === ar.reactNative && typeof global < "u" && typeof (global == null ? void 0 : global.Platform) < "u") {
    const { OS: r, Version: s } = global.Platform;
    return [r, s].join("-");
  }
  const t = hy();
  if (t === null)
    return "unknown";
  const e = t.os ? t.os.replace(" ", "").toLowerCase() : "unknown";
  return t.type === "browser" ? [e, t.name, t.version].join("-") : [e, t.version].join("-");
}
function Qy() {
  var t;
  const e = di();
  return e === ar.browser ? [e, ((t = cd()) == null ? void 0 : t.host) || "unknown"].join(":") : e;
}
function ev(t, e, r) {
  const s = Xy(), n = Qy();
  return [[t, e].join("-"), [By, r].join("-"), s, n].join("/");
}
function tv({ protocol: t, version: e, relayUrl: r, sdkVersion: s, auth: n, projectId: i, useOnCloseEvent: o, bundleId: a }) {
  const u = r.split("?"), c = ev(t, e, s), h = { auth: n, ua: c, projectId: i, useOnCloseEvent: o || void 0, origin: a || void 0 }, p = Yy(u[1] || "", h);
  return u[0] + "?" + p;
}
function Ts(t, e) {
  return t.filter((r) => e.includes(r)).length === t.length;
}
function gd(t) {
  return Object.fromEntries(t.entries());
}
function md(t) {
  return new Map(Object.entries(t));
}
function Hs(t = oe.FIVE_MINUTES, e) {
  const r = oe.toMiliseconds(t || oe.FIVE_MINUTES);
  let s, n, i;
  return { resolve: (o) => {
    i && s && (clearTimeout(i), s(o));
  }, reject: (o) => {
    i && n && (clearTimeout(i), n(o));
  }, done: () => new Promise((o, a) => {
    i = setTimeout(() => {
      a(new Error(e));
    }, r), s = o, n = a;
  }) };
}
function jn(t, e, r) {
  return new Promise(async (s, n) => {
    const i = setTimeout(() => n(new Error(r)), e);
    try {
      const o = await t;
      s(o);
    } catch (o) {
      n(o);
    }
    clearTimeout(i);
  });
}
function yd(t, e) {
  if (typeof e == "string" && e.startsWith(`${t}:`))
    return e;
  if (t.toLowerCase() === "topic") {
    if (typeof e != "string")
      throw new Error('Value must be "string" for expirer target type: topic');
    return `topic:${e}`;
  } else if (t.toLowerCase() === "id") {
    if (typeof e != "number")
      throw new Error('Value must be "number" for expirer target type: id');
    return `id:${e}`;
  }
  throw new Error(`Unknown expirer target type: ${t}`);
}
function rv(t) {
  return yd("topic", t);
}
function sv(t) {
  return yd("id", t);
}
function vd(t) {
  const [e, r] = t.split(":"), s = { id: void 0, topic: void 0 };
  if (e === "topic" && typeof r == "string")
    s.topic = r;
  else if (e === "id" && Number.isInteger(Number(r)))
    s.id = Number(r);
  else
    throw new Error(`Invalid target, expected id:number or topic:string, got ${e}:${r}`);
  return s;
}
function ir(t, e) {
  return oe.fromMiliseconds((e || Date.now()) + oe.toMiliseconds(t));
}
function is(t) {
  return Date.now() >= oe.toMiliseconds(t);
}
function wt(t, e) {
  return `${t}${e ? `:${e}` : ""}`;
}
async function nv({ id: t, topic: e, wcDeepLink: r }) {
  try {
    if (!r)
      return;
    const s = typeof r == "string" ? JSON.parse(r) : r;
    let n = s == null ? void 0 : s.href;
    if (typeof n != "string")
      return;
    n.endsWith("/") && (n = n.slice(0, -1));
    const i = `${n}/wc?requestId=${t}&sessionTopic=${e}`, o = di();
    o === ar.browser ? i.startsWith("https://") ? window.open(i, "_blank", "noreferrer noopener") : window.open(i, "_self", "noreferrer noopener") : o === ar.reactNative && typeof (global == null ? void 0 : global.Linking) < "u" && await global.Linking.openURL(i);
  } catch (s) {
    console.error(s);
  }
}
async function iv(t, e) {
  try {
    return await t.getItem(e) || (pn() ? localStorage.getItem(e) : void 0);
  } catch (r) {
    console.error(r);
  }
}
const av = "irn";
function co(t) {
  return (t == null ? void 0 : t.relay) || { protocol: av };
}
function ji(t) {
  const e = jy[t];
  if (typeof e > "u")
    throw new Error(`Relay Protocol not supported: ${t}`);
  return e;
}
var ov = Object.defineProperty, cv = Object.defineProperties, uv = Object.getOwnPropertyDescriptors, wu = Object.getOwnPropertySymbols, lv = Object.prototype.hasOwnProperty, dv = Object.prototype.propertyIsEnumerable, Eu = (t, e, r) => e in t ? ov(t, e, { enumerable: !0, configurable: !0, writable: !0, value: r }) : t[e] = r, hv = (t, e) => {
  for (var r in e || (e = {}))
    lv.call(e, r) && Eu(t, r, e[r]);
  if (wu)
    for (var r of wu(e))
      dv.call(e, r) && Eu(t, r, e[r]);
  return t;
}, pv = (t, e) => cv(t, uv(e));
function fv(t, e = "-") {
  const r = {}, s = "relay" + e;
  return Object.keys(t).forEach((n) => {
    if (n.startsWith(s)) {
      const i = n.replace(s, ""), o = t[n];
      r[i] = o;
    }
  }), r;
}
function Su(t) {
  t = t.includes("wc://") ? t.replace("wc://", "") : t, t = t.includes("wc:") ? t.replace("wc:", "") : t;
  const e = t.indexOf(":"), r = t.indexOf("?") !== -1 ? t.indexOf("?") : void 0, s = t.substring(0, e), n = t.substring(e + 1, r).split("@"), i = typeof r < "u" ? t.substring(r) : "", o = An.parse(i);
  return { protocol: s, topic: gv(n[0]), version: parseInt(n[1], 10), symKey: o.symKey, relay: fv(o), expiryTimestamp: o.expiryTimestamp ? parseInt(o.expiryTimestamp, 10) : void 0 };
}
function gv(t) {
  return t.startsWith("//") ? t.substring(2) : t;
}
function mv(t, e = "-") {
  const r = "relay", s = {};
  return Object.keys(t).forEach((n) => {
    const i = r + e + n;
    t[n] && (s[i] = t[n]);
  }), s;
}
function yv(t) {
  return `${t.protocol}:${t.topic}@${t.version}?` + An.stringify(pv(hv({ symKey: t.symKey }, mv(t.relay)), { expiryTimestamp: t.expiryTimestamp }));
}
function fn(t) {
  const e = [];
  return t.forEach((r) => {
    const [s, n] = r.split(":");
    e.push(`${s}:${n}`);
  }), e;
}
function vv(t) {
  const e = [];
  return Object.values(t).forEach((r) => {
    e.push(...fn(r.accounts));
  }), e;
}
function _v(t, e) {
  const r = [];
  return Object.values(t).forEach((s) => {
    fn(s.accounts).includes(e) && r.push(...s.methods);
  }), r;
}
function bv(t, e) {
  const r = [];
  return Object.values(t).forEach((s) => {
    fn(s.accounts).includes(e) && r.push(...s.events);
  }), r;
}
const wv = { INVALID_METHOD: { message: "Invalid method.", code: 1001 }, INVALID_EVENT: { message: "Invalid event.", code: 1002 }, INVALID_UPDATE_REQUEST: { message: "Invalid update request.", code: 1003 }, INVALID_EXTEND_REQUEST: { message: "Invalid extend request.", code: 1004 }, INVALID_SESSION_SETTLE_REQUEST: { message: "Invalid session settle request.", code: 1005 }, UNAUTHORIZED_METHOD: { message: "Unauthorized method.", code: 3001 }, UNAUTHORIZED_EVENT: { message: "Unauthorized event.", code: 3002 }, UNAUTHORIZED_UPDATE_REQUEST: { message: "Unauthorized update request.", code: 3003 }, UNAUTHORIZED_EXTEND_REQUEST: { message: "Unauthorized extend request.", code: 3004 }, USER_REJECTED: { message: "User rejected.", code: 5e3 }, USER_REJECTED_CHAINS: { message: "User rejected chains.", code: 5001 }, USER_REJECTED_METHODS: { message: "User rejected methods.", code: 5002 }, USER_REJECTED_EVENTS: { message: "User rejected events.", code: 5003 }, UNSUPPORTED_CHAINS: { message: "Unsupported chains.", code: 5100 }, UNSUPPORTED_METHODS: { message: "Unsupported methods.", code: 5101 }, UNSUPPORTED_EVENTS: { message: "Unsupported events.", code: 5102 }, UNSUPPORTED_ACCOUNTS: { message: "Unsupported accounts.", code: 5103 }, UNSUPPORTED_NAMESPACE_KEY: { message: "Unsupported namespace key.", code: 5104 }, USER_DISCONNECTED: { message: "User disconnected.", code: 6e3 }, SESSION_SETTLEMENT_FAILED: { message: "Session settlement failed.", code: 7e3 }, WC_METHOD_UNSUPPORTED: { message: "Unsupported wc_ method.", code: 10001 } }, Ev = { NOT_INITIALIZED: { message: "Not initialized.", code: 1 }, NO_MATCHING_KEY: { message: "No matching key.", code: 2 }, RESTORE_WILL_OVERRIDE: { message: "Restore will override.", code: 3 }, RESUBSCRIBED: { message: "Resubscribed.", code: 4 }, MISSING_OR_INVALID: { message: "Missing or invalid.", code: 5 }, EXPIRED: { message: "Expired.", code: 6 }, UNKNOWN_TYPE: { message: "Unknown type.", code: 7 }, MISMATCHED_TOPIC: { message: "Mismatched topic.", code: 8 }, NON_CONFORMING_NAMESPACES: { message: "Non conforming namespaces.", code: 9 } };
function Y(t, e) {
  const { message: r, code: s } = Ev[t];
  return { message: e ? `${r} ${e}` : r, code: s };
}
function Et(t, e) {
  const { message: r, code: s } = wv[t];
  return { message: e ? `${r} ${e}` : r, code: s };
}
function hi(t, e) {
  return Array.isArray(t) ? typeof e < "u" && t.length ? t.every(e) : !0 : !1;
}
function Zi(t) {
  return Object.getPrototypeOf(t) === Object.prototype && Object.keys(t).length;
}
function Gt(t) {
  return typeof t > "u";
}
function kt(t, e) {
  return e && Gt(t) ? !0 : typeof t == "string" && !!t.trim().length;
}
function Bo(t, e) {
  return e && Gt(t) ? !0 : typeof t == "number" && !isNaN(t);
}
function Sv(t, e) {
  const { requiredNamespaces: r } = e, s = Object.keys(t.namespaces), n = Object.keys(r);
  let i = !0;
  return Ts(n, s) ? (s.forEach((o) => {
    const { accounts: a, methods: u, events: c } = t.namespaces[o], h = fn(a), p = r[o];
    (!Ts(dd(o, p), h) || !Ts(p.methods, u) || !Ts(p.events, c)) && (i = !1);
  }), i) : !1;
}
function Fi(t) {
  return kt(t, !1) && t.includes(":") ? t.split(":").length === 2 : !1;
}
function Iv(t) {
  if (kt(t, !1) && t.includes(":")) {
    const e = t.split(":");
    if (e.length === 3) {
      const r = e[0] + ":" + e[1];
      return !!e[2] && Fi(r);
    }
  }
  return !1;
}
function xv(t) {
  if (kt(t, !1))
    try {
      return typeof new URL(t) < "u";
    } catch {
      return !1;
    }
  return !1;
}
function Ov(t) {
  var e;
  return (e = t == null ? void 0 : t.proposer) == null ? void 0 : e.publicKey;
}
function Tv(t) {
  return t == null ? void 0 : t.topic;
}
function Pv(t, e) {
  let r = null;
  return kt(t == null ? void 0 : t.publicKey, !1) || (r = Y("MISSING_OR_INVALID", `${e} controller public key should be a string`)), r;
}
function Iu(t) {
  let e = !0;
  return hi(t) ? t.length && (e = t.every((r) => kt(r, !1))) : e = !1, e;
}
function Cv(t, e, r) {
  let s = null;
  return hi(e) && e.length ? e.forEach((n) => {
    s || Fi(n) || (s = Et("UNSUPPORTED_CHAINS", `${r}, chain ${n} should be a string and conform to "namespace:chainId" format`));
  }) : Fi(t) || (s = Et("UNSUPPORTED_CHAINS", `${r}, chains must be defined as "namespace:chainId" e.g. "eip155:1": {...} in the namespace key OR as an array of CAIP-2 chainIds e.g. eip155: { chains: ["eip155:1", "eip155:5"] }`)), s;
}
function Nv(t, e, r) {
  let s = null;
  return Object.entries(t).forEach(([n, i]) => {
    if (s)
      return;
    const o = Cv(n, dd(n, i), `${e} ${r}`);
    o && (s = o);
  }), s;
}
function kv(t, e) {
  let r = null;
  return hi(t) ? t.forEach((s) => {
    r || Iv(s) || (r = Et("UNSUPPORTED_ACCOUNTS", `${e}, account ${s} should be a string and conform to "namespace:chainId:address" format`));
  }) : r = Et("UNSUPPORTED_ACCOUNTS", `${e}, accounts should be an array of strings conforming to "namespace:chainId:address" format`), r;
}
function Rv(t, e) {
  let r = null;
  return Object.values(t).forEach((s) => {
    if (r)
      return;
    const n = kv(s == null ? void 0 : s.accounts, `${e} namespace`);
    n && (r = n);
  }), r;
}
function Av(t, e) {
  let r = null;
  return Iu(t == null ? void 0 : t.methods) ? Iu(t == null ? void 0 : t.events) || (r = Et("UNSUPPORTED_EVENTS", `${e}, events should be an array of strings or empty array for no events`)) : r = Et("UNSUPPORTED_METHODS", `${e}, methods should be an array of strings or empty array for no methods`), r;
}
function _d(t, e) {
  let r = null;
  return Object.values(t).forEach((s) => {
    if (r)
      return;
    const n = Av(s, `${e}, namespace`);
    n && (r = n);
  }), r;
}
function jv(t, e, r) {
  let s = null;
  if (t && Zi(t)) {
    const n = _d(t, e);
    n && (s = n);
    const i = Nv(t, e, r);
    i && (s = i);
  } else
    s = Y("MISSING_OR_INVALID", `${e}, ${r} should be an object with data`);
  return s;
}
function La(t, e) {
  let r = null;
  if (t && Zi(t)) {
    const s = _d(t, e);
    s && (r = s);
    const n = Rv(t, e);
    n && (r = n);
  } else
    r = Y("MISSING_OR_INVALID", `${e}, namespaces should be an object with data`);
  return r;
}
function bd(t) {
  return kt(t.protocol, !0);
}
function Lv(t, e) {
  let r = !1;
  return e && !t ? r = !0 : t && hi(t) && t.length && t.forEach((s) => {
    r = bd(s);
  }), r;
}
function Mv(t) {
  return typeof t == "number";
}
function tr(t) {
  return typeof t < "u" && typeof t !== null;
}
function Dv(t) {
  return !(!t || typeof t != "object" || !t.code || !Bo(t.code, !1) || !t.message || !kt(t.message, !1));
}
function Uv(t) {
  return !(Gt(t) || !kt(t.method, !1));
}
function zv(t) {
  return !(Gt(t) || Gt(t.result) && Gt(t.error) || !Bo(t.id, !1) || !kt(t.jsonrpc, !1));
}
function $v(t) {
  return !(Gt(t) || !kt(t.name, !1));
}
function xu(t, e) {
  return !(!Fi(e) || !vv(t).includes(e));
}
function Vv(t, e, r) {
  return kt(r, !1) ? _v(t, e).includes(r) : !1;
}
function qv(t, e, r) {
  return kt(r, !1) ? bv(t, e).includes(r) : !1;
}
function Ou(t, e, r) {
  let s = null;
  const n = Zv(t), i = Fv(e), o = Object.keys(n), a = Object.keys(i), u = Tu(Object.keys(t)), c = Tu(Object.keys(e)), h = u.filter((p) => !c.includes(p));
  return h.length && (s = Y("NON_CONFORMING_NAMESPACES", `${r} namespaces keys don't satisfy requiredNamespaces.
      Required: ${h.toString()}
      Received: ${Object.keys(e).toString()}`)), Ts(o, a) || (s = Y("NON_CONFORMING_NAMESPACES", `${r} namespaces chains don't satisfy required namespaces.
      Required: ${o.toString()}
      Approved: ${a.toString()}`)), Object.keys(e).forEach((p) => {
    if (!p.includes(":") || s)
      return;
    const g = fn(e[p].accounts);
    g.includes(p) || (s = Y("NON_CONFORMING_NAMESPACES", `${r} namespaces accounts don't satisfy namespace accounts for ${p}
        Required: ${p}
        Approved: ${g.toString()}`));
  }), o.forEach((p) => {
    s || (Ts(n[p].methods, i[p].methods) ? Ts(n[p].events, i[p].events) || (s = Y("NON_CONFORMING_NAMESPACES", `${r} namespaces events don't satisfy namespace events for ${p}`)) : s = Y("NON_CONFORMING_NAMESPACES", `${r} namespaces methods don't satisfy namespace methods for ${p}`));
  }), s;
}
function Zv(t) {
  const e = {};
  return Object.keys(t).forEach((r) => {
    var s;
    r.includes(":") ? e[r] = t[r] : (s = t[r].chains) == null || s.forEach((n) => {
      e[n] = { methods: t[r].methods, events: t[r].events };
    });
  }), e;
}
function Tu(t) {
  return [...new Set(t.map((e) => e.includes(":") ? e.split(":")[0] : e))];
}
function Fv(t) {
  const e = {};
  return Object.keys(t).forEach((r) => {
    if (r.includes(":"))
      e[r] = t[r];
    else {
      const s = fn(t[r].accounts);
      s == null || s.forEach((n) => {
        e[n] = { accounts: t[r].accounts.filter((i) => i.includes(`${n}:`)), methods: t[r].methods, events: t[r].events };
      });
    }
  }), e;
}
function Wv(t, e) {
  return Bo(t, !1) && t <= e.max && t >= e.min;
}
function Pu() {
  const t = di();
  return new Promise((e) => {
    switch (t) {
      case ar.browser:
        e(Kv());
        break;
      case ar.reactNative:
        e(Hv());
        break;
      case ar.node:
        e(Bv());
        break;
      default:
        e(!0);
    }
  });
}
function Kv() {
  return pn() && (navigator == null ? void 0 : navigator.onLine);
}
async function Hv() {
  if (hn() && typeof global < "u" && global != null && global.NetInfo) {
    const t = await (global == null ? void 0 : global.NetInfo.fetch());
    return t == null ? void 0 : t.isConnected;
  }
  return !0;
}
function Bv() {
  return !0;
}
function Gv(t) {
  switch (di()) {
    case ar.browser:
      Yv(t);
      break;
    case ar.reactNative:
      Jv(t);
      break;
  }
}
function Yv(t) {
  !hn() && pn() && (window.addEventListener("online", () => t(!0)), window.addEventListener("offline", () => t(!1)));
}
function Jv(t) {
  hn() && typeof global < "u" && global != null && global.NetInfo && (global == null || global.NetInfo.addEventListener((e) => t(e == null ? void 0 : e.isConnected)));
}
const Ma = {};
let Pi = class {
  static get(t) {
    return Ma[t];
  }
  static set(t, e) {
    Ma[t] = e;
  }
  static delete(t) {
    delete Ma[t];
  }
};
const Xv = "PARSE_ERROR", Qv = "INVALID_REQUEST", e_ = "METHOD_NOT_FOUND", t_ = "INVALID_PARAMS", wd = "INTERNAL_ERROR", Go = "SERVER_ERROR", r_ = [-32700, -32600, -32601, -32602, -32603], Nn = {
  [Xv]: { code: -32700, message: "Parse error" },
  [Qv]: { code: -32600, message: "Invalid Request" },
  [e_]: { code: -32601, message: "Method not found" },
  [t_]: { code: -32602, message: "Invalid params" },
  [wd]: { code: -32603, message: "Internal error" },
  [Go]: { code: -32e3, message: "Server error" }
}, Ed = Go;
function s_(t) {
  return r_.includes(t);
}
function Cu(t) {
  return Object.keys(Nn).includes(t) ? Nn[t] : Nn[Ed];
}
function n_(t) {
  return Object.values(Nn).find((r) => r.code === t) || Nn[Ed];
}
function i_(t, e, r) {
  return t.message.includes("getaddrinfo ENOTFOUND") || t.message.includes("connect ECONNREFUSED") ? new Error(`Unavailable ${r} RPC url at ${e}`) : t;
}
var Sd = {}, Zr = {}, Nu;
function a_() {
  if (Nu)
    return Zr;
  Nu = 1, Object.defineProperty(Zr, "__esModule", { value: !0 }), Zr.isBrowserCryptoAvailable = Zr.getSubtleCrypto = Zr.getBrowerCrypto = void 0;
  function t() {
    return (cs == null ? void 0 : cs.crypto) || (cs == null ? void 0 : cs.msCrypto) || {};
  }
  Zr.getBrowerCrypto = t;
  function e() {
    const s = t();
    return s.subtle || s.webkitSubtle;
  }
  Zr.getSubtleCrypto = e;
  function r() {
    return !!t() && !!e();
  }
  return Zr.isBrowserCryptoAvailable = r, Zr;
}
var Fr = {}, ku;
function o_() {
  if (ku)
    return Fr;
  ku = 1, Object.defineProperty(Fr, "__esModule", { value: !0 }), Fr.isBrowser = Fr.isNode = Fr.isReactNative = void 0;
  function t() {
    return typeof document > "u" && typeof navigator < "u" && navigator.product === "ReactNative";
  }
  Fr.isReactNative = t;
  function e() {
    return typeof process < "u" && typeof process.versions < "u" && typeof process.versions.node < "u";
  }
  Fr.isNode = e;
  function r() {
    return !t() && !e();
  }
  return Fr.isBrowser = r, Fr;
}
(function(t) {
  Object.defineProperty(t, "__esModule", { value: !0 });
  const e = Vr;
  e.__exportStar(a_(), t), e.__exportStar(o_(), t);
})(Sd);
function Yo(t = 3) {
  const e = Date.now() * Math.pow(10, t), r = Math.floor(Math.random() * Math.pow(10, t));
  return e + r;
}
function Id(t = 6) {
  return BigInt(Yo(t));
}
function en(t, e, r) {
  return {
    id: r || Yo(),
    jsonrpc: "2.0",
    method: t,
    params: e
  };
}
function Jo(t, e) {
  return {
    id: t,
    jsonrpc: "2.0",
    result: e
  };
}
function Xo(t, e, r) {
  return {
    id: t,
    jsonrpc: "2.0",
    error: c_(e, r)
  };
}
function c_(t, e) {
  return typeof t > "u" ? Cu(wd) : (typeof t == "string" && (t = Object.assign(Object.assign({}, Cu(Go)), { message: t })), typeof e < "u" && (t.data = e), s_(t.code) && (t = n_(t.code)), t);
}
class u_ {
}
class l_ extends u_ {
  constructor() {
    super();
  }
}
class d_ extends l_ {
  constructor(e) {
    super();
  }
}
const h_ = "^wss?:";
function p_(t) {
  const e = t.match(new RegExp(/^\w+:/, "gi"));
  if (!(!e || !e.length))
    return e[0];
}
function f_(t, e) {
  const r = p_(t);
  return typeof r > "u" ? !1 : new RegExp(e).test(r);
}
function Ru(t) {
  return f_(t, h_);
}
function g_(t) {
  return new RegExp("wss?://localhost(:d{2,5})?").test(t);
}
function xd(t) {
  return typeof t == "object" && "id" in t && "jsonrpc" in t && t.jsonrpc === "2.0";
}
function Qo(t) {
  return xd(t) && "method" in t;
}
function wa(t) {
  return xd(t) && (Br(t) || yr(t));
}
function Br(t) {
  return "result" in t;
}
function yr(t) {
  return "error" in t;
}
class m_ extends d_ {
  constructor(e) {
    super(e), this.events = new Pr.EventEmitter(), this.hasRegisteredEventListeners = !1, this.connection = this.setConnection(e), this.connection.connected && this.registerEventListeners();
  }
  async connect(e = this.connection) {
    await this.open(e);
  }
  async disconnect() {
    await this.close();
  }
  on(e, r) {
    this.events.on(e, r);
  }
  once(e, r) {
    this.events.once(e, r);
  }
  off(e, r) {
    this.events.off(e, r);
  }
  removeListener(e, r) {
    this.events.removeListener(e, r);
  }
  async request(e, r) {
    return this.requestStrict(en(e.method, e.params || [], e.id || Id().toString()), r);
  }
  async requestStrict(e, r) {
    return new Promise(async (s, n) => {
      if (!this.connection.connected)
        try {
          await this.open();
        } catch (i) {
          n(i);
        }
      this.events.on(`${e.id}`, (i) => {
        yr(i) ? n(i.error) : s(i.result);
      });
      try {
        await this.connection.send(e, r);
      } catch (i) {
        n(i);
      }
    });
  }
  setConnection(e = this.connection) {
    return e;
  }
  onPayload(e) {
    this.events.emit("payload", e), wa(e) ? this.events.emit(`${e.id}`, e) : this.events.emit("message", {
      type: e.method,
      data: e.params
    });
  }
  onClose(e) {
    e && e.code === 3e3 && this.events.emit("error", new Error(`WebSocket connection closed abnormally with code: ${e.code} ${e.reason ? `(${e.reason})` : ""}`)), this.events.emit("disconnect");
  }
  async open(e = this.connection) {
    this.connection === e && this.connection.connected || (this.connection.connected && this.close(), typeof e == "string" && (await this.connection.open(e), e = this.connection), this.connection = this.setConnection(e), await this.connection.open(), this.registerEventListeners(), this.events.emit("connect"));
  }
  async close() {
    await this.connection.close();
  }
  registerEventListeners() {
    this.hasRegisteredEventListeners || (this.connection.on("payload", (e) => this.onPayload(e)), this.connection.on("close", (e) => this.onClose(e)), this.connection.on("error", (e) => this.events.emit("error", e)), this.connection.on("register_error", (e) => this.onClose()), this.hasRegisteredEventListeners = !0);
  }
}
const y_ = () => typeof WebSocket < "u" ? WebSocket : typeof global < "u" && typeof global.WebSocket < "u" ? global.WebSocket : typeof window < "u" && typeof window.WebSocket < "u" ? window.WebSocket : typeof self < "u" && typeof self.WebSocket < "u" ? self.WebSocket : (() => {
  try {
    return (() => {try { return require("ws") } catch (e) { } })();
  } catch {
  }
})(), v_ = () => typeof WebSocket < "u" || typeof global < "u" && typeof global.WebSocket < "u" || typeof window < "u" && typeof window.WebSocket < "u" || typeof self < "u" && typeof self.WebSocket < "u", Au = (t) => t.split("?")[0], ju = 10, __ = y_();
class b_ {
  constructor(e) {
    if (this.url = e, this.events = new Pr.EventEmitter(), this.registering = !1, !Ru(e))
      throw new Error(`Provided URL is not compatible with WebSocket connection: ${e}`);
    this.url = e;
  }
  get connected() {
    return typeof this.socket < "u";
  }
  get connecting() {
    return this.registering;
  }
  on(e, r) {
    this.events.on(e, r);
  }
  once(e, r) {
    this.events.once(e, r);
  }
  off(e, r) {
    this.events.off(e, r);
  }
  removeListener(e, r) {
    this.events.removeListener(e, r);
  }
  async open(e = this.url) {
    await this.register(e);
  }
  async close() {
    return new Promise((e, r) => {
      if (typeof this.socket > "u") {
        r(new Error("Connection already closed"));
        return;
      }
      this.socket.onclose = (s) => {
        this.onClose(s), e();
      }, this.socket.close();
    });
  }
  async send(e) {
    typeof this.socket > "u" && (this.socket = await this.register());
    try {
      this.socket.send(oi(e));
    } catch (r) {
      this.onError(e.id, r);
    }
  }
  register(e = this.url) {
    if (!Ru(e))
      throw new Error(`Provided URL is not compatible with WebSocket connection: ${e}`);
    if (this.registering) {
      const r = this.events.getMaxListeners();
      return (this.events.listenerCount("register_error") >= r || this.events.listenerCount("open") >= r) && this.events.setMaxListeners(r + 1), new Promise((s, n) => {
        this.events.once("register_error", (i) => {
          this.resetMaxListeners(), n(i);
        }), this.events.once("open", () => {
          if (this.resetMaxListeners(), typeof this.socket > "u")
            return n(new Error("WebSocket connection is missing or invalid"));
          s(this.socket);
        });
      });
    }
    return this.url = e, this.registering = !0, new Promise((r, s) => {
      const n = new URLSearchParams(e).get("origin"), i = Sd.isReactNative() ? { headers: { origin: n } } : { rejectUnauthorized: !g_(e) }, o = new __(e, [], i);
      v_() ? o.onerror = (a) => {
        const u = a;
        s(this.emitError(u.error));
      } : o.on("error", (a) => {
        s(this.emitError(a));
      }), o.onopen = () => {
        this.onOpen(o), r(o);
      };
    });
  }
  onOpen(e) {
    e.onmessage = (r) => this.onPayload(r), e.onclose = (r) => this.onClose(r), this.socket = e, this.registering = !1, this.events.emit("open");
  }
  onClose(e) {
    this.socket = void 0, this.registering = !1, this.events.emit("close", e);
  }
  onPayload(e) {
    if (typeof e.data > "u")
      return;
    const r = typeof e.data == "string" ? fa(e.data) : e.data;
    this.events.emit("payload", r);
  }
  onError(e, r) {
    const s = this.parseError(r), n = s.message || s.toString(), i = Xo(e, n);
    this.events.emit("payload", i);
  }
  parseError(e, r = this.url) {
    return i_(e, Au(r), "WS");
  }
  resetMaxListeners() {
    this.events.getMaxListeners() > ju && this.events.setMaxListeners(ju);
  }
  emitError(e) {
    const r = this.parseError(new Error((e == null ? void 0 : e.message) || `WebSocket connection failed for host: ${Au(this.url)}`));
    return this.events.emit("register_error", r), r;
  }
}
var Wi = { exports: {} };
Wi.exports;
(function(t, e) {
  var r = 200, s = "__lodash_hash_undefined__", n = 1, i = 2, o = 9007199254740991, a = "[object Arguments]", u = "[object Array]", c = "[object AsyncFunction]", h = "[object Boolean]", p = "[object Date]", g = "[object Error]", v = "[object Function]", b = "[object GeneratorFunction]", S = "[object Map]", C = "[object Number]", M = "[object Null]", _ = "[object Object]", T = "[object Promise]", E = "[object Proxy]", I = "[object RegExp]", m = "[object Set]", l = "[object String]", f = "[object Symbol]", L = "[object Undefined]", A = "[object WeakMap]", V = "[object ArrayBuffer]", J = "[object DataView]", G = "[object Float32Array]", O = "[object Float64Array]", k = "[object Int8Array]", Q = "[object Int16Array]", Z = "[object Int32Array]", z = "[object Uint8Array]", q = "[object Uint8ClampedArray]", U = "[object Uint16Array]", F = "[object Uint32Array]", me = /[\\^$.*+?()[\]{}|]/g, W = /^\[object .+?Constructor\]$/, de = /^(?:0|[1-9]\d*)$/, se = {};
  se[G] = se[O] = se[k] = se[Q] = se[Z] = se[z] = se[q] = se[U] = se[F] = !0, se[a] = se[u] = se[V] = se[h] = se[J] = se[p] = se[g] = se[v] = se[S] = se[C] = se[_] = se[I] = se[m] = se[l] = se[A] = !1;
  var le = typeof cs == "object" && cs && cs.Object === Object && cs, j = typeof self == "object" && self && self.Object === Object && self, R = le || j || Function("return this")(), P = e && !e.nodeType && e, d = P && !0 && t && !t.nodeType && t, x = d && d.exports === P, B = x && le.process, ee = function() {
    try {
      return B && B.binding && B.binding("util");
    } catch {
    }
  }(), Ae = ee && ee.isTypedArray;
  function je(y, N) {
    for (var $ = -1, ae = y == null ? 0 : y.length, st = 0, Pe = []; ++$ < ae; ) {
      var mt = y[$];
      N(mt, $, y) && (Pe[st++] = mt);
    }
    return Pe;
  }
  function xe(y, N) {
    for (var $ = -1, ae = N.length, st = y.length; ++$ < ae; )
      y[st + $] = N[$];
    return y;
  }
  function qe(y, N) {
    for (var $ = -1, ae = y == null ? 0 : y.length; ++$ < ae; )
      if (N(y[$], $, y))
        return !0;
    return !1;
  }
  function nt(y, N) {
    for (var $ = -1, ae = Array(y); ++$ < y; )
      ae[$] = N($);
    return ae;
  }
  function Xe(y) {
    return function(N) {
      return y(N);
    };
  }
  function $e(y, N) {
    return y.has(N);
  }
  function De(y, N) {
    return y == null ? void 0 : y[N];
  }
  function Oe(y) {
    var N = -1, $ = Array(y.size);
    return y.forEach(function(ae, st) {
      $[++N] = [st, ae];
    }), $;
  }
  function Ce(y, N) {
    return function($) {
      return y(N($));
    };
  }
  function Te(y) {
    var N = -1, $ = Array(y.size);
    return y.forEach(function(ae) {
      $[++N] = ae;
    }), $;
  }
  var we = Array.prototype, _e = Function.prototype, he = Object.prototype, Ne = R["__core-js_shared__"], Le = _e.toString, ye = he.hasOwnProperty, Ue = function() {
    var y = /[^.]+$/.exec(Ne && Ne.keys && Ne.keys.IE_PROTO || "");
    return y ? "Symbol(src)_1." + y : "";
  }(), Ze = he.toString, He = RegExp(
    "^" + Le.call(ye).replace(me, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
  ), Be = x ? R.Buffer : void 0, We = R.Symbol, sr = R.Uint8Array, cr = he.propertyIsEnumerable, kr = we.splice, Rt = We ? We.toStringTag : void 0, Rr = Object.getOwnPropertySymbols, ur = Be ? Be.isBuffer : void 0, Qr = Ce(Object.keys, Object), it = Vs(R, "DataView"), tt = Vs(R, "Map"), ht = Vs(R, "Promise"), ot = Vs(R, "Set"), pt = Vs(R, "WeakMap"), rt = Vs(Object, "create"), vt = _s(it), St = _s(tt), It = _s(ht), _t = _s(ot), xt = _s(pt), bt = We ? We.prototype : void 0, ft = bt ? bt.valueOf : void 0;
  function Qe(y) {
    var N = -1, $ = y == null ? 0 : y.length;
    for (this.clear(); ++N < $; ) {
      var ae = y[N];
      this.set(ae[0], ae[1]);
    }
  }
  function w() {
    this.__data__ = rt ? rt(null) : {}, this.size = 0;
  }
  function D(y) {
    var N = this.has(y) && delete this.__data__[y];
    return this.size -= N ? 1 : 0, N;
  }
  function X(y) {
    var N = this.__data__;
    if (rt) {
      var $ = N[y];
      return $ === s ? void 0 : $;
    }
    return ye.call(N, y) ? N[y] : void 0;
  }
  function pe(y) {
    var N = this.__data__;
    return rt ? N[y] !== void 0 : ye.call(N, y);
  }
  function Ke(y, N) {
    var $ = this.__data__;
    return this.size += this.has(y) ? 0 : 1, $[y] = rt && N === void 0 ? s : N, this;
  }
  Qe.prototype.clear = w, Qe.prototype.delete = D, Qe.prototype.get = X, Qe.prototype.has = pe, Qe.prototype.set = Ke;
  function ze(y) {
    var N = -1, $ = y == null ? 0 : y.length;
    for (this.clear(); ++N < $; ) {
      var ae = y[N];
      this.set(ae[0], ae[1]);
    }
  }
  function Ve() {
    this.__data__ = [], this.size = 0;
  }
  function Me(y) {
    var N = this.__data__, $ = vi(N, y);
    if ($ < 0)
      return !1;
    var ae = N.length - 1;
    return $ == ae ? N.pop() : kr.call(N, $, 1), --this.size, !0;
  }
  function At(y) {
    var N = this.__data__, $ = vi(N, y);
    return $ < 0 ? void 0 : N[$][1];
  }
  function ct(y) {
    return vi(this.__data__, y) > -1;
  }
  function gt(y, N) {
    var $ = this.__data__, ae = vi($, y);
    return ae < 0 ? (++this.size, $.push([y, N])) : $[ae][1] = N, this;
  }
  ze.prototype.clear = Ve, ze.prototype.delete = Me, ze.prototype.get = At, ze.prototype.has = ct, ze.prototype.set = gt;
  function Ot(y) {
    var N = -1, $ = y == null ? 0 : y.length;
    for (this.clear(); ++N < $; ) {
      var ae = y[N];
      this.set(ae[0], ae[1]);
    }
  }
  function es() {
    this.size = 0, this.__data__ = {
      hash: new Qe(),
      map: new (tt || ze)(),
      string: new Qe()
    };
  }
  function mi(y) {
    var N = _i(this, y).delete(y);
    return this.size -= N ? 1 : 0, N;
  }
  function fr(y) {
    return _i(this, y).get(y);
  }
  function dh(y) {
    return _i(this, y).has(y);
  }
  function hh(y, N) {
    var $ = _i(this, y), ae = $.size;
    return $.set(y, N), this.size += $.size == ae ? 0 : 1, this;
  }
  Ot.prototype.clear = es, Ot.prototype.delete = mi, Ot.prototype.get = fr, Ot.prototype.has = dh, Ot.prototype.set = hh;
  function yi(y) {
    var N = -1, $ = y == null ? 0 : y.length;
    for (this.__data__ = new Ot(); ++N < $; )
      this.add(y[N]);
  }
  function ph(y) {
    return this.__data__.set(y, s), this;
  }
  function fh(y) {
    return this.__data__.has(y);
  }
  yi.prototype.add = yi.prototype.push = ph, yi.prototype.has = fh;
  function ts(y) {
    var N = this.__data__ = new ze(y);
    this.size = N.size;
  }
  function gh() {
    this.__data__ = new ze(), this.size = 0;
  }
  function mh(y) {
    var N = this.__data__, $ = N.delete(y);
    return this.size = N.size, $;
  }
  function yh(y) {
    return this.__data__.get(y);
  }
  function vh(y) {
    return this.__data__.has(y);
  }
  function _h(y, N) {
    var $ = this.__data__;
    if ($ instanceof ze) {
      var ae = $.__data__;
      if (!tt || ae.length < r - 1)
        return ae.push([y, N]), this.size = ++$.size, this;
      $ = this.__data__ = new Ot(ae);
    }
    return $.set(y, N), this.size = $.size, this;
  }
  ts.prototype.clear = gh, ts.prototype.delete = mh, ts.prototype.get = yh, ts.prototype.has = vh, ts.prototype.set = _h;
  function bh(y, N) {
    var $ = bi(y), ae = !$ && Lh(y), st = !$ && !ae && Ta(y), Pe = !$ && !ae && !st && fc(y), mt = $ || ae || st || Pe, Tt = mt ? nt(y.length, String) : [], jt = Tt.length;
    for (var ut in y)
      (N || ye.call(y, ut)) && !(mt && // Safari 9 has enumerable `arguments.length` in strict mode.
      (ut == "length" || // Node.js 0.10 has enumerable non-index properties on buffers.
      st && (ut == "offset" || ut == "parent") || // PhantomJS 2 has enumerable non-index properties on typed arrays.
      Pe && (ut == "buffer" || ut == "byteLength" || ut == "byteOffset") || // Skip index properties.
      Nh(ut, jt))) && Tt.push(ut);
    return Tt;
  }
  function vi(y, N) {
    for (var $ = y.length; $--; )
      if (lc(y[$][0], N))
        return $;
    return -1;
  }
  function wh(y, N, $) {
    var ae = N(y);
    return bi(y) ? ae : xe(ae, $(y));
  }
  function gn(y) {
    return y == null ? y === void 0 ? L : M : Rt && Rt in Object(y) ? Ph(y) : jh(y);
  }
  function ac(y) {
    return mn(y) && gn(y) == a;
  }
  function oc(y, N, $, ae, st) {
    return y === N ? !0 : y == null || N == null || !mn(y) && !mn(N) ? y !== y && N !== N : Eh(y, N, $, ae, oc, st);
  }
  function Eh(y, N, $, ae, st, Pe) {
    var mt = bi(y), Tt = bi(N), jt = mt ? u : rs(y), ut = Tt ? u : rs(N);
    jt = jt == a ? _ : jt, ut = ut == a ? _ : ut;
    var nr = jt == _, gr = ut == _, Dt = jt == ut;
    if (Dt && Ta(y)) {
      if (!Ta(N))
        return !1;
      mt = !0, nr = !1;
    }
    if (Dt && !nr)
      return Pe || (Pe = new ts()), mt || fc(y) ? cc(y, N, $, ae, st, Pe) : Oh(y, N, jt, $, ae, st, Pe);
    if (!($ & n)) {
      var lr = nr && ye.call(y, "__wrapped__"), dr = gr && ye.call(N, "__wrapped__");
      if (lr || dr) {
        var ss = lr ? y.value() : y, qr = dr ? N.value() : N;
        return Pe || (Pe = new ts()), st(ss, qr, $, ae, Pe);
      }
    }
    return Dt ? (Pe || (Pe = new ts()), Th(y, N, $, ae, st, Pe)) : !1;
  }
  function Sh(y) {
    if (!pc(y) || Rh(y))
      return !1;
    var N = dc(y) ? He : W;
    return N.test(_s(y));
  }
  function Ih(y) {
    return mn(y) && hc(y.length) && !!se[gn(y)];
  }
  function xh(y) {
    if (!Ah(y))
      return Qr(y);
    var N = [];
    for (var $ in Object(y))
      ye.call(y, $) && $ != "constructor" && N.push($);
    return N;
  }
  function cc(y, N, $, ae, st, Pe) {
    var mt = $ & n, Tt = y.length, jt = N.length;
    if (Tt != jt && !(mt && jt > Tt))
      return !1;
    var ut = Pe.get(y);
    if (ut && Pe.get(N))
      return ut == N;
    var nr = -1, gr = !0, Dt = $ & i ? new yi() : void 0;
    for (Pe.set(y, N), Pe.set(N, y); ++nr < Tt; ) {
      var lr = y[nr], dr = N[nr];
      if (ae)
        var ss = mt ? ae(dr, lr, nr, N, y, Pe) : ae(lr, dr, nr, y, N, Pe);
      if (ss !== void 0) {
        if (ss)
          continue;
        gr = !1;
        break;
      }
      if (Dt) {
        if (!qe(N, function(qr, bs) {
          if (!$e(Dt, bs) && (lr === qr || st(lr, qr, $, ae, Pe)))
            return Dt.push(bs);
        })) {
          gr = !1;
          break;
        }
      } else if (!(lr === dr || st(lr, dr, $, ae, Pe))) {
        gr = !1;
        break;
      }
    }
    return Pe.delete(y), Pe.delete(N), gr;
  }
  function Oh(y, N, $, ae, st, Pe, mt) {
    switch ($) {
      case J:
        if (y.byteLength != N.byteLength || y.byteOffset != N.byteOffset)
          return !1;
        y = y.buffer, N = N.buffer;
      case V:
        return !(y.byteLength != N.byteLength || !Pe(new sr(y), new sr(N)));
      case h:
      case p:
      case C:
        return lc(+y, +N);
      case g:
        return y.name == N.name && y.message == N.message;
      case I:
      case l:
        return y == N + "";
      case S:
        var Tt = Oe;
      case m:
        var jt = ae & n;
        if (Tt || (Tt = Te), y.size != N.size && !jt)
          return !1;
        var ut = mt.get(y);
        if (ut)
          return ut == N;
        ae |= i, mt.set(y, N);
        var nr = cc(Tt(y), Tt(N), ae, st, Pe, mt);
        return mt.delete(y), nr;
      case f:
        if (ft)
          return ft.call(y) == ft.call(N);
    }
    return !1;
  }
  function Th(y, N, $, ae, st, Pe) {
    var mt = $ & n, Tt = uc(y), jt = Tt.length, ut = uc(N), nr = ut.length;
    if (jt != nr && !mt)
      return !1;
    for (var gr = jt; gr--; ) {
      var Dt = Tt[gr];
      if (!(mt ? Dt in N : ye.call(N, Dt)))
        return !1;
    }
    var lr = Pe.get(y);
    if (lr && Pe.get(N))
      return lr == N;
    var dr = !0;
    Pe.set(y, N), Pe.set(N, y);
    for (var ss = mt; ++gr < jt; ) {
      Dt = Tt[gr];
      var qr = y[Dt], bs = N[Dt];
      if (ae)
        var gc = mt ? ae(bs, qr, Dt, N, y, Pe) : ae(qr, bs, Dt, y, N, Pe);
      if (!(gc === void 0 ? qr === bs || st(qr, bs, $, ae, Pe) : gc)) {
        dr = !1;
        break;
      }
      ss || (ss = Dt == "constructor");
    }
    if (dr && !ss) {
      var wi = y.constructor, Ei = N.constructor;
      wi != Ei && "constructor" in y && "constructor" in N && !(typeof wi == "function" && wi instanceof wi && typeof Ei == "function" && Ei instanceof Ei) && (dr = !1);
    }
    return Pe.delete(y), Pe.delete(N), dr;
  }
  function uc(y) {
    return wh(y, Uh, Ch);
  }
  function _i(y, N) {
    var $ = y.__data__;
    return kh(N) ? $[typeof N == "string" ? "string" : "hash"] : $.map;
  }
  function Vs(y, N) {
    var $ = De(y, N);
    return Sh($) ? $ : void 0;
  }
  function Ph(y) {
    var N = ye.call(y, Rt), $ = y[Rt];
    try {
      y[Rt] = void 0;
      var ae = !0;
    } catch {
    }
    var st = Ze.call(y);
    return ae && (N ? y[Rt] = $ : delete y[Rt]), st;
  }
  var Ch = Rr ? function(y) {
    return y == null ? [] : (y = Object(y), je(Rr(y), function(N) {
      return cr.call(y, N);
    }));
  } : zh, rs = gn;
  (it && rs(new it(new ArrayBuffer(1))) != J || tt && rs(new tt()) != S || ht && rs(ht.resolve()) != T || ot && rs(new ot()) != m || pt && rs(new pt()) != A) && (rs = function(y) {
    var N = gn(y), $ = N == _ ? y.constructor : void 0, ae = $ ? _s($) : "";
    if (ae)
      switch (ae) {
        case vt:
          return J;
        case St:
          return S;
        case It:
          return T;
        case _t:
          return m;
        case xt:
          return A;
      }
    return N;
  });
  function Nh(y, N) {
    return N = N ?? o, !!N && (typeof y == "number" || de.test(y)) && y > -1 && y % 1 == 0 && y < N;
  }
  function kh(y) {
    var N = typeof y;
    return N == "string" || N == "number" || N == "symbol" || N == "boolean" ? y !== "__proto__" : y === null;
  }
  function Rh(y) {
    return !!Ue && Ue in y;
  }
  function Ah(y) {
    var N = y && y.constructor, $ = typeof N == "function" && N.prototype || he;
    return y === $;
  }
  function jh(y) {
    return Ze.call(y);
  }
  function _s(y) {
    if (y != null) {
      try {
        return Le.call(y);
      } catch {
      }
      try {
        return y + "";
      } catch {
      }
    }
    return "";
  }
  function lc(y, N) {
    return y === N || y !== y && N !== N;
  }
  var Lh = ac(/* @__PURE__ */ function() {
    return arguments;
  }()) ? ac : function(y) {
    return mn(y) && ye.call(y, "callee") && !cr.call(y, "callee");
  }, bi = Array.isArray;
  function Mh(y) {
    return y != null && hc(y.length) && !dc(y);
  }
  var Ta = ur || $h;
  function Dh(y, N) {
    return oc(y, N);
  }
  function dc(y) {
    if (!pc(y))
      return !1;
    var N = gn(y);
    return N == v || N == b || N == c || N == E;
  }
  function hc(y) {
    return typeof y == "number" && y > -1 && y % 1 == 0 && y <= o;
  }
  function pc(y) {
    var N = typeof y;
    return y != null && (N == "object" || N == "function");
  }
  function mn(y) {
    return y != null && typeof y == "object";
  }
  var fc = Ae ? Xe(Ae) : Ih;
  function Uh(y) {
    return Mh(y) ? bh(y) : xh(y);
  }
  function zh() {
    return [];
  }
  function $h() {
    return !1;
  }
  t.exports = Dh;
})(Wi, Wi.exports);
var w_ = Wi.exports;
const E_ = /* @__PURE__ */ da(w_);
function S_(t, e) {
  return e = e || {}, new Promise(function(r, s) {
    var n = new XMLHttpRequest(), i = [], o = [], a = {}, u = function() {
      return { ok: (n.status / 100 | 0) == 2, statusText: n.statusText, status: n.status, url: n.responseURL, text: function() {
        return Promise.resolve(n.responseText);
      }, json: function() {
        return Promise.resolve(n.responseText).then(JSON.parse);
      }, blob: function() {
        return Promise.resolve(new Blob([n.response]));
      }, clone: u, headers: { keys: function() {
        return i;
      }, entries: function() {
        return o;
      }, get: function(h) {
        return a[h.toLowerCase()];
      }, has: function(h) {
        return h.toLowerCase() in a;
      } } };
    };
    for (var c in n.open(e.method || "get", t, !0), n.onload = function() {
      n.getAllResponseHeaders().replace(/^(.*?):[^\S\n]*([\s\S]*?)$/gm, function(h, p, g) {
        i.push(p = p.toLowerCase()), o.push([p, g]), a[p] = a[p] ? a[p] + "," + g : g;
      }), r(u());
    }, n.onerror = s, n.withCredentials = e.credentials == "include", e.headers)
      n.setRequestHeader(c, e.headers[c]);
    n.send(e.body || null);
  });
}
const I_ = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: S_
}, Symbol.toStringTag, { value: "Module" })), Lu = /* @__PURE__ */ ha(I_);
var x_ = fetch || (self.fetch = Lu.default || Lu);
const O_ = /* @__PURE__ */ da(x_);
function T_(t, e) {
  if (t.length >= 255)
    throw new TypeError("Alphabet too long");
  for (var r = new Uint8Array(256), s = 0; s < r.length; s++)
    r[s] = 255;
  for (var n = 0; n < t.length; n++) {
    var i = t.charAt(n), o = i.charCodeAt(0);
    if (r[o] !== 255)
      throw new TypeError(i + " is ambiguous");
    r[o] = n;
  }
  var a = t.length, u = t.charAt(0), c = Math.log(a) / Math.log(256), h = Math.log(256) / Math.log(a);
  function p(b) {
    if (b instanceof Uint8Array || (ArrayBuffer.isView(b) ? b = new Uint8Array(b.buffer, b.byteOffset, b.byteLength) : Array.isArray(b) && (b = Uint8Array.from(b))), !(b instanceof Uint8Array))
      throw new TypeError("Expected Uint8Array");
    if (b.length === 0)
      return "";
    for (var S = 0, C = 0, M = 0, _ = b.length; M !== _ && b[M] === 0; )
      M++, S++;
    for (var T = (_ - M) * h + 1 >>> 0, E = new Uint8Array(T); M !== _; ) {
      for (var I = b[M], m = 0, l = T - 1; (I !== 0 || m < C) && l !== -1; l--, m++)
        I += 256 * E[l] >>> 0, E[l] = I % a >>> 0, I = I / a >>> 0;
      if (I !== 0)
        throw new Error("Non-zero carry");
      C = m, M++;
    }
    for (var f = T - C; f !== T && E[f] === 0; )
      f++;
    for (var L = u.repeat(S); f < T; ++f)
      L += t.charAt(E[f]);
    return L;
  }
  function g(b) {
    if (typeof b != "string")
      throw new TypeError("Expected String");
    if (b.length === 0)
      return new Uint8Array();
    var S = 0;
    if (b[S] !== " ") {
      for (var C = 0, M = 0; b[S] === u; )
        C++, S++;
      for (var _ = (b.length - S) * c + 1 >>> 0, T = new Uint8Array(_); b[S]; ) {
        var E = r[b.charCodeAt(S)];
        if (E === 255)
          return;
        for (var I = 0, m = _ - 1; (E !== 0 || I < M) && m !== -1; m--, I++)
          E += a * T[m] >>> 0, T[m] = E % 256 >>> 0, E = E / 256 >>> 0;
        if (E !== 0)
          throw new Error("Non-zero carry");
        M = I, S++;
      }
      if (b[S] !== " ") {
        for (var l = _ - M; l !== _ && T[l] === 0; )
          l++;
        for (var f = new Uint8Array(C + (_ - l)), L = C; l !== _; )
          f[L++] = T[l++];
        return f;
      }
    }
  }
  function v(b) {
    var S = g(b);
    if (S)
      return S;
    throw new Error(`Non-${e} character`);
  }
  return { encode: p, decodeUnsafe: g, decode: v };
}
var P_ = T_, C_ = P_;
const Od = (t) => {
  if (t instanceof Uint8Array && t.constructor.name === "Uint8Array")
    return t;
  if (t instanceof ArrayBuffer)
    return new Uint8Array(t);
  if (ArrayBuffer.isView(t))
    return new Uint8Array(t.buffer, t.byteOffset, t.byteLength);
  throw new Error("Unknown type, must be binary type");
}, N_ = (t) => new TextEncoder().encode(t), k_ = (t) => new TextDecoder().decode(t);
class R_ {
  constructor(e, r, s) {
    this.name = e, this.prefix = r, this.baseEncode = s;
  }
  encode(e) {
    if (e instanceof Uint8Array)
      return `${this.prefix}${this.baseEncode(e)}`;
    throw Error("Unknown type, must be binary type");
  }
}
class A_ {
  constructor(e, r, s) {
    if (this.name = e, this.prefix = r, r.codePointAt(0) === void 0)
      throw new Error("Invalid prefix character");
    this.prefixCodePoint = r.codePointAt(0), this.baseDecode = s;
  }
  decode(e) {
    if (typeof e == "string") {
      if (e.codePointAt(0) !== this.prefixCodePoint)
        throw Error(`Unable to decode multibase string ${JSON.stringify(e)}, ${this.name} decoder only supports inputs prefixed with ${this.prefix}`);
      return this.baseDecode(e.slice(this.prefix.length));
    } else
      throw Error("Can only multibase decode strings");
  }
  or(e) {
    return Td(this, e);
  }
}
class j_ {
  constructor(e) {
    this.decoders = e;
  }
  or(e) {
    return Td(this, e);
  }
  decode(e) {
    const r = e[0], s = this.decoders[r];
    if (s)
      return s.decode(e);
    throw RangeError(`Unable to decode multibase string ${JSON.stringify(e)}, only inputs prefixed with ${Object.keys(this.decoders)} are supported`);
  }
}
const Td = (t, e) => new j_({ ...t.decoders || { [t.prefix]: t }, ...e.decoders || { [e.prefix]: e } });
class L_ {
  constructor(e, r, s, n) {
    this.name = e, this.prefix = r, this.baseEncode = s, this.baseDecode = n, this.encoder = new R_(e, r, s), this.decoder = new A_(e, r, n);
  }
  encode(e) {
    return this.encoder.encode(e);
  }
  decode(e) {
    return this.decoder.decode(e);
  }
}
const Ea = ({ name: t, prefix: e, encode: r, decode: s }) => new L_(t, e, r, s), pi = ({ prefix: t, name: e, alphabet: r }) => {
  const { encode: s, decode: n } = C_(r, e);
  return Ea({ prefix: t, name: e, encode: s, decode: (i) => Od(n(i)) });
}, M_ = (t, e, r, s) => {
  const n = {};
  for (let h = 0; h < e.length; ++h)
    n[e[h]] = h;
  let i = t.length;
  for (; t[i - 1] === "="; )
    --i;
  const o = new Uint8Array(i * r / 8 | 0);
  let a = 0, u = 0, c = 0;
  for (let h = 0; h < i; ++h) {
    const p = n[t[h]];
    if (p === void 0)
      throw new SyntaxError(`Non-${s} character`);
    u = u << r | p, a += r, a >= 8 && (a -= 8, o[c++] = 255 & u >> a);
  }
  if (a >= r || 255 & u << 8 - a)
    throw new SyntaxError("Unexpected end of data");
  return o;
}, D_ = (t, e, r) => {
  const s = e[e.length - 1] === "=", n = (1 << r) - 1;
  let i = "", o = 0, a = 0;
  for (let u = 0; u < t.length; ++u)
    for (a = a << 8 | t[u], o += 8; o > r; )
      o -= r, i += e[n & a >> o];
  if (o && (i += e[n & a << r - o]), s)
    for (; i.length * r & 7; )
      i += "=";
  return i;
}, Mt = ({ name: t, prefix: e, bitsPerChar: r, alphabet: s }) => Ea({ prefix: e, name: t, encode(n) {
  return D_(n, s, r);
}, decode(n) {
  return M_(n, s, r, t);
} }), U_ = Ea({ prefix: "\0", name: "identity", encode: (t) => k_(t), decode: (t) => N_(t) });
var z_ = Object.freeze({ __proto__: null, identity: U_ });
const $_ = Mt({ prefix: "0", name: "base2", alphabet: "01", bitsPerChar: 1 });
var V_ = Object.freeze({ __proto__: null, base2: $_ });
const q_ = Mt({ prefix: "7", name: "base8", alphabet: "01234567", bitsPerChar: 3 });
var Z_ = Object.freeze({ __proto__: null, base8: q_ });
const F_ = pi({ prefix: "9", name: "base10", alphabet: "0123456789" });
var W_ = Object.freeze({ __proto__: null, base10: F_ });
const K_ = Mt({ prefix: "f", name: "base16", alphabet: "0123456789abcdef", bitsPerChar: 4 }), H_ = Mt({ prefix: "F", name: "base16upper", alphabet: "0123456789ABCDEF", bitsPerChar: 4 });
var B_ = Object.freeze({ __proto__: null, base16: K_, base16upper: H_ });
const G_ = Mt({ prefix: "b", name: "base32", alphabet: "abcdefghijklmnopqrstuvwxyz234567", bitsPerChar: 5 }), Y_ = Mt({ prefix: "B", name: "base32upper", alphabet: "ABCDEFGHIJKLMNOPQRSTUVWXYZ234567", bitsPerChar: 5 }), J_ = Mt({ prefix: "c", name: "base32pad", alphabet: "abcdefghijklmnopqrstuvwxyz234567=", bitsPerChar: 5 }), X_ = Mt({ prefix: "C", name: "base32padupper", alphabet: "ABCDEFGHIJKLMNOPQRSTUVWXYZ234567=", bitsPerChar: 5 }), Q_ = Mt({ prefix: "v", name: "base32hex", alphabet: "0123456789abcdefghijklmnopqrstuv", bitsPerChar: 5 }), eb = Mt({ prefix: "V", name: "base32hexupper", alphabet: "0123456789ABCDEFGHIJKLMNOPQRSTUV", bitsPerChar: 5 }), tb = Mt({ prefix: "t", name: "base32hexpad", alphabet: "0123456789abcdefghijklmnopqrstuv=", bitsPerChar: 5 }), rb = Mt({ prefix: "T", name: "base32hexpadupper", alphabet: "0123456789ABCDEFGHIJKLMNOPQRSTUV=", bitsPerChar: 5 }), sb = Mt({ prefix: "h", name: "base32z", alphabet: "ybndrfg8ejkmcpqxot1uwisza345h769", bitsPerChar: 5 });
var nb = Object.freeze({ __proto__: null, base32: G_, base32upper: Y_, base32pad: J_, base32padupper: X_, base32hex: Q_, base32hexupper: eb, base32hexpad: tb, base32hexpadupper: rb, base32z: sb });
const ib = pi({ prefix: "k", name: "base36", alphabet: "0123456789abcdefghijklmnopqrstuvwxyz" }), ab = pi({ prefix: "K", name: "base36upper", alphabet: "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ" });
var ob = Object.freeze({ __proto__: null, base36: ib, base36upper: ab });
const cb = pi({ name: "base58btc", prefix: "z", alphabet: "123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz" }), ub = pi({ name: "base58flickr", prefix: "Z", alphabet: "123456789abcdefghijkmnopqrstuvwxyzABCDEFGHJKLMNPQRSTUVWXYZ" });
var lb = Object.freeze({ __proto__: null, base58btc: cb, base58flickr: ub });
const db = Mt({ prefix: "m", name: "base64", alphabet: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/", bitsPerChar: 6 }), hb = Mt({ prefix: "M", name: "base64pad", alphabet: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=", bitsPerChar: 6 }), pb = Mt({ prefix: "u", name: "base64url", alphabet: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_", bitsPerChar: 6 }), fb = Mt({ prefix: "U", name: "base64urlpad", alphabet: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_=", bitsPerChar: 6 });
var gb = Object.freeze({ __proto__: null, base64: db, base64pad: hb, base64url: pb, base64urlpad: fb });
const Pd = Array.from("🚀🪐☄🛰🌌🌑🌒🌓🌔🌕🌖🌗🌘🌍🌏🌎🐉☀💻🖥💾💿😂❤😍🤣😊🙏💕😭😘👍😅👏😁🔥🥰💔💖💙😢🤔😆🙄💪😉☺👌🤗💜😔😎😇🌹🤦🎉💞✌✨🤷😱😌🌸🙌😋💗💚😏💛🙂💓🤩😄😀🖤😃💯🙈👇🎶😒🤭❣😜💋👀😪😑💥🙋😞😩😡🤪👊🥳😥🤤👉💃😳✋😚😝😴🌟😬🙃🍀🌷😻😓⭐✅🥺🌈😈🤘💦✔😣🏃💐☹🎊💘😠☝😕🌺🎂🌻😐🖕💝🙊😹🗣💫💀👑🎵🤞😛🔴😤🌼😫⚽🤙☕🏆🤫👈😮🙆🍻🍃🐶💁😲🌿🧡🎁⚡🌞🎈❌✊👋😰🤨😶🤝🚶💰🍓💢🤟🙁🚨💨🤬✈🎀🍺🤓😙💟🌱😖👶🥴▶➡❓💎💸⬇😨🌚🦋😷🕺⚠🙅😟😵👎🤲🤠🤧📌🔵💅🧐🐾🍒😗🤑🌊🤯🐷☎💧😯💆👆🎤🙇🍑❄🌴💣🐸💌📍🥀🤢👅💡💩👐📸👻🤐🤮🎼🥵🚩🍎🍊👼💍📣🥂"), mb = Pd.reduce((t, e, r) => (t[r] = e, t), []), yb = Pd.reduce((t, e, r) => (t[e.codePointAt(0)] = r, t), []);
function vb(t) {
  return t.reduce((e, r) => (e += mb[r], e), "");
}
function _b(t) {
  const e = [];
  for (const r of t) {
    const s = yb[r.codePointAt(0)];
    if (s === void 0)
      throw new Error(`Non-base256emoji character: ${r}`);
    e.push(s);
  }
  return new Uint8Array(e);
}
const bb = Ea({ prefix: "🚀", name: "base256emoji", encode: vb, decode: _b });
var wb = Object.freeze({ __proto__: null, base256emoji: bb }), Eb = Cd, Mu = 128, Sb = 127, Ib = ~Sb, xb = Math.pow(2, 31);
function Cd(t, e, r) {
  e = e || [], r = r || 0;
  for (var s = r; t >= xb; )
    e[r++] = t & 255 | Mu, t /= 128;
  for (; t & Ib; )
    e[r++] = t & 255 | Mu, t >>>= 7;
  return e[r] = t | 0, Cd.bytes = r - s + 1, e;
}
var Ob = uo, Tb = 128, Du = 127;
function uo(t, s) {
  var r = 0, s = s || 0, n = 0, i = s, o, a = t.length;
  do {
    if (i >= a)
      throw uo.bytes = 0, new RangeError("Could not decode varint");
    o = t[i++], r += n < 28 ? (o & Du) << n : (o & Du) * Math.pow(2, n), n += 7;
  } while (o >= Tb);
  return uo.bytes = i - s, r;
}
var Pb = Math.pow(2, 7), Cb = Math.pow(2, 14), Nb = Math.pow(2, 21), kb = Math.pow(2, 28), Rb = Math.pow(2, 35), Ab = Math.pow(2, 42), jb = Math.pow(2, 49), Lb = Math.pow(2, 56), Mb = Math.pow(2, 63), Db = function(t) {
  return t < Pb ? 1 : t < Cb ? 2 : t < Nb ? 3 : t < kb ? 4 : t < Rb ? 5 : t < Ab ? 6 : t < jb ? 7 : t < Lb ? 8 : t < Mb ? 9 : 10;
}, Ub = { encode: Eb, decode: Ob, encodingLength: Db }, Nd = Ub;
const Uu = (t, e, r = 0) => (Nd.encode(t, e, r), e), zu = (t) => Nd.encodingLength(t), lo = (t, e) => {
  const r = e.byteLength, s = zu(t), n = s + zu(r), i = new Uint8Array(n + r);
  return Uu(t, i, 0), Uu(r, i, s), i.set(e, n), new zb(t, r, e, i);
};
class zb {
  constructor(e, r, s, n) {
    this.code = e, this.size = r, this.digest = s, this.bytes = n;
  }
}
const kd = ({ name: t, code: e, encode: r }) => new $b(t, e, r);
class $b {
  constructor(e, r, s) {
    this.name = e, this.code = r, this.encode = s;
  }
  digest(e) {
    if (e instanceof Uint8Array) {
      const r = this.encode(e);
      return r instanceof Uint8Array ? lo(this.code, r) : r.then((s) => lo(this.code, s));
    } else
      throw Error("Unknown type, must be binary type");
  }
}
const Rd = (t) => async (e) => new Uint8Array(await crypto.subtle.digest(t, e)), Vb = kd({ name: "sha2-256", code: 18, encode: Rd("SHA-256") }), qb = kd({ name: "sha2-512", code: 19, encode: Rd("SHA-512") });
var Zb = Object.freeze({ __proto__: null, sha256: Vb, sha512: qb });
const Ad = 0, Fb = "identity", jd = Od, Wb = (t) => lo(Ad, jd(t)), Kb = { code: Ad, name: Fb, encode: jd, digest: Wb };
var Hb = Object.freeze({ __proto__: null, identity: Kb });
new TextEncoder(), new TextDecoder();
const $u = { ...z_, ...V_, ...Z_, ...W_, ...B_, ...nb, ...ob, ...lb, ...gb, ...wb };
({ ...Zb, ...Hb });
function Ld(t) {
  return globalThis.Buffer != null ? new Uint8Array(t.buffer, t.byteOffset, t.byteLength) : t;
}
function Bb(t = 0) {
  return globalThis.Buffer != null && globalThis.Buffer.allocUnsafe != null ? Ld(globalThis.Buffer.allocUnsafe(t)) : new Uint8Array(t);
}
function Md(t, e, r, s) {
  return { name: t, prefix: e, encoder: { name: t, prefix: e, encode: r }, decoder: { decode: s } };
}
const Vu = Md("utf8", "u", (t) => "u" + new TextDecoder("utf8").decode(t), (t) => new TextEncoder().encode(t.substring(1))), Da = Md("ascii", "a", (t) => {
  let e = "a";
  for (let r = 0; r < t.length; r++)
    e += String.fromCharCode(t[r]);
  return e;
}, (t) => {
  t = t.substring(1);
  const e = Bb(t.length);
  for (let r = 0; r < t.length; r++)
    e[r] = t.charCodeAt(r);
  return e;
}), Gb = { utf8: Vu, "utf-8": Vu, hex: $u.base16, latin1: Da, ascii: Da, binary: Da, ...$u };
function Yb(t, e = "utf8") {
  const r = Gb[e];
  if (!r)
    throw new Error(`Unsupported encoding "${e}"`);
  return (e === "utf8" || e === "utf-8") && globalThis.Buffer != null && globalThis.Buffer.from != null ? Ld(globalThis.Buffer.from(t, "utf-8")) : r.decoder.decode(`${r.prefix}${t}`);
}
const Dd = "wc", Jb = 2, ec = "core", ls = `${Dd}@2:${ec}:`, Xb = { name: ec, logger: "error" }, Qb = { database: ":memory:" }, e0 = "crypto", qu = "client_ed25519_seed", t0 = oe.ONE_DAY, r0 = "keychain", s0 = "0.3", n0 = "messages", i0 = "0.3", a0 = oe.SIX_HOURS, o0 = "publisher", Ud = "irn", c0 = "error", zd = "wss://relay.walletconnect.com", Zu = "wss://relay.walletconnect.org", u0 = "relayer", Zt = { message: "relayer_message", message_ack: "relayer_message_ack", connect: "relayer_connect", disconnect: "relayer_disconnect", error: "relayer_error", connection_stalled: "relayer_connection_stalled", transport_closed: "relayer_transport_closed", publish: "relayer_publish" }, l0 = "_subscription", Wr = { payload: "payload", connect: "connect", disconnect: "disconnect", error: "error" }, d0 = oe.ONE_SECOND, h0 = "2.11.1", p0 = 1e4, f0 = "0.3", g0 = "WALLETCONNECT_CLIENT_ID", mr = { created: "subscription_created", deleted: "subscription_deleted", expired: "subscription_expired", disabled: "subscription_disabled", sync: "subscription_sync", resubscribed: "subscription_resubscribed" }, m0 = "subscription", y0 = "0.3", v0 = oe.FIVE_SECONDS * 1e3, _0 = "pairing", b0 = "0.3", En = { wc_pairingDelete: { req: { ttl: oe.ONE_DAY, prompt: !1, tag: 1e3 }, res: { ttl: oe.ONE_DAY, prompt: !1, tag: 1001 } }, wc_pairingPing: { req: { ttl: oe.THIRTY_SECONDS, prompt: !1, tag: 1002 }, res: { ttl: oe.THIRTY_SECONDS, prompt: !1, tag: 1003 } }, unregistered_method: { req: { ttl: oe.ONE_DAY, prompt: !1, tag: 0 }, res: { ttl: oe.ONE_DAY, prompt: !1, tag: 0 } } }, Tn = { create: "pairing_create", expire: "pairing_expire", delete: "pairing_delete", ping: "pairing_ping" }, Mr = { created: "history_created", updated: "history_updated", deleted: "history_deleted", sync: "history_sync" }, w0 = "history", E0 = "0.3", S0 = "expirer", hr = { created: "expirer_created", deleted: "expirer_deleted", expired: "expirer_expired", sync: "expirer_sync" }, I0 = "0.3", Ua = "verify-api", Js = "https://verify.walletconnect.com", ho = "https://verify.walletconnect.org", x0 = [Js, ho], O0 = "echo", T0 = "https://echo.walletconnect.com";
class P0 {
  constructor(e, r) {
    this.core = e, this.logger = r, this.keychain = /* @__PURE__ */ new Map(), this.name = r0, this.version = s0, this.initialized = !1, this.storagePrefix = ls, this.init = async () => {
      if (!this.initialized) {
        const s = await this.getKeyChain();
        typeof s < "u" && (this.keychain = s), this.initialized = !0;
      }
    }, this.has = (s) => (this.isInitialized(), this.keychain.has(s)), this.set = async (s, n) => {
      this.isInitialized(), this.keychain.set(s, n), await this.persist();
    }, this.get = (s) => {
      this.isInitialized();
      const n = this.keychain.get(s);
      if (typeof n > "u") {
        const { message: i } = Y("NO_MATCHING_KEY", `${this.name}: ${s}`);
        throw new Error(i);
      }
      return n;
    }, this.del = async (s) => {
      this.isInitialized(), this.keychain.delete(s), await this.persist();
    }, this.core = e, this.logger = Fe.generateChildLogger(r, this.name);
  }
  get context() {
    return Fe.getLoggerContext(this.logger);
  }
  get storageKey() {
    return this.storagePrefix + this.version + this.core.customStoragePrefix + "//" + this.name;
  }
  async setKeyChain(e) {
    await this.core.storage.setItem(this.storageKey, gd(e));
  }
  async getKeyChain() {
    const e = await this.core.storage.getItem(this.storageKey);
    return typeof e < "u" ? md(e) : void 0;
  }
  async persist() {
    await this.setKeyChain(this.keychain);
  }
  isInitialized() {
    if (!this.initialized) {
      const { message: e } = Y("NOT_INITIALIZED", this.name);
      throw new Error(e);
    }
  }
}
class C0 {
  constructor(e, r, s) {
    this.core = e, this.logger = r, this.name = e0, this.initialized = !1, this.init = async () => {
      this.initialized || (await this.keychain.init(), this.initialized = !0);
    }, this.hasKeys = (n) => (this.isInitialized(), this.keychain.has(n)), this.getClientId = async () => {
      this.isInitialized();
      const n = await this.getClientSeed(), i = au(n);
      return rd(i.publicKey);
    }, this.generateKeyPair = () => {
      this.isInitialized();
      const n = My();
      return this.setPrivateKey(n.publicKey, n.privateKey);
    }, this.signJWT = async (n) => {
      this.isInitialized();
      const i = await this.getClientSeed(), o = au(i), a = oo();
      return await Fm(a, n, t0, o);
    }, this.generateSharedKey = (n, i, o) => {
      this.isInitialized();
      const a = this.getPrivateKey(n), u = Dy(a, i);
      return this.setSymKey(u, o);
    }, this.setSymKey = async (n, i) => {
      this.isInitialized();
      const o = i || Uy(n);
      return await this.keychain.set(o, n), o;
    }, this.deleteKeyPair = async (n) => {
      this.isInitialized(), await this.keychain.del(n);
    }, this.deleteSymKey = async (n) => {
      this.isInitialized(), await this.keychain.del(n);
    }, this.encode = async (n, i, o) => {
      this.isInitialized();
      const a = fd(o), u = oi(i);
      if (yu(a)) {
        const g = a.senderPublicKey, v = a.receiverPublicKey;
        n = await this.generateSharedKey(g, v);
      }
      const c = this.getSymKey(n), { type: h, senderPublicKey: p } = a;
      return $y({ type: h, symKey: c, message: u, senderPublicKey: p });
    }, this.decode = async (n, i, o) => {
      this.isInitialized();
      const a = Zy(i, o);
      if (yu(a)) {
        const u = a.receiverPublicKey, c = a.senderPublicKey;
        n = await this.generateSharedKey(u, c);
      }
      try {
        const u = this.getSymKey(n), c = Vy({ symKey: u, encoded: i });
        return fa(c);
      } catch (u) {
        this.logger.error(`Failed to decode message from topic: '${n}', clientId: '${await this.getClientId()}'`), this.logger.error(u);
      }
    }, this.getPayloadType = (n) => {
      const i = qi(n);
      return li(i.type);
    }, this.getPayloadSenderPublicKey = (n) => {
      const i = qi(n);
      return i.senderPublicKey ? Jt(i.senderPublicKey, Yt) : void 0;
    }, this.core = e, this.logger = Fe.generateChildLogger(r, this.name), this.keychain = s || new P0(this.core, this.logger);
  }
  get context() {
    return Fe.getLoggerContext(this.logger);
  }
  async setPrivateKey(e, r) {
    return await this.keychain.set(e, r), e;
  }
  getPrivateKey(e) {
    return this.keychain.get(e);
  }
  async getClientSeed() {
    let e = "";
    try {
      e = this.keychain.get(qu);
    } catch {
      e = oo(), await this.keychain.set(qu, e);
    }
    return Yb(e, "base16");
  }
  getSymKey(e) {
    return this.keychain.get(e);
  }
  isInitialized() {
    if (!this.initialized) {
      const { message: e } = Y("NOT_INITIALIZED", this.name);
      throw new Error(e);
    }
  }
}
class N0 extends Bf {
  constructor(e, r) {
    super(e, r), this.logger = e, this.core = r, this.messages = /* @__PURE__ */ new Map(), this.name = n0, this.version = i0, this.initialized = !1, this.storagePrefix = ls, this.init = async () => {
      if (!this.initialized) {
        this.logger.trace("Initialized");
        try {
          const s = await this.getRelayerMessages();
          typeof s < "u" && (this.messages = s), this.logger.debug(`Successfully Restored records for ${this.name}`), this.logger.trace({ type: "method", method: "restore", size: this.messages.size });
        } catch (s) {
          this.logger.debug(`Failed to Restore records for ${this.name}`), this.logger.error(s);
        } finally {
          this.initialized = !0;
        }
      }
    }, this.set = async (s, n) => {
      this.isInitialized();
      const i = Qs(n);
      let o = this.messages.get(s);
      return typeof o > "u" && (o = {}), typeof o[i] < "u" || (o[i] = n, this.messages.set(s, o), await this.persist()), i;
    }, this.get = (s) => {
      this.isInitialized();
      let n = this.messages.get(s);
      return typeof n > "u" && (n = {}), n;
    }, this.has = (s, n) => {
      this.isInitialized();
      const i = this.get(s), o = Qs(n);
      return typeof i[o] < "u";
    }, this.del = async (s) => {
      this.isInitialized(), this.messages.delete(s), await this.persist();
    }, this.logger = Fe.generateChildLogger(e, this.name), this.core = r;
  }
  get context() {
    return Fe.getLoggerContext(this.logger);
  }
  get storageKey() {
    return this.storagePrefix + this.version + this.core.customStoragePrefix + "//" + this.name;
  }
  async setRelayerMessages(e) {
    await this.core.storage.setItem(this.storageKey, gd(e));
  }
  async getRelayerMessages() {
    const e = await this.core.storage.getItem(this.storageKey);
    return typeof e < "u" ? md(e) : void 0;
  }
  async persist() {
    await this.setRelayerMessages(this.messages);
  }
  isInitialized() {
    if (!this.initialized) {
      const { message: e } = Y("NOT_INITIALIZED", this.name);
      throw new Error(e);
    }
  }
}
class k0 extends Gf {
  constructor(e, r) {
    super(e, r), this.relayer = e, this.logger = r, this.events = new Pr.EventEmitter(), this.name = o0, this.queue = /* @__PURE__ */ new Map(), this.publishTimeout = oe.toMiliseconds(oe.TEN_SECONDS * 2), this.needsTransportRestart = !1, this.publish = async (s, n, i) => {
      var o;
      this.logger.debug("Publishing Payload"), this.logger.trace({ type: "method", method: "publish", params: { topic: s, message: n, opts: i } });
      try {
        const a = (i == null ? void 0 : i.ttl) || a0, u = co(i), c = (i == null ? void 0 : i.prompt) || !1, h = (i == null ? void 0 : i.tag) || 0, p = (i == null ? void 0 : i.id) || Id().toString(), g = { topic: s, message: n, opts: { ttl: a, relay: u, prompt: c, tag: h, id: p } }, v = setTimeout(() => this.queue.set(p, g), this.publishTimeout);
        try {
          await await jn(this.rpcPublish(s, n, a, u, c, h, p), this.publishTimeout, `Failed to publish payload, please try again. id:${p} tag:${h}`), this.removeRequestFromQueue(p), this.relayer.events.emit(Zt.publish, g);
        } catch (b) {
          if (this.logger.debug("Publishing Payload stalled"), this.needsTransportRestart = !0, (o = i == null ? void 0 : i.internal) != null && o.throwOnFailedPublish)
            throw this.removeRequestFromQueue(p), b;
          return;
        } finally {
          clearTimeout(v);
        }
        this.logger.debug("Successfully Published Payload"), this.logger.trace({ type: "method", method: "publish", params: { topic: s, message: n, opts: i } });
      } catch (a) {
        throw this.logger.debug("Failed to Publish Payload"), this.logger.error(a), a;
      }
    }, this.on = (s, n) => {
      this.events.on(s, n);
    }, this.once = (s, n) => {
      this.events.once(s, n);
    }, this.off = (s, n) => {
      this.events.off(s, n);
    }, this.removeListener = (s, n) => {
      this.events.removeListener(s, n);
    }, this.relayer = e, this.logger = Fe.generateChildLogger(r, this.name), this.registerEventListeners();
  }
  get context() {
    return Fe.getLoggerContext(this.logger);
  }
  rpcPublish(e, r, s, n, i, o, a) {
    var u, c, h, p;
    const g = { method: ji(n.protocol).publish, params: { topic: e, message: r, ttl: s, prompt: i, tag: o }, id: a };
    return Gt((u = g.params) == null ? void 0 : u.prompt) && ((c = g.params) == null || delete c.prompt), Gt((h = g.params) == null ? void 0 : h.tag) && ((p = g.params) == null || delete p.tag), this.logger.debug("Outgoing Relay Payload"), this.logger.trace({ type: "message", direction: "outgoing", request: g }), this.relayer.request(g);
  }
  removeRequestFromQueue(e) {
    this.queue.delete(e);
  }
  checkQueue() {
    this.queue.forEach(async (e) => {
      const { topic: r, message: s, opts: n } = e;
      await this.publish(r, s, n);
    });
  }
  registerEventListeners() {
    this.relayer.core.heartbeat.on(un.HEARTBEAT_EVENTS.pulse, () => {
      if (this.needsTransportRestart) {
        this.needsTransportRestart = !1, this.relayer.events.emit(Zt.connection_stalled);
        return;
      }
      this.checkQueue();
    }), this.relayer.on(Zt.message_ack, (e) => {
      this.removeRequestFromQueue(e.id.toString());
    });
  }
}
class R0 {
  constructor() {
    this.map = /* @__PURE__ */ new Map(), this.set = (e, r) => {
      const s = this.get(e);
      this.exists(e, r) || this.map.set(e, [...s, r]);
    }, this.get = (e) => this.map.get(e) || [], this.exists = (e, r) => this.get(e).includes(r), this.delete = (e, r) => {
      if (typeof r > "u") {
        this.map.delete(e);
        return;
      }
      if (!this.map.has(e))
        return;
      const s = this.get(e);
      if (!this.exists(e, r))
        return;
      const n = s.filter((i) => i !== r);
      if (!n.length) {
        this.map.delete(e);
        return;
      }
      this.map.set(e, n);
    }, this.clear = () => {
      this.map.clear();
    };
  }
  get topics() {
    return Array.from(this.map.keys());
  }
}
var A0 = Object.defineProperty, j0 = Object.defineProperties, L0 = Object.getOwnPropertyDescriptors, Fu = Object.getOwnPropertySymbols, M0 = Object.prototype.hasOwnProperty, D0 = Object.prototype.propertyIsEnumerable, Wu = (t, e, r) => e in t ? A0(t, e, { enumerable: !0, configurable: !0, writable: !0, value: r }) : t[e] = r, Sn = (t, e) => {
  for (var r in e || (e = {}))
    M0.call(e, r) && Wu(t, r, e[r]);
  if (Fu)
    for (var r of Fu(e))
      D0.call(e, r) && Wu(t, r, e[r]);
  return t;
}, za = (t, e) => j0(t, L0(e));
class U0 extends Xf {
  constructor(e, r) {
    super(e, r), this.relayer = e, this.logger = r, this.subscriptions = /* @__PURE__ */ new Map(), this.topicMap = new R0(), this.events = new Pr.EventEmitter(), this.name = m0, this.version = y0, this.pending = /* @__PURE__ */ new Map(), this.cached = [], this.initialized = !1, this.pendingSubscriptionWatchLabel = "pending_sub_watch_label", this.pollingInterval = 20, this.storagePrefix = ls, this.subscribeTimeout = 1e4, this.restartInProgress = !1, this.batchSubscribeTopicsLimit = 500, this.init = async () => {
      this.initialized || (this.logger.trace("Initialized"), this.registerEventListeners(), this.clientId = await this.relayer.core.crypto.getClientId());
    }, this.subscribe = async (s, n) => {
      await this.restartToComplete(), this.isInitialized(), this.logger.debug("Subscribing Topic"), this.logger.trace({ type: "method", method: "subscribe", params: { topic: s, opts: n } });
      try {
        const i = co(n), o = { topic: s, relay: i };
        this.pending.set(s, o);
        const a = await this.rpcSubscribe(s, i);
        return this.onSubscribe(a, o), this.logger.debug("Successfully Subscribed Topic"), this.logger.trace({ type: "method", method: "subscribe", params: { topic: s, opts: n } }), a;
      } catch (i) {
        throw this.logger.debug("Failed to Subscribe Topic"), this.logger.error(i), i;
      }
    }, this.unsubscribe = async (s, n) => {
      await this.restartToComplete(), this.isInitialized(), typeof (n == null ? void 0 : n.id) < "u" ? await this.unsubscribeById(s, n.id, n) : await this.unsubscribeByTopic(s, n);
    }, this.isSubscribed = async (s) => {
      if (this.topics.includes(s))
        return !0;
      const n = `${this.pendingSubscriptionWatchLabel}_${s}`;
      return await new Promise((i, o) => {
        const a = new oe.Watch();
        a.start(n);
        const u = setInterval(() => {
          !this.pending.has(s) && this.topics.includes(s) && (clearInterval(u), a.stop(n), i(!0)), a.elapsed(n) >= v0 && (clearInterval(u), a.stop(n), o(new Error("Subscription resolution timeout")));
        }, this.pollingInterval);
      }).catch(() => !1);
    }, this.on = (s, n) => {
      this.events.on(s, n);
    }, this.once = (s, n) => {
      this.events.once(s, n);
    }, this.off = (s, n) => {
      this.events.off(s, n);
    }, this.removeListener = (s, n) => {
      this.events.removeListener(s, n);
    }, this.restart = async () => {
      this.restartInProgress = !0, await this.restore(), await this.reset(), this.restartInProgress = !1;
    }, this.relayer = e, this.logger = Fe.generateChildLogger(r, this.name), this.clientId = "";
  }
  get context() {
    return Fe.getLoggerContext(this.logger);
  }
  get storageKey() {
    return this.storagePrefix + this.version + this.relayer.core.customStoragePrefix + "//" + this.name;
  }
  get length() {
    return this.subscriptions.size;
  }
  get ids() {
    return Array.from(this.subscriptions.keys());
  }
  get values() {
    return Array.from(this.subscriptions.values());
  }
  get topics() {
    return this.topicMap.topics;
  }
  hasSubscription(e, r) {
    let s = !1;
    try {
      s = this.getSubscription(e).topic === r;
    } catch {
    }
    return s;
  }
  onEnable() {
    this.cached = [], this.initialized = !0;
  }
  onDisable() {
    this.cached = this.values, this.subscriptions.clear(), this.topicMap.clear();
  }
  async unsubscribeByTopic(e, r) {
    const s = this.topicMap.get(e);
    await Promise.all(s.map(async (n) => await this.unsubscribeById(e, n, r)));
  }
  async unsubscribeById(e, r, s) {
    this.logger.debug("Unsubscribing Topic"), this.logger.trace({ type: "method", method: "unsubscribe", params: { topic: e, id: r, opts: s } });
    try {
      const n = co(s);
      await this.rpcUnsubscribe(e, r, n);
      const i = Et("USER_DISCONNECTED", `${this.name}, ${e}`);
      await this.onUnsubscribe(e, r, i), this.logger.debug("Successfully Unsubscribed Topic"), this.logger.trace({ type: "method", method: "unsubscribe", params: { topic: e, id: r, opts: s } });
    } catch (n) {
      throw this.logger.debug("Failed to Unsubscribe Topic"), this.logger.error(n), n;
    }
  }
  async rpcSubscribe(e, r) {
    const s = { method: ji(r.protocol).subscribe, params: { topic: e } };
    this.logger.debug("Outgoing Relay Payload"), this.logger.trace({ type: "payload", direction: "outgoing", request: s });
    try {
      await await jn(this.relayer.request(s), this.subscribeTimeout);
    } catch {
      this.logger.debug("Outgoing Relay Subscribe Payload stalled"), this.relayer.events.emit(Zt.connection_stalled);
    }
    return Qs(e + this.clientId);
  }
  async rpcBatchSubscribe(e) {
    if (!e.length)
      return;
    const r = e[0].relay, s = { method: ji(r.protocol).batchSubscribe, params: { topics: e.map((n) => n.topic) } };
    this.logger.debug("Outgoing Relay Payload"), this.logger.trace({ type: "payload", direction: "outgoing", request: s });
    try {
      return await await jn(this.relayer.request(s), this.subscribeTimeout);
    } catch {
      this.logger.debug("Outgoing Relay Payload stalled"), this.relayer.events.emit(Zt.connection_stalled);
    }
  }
  rpcUnsubscribe(e, r, s) {
    const n = { method: ji(s.protocol).unsubscribe, params: { topic: e, id: r } };
    return this.logger.debug("Outgoing Relay Payload"), this.logger.trace({ type: "payload", direction: "outgoing", request: n }), this.relayer.request(n);
  }
  onSubscribe(e, r) {
    this.setSubscription(e, za(Sn({}, r), { id: e })), this.pending.delete(r.topic);
  }
  onBatchSubscribe(e) {
    e.length && e.forEach((r) => {
      this.setSubscription(r.id, Sn({}, r)), this.pending.delete(r.topic);
    });
  }
  async onUnsubscribe(e, r, s) {
    this.events.removeAllListeners(r), this.hasSubscription(r, e) && this.deleteSubscription(r, s), await this.relayer.messages.del(e);
  }
  async setRelayerSubscriptions(e) {
    await this.relayer.core.storage.setItem(this.storageKey, e);
  }
  async getRelayerSubscriptions() {
    return await this.relayer.core.storage.getItem(this.storageKey);
  }
  setSubscription(e, r) {
    this.subscriptions.has(e) || (this.logger.debug("Setting subscription"), this.logger.trace({ type: "method", method: "setSubscription", id: e, subscription: r }), this.addSubscription(e, r));
  }
  addSubscription(e, r) {
    this.subscriptions.set(e, Sn({}, r)), this.topicMap.set(r.topic, e), this.events.emit(mr.created, r);
  }
  getSubscription(e) {
    this.logger.debug("Getting subscription"), this.logger.trace({ type: "method", method: "getSubscription", id: e });
    const r = this.subscriptions.get(e);
    if (!r) {
      const { message: s } = Y("NO_MATCHING_KEY", `${this.name}: ${e}`);
      throw new Error(s);
    }
    return r;
  }
  deleteSubscription(e, r) {
    this.logger.debug("Deleting subscription"), this.logger.trace({ type: "method", method: "deleteSubscription", id: e, reason: r });
    const s = this.getSubscription(e);
    this.subscriptions.delete(e), this.topicMap.delete(s.topic, e), this.events.emit(mr.deleted, za(Sn({}, s), { reason: r }));
  }
  async persist() {
    await this.setRelayerSubscriptions(this.values), this.events.emit(mr.sync);
  }
  async reset() {
    if (this.cached.length) {
      const e = Math.ceil(this.cached.length / this.batchSubscribeTopicsLimit);
      for (let r = 0; r < e; r++) {
        const s = this.cached.splice(0, this.batchSubscribeTopicsLimit);
        await this.batchSubscribe(s);
      }
    }
    this.events.emit(mr.resubscribed);
  }
  async restore() {
    try {
      const e = await this.getRelayerSubscriptions();
      if (typeof e > "u" || !e.length)
        return;
      if (this.subscriptions.size) {
        const { message: r } = Y("RESTORE_WILL_OVERRIDE", this.name);
        throw this.logger.error(r), this.logger.error(`${this.name}: ${JSON.stringify(this.values)}`), new Error(r);
      }
      this.cached = e, this.logger.debug(`Successfully Restored subscriptions for ${this.name}`), this.logger.trace({ type: "method", method: "restore", subscriptions: this.values });
    } catch (e) {
      this.logger.debug(`Failed to Restore subscriptions for ${this.name}`), this.logger.error(e);
    }
  }
  async batchSubscribe(e) {
    if (!e.length)
      return;
    const r = await this.rpcBatchSubscribe(e);
    hi(r) && this.onBatchSubscribe(r.map((s, n) => za(Sn({}, e[n]), { id: s })));
  }
  async onConnect() {
    this.restartInProgress || (await this.restart(), this.onEnable());
  }
  onDisconnect() {
    this.onDisable();
  }
  async checkPending() {
    if (!this.initialized || this.relayer.transportExplicitlyClosed)
      return;
    const e = [];
    this.pending.forEach((r) => {
      e.push(r);
    }), await this.batchSubscribe(e);
  }
  registerEventListeners() {
    this.relayer.core.heartbeat.on(un.HEARTBEAT_EVENTS.pulse, async () => {
      await this.checkPending();
    }), this.relayer.on(Zt.connect, async () => {
      await this.onConnect();
    }), this.relayer.on(Zt.disconnect, () => {
      this.onDisconnect();
    }), this.events.on(mr.created, async (e) => {
      const r = mr.created;
      this.logger.info(`Emitting ${r}`), this.logger.debug({ type: "event", event: r, data: e }), await this.persist();
    }), this.events.on(mr.deleted, async (e) => {
      const r = mr.deleted;
      this.logger.info(`Emitting ${r}`), this.logger.debug({ type: "event", event: r, data: e }), await this.persist();
    });
  }
  isInitialized() {
    if (!this.initialized) {
      const { message: e } = Y("NOT_INITIALIZED", this.name);
      throw new Error(e);
    }
  }
  async restartToComplete() {
    this.restartInProgress && await new Promise((e) => {
      const r = setInterval(() => {
        this.restartInProgress || (clearInterval(r), e());
      }, this.pollingInterval);
    });
  }
}
var z0 = Object.defineProperty, Ku = Object.getOwnPropertySymbols, $0 = Object.prototype.hasOwnProperty, V0 = Object.prototype.propertyIsEnumerable, Hu = (t, e, r) => e in t ? z0(t, e, { enumerable: !0, configurable: !0, writable: !0, value: r }) : t[e] = r, q0 = (t, e) => {
  for (var r in e || (e = {}))
    $0.call(e, r) && Hu(t, r, e[r]);
  if (Ku)
    for (var r of Ku(e))
      V0.call(e, r) && Hu(t, r, e[r]);
  return t;
};
class Z0 extends Yf {
  constructor(e) {
    super(e), this.protocol = "wc", this.version = 2, this.events = new Pr.EventEmitter(), this.name = u0, this.transportExplicitlyClosed = !1, this.initialized = !1, this.connectionAttemptInProgress = !1, this.connectionStatusPollingInterval = 20, this.staleConnectionErrors = ["socket hang up", "socket stalled"], this.hasExperiencedNetworkDisruption = !1, this.requestsInFlight = /* @__PURE__ */ new Map(), this.request = async (r) => {
      this.logger.debug("Publishing Request Payload");
      const s = r.id, n = this.provider.request(r);
      this.requestsInFlight.set(s, { promise: n, request: r });
      try {
        return await this.toEstablishConnection(), await n;
      } catch (i) {
        throw this.logger.debug("Failed to Publish Request"), this.logger.error(i), i;
      } finally {
        this.requestsInFlight.delete(s);
      }
    }, this.onPayloadHandler = (r) => {
      this.onProviderPayload(r);
    }, this.onConnectHandler = () => {
      this.events.emit(Zt.connect);
    }, this.onDisconnectHandler = () => {
      this.onProviderDisconnect();
    }, this.onProviderErrorHandler = (r) => {
      this.logger.error(r), this.events.emit(Zt.error, r), this.logger.info("Fatal socket error received, closing transport"), this.transportClose();
    }, this.registerProviderListeners = () => {
      this.provider.on(Wr.payload, this.onPayloadHandler), this.provider.on(Wr.connect, this.onConnectHandler), this.provider.on(Wr.disconnect, this.onDisconnectHandler), this.provider.on(Wr.error, this.onProviderErrorHandler);
    }, this.core = e.core, this.logger = typeof e.logger < "u" && typeof e.logger != "string" ? Fe.generateChildLogger(e.logger, this.name) : Fe.pino(Fe.getDefaultLoggerOptions({ level: e.logger || c0 })), this.messages = new N0(this.logger, e.core), this.subscriber = new U0(this, this.logger), this.publisher = new k0(this, this.logger), this.relayUrl = (e == null ? void 0 : e.relayUrl) || zd, this.projectId = e.projectId, this.bundleId = Gy(), this.provider = {};
  }
  async init() {
    this.logger.trace("Initialized"), this.registerEventListeners(), await this.createProvider(), await Promise.all([this.messages.init(), this.subscriber.init()]);
    try {
      await this.transportOpen();
    } catch {
      this.logger.warn(`Connection via ${this.relayUrl} failed, attempting to connect via failover domain ${Zu}...`), await this.restartTransport(Zu);
    }
    this.initialized = !0, setTimeout(async () => {
      this.subscriber.topics.length === 0 && (this.logger.info("No topics subscribed to after init, closing transport"), await this.transportClose(), this.transportExplicitlyClosed = !1);
    }, p0);
  }
  get context() {
    return Fe.getLoggerContext(this.logger);
  }
  get connected() {
    return this.provider.connection.connected;
  }
  get connecting() {
    return this.provider.connection.connecting;
  }
  async publish(e, r, s) {
    this.isInitialized(), await this.publisher.publish(e, r, s), await this.recordMessageEvent({ topic: e, message: r, publishedAt: Date.now() });
  }
  async subscribe(e, r) {
    var s;
    this.isInitialized();
    let n = ((s = this.subscriber.topicMap.get(e)) == null ? void 0 : s[0]) || "";
    if (n)
      return n;
    let i;
    const o = (a) => {
      a.topic === e && (this.subscriber.off(mr.created, o), i());
    };
    return await Promise.all([new Promise((a) => {
      i = a, this.subscriber.on(mr.created, o);
    }), new Promise(async (a) => {
      n = await this.subscriber.subscribe(e, r), a();
    })]), n;
  }
  async unsubscribe(e, r) {
    this.isInitialized(), await this.subscriber.unsubscribe(e, r);
  }
  on(e, r) {
    this.events.on(e, r);
  }
  once(e, r) {
    this.events.once(e, r);
  }
  off(e, r) {
    this.events.off(e, r);
  }
  removeListener(e, r) {
    this.events.removeListener(e, r);
  }
  async transportClose() {
    this.requestsInFlight.size > 0 && (this.logger.debug("Waiting for all in-flight requests to finish before closing transport..."), this.requestsInFlight.forEach(async (e) => {
      await e.promise;
    })), this.transportExplicitlyClosed = !0, this.hasExperiencedNetworkDisruption && this.connected ? await jn(this.provider.disconnect(), 1e3, "provider.disconnect()").catch(() => this.onProviderDisconnect()) : this.connected && await this.provider.disconnect();
  }
  async transportOpen(e) {
    if (this.transportExplicitlyClosed = !1, await this.confirmOnlineStateOrThrow(), !this.connectionAttemptInProgress) {
      e && e !== this.relayUrl && (this.relayUrl = e, await this.transportClose(), await this.createProvider()), this.connectionAttemptInProgress = !0;
      try {
        await Promise.all([new Promise((r) => {
          if (!this.initialized)
            return r();
          this.subscriber.once(mr.resubscribed, () => {
            r();
          });
        }), new Promise(async (r, s) => {
          try {
            await jn(this.provider.connect(), 1e4, `Socket stalled when trying to connect to ${this.relayUrl}`);
          } catch (n) {
            s(n);
            return;
          }
          r();
        })]);
      } catch (r) {
        this.logger.error(r);
        const s = r;
        if (!this.isConnectionStalled(s.message))
          throw r;
        this.provider.events.emit(Wr.disconnect);
      } finally {
        this.connectionAttemptInProgress = !1, this.hasExperiencedNetworkDisruption = !1;
      }
    }
  }
  async restartTransport(e) {
    await this.confirmOnlineStateOrThrow(), !this.connectionAttemptInProgress && (this.relayUrl = e || this.relayUrl, await this.transportClose(), await this.createProvider(), await this.transportOpen());
  }
  async confirmOnlineStateOrThrow() {
    if (!await Pu())
      throw new Error("No internet connection detected. Please restart your network and try again.");
  }
  isConnectionStalled(e) {
    return this.staleConnectionErrors.some((r) => e.includes(r));
  }
  async createProvider() {
    this.provider.connection && this.unregisterProviderListeners();
    const e = await this.core.crypto.signJWT(this.relayUrl);
    this.provider = new m_(new b_(tv({ sdkVersion: h0, protocol: this.protocol, version: this.version, relayUrl: this.relayUrl, projectId: this.projectId, auth: e, useOnCloseEvent: !0, bundleId: this.bundleId }))), this.registerProviderListeners();
  }
  async recordMessageEvent(e) {
    const { topic: r, message: s } = e;
    await this.messages.set(r, s);
  }
  async shouldIgnoreMessageEvent(e) {
    const { topic: r, message: s } = e;
    if (!s || s.length === 0)
      return this.logger.debug(`Ignoring invalid/empty message: ${s}`), !0;
    if (!await this.subscriber.isSubscribed(r))
      return this.logger.debug(`Ignoring message for non-subscribed topic ${r}`), !0;
    const n = this.messages.has(r, s);
    return n && this.logger.debug(`Ignoring duplicate message: ${s}`), n;
  }
  async onProviderPayload(e) {
    if (this.logger.debug("Incoming Relay Payload"), this.logger.trace({ type: "payload", direction: "incoming", payload: e }), Qo(e)) {
      if (!e.method.endsWith(l0))
        return;
      const r = e.params, { topic: s, message: n, publishedAt: i } = r.data, o = { topic: s, message: n, publishedAt: i };
      this.logger.debug("Emitting Relayer Payload"), this.logger.trace(q0({ type: "event", event: r.id }, o)), this.events.emit(r.id, o), await this.acknowledgePayload(e), await this.onMessageEvent(o);
    } else
      wa(e) && this.events.emit(Zt.message_ack, e);
  }
  async onMessageEvent(e) {
    await this.shouldIgnoreMessageEvent(e) || (this.events.emit(Zt.message, e), await this.recordMessageEvent(e));
  }
  async acknowledgePayload(e) {
    const r = Jo(e.id, !0);
    await this.provider.connection.send(r);
  }
  unregisterProviderListeners() {
    this.provider.off(Wr.payload, this.onPayloadHandler), this.provider.off(Wr.connect, this.onConnectHandler), this.provider.off(Wr.disconnect, this.onDisconnectHandler), this.provider.off(Wr.error, this.onProviderErrorHandler);
  }
  async registerEventListeners() {
    this.events.on(Zt.connection_stalled, () => {
      this.restartTransport().catch((r) => this.logger.error(r));
    });
    let e = await Pu();
    Gv(async (r) => {
      this.initialized && e !== r && (e = r, r ? await this.restartTransport().catch((s) => this.logger.error(s)) : (this.hasExperiencedNetworkDisruption = !0, await this.transportClose().catch((s) => this.logger.error(s))));
    });
  }
  onProviderDisconnect() {
    this.events.emit(Zt.disconnect), this.attemptToReconnect();
  }
  attemptToReconnect() {
    this.transportExplicitlyClosed || (this.logger.info("attemptToReconnect called. Connecting..."), setTimeout(async () => {
      await this.restartTransport().catch((e) => this.logger.error(e));
    }, oe.toMiliseconds(d0)));
  }
  isInitialized() {
    if (!this.initialized) {
      const { message: e } = Y("NOT_INITIALIZED", this.name);
      throw new Error(e);
    }
  }
  async toEstablishConnection() {
    if (await this.confirmOnlineStateOrThrow(), !this.connected) {
      if (this.connectionAttemptInProgress)
        return await new Promise((e) => {
          const r = setInterval(() => {
            this.connected && (clearInterval(r), e());
          }, this.connectionStatusPollingInterval);
        });
      await this.restartTransport();
    }
  }
}
var F0 = Object.defineProperty, Bu = Object.getOwnPropertySymbols, W0 = Object.prototype.hasOwnProperty, K0 = Object.prototype.propertyIsEnumerable, Gu = (t, e, r) => e in t ? F0(t, e, { enumerable: !0, configurable: !0, writable: !0, value: r }) : t[e] = r, Yu = (t, e) => {
  for (var r in e || (e = {}))
    W0.call(e, r) && Gu(t, r, e[r]);
  if (Bu)
    for (var r of Bu(e))
      K0.call(e, r) && Gu(t, r, e[r]);
  return t;
};
class Sa extends Jf {
  constructor(e, r, s, n = ls, i = void 0) {
    super(e, r, s, n), this.core = e, this.logger = r, this.name = s, this.map = /* @__PURE__ */ new Map(), this.version = f0, this.cached = [], this.initialized = !1, this.storagePrefix = ls, this.init = async () => {
      this.initialized || (this.logger.trace("Initialized"), await this.restore(), this.cached.forEach((o) => {
        this.getKey && o !== null && !Gt(o) ? this.map.set(this.getKey(o), o) : Ov(o) ? this.map.set(o.id, o) : Tv(o) && this.map.set(o.topic, o);
      }), this.cached = [], this.initialized = !0);
    }, this.set = async (o, a) => {
      this.isInitialized(), this.map.has(o) ? await this.update(o, a) : (this.logger.debug("Setting value"), this.logger.trace({ type: "method", method: "set", key: o, value: a }), this.map.set(o, a), await this.persist());
    }, this.get = (o) => (this.isInitialized(), this.logger.debug("Getting value"), this.logger.trace({ type: "method", method: "get", key: o }), this.getData(o)), this.getAll = (o) => (this.isInitialized(), o ? this.values.filter((a) => Object.keys(o).every((u) => E_(a[u], o[u]))) : this.values), this.update = async (o, a) => {
      this.isInitialized(), this.logger.debug("Updating value"), this.logger.trace({ type: "method", method: "update", key: o, update: a });
      const u = Yu(Yu({}, this.getData(o)), a);
      this.map.set(o, u), await this.persist();
    }, this.delete = async (o, a) => {
      this.isInitialized(), this.map.has(o) && (this.logger.debug("Deleting value"), this.logger.trace({ type: "method", method: "delete", key: o, reason: a }), this.map.delete(o), await this.persist());
    }, this.logger = Fe.generateChildLogger(r, this.name), this.storagePrefix = n, this.getKey = i;
  }
  get context() {
    return Fe.getLoggerContext(this.logger);
  }
  get storageKey() {
    return this.storagePrefix + this.version + this.core.customStoragePrefix + "//" + this.name;
  }
  get length() {
    return this.map.size;
  }
  get keys() {
    return Array.from(this.map.keys());
  }
  get values() {
    return Array.from(this.map.values());
  }
  async setDataStore(e) {
    await this.core.storage.setItem(this.storageKey, e);
  }
  async getDataStore() {
    return await this.core.storage.getItem(this.storageKey);
  }
  getData(e) {
    const r = this.map.get(e);
    if (!r) {
      const { message: s } = Y("NO_MATCHING_KEY", `${this.name}: ${e}`);
      throw this.logger.error(s), new Error(s);
    }
    return r;
  }
  async persist() {
    await this.setDataStore(this.values);
  }
  async restore() {
    try {
      const e = await this.getDataStore();
      if (typeof e > "u" || !e.length)
        return;
      if (this.map.size) {
        const { message: r } = Y("RESTORE_WILL_OVERRIDE", this.name);
        throw this.logger.error(r), new Error(r);
      }
      this.cached = e, this.logger.debug(`Successfully Restored value for ${this.name}`), this.logger.trace({ type: "method", method: "restore", value: this.values });
    } catch (e) {
      this.logger.debug(`Failed to Restore value for ${this.name}`), this.logger.error(e);
    }
  }
  isInitialized() {
    if (!this.initialized) {
      const { message: e } = Y("NOT_INITIALIZED", this.name);
      throw new Error(e);
    }
  }
}
class H0 {
  constructor(e, r) {
    this.core = e, this.logger = r, this.name = _0, this.version = b0, this.events = new Mo(), this.initialized = !1, this.storagePrefix = ls, this.ignoredPayloadTypes = [$s], this.registeredMethods = [], this.init = async () => {
      this.initialized || (await this.pairings.init(), await this.cleanup(), this.registerRelayerEvents(), this.registerExpirerEvents(), this.initialized = !0, this.logger.trace("Initialized"));
    }, this.register = ({ methods: s }) => {
      this.isInitialized(), this.registeredMethods = [.../* @__PURE__ */ new Set([...this.registeredMethods, ...s])];
    }, this.create = async () => {
      this.isInitialized();
      const s = oo(), n = await this.core.crypto.setSymKey(s), i = ir(oe.FIVE_MINUTES), o = { protocol: Ud }, a = { topic: n, expiry: i, relay: o, active: !1 }, u = yv({ protocol: this.core.protocol, version: this.core.version, topic: n, symKey: s, relay: o, expiryTimestamp: i });
      return await this.pairings.set(n, a), await this.core.relayer.subscribe(n), this.core.expirer.set(n, i), { topic: n, uri: u };
    }, this.pair = async (s) => {
      this.isInitialized(), this.isValidPair(s);
      const { topic: n, symKey: i, relay: o, expiryTimestamp: a } = Su(s.uri);
      let u;
      if (this.pairings.keys.includes(n) && (u = this.pairings.get(n), u.active))
        throw new Error(`Pairing already exists: ${n}. Please try again with a new connection URI.`);
      const c = a || ir(oe.FIVE_MINUTES), h = { topic: n, relay: o, expiry: c, active: !1 };
      return await this.pairings.set(n, h), this.core.expirer.set(n, c), s.activatePairing && await this.activate({ topic: n }), this.events.emit(Tn.create, h), this.core.crypto.keychain.has(n) || (await this.core.crypto.setSymKey(i, n), await this.core.relayer.subscribe(n, { relay: o })), h;
    }, this.activate = async ({ topic: s }) => {
      this.isInitialized();
      const n = ir(oe.THIRTY_DAYS);
      await this.pairings.update(s, { active: !0, expiry: n }), this.core.expirer.set(s, n);
    }, this.ping = async (s) => {
      this.isInitialized(), await this.isValidPing(s);
      const { topic: n } = s;
      if (this.pairings.keys.includes(n)) {
        const i = await this.sendRequest(n, "wc_pairingPing", {}), { done: o, resolve: a, reject: u } = Hs();
        this.events.once(wt("pairing_ping", i), ({ error: c }) => {
          c ? u(c) : a();
        }), await o();
      }
    }, this.updateExpiry = async ({ topic: s, expiry: n }) => {
      this.isInitialized(), await this.pairings.update(s, { expiry: n });
    }, this.updateMetadata = async ({ topic: s, metadata: n }) => {
      this.isInitialized(), await this.pairings.update(s, { peerMetadata: n });
    }, this.getPairings = () => (this.isInitialized(), this.pairings.values), this.disconnect = async (s) => {
      this.isInitialized(), await this.isValidDisconnect(s);
      const { topic: n } = s;
      this.pairings.keys.includes(n) && (await this.sendRequest(n, "wc_pairingDelete", Et("USER_DISCONNECTED")), await this.deletePairing(n));
    }, this.sendRequest = async (s, n, i) => {
      const o = en(n, i), a = await this.core.crypto.encode(s, o), u = En[n].req;
      return this.core.history.set(s, o), this.core.relayer.publish(s, a, u), o.id;
    }, this.sendResult = async (s, n, i) => {
      const o = Jo(s, i), a = await this.core.crypto.encode(n, o), u = await this.core.history.get(n, s), c = En[u.request.method].res;
      await this.core.relayer.publish(n, a, c), await this.core.history.resolve(o);
    }, this.sendError = async (s, n, i) => {
      const o = Xo(s, i), a = await this.core.crypto.encode(n, o), u = await this.core.history.get(n, s), c = En[u.request.method] ? En[u.request.method].res : En.unregistered_method.res;
      await this.core.relayer.publish(n, a, c), await this.core.history.resolve(o);
    }, this.deletePairing = async (s, n) => {
      await this.core.relayer.unsubscribe(s), await Promise.all([this.pairings.delete(s, Et("USER_DISCONNECTED")), this.core.crypto.deleteSymKey(s), n ? Promise.resolve() : this.core.expirer.del(s)]);
    }, this.cleanup = async () => {
      const s = this.pairings.getAll().filter((n) => is(n.expiry));
      await Promise.all(s.map((n) => this.deletePairing(n.topic)));
    }, this.onRelayEventRequest = (s) => {
      const { topic: n, payload: i } = s;
      switch (i.method) {
        case "wc_pairingPing":
          return this.onPairingPingRequest(n, i);
        case "wc_pairingDelete":
          return this.onPairingDeleteRequest(n, i);
        default:
          return this.onUnknownRpcMethodRequest(n, i);
      }
    }, this.onRelayEventResponse = async (s) => {
      const { topic: n, payload: i } = s, o = (await this.core.history.get(n, i.id)).request.method;
      switch (o) {
        case "wc_pairingPing":
          return this.onPairingPingResponse(n, i);
        default:
          return this.onUnknownRpcMethodResponse(o);
      }
    }, this.onPairingPingRequest = async (s, n) => {
      const { id: i } = n;
      try {
        this.isValidPing({ topic: s }), await this.sendResult(i, s, !0), this.events.emit(Tn.ping, { id: i, topic: s });
      } catch (o) {
        await this.sendError(i, s, o), this.logger.error(o);
      }
    }, this.onPairingPingResponse = (s, n) => {
      const { id: i } = n;
      setTimeout(() => {
        Br(n) ? this.events.emit(wt("pairing_ping", i), {}) : yr(n) && this.events.emit(wt("pairing_ping", i), { error: n.error });
      }, 500);
    }, this.onPairingDeleteRequest = async (s, n) => {
      const { id: i } = n;
      try {
        this.isValidDisconnect({ topic: s }), await this.deletePairing(s), this.events.emit(Tn.delete, { id: i, topic: s });
      } catch (o) {
        await this.sendError(i, s, o), this.logger.error(o);
      }
    }, this.onUnknownRpcMethodRequest = async (s, n) => {
      const { id: i, method: o } = n;
      try {
        if (this.registeredMethods.includes(o))
          return;
        const a = Et("WC_METHOD_UNSUPPORTED", o);
        await this.sendError(i, s, a), this.logger.error(a);
      } catch (a) {
        await this.sendError(i, s, a), this.logger.error(a);
      }
    }, this.onUnknownRpcMethodResponse = (s) => {
      this.registeredMethods.includes(s) || this.logger.error(Et("WC_METHOD_UNSUPPORTED", s));
    }, this.isValidPair = (s) => {
      var n;
      if (!tr(s)) {
        const { message: o } = Y("MISSING_OR_INVALID", `pair() params: ${s}`);
        throw new Error(o);
      }
      if (!xv(s.uri)) {
        const { message: o } = Y("MISSING_OR_INVALID", `pair() uri: ${s.uri}`);
        throw new Error(o);
      }
      const i = Su(s.uri);
      if (!((n = i == null ? void 0 : i.relay) != null && n.protocol)) {
        const { message: o } = Y("MISSING_OR_INVALID", "pair() uri#relay-protocol");
        throw new Error(o);
      }
      if (!(i != null && i.symKey)) {
        const { message: o } = Y("MISSING_OR_INVALID", "pair() uri#symKey");
        throw new Error(o);
      }
      if (i != null && i.expiryTimestamp && oe.toMiliseconds(i == null ? void 0 : i.expiryTimestamp) < Date.now()) {
        const { message: o } = Y("EXPIRED", "pair() URI has expired. Please try again with a new connection URI.");
        throw new Error(o);
      }
    }, this.isValidPing = async (s) => {
      if (!tr(s)) {
        const { message: i } = Y("MISSING_OR_INVALID", `ping() params: ${s}`);
        throw new Error(i);
      }
      const { topic: n } = s;
      await this.isValidPairingTopic(n);
    }, this.isValidDisconnect = async (s) => {
      if (!tr(s)) {
        const { message: i } = Y("MISSING_OR_INVALID", `disconnect() params: ${s}`);
        throw new Error(i);
      }
      const { topic: n } = s;
      await this.isValidPairingTopic(n);
    }, this.isValidPairingTopic = async (s) => {
      if (!kt(s, !1)) {
        const { message: n } = Y("MISSING_OR_INVALID", `pairing topic should be a string: ${s}`);
        throw new Error(n);
      }
      if (!this.pairings.keys.includes(s)) {
        const { message: n } = Y("NO_MATCHING_KEY", `pairing topic doesn't exist: ${s}`);
        throw new Error(n);
      }
      if (is(this.pairings.get(s).expiry)) {
        await this.deletePairing(s);
        const { message: n } = Y("EXPIRED", `pairing topic: ${s}`);
        throw new Error(n);
      }
    }, this.core = e, this.logger = Fe.generateChildLogger(r, this.name), this.pairings = new Sa(this.core, this.logger, this.name, this.storagePrefix);
  }
  get context() {
    return Fe.getLoggerContext(this.logger);
  }
  isInitialized() {
    if (!this.initialized) {
      const { message: e } = Y("NOT_INITIALIZED", this.name);
      throw new Error(e);
    }
  }
  registerRelayerEvents() {
    this.core.relayer.on(Zt.message, async (e) => {
      const { topic: r, message: s } = e;
      if (!this.pairings.keys.includes(r) || this.ignoredPayloadTypes.includes(this.core.crypto.getPayloadType(s)))
        return;
      const n = await this.core.crypto.decode(r, s);
      try {
        Qo(n) ? (this.core.history.set(r, n), this.onRelayEventRequest({ topic: r, payload: n })) : wa(n) && (await this.core.history.resolve(n), await this.onRelayEventResponse({ topic: r, payload: n }), this.core.history.delete(r, n.id));
      } catch (i) {
        this.logger.error(i);
      }
    });
  }
  registerExpirerEvents() {
    this.core.expirer.on(hr.expired, async (e) => {
      const { topic: r } = vd(e.target);
      r && this.pairings.keys.includes(r) && (await this.deletePairing(r, !0), this.events.emit(Tn.expire, { topic: r }));
    });
  }
}
class B0 extends Hf {
  constructor(e, r) {
    super(e, r), this.core = e, this.logger = r, this.records = /* @__PURE__ */ new Map(), this.events = new Pr.EventEmitter(), this.name = w0, this.version = E0, this.cached = [], this.initialized = !1, this.storagePrefix = ls, this.init = async () => {
      this.initialized || (this.logger.trace("Initialized"), await this.restore(), this.cached.forEach((s) => this.records.set(s.id, s)), this.cached = [], this.registerEventListeners(), this.initialized = !0);
    }, this.set = (s, n, i) => {
      if (this.isInitialized(), this.logger.debug("Setting JSON-RPC request history record"), this.logger.trace({ type: "method", method: "set", topic: s, request: n, chainId: i }), this.records.has(n.id))
        return;
      const o = { id: n.id, topic: s, request: { method: n.method, params: n.params || null }, chainId: i, expiry: ir(oe.THIRTY_DAYS) };
      this.records.set(o.id, o), this.events.emit(Mr.created, o);
    }, this.resolve = async (s) => {
      if (this.isInitialized(), this.logger.debug("Updating JSON-RPC response history record"), this.logger.trace({ type: "method", method: "update", response: s }), !this.records.has(s.id))
        return;
      const n = await this.getRecord(s.id);
      typeof n.response > "u" && (n.response = yr(s) ? { error: s.error } : { result: s.result }, this.records.set(n.id, n), this.events.emit(Mr.updated, n));
    }, this.get = async (s, n) => (this.isInitialized(), this.logger.debug("Getting record"), this.logger.trace({ type: "method", method: "get", topic: s, id: n }), await this.getRecord(n)), this.delete = (s, n) => {
      this.isInitialized(), this.logger.debug("Deleting record"), this.logger.trace({ type: "method", method: "delete", id: n }), this.values.forEach((i) => {
        if (i.topic === s) {
          if (typeof n < "u" && i.id !== n)
            return;
          this.records.delete(i.id), this.events.emit(Mr.deleted, i);
        }
      });
    }, this.exists = async (s, n) => (this.isInitialized(), this.records.has(n) ? (await this.getRecord(n)).topic === s : !1), this.on = (s, n) => {
      this.events.on(s, n);
    }, this.once = (s, n) => {
      this.events.once(s, n);
    }, this.off = (s, n) => {
      this.events.off(s, n);
    }, this.removeListener = (s, n) => {
      this.events.removeListener(s, n);
    }, this.logger = Fe.generateChildLogger(r, this.name);
  }
  get context() {
    return Fe.getLoggerContext(this.logger);
  }
  get storageKey() {
    return this.storagePrefix + this.version + this.core.customStoragePrefix + "//" + this.name;
  }
  get size() {
    return this.records.size;
  }
  get keys() {
    return Array.from(this.records.keys());
  }
  get values() {
    return Array.from(this.records.values());
  }
  get pending() {
    const e = [];
    return this.values.forEach((r) => {
      if (typeof r.response < "u")
        return;
      const s = { topic: r.topic, request: en(r.request.method, r.request.params, r.id), chainId: r.chainId };
      return e.push(s);
    }), e;
  }
  async setJsonRpcRecords(e) {
    await this.core.storage.setItem(this.storageKey, e);
  }
  async getJsonRpcRecords() {
    return await this.core.storage.getItem(this.storageKey);
  }
  getRecord(e) {
    this.isInitialized();
    const r = this.records.get(e);
    if (!r) {
      const { message: s } = Y("NO_MATCHING_KEY", `${this.name}: ${e}`);
      throw new Error(s);
    }
    return r;
  }
  async persist() {
    await this.setJsonRpcRecords(this.values), this.events.emit(Mr.sync);
  }
  async restore() {
    try {
      const e = await this.getJsonRpcRecords();
      if (typeof e > "u" || !e.length)
        return;
      if (this.records.size) {
        const { message: r } = Y("RESTORE_WILL_OVERRIDE", this.name);
        throw this.logger.error(r), new Error(r);
      }
      this.cached = e, this.logger.debug(`Successfully Restored records for ${this.name}`), this.logger.trace({ type: "method", method: "restore", records: this.values });
    } catch (e) {
      this.logger.debug(`Failed to Restore records for ${this.name}`), this.logger.error(e);
    }
  }
  registerEventListeners() {
    this.events.on(Mr.created, (e) => {
      const r = Mr.created;
      this.logger.info(`Emitting ${r}`), this.logger.debug({ type: "event", event: r, record: e }), this.persist();
    }), this.events.on(Mr.updated, (e) => {
      const r = Mr.updated;
      this.logger.info(`Emitting ${r}`), this.logger.debug({ type: "event", event: r, record: e }), this.persist();
    }), this.events.on(Mr.deleted, (e) => {
      const r = Mr.deleted;
      this.logger.info(`Emitting ${r}`), this.logger.debug({ type: "event", event: r, record: e }), this.persist();
    }), this.core.heartbeat.on(un.HEARTBEAT_EVENTS.pulse, () => {
      this.cleanup();
    });
  }
  cleanup() {
    try {
      this.records.forEach((e) => {
        oe.toMiliseconds(e.expiry || 0) - Date.now() <= 0 && (this.logger.info(`Deleting expired history log: ${e.id}`), this.delete(e.topic, e.id));
      });
    } catch (e) {
      this.logger.warn(e);
    }
  }
  isInitialized() {
    if (!this.initialized) {
      const { message: e } = Y("NOT_INITIALIZED", this.name);
      throw new Error(e);
    }
  }
}
class G0 extends Qf {
  constructor(e, r) {
    super(e, r), this.core = e, this.logger = r, this.expirations = /* @__PURE__ */ new Map(), this.events = new Pr.EventEmitter(), this.name = S0, this.version = I0, this.cached = [], this.initialized = !1, this.storagePrefix = ls, this.init = async () => {
      this.initialized || (this.logger.trace("Initialized"), await this.restore(), this.cached.forEach((s) => this.expirations.set(s.target, s)), this.cached = [], this.registerEventListeners(), this.initialized = !0);
    }, this.has = (s) => {
      try {
        const n = this.formatTarget(s);
        return typeof this.getExpiration(n) < "u";
      } catch {
        return !1;
      }
    }, this.set = (s, n) => {
      this.isInitialized();
      const i = this.formatTarget(s), o = { target: i, expiry: n };
      this.expirations.set(i, o), this.checkExpiry(i, o), this.events.emit(hr.created, { target: i, expiration: o });
    }, this.get = (s) => {
      this.isInitialized();
      const n = this.formatTarget(s);
      return this.getExpiration(n);
    }, this.del = (s) => {
      if (this.isInitialized(), this.has(s)) {
        const n = this.formatTarget(s), i = this.getExpiration(n);
        this.expirations.delete(n), this.events.emit(hr.deleted, { target: n, expiration: i });
      }
    }, this.on = (s, n) => {
      this.events.on(s, n);
    }, this.once = (s, n) => {
      this.events.once(s, n);
    }, this.off = (s, n) => {
      this.events.off(s, n);
    }, this.removeListener = (s, n) => {
      this.events.removeListener(s, n);
    }, this.logger = Fe.generateChildLogger(r, this.name);
  }
  get context() {
    return Fe.getLoggerContext(this.logger);
  }
  get storageKey() {
    return this.storagePrefix + this.version + this.core.customStoragePrefix + "//" + this.name;
  }
  get length() {
    return this.expirations.size;
  }
  get keys() {
    return Array.from(this.expirations.keys());
  }
  get values() {
    return Array.from(this.expirations.values());
  }
  formatTarget(e) {
    if (typeof e == "string")
      return rv(e);
    if (typeof e == "number")
      return sv(e);
    const { message: r } = Y("UNKNOWN_TYPE", `Target type: ${typeof e}`);
    throw new Error(r);
  }
  async setExpirations(e) {
    await this.core.storage.setItem(this.storageKey, e);
  }
  async getExpirations() {
    return await this.core.storage.getItem(this.storageKey);
  }
  async persist() {
    await this.setExpirations(this.values), this.events.emit(hr.sync);
  }
  async restore() {
    try {
      const e = await this.getExpirations();
      if (typeof e > "u" || !e.length)
        return;
      if (this.expirations.size) {
        const { message: r } = Y("RESTORE_WILL_OVERRIDE", this.name);
        throw this.logger.error(r), new Error(r);
      }
      this.cached = e, this.logger.debug(`Successfully Restored expirations for ${this.name}`), this.logger.trace({ type: "method", method: "restore", expirations: this.values });
    } catch (e) {
      this.logger.debug(`Failed to Restore expirations for ${this.name}`), this.logger.error(e);
    }
  }
  getExpiration(e) {
    const r = this.expirations.get(e);
    if (!r) {
      const { message: s } = Y("NO_MATCHING_KEY", `${this.name}: ${e}`);
      throw this.logger.error(s), new Error(s);
    }
    return r;
  }
  checkExpiry(e, r) {
    const { expiry: s } = r;
    oe.toMiliseconds(s) - Date.now() <= 0 && this.expire(e, r);
  }
  expire(e, r) {
    this.expirations.delete(e), this.events.emit(hr.expired, { target: e, expiration: r });
  }
  checkExpirations() {
    this.core.relayer.connected && this.expirations.forEach((e, r) => this.checkExpiry(r, e));
  }
  registerEventListeners() {
    this.core.heartbeat.on(un.HEARTBEAT_EVENTS.pulse, () => this.checkExpirations()), this.events.on(hr.created, (e) => {
      const r = hr.created;
      this.logger.info(`Emitting ${r}`), this.logger.debug({ type: "event", event: r, data: e }), this.persist();
    }), this.events.on(hr.expired, (e) => {
      const r = hr.expired;
      this.logger.info(`Emitting ${r}`), this.logger.debug({ type: "event", event: r, data: e }), this.persist();
    }), this.events.on(hr.deleted, (e) => {
      const r = hr.deleted;
      this.logger.info(`Emitting ${r}`), this.logger.debug({ type: "event", event: r, data: e }), this.persist();
    });
  }
  isInitialized() {
    if (!this.initialized) {
      const { message: e } = Y("NOT_INITIALIZED", this.name);
      throw new Error(e);
    }
  }
}
class Y0 extends eg {
  constructor(e, r) {
    super(e, r), this.projectId = e, this.logger = r, this.name = Ua, this.initialized = !1, this.queue = [], this.verifyDisabled = !1, this.init = async (s) => {
      if (this.verifyDisabled || hn() || !pn())
        return;
      const n = this.getVerifyUrl(s == null ? void 0 : s.verifyUrl);
      this.verifyUrl !== n && this.removeIframe(), this.verifyUrl = n;
      try {
        await this.createIframe();
      } catch (i) {
        this.logger.info(`Verify iframe failed to load: ${this.verifyUrl}`), this.logger.info(i);
      }
      if (!this.initialized) {
        this.removeIframe(), this.verifyUrl = ho;
        try {
          await this.createIframe();
        } catch (i) {
          this.logger.info(`Verify iframe failed to load: ${this.verifyUrl}`), this.logger.info(i), this.verifyDisabled = !0;
        }
      }
    }, this.register = async (s) => {
      this.initialized ? this.sendPost(s.attestationId) : (this.addToQueue(s.attestationId), await this.init());
    }, this.resolve = async (s) => {
      if (this.isDevEnv)
        return "";
      const n = this.getVerifyUrl(s == null ? void 0 : s.verifyUrl);
      let i;
      try {
        i = await this.fetchAttestation(s.attestationId, n);
      } catch (o) {
        this.logger.info(`failed to resolve attestation: ${s.attestationId} from url: ${n}`), this.logger.info(o), i = await this.fetchAttestation(s.attestationId, ho);
      }
      return i;
    }, this.fetchAttestation = async (s, n) => {
      this.logger.info(`resolving attestation: ${s} from url: ${n}`);
      const i = this.startAbortTimer(oe.ONE_SECOND * 2), o = await fetch(`${n}/attestation/${s}`, { signal: this.abortController.signal });
      return clearTimeout(i), o.status === 200 ? await o.json() : void 0;
    }, this.addToQueue = (s) => {
      this.queue.push(s);
    }, this.processQueue = () => {
      this.queue.length !== 0 && (this.queue.forEach((s) => this.sendPost(s)), this.queue = []);
    }, this.sendPost = (s) => {
      var n;
      try {
        if (!this.iframe)
          return;
        (n = this.iframe.contentWindow) == null || n.postMessage(s, "*"), this.logger.info(`postMessage sent: ${s} ${this.verifyUrl}`);
      } catch {
      }
    }, this.createIframe = async () => {
      let s;
      const n = (i) => {
        i.data === "verify_ready" && (this.initialized = !0, this.processQueue(), window.removeEventListener("message", n), s());
      };
      await Promise.race([new Promise((i) => {
        if (document.getElementById(Ua))
          return i();
        window.addEventListener("message", n);
        const o = document.createElement("iframe");
        o.id = Ua, o.src = `${this.verifyUrl}/${this.projectId}`, o.style.display = "none", document.body.append(o), this.iframe = o, s = i;
      }), new Promise((i, o) => setTimeout(() => {
        window.removeEventListener("message", n), o("verify iframe load timeout");
      }, oe.toMiliseconds(oe.FIVE_SECONDS)))]);
    }, this.removeIframe = () => {
      this.iframe && (this.iframe.remove(), this.iframe = void 0, this.initialized = !1);
    }, this.getVerifyUrl = (s) => {
      let n = s || Js;
      return x0.includes(n) || (this.logger.info(`verify url: ${n}, not included in trusted list, assigning default: ${Js}`), n = Js), n;
    }, this.logger = Fe.generateChildLogger(r, this.name), this.verifyUrl = Js, this.abortController = new AbortController(), this.isDevEnv = Ho() && process.env.IS_VITEST;
  }
  get context() {
    return Fe.getLoggerContext(this.logger);
  }
  startAbortTimer(e) {
    return this.abortController = new AbortController(), setTimeout(() => this.abortController.abort(), oe.toMiliseconds(e));
  }
}
class J0 extends tg {
  constructor(e, r) {
    super(e, r), this.projectId = e, this.logger = r, this.context = O0, this.registerDeviceToken = async (s) => {
      const { clientId: n, token: i, notificationType: o, enableEncrypted: a = !1 } = s, u = `${T0}/${this.projectId}/clients`;
      await O_(u, { method: "POST", headers: { "Content-Type": "application/json" }, body: JSON.stringify({ client_id: n, type: o, token: i, always_raw: a }) });
    }, this.logger = Fe.generateChildLogger(r, this.context);
  }
}
var X0 = Object.defineProperty, Ju = Object.getOwnPropertySymbols, Q0 = Object.prototype.hasOwnProperty, ew = Object.prototype.propertyIsEnumerable, Xu = (t, e, r) => e in t ? X0(t, e, { enumerable: !0, configurable: !0, writable: !0, value: r }) : t[e] = r, Qu = (t, e) => {
  for (var r in e || (e = {}))
    Q0.call(e, r) && Xu(t, r, e[r]);
  if (Ju)
    for (var r of Ju(e))
      ew.call(e, r) && Xu(t, r, e[r]);
  return t;
};
class tc extends Kf {
  constructor(e) {
    super(e), this.protocol = Dd, this.version = Jb, this.name = ec, this.events = new Pr.EventEmitter(), this.initialized = !1, this.on = (s, n) => this.events.on(s, n), this.once = (s, n) => this.events.once(s, n), this.off = (s, n) => this.events.off(s, n), this.removeListener = (s, n) => this.events.removeListener(s, n), this.projectId = e == null ? void 0 : e.projectId, this.relayUrl = (e == null ? void 0 : e.relayUrl) || zd, this.customStoragePrefix = e != null && e.customStoragePrefix ? `:${e.customStoragePrefix}` : "";
    const r = typeof (e == null ? void 0 : e.logger) < "u" && typeof (e == null ? void 0 : e.logger) != "string" ? e.logger : Fe.pino(Fe.getDefaultLoggerOptions({ level: (e == null ? void 0 : e.logger) || Xb.logger }));
    this.logger = Fe.generateChildLogger(r, this.name), this.heartbeat = new un.HeartBeat(), this.crypto = new C0(this, this.logger, e == null ? void 0 : e.keychain), this.history = new B0(this, this.logger), this.expirer = new G0(this, this.logger), this.storage = e != null && e.storage ? e.storage : new uf(Qu(Qu({}, Qb), e == null ? void 0 : e.storageOptions)), this.relayer = new Z0({ core: this, logger: this.logger, relayUrl: this.relayUrl, projectId: this.projectId }), this.pairing = new H0(this, this.logger), this.verify = new Y0(this.projectId || "", this.logger), this.echoClient = new J0(this.projectId || "", this.logger);
  }
  static async init(e) {
    const r = new tc(e);
    await r.initialize();
    const s = await r.crypto.getClientId();
    return await r.storage.setItem(g0, s), r;
  }
  get context() {
    return Fe.getLoggerContext(this.logger);
  }
  async start() {
    this.initialized || await this.initialize();
  }
  async initialize() {
    this.logger.trace("Initialized");
    try {
      await this.crypto.init(), await this.history.init(), await this.expirer.init(), await this.relayer.init(), await this.heartbeat.init(), await this.pairing.init(), this.initialized = !0, this.logger.info("Core Initialization Success");
    } catch (e) {
      throw this.logger.warn(`Core Initialization Failure at epoch ${Date.now()}`, e), this.logger.error(e.message), e;
    }
  }
}
const tw = tc, $d = "wc", Vd = 2, qd = "client", rc = `${$d}@${Vd}:${qd}:`, $a = { name: qd, logger: "error", controller: !1, relayUrl: "wss://relay.walletconnect.com" }, el = "WALLETCONNECT_DEEPLINK_CHOICE", rw = "proposal", sw = "Proposal expired", nw = "session", Ci = oe.SEVEN_DAYS, iw = "engine", Kr = { wc_sessionPropose: { req: { ttl: oe.FIVE_MINUTES, prompt: !0, tag: 1100 }, res: { ttl: oe.FIVE_MINUTES, prompt: !1, tag: 1101 } }, wc_sessionSettle: { req: { ttl: oe.FIVE_MINUTES, prompt: !1, tag: 1102 }, res: { ttl: oe.FIVE_MINUTES, prompt: !1, tag: 1103 } }, wc_sessionUpdate: { req: { ttl: oe.ONE_DAY, prompt: !1, tag: 1104 }, res: { ttl: oe.ONE_DAY, prompt: !1, tag: 1105 } }, wc_sessionExtend: { req: { ttl: oe.ONE_DAY, prompt: !1, tag: 1106 }, res: { ttl: oe.ONE_DAY, prompt: !1, tag: 1107 } }, wc_sessionRequest: { req: { ttl: oe.FIVE_MINUTES, prompt: !0, tag: 1108 }, res: { ttl: oe.FIVE_MINUTES, prompt: !1, tag: 1109 } }, wc_sessionEvent: { req: { ttl: oe.FIVE_MINUTES, prompt: !0, tag: 1110 }, res: { ttl: oe.FIVE_MINUTES, prompt: !1, tag: 1111 } }, wc_sessionDelete: { req: { ttl: oe.ONE_DAY, prompt: !1, tag: 1112 }, res: { ttl: oe.ONE_DAY, prompt: !1, tag: 1113 } }, wc_sessionPing: { req: { ttl: oe.THIRTY_SECONDS, prompt: !1, tag: 1114 }, res: { ttl: oe.THIRTY_SECONDS, prompt: !1, tag: 1115 } } }, Va = { min: oe.FIVE_MINUTES, max: oe.SEVEN_DAYS }, Hr = { idle: "IDLE", active: "ACTIVE" }, aw = "request", ow = ["wc_sessionPropose", "wc_sessionRequest", "wc_authRequest"];
var cw = Object.defineProperty, uw = Object.defineProperties, lw = Object.getOwnPropertyDescriptors, tl = Object.getOwnPropertySymbols, dw = Object.prototype.hasOwnProperty, hw = Object.prototype.propertyIsEnumerable, rl = (t, e, r) => e in t ? cw(t, e, { enumerable: !0, configurable: !0, writable: !0, value: r }) : t[e] = r, Ht = (t, e) => {
  for (var r in e || (e = {}))
    dw.call(e, r) && rl(t, r, e[r]);
  if (tl)
    for (var r of tl(e))
      hw.call(e, r) && rl(t, r, e[r]);
  return t;
}, Ks = (t, e) => uw(t, lw(e));
class pw extends sg {
  constructor(e) {
    super(e), this.name = iw, this.events = new Mo(), this.initialized = !1, this.ignoredPayloadTypes = [$s], this.requestQueue = { state: Hr.idle, queue: [] }, this.sessionRequestQueue = { state: Hr.idle, queue: [] }, this.requestQueueDelay = oe.ONE_SECOND, this.init = async () => {
      this.initialized || (await this.cleanup(), this.registerRelayerEvents(), this.registerExpirerEvents(), this.registerPairingEvents(), this.client.core.pairing.register({ methods: Object.keys(Kr) }), this.initialized = !0, setTimeout(() => {
        this.sessionRequestQueue.queue = this.getPendingSessionRequests(), this.processSessionRequestQueue();
      }, oe.toMiliseconds(this.requestQueueDelay)));
    }, this.connect = async (r) => {
      await this.isInitialized();
      const s = Ks(Ht({}, r), { requiredNamespaces: r.requiredNamespaces || {}, optionalNamespaces: r.optionalNamespaces || {} });
      await this.isValidConnect(s);
      const { pairingTopic: n, requiredNamespaces: i, optionalNamespaces: o, sessionProperties: a, relays: u } = s;
      let c = n, h, p = !1;
      if (c && (p = this.client.core.pairing.pairings.get(c).active), !c || !p) {
        const { topic: E, uri: I } = await this.client.core.pairing.create();
        c = E, h = I;
      }
      const g = await this.client.core.crypto.generateKeyPair(), v = Kr.wc_sessionPropose.req.ttl || oe.FIVE_MINUTES, b = ir(v), S = Ht({ requiredNamespaces: i, optionalNamespaces: o, relays: u ?? [{ protocol: Ud }], proposer: { publicKey: g, metadata: this.client.metadata }, expiryTimestamp: b }, a && { sessionProperties: a }), { reject: C, resolve: M, done: _ } = Hs(v, sw);
      if (this.events.once(wt("session_connect"), async ({ error: E, session: I }) => {
        if (E)
          C(E);
        else if (I) {
          I.self.publicKey = g;
          const m = Ks(Ht({}, I), { requiredNamespaces: S.requiredNamespaces, optionalNamespaces: S.optionalNamespaces });
          await this.client.session.set(I.topic, m), await this.setExpiry(I.topic, I.expiry), c && await this.client.core.pairing.updateMetadata({ topic: c, metadata: I.peer.metadata }), M(m);
        }
      }), !c) {
        const { message: E } = Y("NO_MATCHING_KEY", `connect() pairing topic: ${c}`);
        throw new Error(E);
      }
      const T = await this.sendRequest({ topic: c, method: "wc_sessionPropose", params: S, throwOnFailedPublish: !0 });
      return await this.setProposal(T, Ht({ id: T }, S)), { uri: h, approval: _ };
    }, this.pair = async (r) => (await this.isInitialized(), await this.client.core.pairing.pair(r)), this.approve = async (r) => {
      await this.isInitialized(), await this.isValidApprove(r);
      const { id: s, relayProtocol: n, namespaces: i, sessionProperties: o } = r, a = this.client.proposal.get(s);
      let { pairingTopic: u, proposer: c, requiredNamespaces: h, optionalNamespaces: p } = a;
      u = u || "";
      const g = await this.client.core.crypto.generateKeyPair(), v = c.publicKey, b = await this.client.core.crypto.generateSharedKey(g, v);
      u && s && (await this.client.core.pairing.updateMetadata({ topic: u, metadata: c.metadata }), await this.sendResult({ id: s, topic: u, result: { relay: { protocol: n ?? "irn" }, responderPublicKey: g } }), await this.client.proposal.delete(s, Et("USER_DISCONNECTED")), await this.client.core.pairing.activate({ topic: u }));
      const S = Ht({ relay: { protocol: n ?? "irn" }, namespaces: i, pairingTopic: u, controller: { publicKey: g, metadata: this.client.metadata }, expiry: ir(Ci) }, o && { sessionProperties: o });
      await this.client.core.relayer.subscribe(b);
      const C = Ks(Ht({}, S), { topic: b, requiredNamespaces: h, optionalNamespaces: p, pairingTopic: u, acknowledged: !1, self: S.controller, peer: { publicKey: c.publicKey, metadata: c.metadata }, controller: g });
      await this.client.session.set(b, C);
      try {
        await this.sendRequest({ topic: b, method: "wc_sessionSettle", params: S, throwOnFailedPublish: !0 });
      } catch (M) {
        throw this.client.logger.error(M), this.client.session.delete(b, Et("USER_DISCONNECTED")), await this.client.core.relayer.unsubscribe(b), M;
      }
      return await this.setExpiry(b, ir(Ci)), { topic: b, acknowledged: () => new Promise((M) => setTimeout(() => M(this.client.session.get(b)), 500)) };
    }, this.reject = async (r) => {
      await this.isInitialized(), await this.isValidReject(r);
      const { id: s, reason: n } = r, { pairingTopic: i } = this.client.proposal.get(s);
      i && (await this.sendError(s, i, n), await this.client.proposal.delete(s, Et("USER_DISCONNECTED")));
    }, this.update = async (r) => {
      await this.isInitialized(), await this.isValidUpdate(r);
      const { topic: s, namespaces: n } = r, i = await this.sendRequest({ topic: s, method: "wc_sessionUpdate", params: { namespaces: n } }), { done: o, resolve: a, reject: u } = Hs();
      return this.events.once(wt("session_update", i), ({ error: c }) => {
        c ? u(c) : a();
      }), await this.client.session.update(s, { namespaces: n }), { acknowledged: o };
    }, this.extend = async (r) => {
      await this.isInitialized(), await this.isValidExtend(r);
      const { topic: s } = r, n = await this.sendRequest({ topic: s, method: "wc_sessionExtend", params: {} }), { done: i, resolve: o, reject: a } = Hs();
      return this.events.once(wt("session_extend", n), ({ error: u }) => {
        u ? a(u) : o();
      }), await this.setExpiry(s, ir(Ci)), { acknowledged: i };
    }, this.request = async (r) => {
      await this.isInitialized(), await this.isValidRequest(r);
      const { chainId: s, request: n, topic: i, expiry: o = Kr.wc_sessionRequest.req.ttl } = r, a = Yo(), { done: u, resolve: c, reject: h } = Hs(o, "Request expired. Please try again.");
      return this.events.once(wt("session_request", a), ({ error: p, result: g }) => {
        p ? h(p) : c(g);
      }), await Promise.all([new Promise(async (p) => {
        await this.sendRequest({ clientRpcId: a, topic: i, method: "wc_sessionRequest", params: { request: Ks(Ht({}, n), { expiryTimestamp: ir(o) }), chainId: s }, expiry: o, throwOnFailedPublish: !0 }).catch((g) => h(g)), this.client.events.emit("session_request_sent", { topic: i, request: n, chainId: s, id: a }), p();
      }), new Promise(async (p) => {
        const g = await iv(this.client.core.storage, el);
        nv({ id: a, topic: i, wcDeepLink: g }), p();
      }), u()]).then((p) => p[2]);
    }, this.respond = async (r) => {
      await this.isInitialized(), await this.isValidRespond(r);
      const { topic: s, response: n } = r, { id: i } = n;
      Br(n) ? await this.sendResult({ id: i, topic: s, result: n.result, throwOnFailedPublish: !0 }) : yr(n) && await this.sendError(i, s, n.error), this.cleanupAfterResponse(r);
    }, this.ping = async (r) => {
      await this.isInitialized(), await this.isValidPing(r);
      const { topic: s } = r;
      if (this.client.session.keys.includes(s)) {
        const n = await this.sendRequest({ topic: s, method: "wc_sessionPing", params: {} }), { done: i, resolve: o, reject: a } = Hs();
        this.events.once(wt("session_ping", n), ({ error: u }) => {
          u ? a(u) : o();
        }), await i();
      } else
        this.client.core.pairing.pairings.keys.includes(s) && await this.client.core.pairing.ping({ topic: s });
    }, this.emit = async (r) => {
      await this.isInitialized(), await this.isValidEmit(r);
      const { topic: s, event: n, chainId: i } = r;
      await this.sendRequest({ topic: s, method: "wc_sessionEvent", params: { event: n, chainId: i } });
    }, this.disconnect = async (r) => {
      await this.isInitialized(), await this.isValidDisconnect(r);
      const { topic: s } = r;
      if (this.client.session.keys.includes(s))
        await this.sendRequest({ topic: s, method: "wc_sessionDelete", params: Et("USER_DISCONNECTED"), throwOnFailedPublish: !0 }), await this.deleteSession({ topic: s, emitEvent: !1 });
      else if (this.client.core.pairing.pairings.keys.includes(s))
        await this.client.core.pairing.disconnect({ topic: s });
      else {
        const { message: n } = Y("MISMATCHED_TOPIC", `Session or pairing topic not found: ${s}`);
        throw new Error(n);
      }
    }, this.find = (r) => (this.isInitialized(), this.client.session.getAll().filter((s) => Sv(s, r))), this.getPendingSessionRequests = () => this.client.pendingRequest.getAll(), this.cleanupDuplicatePairings = async (r) => {
      if (r.pairingTopic)
        try {
          const s = this.client.core.pairing.pairings.get(r.pairingTopic), n = this.client.core.pairing.pairings.getAll().filter((i) => {
            var o, a;
            return ((o = i.peerMetadata) == null ? void 0 : o.url) && ((a = i.peerMetadata) == null ? void 0 : a.url) === r.peer.metadata.url && i.topic && i.topic !== s.topic;
          });
          if (n.length === 0)
            return;
          this.client.logger.info(`Cleaning up ${n.length} duplicate pairing(s)`), await Promise.all(n.map((i) => this.client.core.pairing.disconnect({ topic: i.topic }))), this.client.logger.info("Duplicate pairings clean up finished");
        } catch (s) {
          this.client.logger.error(s);
        }
    }, this.deleteSession = async (r) => {
      const { topic: s, expirerHasDeleted: n = !1, emitEvent: i = !0, id: o = 0 } = r, { self: a } = this.client.session.get(s);
      await this.client.core.relayer.unsubscribe(s), await this.client.session.delete(s, Et("USER_DISCONNECTED")), this.client.core.crypto.keychain.has(a.publicKey) && await this.client.core.crypto.deleteKeyPair(a.publicKey), this.client.core.crypto.keychain.has(s) && await this.client.core.crypto.deleteSymKey(s), n || this.client.core.expirer.del(s), this.client.core.storage.removeItem(el).catch((u) => this.client.logger.warn(u)), this.getPendingSessionRequests().forEach((u) => {
        u.topic === s && this.deletePendingSessionRequest(u.id, Et("USER_DISCONNECTED"));
      }), i && this.client.events.emit("session_delete", { id: o, topic: s });
    }, this.deleteProposal = async (r, s) => {
      await Promise.all([this.client.proposal.delete(r, Et("USER_DISCONNECTED")), s ? Promise.resolve() : this.client.core.expirer.del(r)]);
    }, this.deletePendingSessionRequest = async (r, s, n = !1) => {
      await Promise.all([this.client.pendingRequest.delete(r, s), n ? Promise.resolve() : this.client.core.expirer.del(r)]), this.sessionRequestQueue.queue = this.sessionRequestQueue.queue.filter((i) => i.id !== r), n && (this.sessionRequestQueue.state = Hr.idle, this.client.events.emit("session_request_expire", { id: r }));
    }, this.setExpiry = async (r, s) => {
      this.client.session.keys.includes(r) && await this.client.session.update(r, { expiry: s }), this.client.core.expirer.set(r, s);
    }, this.setProposal = async (r, s) => {
      await this.client.proposal.set(r, s), this.client.core.expirer.set(r, ir(Kr.wc_sessionPropose.req.ttl));
    }, this.setPendingSessionRequest = async (r) => {
      const { id: s, topic: n, params: i, verifyContext: o } = r, a = i.request.expiryTimestamp || ir(Kr.wc_sessionRequest.req.ttl);
      await this.client.pendingRequest.set(s, { id: s, topic: n, params: i, verifyContext: o }), a && this.client.core.expirer.set(s, a);
    }, this.sendRequest = async (r) => {
      const { topic: s, method: n, params: i, expiry: o, relayRpcId: a, clientRpcId: u, throwOnFailedPublish: c } = r, h = en(n, i, u);
      if (pn() && ow.includes(n)) {
        const v = Qs(JSON.stringify(h));
        this.client.core.verify.register({ attestationId: v });
      }
      const p = await this.client.core.crypto.encode(s, h), g = Kr[n].req;
      return o && (g.ttl = o), a && (g.id = a), this.client.core.history.set(s, h), c ? (g.internal = Ks(Ht({}, g.internal), { throwOnFailedPublish: !0 }), await this.client.core.relayer.publish(s, p, g)) : this.client.core.relayer.publish(s, p, g).catch((v) => this.client.logger.error(v)), h.id;
    }, this.sendResult = async (r) => {
      const { id: s, topic: n, result: i, throwOnFailedPublish: o } = r, a = Jo(s, i), u = await this.client.core.crypto.encode(n, a), c = await this.client.core.history.get(n, s), h = Kr[c.request.method].res;
      o ? (h.internal = Ks(Ht({}, h.internal), { throwOnFailedPublish: !0 }), await this.client.core.relayer.publish(n, u, h)) : this.client.core.relayer.publish(n, u, h).catch((p) => this.client.logger.error(p)), await this.client.core.history.resolve(a);
    }, this.sendError = async (r, s, n) => {
      const i = Xo(r, n), o = await this.client.core.crypto.encode(s, i), a = await this.client.core.history.get(s, r), u = Kr[a.request.method].res;
      this.client.core.relayer.publish(s, o, u), await this.client.core.history.resolve(i);
    }, this.cleanup = async () => {
      const r = [], s = [];
      this.client.session.getAll().forEach((n) => {
        let i = !1;
        is(n.expiry) && (i = !0), this.client.core.crypto.keychain.has(n.topic) || (i = !0), i && r.push(n.topic);
      }), this.client.proposal.getAll().forEach((n) => {
        is(n.expiryTimestamp) && s.push(n.id);
      }), await Promise.all([...r.map((n) => this.deleteSession({ topic: n })), ...s.map((n) => this.deleteProposal(n))]);
    }, this.onRelayEventRequest = async (r) => {
      this.requestQueue.queue.push(r), await this.processRequestsQueue();
    }, this.processRequestsQueue = async () => {
      if (this.requestQueue.state === Hr.active) {
        this.client.logger.info("Request queue already active, skipping...");
        return;
      }
      for (this.client.logger.info(`Request queue starting with ${this.requestQueue.queue.length} requests`); this.requestQueue.queue.length > 0; ) {
        this.requestQueue.state = Hr.active;
        const r = this.requestQueue.queue.shift();
        if (r)
          try {
            this.processRequest(r), await new Promise((s) => setTimeout(s, 300));
          } catch (s) {
            this.client.logger.warn(s);
          }
      }
      this.requestQueue.state = Hr.idle;
    }, this.processRequest = (r) => {
      const { topic: s, payload: n } = r, i = n.method;
      switch (i) {
        case "wc_sessionPropose":
          return this.onSessionProposeRequest(s, n);
        case "wc_sessionSettle":
          return this.onSessionSettleRequest(s, n);
        case "wc_sessionUpdate":
          return this.onSessionUpdateRequest(s, n);
        case "wc_sessionExtend":
          return this.onSessionExtendRequest(s, n);
        case "wc_sessionPing":
          return this.onSessionPingRequest(s, n);
        case "wc_sessionDelete":
          return this.onSessionDeleteRequest(s, n);
        case "wc_sessionRequest":
          return this.onSessionRequest(s, n);
        case "wc_sessionEvent":
          return this.onSessionEventRequest(s, n);
        default:
          return this.client.logger.info(`Unsupported request method ${i}`);
      }
    }, this.onRelayEventResponse = async (r) => {
      const { topic: s, payload: n } = r, i = (await this.client.core.history.get(s, n.id)).request.method;
      switch (i) {
        case "wc_sessionPropose":
          return this.onSessionProposeResponse(s, n);
        case "wc_sessionSettle":
          return this.onSessionSettleResponse(s, n);
        case "wc_sessionUpdate":
          return this.onSessionUpdateResponse(s, n);
        case "wc_sessionExtend":
          return this.onSessionExtendResponse(s, n);
        case "wc_sessionPing":
          return this.onSessionPingResponse(s, n);
        case "wc_sessionRequest":
          return this.onSessionRequestResponse(s, n);
        default:
          return this.client.logger.info(`Unsupported response method ${i}`);
      }
    }, this.onRelayEventUnknownPayload = (r) => {
      const { topic: s } = r, { message: n } = Y("MISSING_OR_INVALID", `Decoded payload on topic ${s} is not identifiable as a JSON-RPC request or a response.`);
      throw new Error(n);
    }, this.onSessionProposeRequest = async (r, s) => {
      const { params: n, id: i } = s;
      try {
        this.isValidConnect(Ht({}, s.params));
        const o = n.expiryTimestamp || ir(Kr.wc_sessionPropose.req.ttl), a = Ht({ id: i, pairingTopic: r, expiryTimestamp: o }, n);
        await this.setProposal(i, a);
        const u = Qs(JSON.stringify(s)), c = await this.getVerifyContext(u, a.proposer.metadata);
        this.client.events.emit("session_proposal", { id: i, params: a, verifyContext: c });
      } catch (o) {
        await this.sendError(i, r, o), this.client.logger.error(o);
      }
    }, this.onSessionProposeResponse = async (r, s) => {
      const { id: n } = s;
      if (Br(s)) {
        const { result: i } = s;
        this.client.logger.trace({ type: "method", method: "onSessionProposeResponse", result: i });
        const o = this.client.proposal.get(n);
        this.client.logger.trace({ type: "method", method: "onSessionProposeResponse", proposal: o });
        const a = o.proposer.publicKey;
        this.client.logger.trace({ type: "method", method: "onSessionProposeResponse", selfPublicKey: a });
        const u = i.responderPublicKey;
        this.client.logger.trace({ type: "method", method: "onSessionProposeResponse", peerPublicKey: u });
        const c = await this.client.core.crypto.generateSharedKey(a, u);
        this.client.logger.trace({ type: "method", method: "onSessionProposeResponse", sessionTopic: c });
        const h = await this.client.core.relayer.subscribe(c);
        this.client.logger.trace({ type: "method", method: "onSessionProposeResponse", subscriptionId: h }), await this.client.core.pairing.activate({ topic: r });
      } else
        yr(s) && (await this.client.proposal.delete(n, Et("USER_DISCONNECTED")), this.events.emit(wt("session_connect"), { error: s.error }));
    }, this.onSessionSettleRequest = async (r, s) => {
      const { id: n, params: i } = s;
      try {
        this.isValidSessionSettleRequest(i);
        const { relay: o, controller: a, expiry: u, namespaces: c, sessionProperties: h, pairingTopic: p } = s.params, g = Ht({ topic: r, relay: o, expiry: u, namespaces: c, acknowledged: !0, pairingTopic: p, requiredNamespaces: {}, optionalNamespaces: {}, controller: a.publicKey, self: { publicKey: "", metadata: this.client.metadata }, peer: { publicKey: a.publicKey, metadata: a.metadata } }, h && { sessionProperties: h });
        await this.sendResult({ id: s.id, topic: r, result: !0 }), this.events.emit(wt("session_connect"), { session: g }), this.cleanupDuplicatePairings(g);
      } catch (o) {
        await this.sendError(n, r, o), this.client.logger.error(o);
      }
    }, this.onSessionSettleResponse = async (r, s) => {
      const { id: n } = s;
      Br(s) ? (await this.client.session.update(r, { acknowledged: !0 }), this.events.emit(wt("session_approve", n), {})) : yr(s) && (await this.client.session.delete(r, Et("USER_DISCONNECTED")), this.events.emit(wt("session_approve", n), { error: s.error }));
    }, this.onSessionUpdateRequest = async (r, s) => {
      const { params: n, id: i } = s;
      try {
        const o = `${r}_session_update`, a = Pi.get(o);
        if (a && this.isRequestOutOfSync(a, i)) {
          this.client.logger.info(`Discarding out of sync request - ${i}`);
          return;
        }
        this.isValidUpdate(Ht({ topic: r }, n)), await this.client.session.update(r, { namespaces: n.namespaces }), await this.sendResult({ id: i, topic: r, result: !0 }), this.client.events.emit("session_update", { id: i, topic: r, params: n }), Pi.set(o, i);
      } catch (o) {
        await this.sendError(i, r, o), this.client.logger.error(o);
      }
    }, this.isRequestOutOfSync = (r, s) => parseInt(s.toString().slice(0, -3)) <= parseInt(r.toString().slice(0, -3)), this.onSessionUpdateResponse = (r, s) => {
      const { id: n } = s;
      Br(s) ? this.events.emit(wt("session_update", n), {}) : yr(s) && this.events.emit(wt("session_update", n), { error: s.error });
    }, this.onSessionExtendRequest = async (r, s) => {
      const { id: n } = s;
      try {
        this.isValidExtend({ topic: r }), await this.setExpiry(r, ir(Ci)), await this.sendResult({ id: n, topic: r, result: !0 }), this.client.events.emit("session_extend", { id: n, topic: r });
      } catch (i) {
        await this.sendError(n, r, i), this.client.logger.error(i);
      }
    }, this.onSessionExtendResponse = (r, s) => {
      const { id: n } = s;
      Br(s) ? this.events.emit(wt("session_extend", n), {}) : yr(s) && this.events.emit(wt("session_extend", n), { error: s.error });
    }, this.onSessionPingRequest = async (r, s) => {
      const { id: n } = s;
      try {
        this.isValidPing({ topic: r }), await this.sendResult({ id: n, topic: r, result: !0 }), this.client.events.emit("session_ping", { id: n, topic: r });
      } catch (i) {
        await this.sendError(n, r, i), this.client.logger.error(i);
      }
    }, this.onSessionPingResponse = (r, s) => {
      const { id: n } = s;
      setTimeout(() => {
        Br(s) ? this.events.emit(wt("session_ping", n), {}) : yr(s) && this.events.emit(wt("session_ping", n), { error: s.error });
      }, 500);
    }, this.onSessionDeleteRequest = async (r, s) => {
      const { id: n } = s;
      try {
        this.isValidDisconnect({ topic: r, reason: s.params }), await Promise.all([new Promise((i) => {
          this.client.core.relayer.once(Zt.publish, async () => {
            i(await this.deleteSession({ topic: r, id: n }));
          });
        }), this.sendResult({ id: n, topic: r, result: !0 }), this.cleanupPendingSentRequestsForTopic({ topic: r, error: Et("USER_DISCONNECTED") })]);
      } catch (i) {
        this.client.logger.error(i);
      }
    }, this.onSessionRequest = async (r, s) => {
      const { id: n, params: i } = s;
      try {
        this.isValidRequest(Ht({ topic: r }, i));
        const o = Qs(JSON.stringify(en("wc_sessionRequest", i, n))), a = this.client.session.get(r), u = await this.getVerifyContext(o, a.peer.metadata), c = { id: n, topic: r, params: i, verifyContext: u };
        await this.setPendingSessionRequest(c), this.addSessionRequestToSessionRequestQueue(c), this.processSessionRequestQueue();
      } catch (o) {
        await this.sendError(n, r, o), this.client.logger.error(o);
      }
    }, this.onSessionRequestResponse = (r, s) => {
      const { id: n } = s;
      Br(s) ? this.events.emit(wt("session_request", n), { result: s.result }) : yr(s) && this.events.emit(wt("session_request", n), { error: s.error });
    }, this.onSessionEventRequest = async (r, s) => {
      const { id: n, params: i } = s;
      try {
        const o = `${r}_session_event_${i.event.name}`, a = Pi.get(o);
        if (a && this.isRequestOutOfSync(a, n)) {
          this.client.logger.info(`Discarding out of sync request - ${n}`);
          return;
        }
        this.isValidEmit(Ht({ topic: r }, i)), this.client.events.emit("session_event", { id: n, topic: r, params: i }), Pi.set(o, n);
      } catch (o) {
        await this.sendError(n, r, o), this.client.logger.error(o);
      }
    }, this.addSessionRequestToSessionRequestQueue = (r) => {
      this.sessionRequestQueue.queue.push(r);
    }, this.cleanupAfterResponse = (r) => {
      this.deletePendingSessionRequest(r.response.id, { message: "fulfilled", code: 0 }), setTimeout(() => {
        this.sessionRequestQueue.state = Hr.idle, this.processSessionRequestQueue();
      }, oe.toMiliseconds(this.requestQueueDelay));
    }, this.cleanupPendingSentRequestsForTopic = ({ topic: r, error: s }) => {
      const n = this.client.core.history.pending;
      n.length > 0 && n.filter((i) => i.topic === r && i.request.method === "wc_sessionRequest").forEach((i) => {
        this.events.emit(wt("session_request", i.request.id), { error: s });
      });
    }, this.processSessionRequestQueue = () => {
      if (this.sessionRequestQueue.state === Hr.active) {
        this.client.logger.info("session request queue is already active.");
        return;
      }
      const r = this.sessionRequestQueue.queue[0];
      if (!r) {
        this.client.logger.info("session request queue is empty.");
        return;
      }
      try {
        this.sessionRequestQueue.state = Hr.active, this.client.events.emit("session_request", r);
      } catch (s) {
        this.client.logger.error(s);
      }
    }, this.onPairingCreated = (r) => {
      if (r.active)
        return;
      const s = this.client.proposal.getAll().find((n) => n.pairingTopic === r.topic);
      s && this.onSessionProposeRequest(r.topic, en("wc_sessionPropose", { requiredNamespaces: s.requiredNamespaces, optionalNamespaces: s.optionalNamespaces, relays: s.relays, proposer: s.proposer, sessionProperties: s.sessionProperties }, s.id));
    }, this.isValidConnect = async (r) => {
      if (!tr(r)) {
        const { message: u } = Y("MISSING_OR_INVALID", `connect() params: ${JSON.stringify(r)}`);
        throw new Error(u);
      }
      const { pairingTopic: s, requiredNamespaces: n, optionalNamespaces: i, sessionProperties: o, relays: a } = r;
      if (Gt(s) || await this.isValidPairingTopic(s), !Lv(a, !0)) {
        const { message: u } = Y("MISSING_OR_INVALID", `connect() relays: ${a}`);
        throw new Error(u);
      }
      !Gt(n) && Zi(n) !== 0 && this.validateNamespaces(n, "requiredNamespaces"), !Gt(i) && Zi(i) !== 0 && this.validateNamespaces(i, "optionalNamespaces"), Gt(o) || this.validateSessionProps(o, "sessionProperties");
    }, this.validateNamespaces = (r, s) => {
      const n = jv(r, "connect()", s);
      if (n)
        throw new Error(n.message);
    }, this.isValidApprove = async (r) => {
      if (!tr(r))
        throw new Error(Y("MISSING_OR_INVALID", `approve() params: ${r}`).message);
      const { id: s, namespaces: n, relayProtocol: i, sessionProperties: o } = r;
      await this.isValidProposalId(s);
      const a = this.client.proposal.get(s), u = La(n, "approve()");
      if (u)
        throw new Error(u.message);
      const c = Ou(a.requiredNamespaces, n, "approve()");
      if (c)
        throw new Error(c.message);
      if (!kt(i, !0)) {
        const { message: h } = Y("MISSING_OR_INVALID", `approve() relayProtocol: ${i}`);
        throw new Error(h);
      }
      Gt(o) || this.validateSessionProps(o, "sessionProperties");
    }, this.isValidReject = async (r) => {
      if (!tr(r)) {
        const { message: i } = Y("MISSING_OR_INVALID", `reject() params: ${r}`);
        throw new Error(i);
      }
      const { id: s, reason: n } = r;
      if (await this.isValidProposalId(s), !Dv(n)) {
        const { message: i } = Y("MISSING_OR_INVALID", `reject() reason: ${JSON.stringify(n)}`);
        throw new Error(i);
      }
    }, this.isValidSessionSettleRequest = (r) => {
      if (!tr(r)) {
        const { message: c } = Y("MISSING_OR_INVALID", `onSessionSettleRequest() params: ${r}`);
        throw new Error(c);
      }
      const { relay: s, controller: n, namespaces: i, expiry: o } = r;
      if (!bd(s)) {
        const { message: c } = Y("MISSING_OR_INVALID", "onSessionSettleRequest() relay protocol should be a string");
        throw new Error(c);
      }
      const a = Pv(n, "onSessionSettleRequest()");
      if (a)
        throw new Error(a.message);
      const u = La(i, "onSessionSettleRequest()");
      if (u)
        throw new Error(u.message);
      if (is(o)) {
        const { message: c } = Y("EXPIRED", "onSessionSettleRequest()");
        throw new Error(c);
      }
    }, this.isValidUpdate = async (r) => {
      if (!tr(r)) {
        const { message: u } = Y("MISSING_OR_INVALID", `update() params: ${r}`);
        throw new Error(u);
      }
      const { topic: s, namespaces: n } = r;
      await this.isValidSessionTopic(s);
      const i = this.client.session.get(s), o = La(n, "update()");
      if (o)
        throw new Error(o.message);
      const a = Ou(i.requiredNamespaces, n, "update()");
      if (a)
        throw new Error(a.message);
    }, this.isValidExtend = async (r) => {
      if (!tr(r)) {
        const { message: n } = Y("MISSING_OR_INVALID", `extend() params: ${r}`);
        throw new Error(n);
      }
      const { topic: s } = r;
      await this.isValidSessionTopic(s);
    }, this.isValidRequest = async (r) => {
      if (!tr(r)) {
        const { message: u } = Y("MISSING_OR_INVALID", `request() params: ${r}`);
        throw new Error(u);
      }
      const { topic: s, request: n, chainId: i, expiry: o } = r;
      await this.isValidSessionTopic(s);
      const { namespaces: a } = this.client.session.get(s);
      if (!xu(a, i)) {
        const { message: u } = Y("MISSING_OR_INVALID", `request() chainId: ${i}`);
        throw new Error(u);
      }
      if (!Uv(n)) {
        const { message: u } = Y("MISSING_OR_INVALID", `request() ${JSON.stringify(n)}`);
        throw new Error(u);
      }
      if (!Vv(a, i, n.method)) {
        const { message: u } = Y("MISSING_OR_INVALID", `request() method: ${n.method}`);
        throw new Error(u);
      }
      if (o && !Wv(o, Va)) {
        const { message: u } = Y("MISSING_OR_INVALID", `request() expiry: ${o}. Expiry must be a number (in seconds) between ${Va.min} and ${Va.max}`);
        throw new Error(u);
      }
    }, this.isValidRespond = async (r) => {
      var s;
      if (!tr(r)) {
        const { message: o } = Y("MISSING_OR_INVALID", `respond() params: ${r}`);
        throw new Error(o);
      }
      const { topic: n, response: i } = r;
      try {
        await this.isValidSessionTopic(n);
      } catch (o) {
        throw (s = r == null ? void 0 : r.response) != null && s.id && this.cleanupAfterResponse(r), o;
      }
      if (!zv(i)) {
        const { message: o } = Y("MISSING_OR_INVALID", `respond() response: ${JSON.stringify(i)}`);
        throw new Error(o);
      }
    }, this.isValidPing = async (r) => {
      if (!tr(r)) {
        const { message: n } = Y("MISSING_OR_INVALID", `ping() params: ${r}`);
        throw new Error(n);
      }
      const { topic: s } = r;
      await this.isValidSessionOrPairingTopic(s);
    }, this.isValidEmit = async (r) => {
      if (!tr(r)) {
        const { message: a } = Y("MISSING_OR_INVALID", `emit() params: ${r}`);
        throw new Error(a);
      }
      const { topic: s, event: n, chainId: i } = r;
      await this.isValidSessionTopic(s);
      const { namespaces: o } = this.client.session.get(s);
      if (!xu(o, i)) {
        const { message: a } = Y("MISSING_OR_INVALID", `emit() chainId: ${i}`);
        throw new Error(a);
      }
      if (!$v(n)) {
        const { message: a } = Y("MISSING_OR_INVALID", `emit() event: ${JSON.stringify(n)}`);
        throw new Error(a);
      }
      if (!qv(o, i, n.name)) {
        const { message: a } = Y("MISSING_OR_INVALID", `emit() event: ${JSON.stringify(n)}`);
        throw new Error(a);
      }
    }, this.isValidDisconnect = async (r) => {
      if (!tr(r)) {
        const { message: n } = Y("MISSING_OR_INVALID", `disconnect() params: ${r}`);
        throw new Error(n);
      }
      const { topic: s } = r;
      await this.isValidSessionOrPairingTopic(s);
    }, this.getVerifyContext = async (r, s) => {
      const n = { verified: { verifyUrl: s.verifyUrl || Js, validation: "UNKNOWN", origin: s.url || "" } };
      try {
        const i = await this.client.core.verify.resolve({ attestationId: r, verifyUrl: s.verifyUrl });
        i && (n.verified.origin = i.origin, n.verified.isScam = i.isScam, n.verified.validation = i.origin === new URL(s.url).origin ? "VALID" : "INVALID");
      } catch (i) {
        this.client.logger.info(i);
      }
      return this.client.logger.info(`Verify context: ${JSON.stringify(n)}`), n;
    }, this.validateSessionProps = (r, s) => {
      Object.values(r).forEach((n) => {
        if (!kt(n, !1)) {
          const { message: i } = Y("MISSING_OR_INVALID", `${s} must be in Record<string, string> format. Received: ${JSON.stringify(n)}`);
          throw new Error(i);
        }
      });
    };
  }
  async isInitialized() {
    if (!this.initialized) {
      const { message: e } = Y("NOT_INITIALIZED", this.name);
      throw new Error(e);
    }
    await this.client.core.relayer.confirmOnlineStateOrThrow();
  }
  registerRelayerEvents() {
    this.client.core.relayer.on(Zt.message, async (e) => {
      const { topic: r, message: s } = e;
      if (this.ignoredPayloadTypes.includes(this.client.core.crypto.getPayloadType(s)))
        return;
      const n = await this.client.core.crypto.decode(r, s);
      try {
        Qo(n) ? (this.client.core.history.set(r, n), this.onRelayEventRequest({ topic: r, payload: n })) : wa(n) ? (await this.client.core.history.resolve(n), await this.onRelayEventResponse({ topic: r, payload: n }), this.client.core.history.delete(r, n.id)) : this.onRelayEventUnknownPayload({ topic: r, payload: n });
      } catch (i) {
        this.client.logger.error(i);
      }
    });
  }
  registerExpirerEvents() {
    this.client.core.expirer.on(hr.expired, async (e) => {
      const { topic: r, id: s } = vd(e.target);
      if (s && this.client.pendingRequest.keys.includes(s))
        return await this.deletePendingSessionRequest(s, Y("EXPIRED"), !0);
      r ? this.client.session.keys.includes(r) && (await this.deleteSession({ topic: r, expirerHasDeleted: !0 }), this.client.events.emit("session_expire", { topic: r })) : s && (await this.deleteProposal(s, !0), this.client.events.emit("proposal_expire", { id: s }));
    });
  }
  registerPairingEvents() {
    this.client.core.pairing.events.on(Tn.create, (e) => this.onPairingCreated(e));
  }
  isValidPairingTopic(e) {
    if (!kt(e, !1)) {
      const { message: r } = Y("MISSING_OR_INVALID", `pairing topic should be a string: ${e}`);
      throw new Error(r);
    }
    if (!this.client.core.pairing.pairings.keys.includes(e)) {
      const { message: r } = Y("NO_MATCHING_KEY", `pairing topic doesn't exist: ${e}`);
      throw new Error(r);
    }
    if (is(this.client.core.pairing.pairings.get(e).expiry)) {
      const { message: r } = Y("EXPIRED", `pairing topic: ${e}`);
      throw new Error(r);
    }
  }
  async isValidSessionTopic(e) {
    if (!kt(e, !1)) {
      const { message: r } = Y("MISSING_OR_INVALID", `session topic should be a string: ${e}`);
      throw new Error(r);
    }
    if (!this.client.session.keys.includes(e)) {
      const { message: r } = Y("NO_MATCHING_KEY", `session topic doesn't exist: ${e}`);
      throw new Error(r);
    }
    if (is(this.client.session.get(e).expiry)) {
      await this.deleteSession({ topic: e });
      const { message: r } = Y("EXPIRED", `session topic: ${e}`);
      throw new Error(r);
    }
    if (!this.client.core.crypto.keychain.has(e)) {
      const { message: r } = Y("MISSING_OR_INVALID", `session topic does not exist in keychain: ${e}`);
      throw await this.deleteSession({ topic: e }), new Error(r);
    }
  }
  async isValidSessionOrPairingTopic(e) {
    if (this.client.session.keys.includes(e))
      await this.isValidSessionTopic(e);
    else if (this.client.core.pairing.pairings.keys.includes(e))
      this.isValidPairingTopic(e);
    else if (kt(e, !1)) {
      const { message: r } = Y("NO_MATCHING_KEY", `session or pairing topic doesn't exist: ${e}`);
      throw new Error(r);
    } else {
      const { message: r } = Y("MISSING_OR_INVALID", `session or pairing topic should be a string: ${e}`);
      throw new Error(r);
    }
  }
  async isValidProposalId(e) {
    if (!Mv(e)) {
      const { message: r } = Y("MISSING_OR_INVALID", `proposal id should be a number: ${e}`);
      throw new Error(r);
    }
    if (!this.client.proposal.keys.includes(e)) {
      const { message: r } = Y("NO_MATCHING_KEY", `proposal id doesn't exist: ${e}`);
      throw new Error(r);
    }
    if (is(this.client.proposal.get(e).expiryTimestamp)) {
      await this.deleteProposal(e);
      const { message: r } = Y("EXPIRED", `proposal id: ${e}`);
      throw new Error(r);
    }
  }
}
class fw extends Sa {
  constructor(e, r) {
    super(e, r, rw, rc), this.core = e, this.logger = r;
  }
}
class gw extends Sa {
  constructor(e, r) {
    super(e, r, nw, rc), this.core = e, this.logger = r;
  }
}
class mw extends Sa {
  constructor(e, r) {
    super(e, r, aw, rc, (s) => s.id), this.core = e, this.logger = r;
  }
}
class sc extends rg {
  constructor(e) {
    super(e), this.protocol = $d, this.version = Vd, this.name = $a.name, this.events = new Pr.EventEmitter(), this.on = (s, n) => this.events.on(s, n), this.once = (s, n) => this.events.once(s, n), this.off = (s, n) => this.events.off(s, n), this.removeListener = (s, n) => this.events.removeListener(s, n), this.removeAllListeners = (s) => this.events.removeAllListeners(s), this.connect = async (s) => {
      try {
        return await this.engine.connect(s);
      } catch (n) {
        throw this.logger.error(n.message), n;
      }
    }, this.pair = async (s) => {
      try {
        return await this.engine.pair(s);
      } catch (n) {
        throw this.logger.error(n.message), n;
      }
    }, this.approve = async (s) => {
      try {
        return await this.engine.approve(s);
      } catch (n) {
        throw this.logger.error(n.message), n;
      }
    }, this.reject = async (s) => {
      try {
        return await this.engine.reject(s);
      } catch (n) {
        throw this.logger.error(n.message), n;
      }
    }, this.update = async (s) => {
      try {
        return await this.engine.update(s);
      } catch (n) {
        throw this.logger.error(n.message), n;
      }
    }, this.extend = async (s) => {
      try {
        return await this.engine.extend(s);
      } catch (n) {
        throw this.logger.error(n.message), n;
      }
    }, this.request = async (s) => {
      try {
        return await this.engine.request(s);
      } catch (n) {
        throw this.logger.error(n.message), n;
      }
    }, this.respond = async (s) => {
      try {
        return await this.engine.respond(s);
      } catch (n) {
        throw this.logger.error(n.message), n;
      }
    }, this.ping = async (s) => {
      try {
        return await this.engine.ping(s);
      } catch (n) {
        throw this.logger.error(n.message), n;
      }
    }, this.emit = async (s) => {
      try {
        return await this.engine.emit(s);
      } catch (n) {
        throw this.logger.error(n.message), n;
      }
    }, this.disconnect = async (s) => {
      try {
        return await this.engine.disconnect(s);
      } catch (n) {
        throw this.logger.error(n.message), n;
      }
    }, this.find = (s) => {
      try {
        return this.engine.find(s);
      } catch (n) {
        throw this.logger.error(n.message), n;
      }
    }, this.getPendingSessionRequests = () => {
      try {
        return this.engine.getPendingSessionRequests();
      } catch (s) {
        throw this.logger.error(s.message), s;
      }
    }, this.name = (e == null ? void 0 : e.name) || $a.name, this.metadata = (e == null ? void 0 : e.metadata) || Jy();
    const r = typeof (e == null ? void 0 : e.logger) < "u" && typeof (e == null ? void 0 : e.logger) != "string" ? e.logger : Fe.pino(Fe.getDefaultLoggerOptions({ level: (e == null ? void 0 : e.logger) || $a.logger }));
    this.core = (e == null ? void 0 : e.core) || new tw(e), this.logger = Fe.generateChildLogger(r, this.name), this.session = new gw(this.core, this.logger), this.proposal = new fw(this.core, this.logger), this.pendingRequest = new mw(this.core, this.logger), this.engine = new pw(this);
  }
  static async init(e) {
    const r = new sc(e);
    return await r.initialize(), r;
  }
  get context() {
    return Fe.getLoggerContext(this.logger);
  }
  get pairing() {
    return this.core.pairing.pairings;
  }
  async initialize() {
    this.logger.trace("Initialized");
    try {
      await this.core.start(), await this.session.init(), await this.proposal.init(), await this.pendingRequest.init(), await this.engine.init(), this.core.verify.init({ verifyUrl: this.metadata.verifyUrl }), this.logger.info("SignClient Initialization Success");
    } catch (e) {
      throw this.logger.info("SignClient Initialization Failure"), this.logger.error(e.message), e;
    }
  }
}
var yw = Object.defineProperty, vw = Object.defineProperties, _w = Object.getOwnPropertyDescriptors, sl = Object.getOwnPropertySymbols, bw = Object.prototype.hasOwnProperty, ww = Object.prototype.propertyIsEnumerable, nl = (t, e, r) => e in t ? yw(t, e, { enumerable: !0, configurable: !0, writable: !0, value: r }) : t[e] = r, Ew = (t, e) => {
  for (var r in e || (e = {}))
    bw.call(e, r) && nl(t, r, e[r]);
  if (sl)
    for (var r of sl(e))
      ww.call(e, r) && nl(t, r, e[r]);
  return t;
}, Sw = (t, e) => vw(t, _w(e)), nc = (t, e, r) => {
  if (!e.has(t))
    throw TypeError("Cannot " + r);
}, at = (t, e, r) => (nc(t, e, "read from private field"), r ? r.call(t) : e.get(t)), xs = (t, e, r) => {
  if (e.has(t))
    throw TypeError("Cannot add the same private member more than once");
  e instanceof WeakSet ? e.add(t) : e.set(t, r);
}, Ki = (t, e, r, s) => (nc(t, e, "write to private field"), s ? s.call(t, r) : e.set(t, r), r), $t = (t, e, r) => (nc(t, e, "access private method"), r), Os, Bs, Pn, Nt, po, Zd, Vt, Bt, fo, il;
let Iw = class {
  constructor(t) {
    xs(this, po), xs(this, Vt), xs(this, fo), xs(this, Os, void 0), xs(this, Bs, void 0), xs(this, Pn, void 0), xs(this, Nt, void 0), Ki(this, Os, t), Ki(this, Bs, $t(this, po, Zd).call(this)), $t(this, Vt, Bt).call(this);
  }
  async connect(t) {
    const { requiredNamespaces: e, optionalNamespaces: r } = t;
    return new Promise(async (s, n) => {
      await $t(this, Vt, Bt).call(this);
      const i = at(this, Bs).subscribeModal((u) => {
        u.open || (i(), n(new Error("Modal closed")));
      }), { uri: o, approval: a } = await at(this, Nt).connect(t);
      if (o) {
        const u = /* @__PURE__ */ new Set();
        e && Object.values(e).forEach(({ chains: c }) => {
          c && c.forEach((h) => u.add(h));
        }), r && Object.values(r).forEach(({ chains: c }) => {
          c && c.forEach((h) => u.add(h));
        }), await at(this, Bs).openModal({ uri: o, chains: Array.from(u) });
      }
      try {
        const u = await a();
        s(u);
      } catch (u) {
        n(u);
      } finally {
        i(), at(this, Bs).closeModal();
      }
    });
  }
  async disconnect(t) {
    await $t(this, Vt, Bt).call(this), await at(this, Nt).disconnect(t);
  }
  async request(t) {
    return await $t(this, Vt, Bt).call(this), await at(this, Nt).request(t);
  }
  async getSessions() {
    return await $t(this, Vt, Bt).call(this), at(this, Nt).session.getAll();
  }
  async getSession() {
    return await $t(this, Vt, Bt).call(this), at(this, Nt).session.getAll().at(-1);
  }
  async onSessionEvent(t) {
    await $t(this, Vt, Bt).call(this), at(this, Nt).on("session_event", t);
  }
  async offSessionEvent(t) {
    await $t(this, Vt, Bt).call(this), at(this, Nt).off("session_event", t);
  }
  async onSessionUpdate(t) {
    await $t(this, Vt, Bt).call(this), at(this, Nt).on("session_update", t);
  }
  async offSessionUpdate(t) {
    await $t(this, Vt, Bt).call(this), at(this, Nt).off("session_update", t);
  }
  async onSessionDelete(t) {
    await $t(this, Vt, Bt).call(this), at(this, Nt).on("session_delete", t);
  }
  async offSessionDelete(t) {
    await $t(this, Vt, Bt).call(this), at(this, Nt).off("session_delete", t);
  }
  async onSessionExpire(t) {
    await $t(this, Vt, Bt).call(this), at(this, Nt).on("session_expire", t);
  }
  async offSessionExpire(t) {
    await $t(this, Vt, Bt).call(this), at(this, Nt).off("session_expire", t);
  }
};
Os = /* @__PURE__ */ new WeakMap(), Bs = /* @__PURE__ */ new WeakMap(), Pn = /* @__PURE__ */ new WeakMap(), Nt = /* @__PURE__ */ new WeakMap(), po = /* @__PURE__ */ new WeakSet(), Zd = function() {
  const { modalOptions: t, projectId: e } = at(this, Os);
  return new Ip(Sw(Ew({}, t), { projectId: e }));
}, Vt = /* @__PURE__ */ new WeakSet(), Bt = async function() {
  return at(this, Nt) ? !0 : (!at(this, Pn) && typeof window < "u" && Ki(this, Pn, $t(this, fo, il).call(this)), at(this, Pn));
}, fo = /* @__PURE__ */ new WeakSet(), il = async function() {
  Ki(this, Nt, await sc.init({ metadata: at(this, Os).metadata, projectId: at(this, Os).projectId, relayUrl: at(this, Os).relayUrl }));
  const t = await at(this, Nt).core.crypto.getClientId();
  try {
    localStorage.setItem("WCM_WALLETCONNECT_CLIENT_ID", t);
  } catch {
    console.info("Unable to set client id");
  }
};
const xw = [
  "decrypt",
  "disconnect",
  "getSelectedAccount",
  "getBalance",
  "getRecords",
  "requestCreateEvent",
  "getEvent",
  "getEvents",
  "createSharedState",
  "importSharedState",
  "requestSignature"
], Fd = ["aleo:1"], Ow = ["chainChanged", "accountSelected", "selectedAccountSynced", "sharedAccountSynced"], Tw = "f0aaeffe71b636da453fce042d79d723", Pw = {
  standaloneChains: Fd,
  enableExplorer: !1,
  enableAccountView: !0,
  enableNetworkView: !0,
  enableStandaloneMode: !0,
  mobileWallets: [
    {
      id: "puzzle",
      name: "Puzzle Wallet",
      links: {
        native: "puzzleapp://",
        universal: ""
      }
    }
  ],
  desktopWallets: [
    {
      id: "puzzle",
      name: "Puzzle Wallet",
      links: {
        native: "",
        universal: "https://walletconnect.puzzle.online/"
      }
    },
    {
      id: "avail",
      name: "Avail Wallet",
      links: {
        native: "avail://",
        universal: "https://avail.global"
      }
    }
  ],
  walletImages: {
    puzzle: "https://i.imgur.com/p9tHaFC.png",
    avail: "https://i.imgur.com/GxNn8BO.png"
  }
}, Wd = new Mo();
let Cn;
function Cw(t) {
  Cn = new Iw({
    projectId: Tw,
    metadata: {
      name: t.dAppName,
      description: t.dAppDescription,
      url: t.dAppUrl,
      icons: [t.dAppIconURL]
    },
    modalOptions: { ...Pw }
  }), window.localStorage.removeItem("WALLETCONNECT_DEEPLINK_CHOICE");
}
async function Kd() {
  return new Promise((t) => {
    if (Cn)
      t(Cn);
    else {
      const e = setInterval(() => {
        Cn && (clearInterval(e), t(Cn));
      }, 200);
    }
    window.localStorage.removeItem("WALLETCONNECT_DEEPLINK_CHOICE");
  });
}
var Ge;
(function(t) {
  t.assertEqual = (n) => n;
  function e(n) {
  }
  t.assertIs = e;
  function r(n) {
    throw new Error();
  }
  t.assertNever = r, t.arrayToEnum = (n) => {
    const i = {};
    for (const o of n)
      i[o] = o;
    return i;
  }, t.getValidEnumValues = (n) => {
    const i = t.objectKeys(n).filter((a) => typeof n[n[a]] != "number"), o = {};
    for (const a of i)
      o[a] = n[a];
    return t.objectValues(o);
  }, t.objectValues = (n) => t.objectKeys(n).map(function(i) {
    return n[i];
  }), t.objectKeys = typeof Object.keys == "function" ? (n) => Object.keys(n) : (n) => {
    const i = [];
    for (const o in n)
      Object.prototype.hasOwnProperty.call(n, o) && i.push(o);
    return i;
  }, t.find = (n, i) => {
    for (const o of n)
      if (i(o))
        return o;
  }, t.isInteger = typeof Number.isInteger == "function" ? (n) => Number.isInteger(n) : (n) => typeof n == "number" && isFinite(n) && Math.floor(n) === n;
  function s(n, i = " | ") {
    return n.map((o) => typeof o == "string" ? `'${o}'` : o).join(i);
  }
  t.joinValues = s, t.jsonStringifyReplacer = (n, i) => typeof i == "bigint" ? i.toString() : i;
})(Ge || (Ge = {}));
var go;
(function(t) {
  t.mergeShapes = (e, r) => ({
    ...e,
    ...r
    // second overwrites first
  });
})(go || (go = {}));
const te = Ge.arrayToEnum([
  "string",
  "nan",
  "number",
  "integer",
  "float",
  "boolean",
  "date",
  "bigint",
  "symbol",
  "function",
  "undefined",
  "null",
  "array",
  "object",
  "unknown",
  "promise",
  "void",
  "never",
  "map",
  "set"
]), as = (t) => {
  switch (typeof t) {
    case "undefined":
      return te.undefined;
    case "string":
      return te.string;
    case "number":
      return isNaN(t) ? te.nan : te.number;
    case "boolean":
      return te.boolean;
    case "function":
      return te.function;
    case "bigint":
      return te.bigint;
    case "symbol":
      return te.symbol;
    case "object":
      return Array.isArray(t) ? te.array : t === null ? te.null : t.then && typeof t.then == "function" && t.catch && typeof t.catch == "function" ? te.promise : typeof Map < "u" && t instanceof Map ? te.map : typeof Set < "u" && t instanceof Set ? te.set : typeof Date < "u" && t instanceof Date ? te.date : te.object;
    default:
      return te.unknown;
  }
}, K = Ge.arrayToEnum([
  "invalid_type",
  "invalid_literal",
  "custom",
  "invalid_union",
  "invalid_union_discriminator",
  "invalid_enum_value",
  "unrecognized_keys",
  "invalid_arguments",
  "invalid_return_type",
  "invalid_date",
  "invalid_string",
  "too_small",
  "too_big",
  "invalid_intersection_types",
  "not_multiple_of",
  "not_finite"
]), Nw = (t) => JSON.stringify(t, null, 2).replace(/"([^"]+)":/g, "$1:");
class wr extends Error {
  constructor(e) {
    super(), this.issues = [], this.addIssue = (s) => {
      this.issues = [...this.issues, s];
    }, this.addIssues = (s = []) => {
      this.issues = [...this.issues, ...s];
    };
    const r = new.target.prototype;
    Object.setPrototypeOf ? Object.setPrototypeOf(this, r) : this.__proto__ = r, this.name = "ZodError", this.issues = e;
  }
  get errors() {
    return this.issues;
  }
  format(e) {
    const r = e || function(i) {
      return i.message;
    }, s = { _errors: [] }, n = (i) => {
      for (const o of i.issues)
        if (o.code === "invalid_union")
          o.unionErrors.map(n);
        else if (o.code === "invalid_return_type")
          n(o.returnTypeError);
        else if (o.code === "invalid_arguments")
          n(o.argumentsError);
        else if (o.path.length === 0)
          s._errors.push(r(o));
        else {
          let a = s, u = 0;
          for (; u < o.path.length; ) {
            const c = o.path[u];
            u === o.path.length - 1 ? (a[c] = a[c] || { _errors: [] }, a[c]._errors.push(r(o))) : a[c] = a[c] || { _errors: [] }, a = a[c], u++;
          }
        }
    };
    return n(this), s;
  }
  toString() {
    return this.message;
  }
  get message() {
    return JSON.stringify(this.issues, Ge.jsonStringifyReplacer, 2);
  }
  get isEmpty() {
    return this.issues.length === 0;
  }
  flatten(e = (r) => r.message) {
    const r = {}, s = [];
    for (const n of this.issues)
      n.path.length > 0 ? (r[n.path[0]] = r[n.path[0]] || [], r[n.path[0]].push(e(n))) : s.push(e(n));
    return { formErrors: s, fieldErrors: r };
  }
  get formErrors() {
    return this.flatten();
  }
}
wr.create = (t) => new wr(t);
const Ln = (t, e) => {
  let r;
  switch (t.code) {
    case K.invalid_type:
      t.received === te.undefined ? r = "Required" : r = `Expected ${t.expected}, received ${t.received}`;
      break;
    case K.invalid_literal:
      r = `Invalid literal value, expected ${JSON.stringify(t.expected, Ge.jsonStringifyReplacer)}`;
      break;
    case K.unrecognized_keys:
      r = `Unrecognized key(s) in object: ${Ge.joinValues(t.keys, ", ")}`;
      break;
    case K.invalid_union:
      r = "Invalid input";
      break;
    case K.invalid_union_discriminator:
      r = `Invalid discriminator value. Expected ${Ge.joinValues(t.options)}`;
      break;
    case K.invalid_enum_value:
      r = `Invalid enum value. Expected ${Ge.joinValues(t.options)}, received '${t.received}'`;
      break;
    case K.invalid_arguments:
      r = "Invalid function arguments";
      break;
    case K.invalid_return_type:
      r = "Invalid function return type";
      break;
    case K.invalid_date:
      r = "Invalid date";
      break;
    case K.invalid_string:
      typeof t.validation == "object" ? "includes" in t.validation ? (r = `Invalid input: must include "${t.validation.includes}"`, typeof t.validation.position == "number" && (r = `${r} at one or more positions greater than or equal to ${t.validation.position}`)) : "startsWith" in t.validation ? r = `Invalid input: must start with "${t.validation.startsWith}"` : "endsWith" in t.validation ? r = `Invalid input: must end with "${t.validation.endsWith}"` : Ge.assertNever(t.validation) : t.validation !== "regex" ? r = `Invalid ${t.validation}` : r = "Invalid";
      break;
    case K.too_small:
      t.type === "array" ? r = `Array must contain ${t.exact ? "exactly" : t.inclusive ? "at least" : "more than"} ${t.minimum} element(s)` : t.type === "string" ? r = `String must contain ${t.exact ? "exactly" : t.inclusive ? "at least" : "over"} ${t.minimum} character(s)` : t.type === "number" ? r = `Number must be ${t.exact ? "exactly equal to " : t.inclusive ? "greater than or equal to " : "greater than "}${t.minimum}` : t.type === "date" ? r = `Date must be ${t.exact ? "exactly equal to " : t.inclusive ? "greater than or equal to " : "greater than "}${new Date(Number(t.minimum))}` : r = "Invalid input";
      break;
    case K.too_big:
      t.type === "array" ? r = `Array must contain ${t.exact ? "exactly" : t.inclusive ? "at most" : "less than"} ${t.maximum} element(s)` : t.type === "string" ? r = `String must contain ${t.exact ? "exactly" : t.inclusive ? "at most" : "under"} ${t.maximum} character(s)` : t.type === "number" ? r = `Number must be ${t.exact ? "exactly" : t.inclusive ? "less than or equal to" : "less than"} ${t.maximum}` : t.type === "bigint" ? r = `BigInt must be ${t.exact ? "exactly" : t.inclusive ? "less than or equal to" : "less than"} ${t.maximum}` : t.type === "date" ? r = `Date must be ${t.exact ? "exactly" : t.inclusive ? "smaller than or equal to" : "smaller than"} ${new Date(Number(t.maximum))}` : r = "Invalid input";
      break;
    case K.custom:
      r = "Invalid input";
      break;
    case K.invalid_intersection_types:
      r = "Intersection results could not be merged";
      break;
    case K.not_multiple_of:
      r = `Number must be a multiple of ${t.multipleOf}`;
      break;
    case K.not_finite:
      r = "Number must be finite";
      break;
    default:
      r = e.defaultError, Ge.assertNever(t);
  }
  return { message: r };
};
let Hd = Ln;
function kw(t) {
  Hd = t;
}
function Hi() {
  return Hd;
}
const Bi = (t) => {
  const { data: e, path: r, errorMaps: s, issueData: n } = t, i = [...r, ...n.path || []], o = {
    ...n,
    path: i
  };
  let a = "";
  const u = s.filter((c) => !!c).slice().reverse();
  for (const c of u)
    a = c(o, { data: e, defaultError: a }).message;
  return {
    ...n,
    path: i,
    message: n.message || a
  };
}, Rw = [];
function ne(t, e) {
  const r = Bi({
    issueData: e,
    data: t.data,
    path: t.path,
    errorMaps: [
      t.common.contextualErrorMap,
      t.schemaErrorMap,
      Hi(),
      Ln
      // then global default map
    ].filter((s) => !!s)
  });
  t.common.issues.push(r);
}
class Ft {
  constructor() {
    this.value = "valid";
  }
  dirty() {
    this.value === "valid" && (this.value = "dirty");
  }
  abort() {
    this.value !== "aborted" && (this.value = "aborted");
  }
  static mergeArray(e, r) {
    const s = [];
    for (const n of r) {
      if (n.status === "aborted")
        return be;
      n.status === "dirty" && e.dirty(), s.push(n.value);
    }
    return { status: e.value, value: s };
  }
  static async mergeObjectAsync(e, r) {
    const s = [];
    for (const n of r)
      s.push({
        key: await n.key,
        value: await n.value
      });
    return Ft.mergeObjectSync(e, s);
  }
  static mergeObjectSync(e, r) {
    const s = {};
    for (const n of r) {
      const { key: i, value: o } = n;
      if (i.status === "aborted" || o.status === "aborted")
        return be;
      i.status === "dirty" && e.dirty(), o.status === "dirty" && e.dirty(), (typeof o.value < "u" || n.alwaysSet) && (s[i.value] = o.value);
    }
    return { status: e.value, value: s };
  }
}
const be = Object.freeze({
  status: "aborted"
}), Bd = (t) => ({ status: "dirty", value: t }), Xt = (t) => ({ status: "valid", value: t }), mo = (t) => t.status === "aborted", yo = (t) => t.status === "dirty", Gi = (t) => t.status === "valid", Yi = (t) => typeof Promise < "u" && t instanceof Promise;
var ce;
(function(t) {
  t.errToObj = (e) => typeof e == "string" ? { message: e } : e || {}, t.toString = (e) => typeof e == "string" ? e : e == null ? void 0 : e.message;
})(ce || (ce = {}));
class Dr {
  constructor(e, r, s, n) {
    this._cachedPath = [], this.parent = e, this.data = r, this._path = s, this._key = n;
  }
  get path() {
    return this._cachedPath.length || (this._key instanceof Array ? this._cachedPath.push(...this._path, ...this._key) : this._cachedPath.push(...this._path, this._key)), this._cachedPath;
  }
}
const al = (t, e) => {
  if (Gi(e))
    return { success: !0, data: e.value };
  if (!t.common.issues.length)
    throw new Error("Validation failed but no issues detected.");
  return {
    success: !1,
    get error() {
      if (this._error)
        return this._error;
      const r = new wr(t.common.issues);
      return this._error = r, this._error;
    }
  };
};
function Se(t) {
  if (!t)
    return {};
  const { errorMap: e, invalid_type_error: r, required_error: s, description: n } = t;
  if (e && (r || s))
    throw new Error(`Can't use "invalid_type_error" or "required_error" in conjunction with custom error map.`);
  return e ? { errorMap: e, description: n } : { errorMap: (i, o) => i.code !== "invalid_type" ? { message: o.defaultError } : typeof o.data > "u" ? { message: s ?? o.defaultError } : { message: r ?? o.defaultError }, description: n };
}
class ke {
  constructor(e) {
    this.spa = this.safeParseAsync, this._def = e, this.parse = this.parse.bind(this), this.safeParse = this.safeParse.bind(this), this.parseAsync = this.parseAsync.bind(this), this.safeParseAsync = this.safeParseAsync.bind(this), this.spa = this.spa.bind(this), this.refine = this.refine.bind(this), this.refinement = this.refinement.bind(this), this.superRefine = this.superRefine.bind(this), this.optional = this.optional.bind(this), this.nullable = this.nullable.bind(this), this.nullish = this.nullish.bind(this), this.array = this.array.bind(this), this.promise = this.promise.bind(this), this.or = this.or.bind(this), this.and = this.and.bind(this), this.transform = this.transform.bind(this), this.brand = this.brand.bind(this), this.default = this.default.bind(this), this.catch = this.catch.bind(this), this.describe = this.describe.bind(this), this.pipe = this.pipe.bind(this), this.isNullable = this.isNullable.bind(this), this.isOptional = this.isOptional.bind(this);
  }
  get description() {
    return this._def.description;
  }
  _getType(e) {
    return as(e.data);
  }
  _getOrReturnCtx(e, r) {
    return r || {
      common: e.parent.common,
      data: e.data,
      parsedType: as(e.data),
      schemaErrorMap: this._def.errorMap,
      path: e.path,
      parent: e.parent
    };
  }
  _processInputParams(e) {
    return {
      status: new Ft(),
      ctx: {
        common: e.parent.common,
        data: e.data,
        parsedType: as(e.data),
        schemaErrorMap: this._def.errorMap,
        path: e.path,
        parent: e.parent
      }
    };
  }
  _parseSync(e) {
    const r = this._parse(e);
    if (Yi(r))
      throw new Error("Synchronous parse encountered promise.");
    return r;
  }
  _parseAsync(e) {
    const r = this._parse(e);
    return Promise.resolve(r);
  }
  parse(e, r) {
    const s = this.safeParse(e, r);
    if (s.success)
      return s.data;
    throw s.error;
  }
  safeParse(e, r) {
    var s;
    const n = {
      common: {
        issues: [],
        async: (s = r == null ? void 0 : r.async) !== null && s !== void 0 ? s : !1,
        contextualErrorMap: r == null ? void 0 : r.errorMap
      },
      path: (r == null ? void 0 : r.path) || [],
      schemaErrorMap: this._def.errorMap,
      parent: null,
      data: e,
      parsedType: as(e)
    }, i = this._parseSync({ data: e, path: n.path, parent: n });
    return al(n, i);
  }
  async parseAsync(e, r) {
    const s = await this.safeParseAsync(e, r);
    if (s.success)
      return s.data;
    throw s.error;
  }
  async safeParseAsync(e, r) {
    const s = {
      common: {
        issues: [],
        contextualErrorMap: r == null ? void 0 : r.errorMap,
        async: !0
      },
      path: (r == null ? void 0 : r.path) || [],
      schemaErrorMap: this._def.errorMap,
      parent: null,
      data: e,
      parsedType: as(e)
    }, n = this._parse({ data: e, path: s.path, parent: s }), i = await (Yi(n) ? n : Promise.resolve(n));
    return al(s, i);
  }
  refine(e, r) {
    const s = (n) => typeof r == "string" || typeof r > "u" ? { message: r } : typeof r == "function" ? r(n) : r;
    return this._refinement((n, i) => {
      const o = e(n), a = () => i.addIssue({
        code: K.custom,
        ...s(n)
      });
      return typeof Promise < "u" && o instanceof Promise ? o.then((u) => u ? !0 : (a(), !1)) : o ? !0 : (a(), !1);
    });
  }
  refinement(e, r) {
    return this._refinement((s, n) => e(s) ? !0 : (n.addIssue(typeof r == "function" ? r(s, n) : r), !1));
  }
  _refinement(e) {
    return new Or({
      schema: this,
      typeName: fe.ZodEffects,
      effect: { type: "refinement", refinement: e }
    });
  }
  superRefine(e) {
    return this._refinement(e);
  }
  optional() {
    return Gr.create(this, this._def);
  }
  nullable() {
    return Rs.create(this, this._def);
  }
  nullish() {
    return this.nullable().optional();
  }
  array() {
    return Er.create(this, this._def);
  }
  promise() {
    return an.create(this, this._def);
  }
  or(e) {
    return zn.create([this, e], this._def);
  }
  and(e) {
    return $n.create(this, e, this._def);
  }
  transform(e) {
    return new Or({
      ...Se(this._def),
      schema: this,
      typeName: fe.ZodEffects,
      effect: { type: "transform", transform: e }
    });
  }
  default(e) {
    const r = typeof e == "function" ? e : () => e;
    return new Wn({
      ...Se(this._def),
      innerType: this,
      defaultValue: r,
      typeName: fe.ZodDefault
    });
  }
  brand() {
    return new Yd({
      typeName: fe.ZodBranded,
      type: this,
      ...Se(this._def)
    });
  }
  catch(e) {
    const r = typeof e == "function" ? e : () => e;
    return new ea({
      ...Se(this._def),
      innerType: this,
      catchValue: r,
      typeName: fe.ZodCatch
    });
  }
  describe(e) {
    const r = this.constructor;
    return new r({
      ...this._def,
      description: e
    });
  }
  pipe(e) {
    return fi.create(this, e);
  }
  isOptional() {
    return this.safeParse(void 0).success;
  }
  isNullable() {
    return this.safeParse(null).success;
  }
}
const Aw = /^c[^\s-]{8,}$/i, jw = /^[a-z][a-z0-9]*$/, Lw = /[0-9A-HJKMNP-TV-Z]{26}/, Mw = /^([a-f0-9]{8}-[a-f0-9]{4}-[1-5][a-f0-9]{3}-[a-f0-9]{4}-[a-f0-9]{12}|00000000-0000-0000-0000-000000000000)$/i, Dw = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[(((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2}))\.){3}((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2}))\])|(\[IPv6:(([a-f0-9]{1,4}:){7}|::([a-f0-9]{1,4}:){0,6}|([a-f0-9]{1,4}:){1}:([a-f0-9]{1,4}:){0,5}|([a-f0-9]{1,4}:){2}:([a-f0-9]{1,4}:){0,4}|([a-f0-9]{1,4}:){3}:([a-f0-9]{1,4}:){0,3}|([a-f0-9]{1,4}:){4}:([a-f0-9]{1,4}:){0,2}|([a-f0-9]{1,4}:){5}:([a-f0-9]{1,4}:){0,1})([a-f0-9]{1,4}|(((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2}))\.){3}((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2})))\])|([A-Za-z0-9]([A-Za-z0-9-]*[A-Za-z0-9])*(\.[A-Za-z]{2,})+))$/, Uw = new RegExp("^(\\p{Extended_Pictographic}|\\p{Emoji_Component})+$", "u"), zw = /^(((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2}))\.){3}((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2}))$/, $w = /^(([a-f0-9]{1,4}:){7}|::([a-f0-9]{1,4}:){0,6}|([a-f0-9]{1,4}:){1}:([a-f0-9]{1,4}:){0,5}|([a-f0-9]{1,4}:){2}:([a-f0-9]{1,4}:){0,4}|([a-f0-9]{1,4}:){3}:([a-f0-9]{1,4}:){0,3}|([a-f0-9]{1,4}:){4}:([a-f0-9]{1,4}:){0,2}|([a-f0-9]{1,4}:){5}:([a-f0-9]{1,4}:){0,1})([a-f0-9]{1,4}|(((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2}))\.){3}((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2})))$/, Vw = (t) => t.precision ? t.offset ? new RegExp(`^\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}\\.\\d{${t.precision}}(([+-]\\d{2}(:?\\d{2})?)|Z)$`) : new RegExp(`^\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}\\.\\d{${t.precision}}Z$`) : t.precision === 0 ? t.offset ? new RegExp("^\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(([+-]\\d{2}(:?\\d{2})?)|Z)$") : new RegExp("^\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}Z$") : t.offset ? new RegExp("^\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(\\.\\d+)?(([+-]\\d{2}(:?\\d{2})?)|Z)$") : new RegExp("^\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(\\.\\d+)?Z$");
function qw(t, e) {
  return !!((e === "v4" || !e) && zw.test(t) || (e === "v6" || !e) && $w.test(t));
}
class _r extends ke {
  constructor() {
    super(...arguments), this._regex = (e, r, s) => this.refinement((n) => e.test(n), {
      validation: r,
      code: K.invalid_string,
      ...ce.errToObj(s)
    }), this.nonempty = (e) => this.min(1, ce.errToObj(e)), this.trim = () => new _r({
      ...this._def,
      checks: [...this._def.checks, { kind: "trim" }]
    }), this.toLowerCase = () => new _r({
      ...this._def,
      checks: [...this._def.checks, { kind: "toLowerCase" }]
    }), this.toUpperCase = () => new _r({
      ...this._def,
      checks: [...this._def.checks, { kind: "toUpperCase" }]
    });
  }
  _parse(e) {
    if (this._def.coerce && (e.data = String(e.data)), this._getType(e) !== te.string) {
      const n = this._getOrReturnCtx(e);
      return ne(
        n,
        {
          code: K.invalid_type,
          expected: te.string,
          received: n.parsedType
        }
        //
      ), be;
    }
    const r = new Ft();
    let s;
    for (const n of this._def.checks)
      if (n.kind === "min")
        e.data.length < n.value && (s = this._getOrReturnCtx(e, s), ne(s, {
          code: K.too_small,
          minimum: n.value,
          type: "string",
          inclusive: !0,
          exact: !1,
          message: n.message
        }), r.dirty());
      else if (n.kind === "max")
        e.data.length > n.value && (s = this._getOrReturnCtx(e, s), ne(s, {
          code: K.too_big,
          maximum: n.value,
          type: "string",
          inclusive: !0,
          exact: !1,
          message: n.message
        }), r.dirty());
      else if (n.kind === "length") {
        const i = e.data.length > n.value, o = e.data.length < n.value;
        (i || o) && (s = this._getOrReturnCtx(e, s), i ? ne(s, {
          code: K.too_big,
          maximum: n.value,
          type: "string",
          inclusive: !0,
          exact: !0,
          message: n.message
        }) : o && ne(s, {
          code: K.too_small,
          minimum: n.value,
          type: "string",
          inclusive: !0,
          exact: !0,
          message: n.message
        }), r.dirty());
      } else if (n.kind === "email")
        Dw.test(e.data) || (s = this._getOrReturnCtx(e, s), ne(s, {
          validation: "email",
          code: K.invalid_string,
          message: n.message
        }), r.dirty());
      else if (n.kind === "emoji")
        Uw.test(e.data) || (s = this._getOrReturnCtx(e, s), ne(s, {
          validation: "emoji",
          code: K.invalid_string,
          message: n.message
        }), r.dirty());
      else if (n.kind === "uuid")
        Mw.test(e.data) || (s = this._getOrReturnCtx(e, s), ne(s, {
          validation: "uuid",
          code: K.invalid_string,
          message: n.message
        }), r.dirty());
      else if (n.kind === "cuid")
        Aw.test(e.data) || (s = this._getOrReturnCtx(e, s), ne(s, {
          validation: "cuid",
          code: K.invalid_string,
          message: n.message
        }), r.dirty());
      else if (n.kind === "cuid2")
        jw.test(e.data) || (s = this._getOrReturnCtx(e, s), ne(s, {
          validation: "cuid2",
          code: K.invalid_string,
          message: n.message
        }), r.dirty());
      else if (n.kind === "ulid")
        Lw.test(e.data) || (s = this._getOrReturnCtx(e, s), ne(s, {
          validation: "ulid",
          code: K.invalid_string,
          message: n.message
        }), r.dirty());
      else if (n.kind === "url")
        try {
          new URL(e.data);
        } catch {
          s = this._getOrReturnCtx(e, s), ne(s, {
            validation: "url",
            code: K.invalid_string,
            message: n.message
          }), r.dirty();
        }
      else
        n.kind === "regex" ? (n.regex.lastIndex = 0, n.regex.test(e.data) || (s = this._getOrReturnCtx(e, s), ne(s, {
          validation: "regex",
          code: K.invalid_string,
          message: n.message
        }), r.dirty())) : n.kind === "trim" ? e.data = e.data.trim() : n.kind === "includes" ? e.data.includes(n.value, n.position) || (s = this._getOrReturnCtx(e, s), ne(s, {
          code: K.invalid_string,
          validation: { includes: n.value, position: n.position },
          message: n.message
        }), r.dirty()) : n.kind === "toLowerCase" ? e.data = e.data.toLowerCase() : n.kind === "toUpperCase" ? e.data = e.data.toUpperCase() : n.kind === "startsWith" ? e.data.startsWith(n.value) || (s = this._getOrReturnCtx(e, s), ne(s, {
          code: K.invalid_string,
          validation: { startsWith: n.value },
          message: n.message
        }), r.dirty()) : n.kind === "endsWith" ? e.data.endsWith(n.value) || (s = this._getOrReturnCtx(e, s), ne(s, {
          code: K.invalid_string,
          validation: { endsWith: n.value },
          message: n.message
        }), r.dirty()) : n.kind === "datetime" ? Vw(n).test(e.data) || (s = this._getOrReturnCtx(e, s), ne(s, {
          code: K.invalid_string,
          validation: "datetime",
          message: n.message
        }), r.dirty()) : n.kind === "ip" ? qw(e.data, n.version) || (s = this._getOrReturnCtx(e, s), ne(s, {
          validation: "ip",
          code: K.invalid_string,
          message: n.message
        }), r.dirty()) : Ge.assertNever(n);
    return { status: r.value, value: e.data };
  }
  _addCheck(e) {
    return new _r({
      ...this._def,
      checks: [...this._def.checks, e]
    });
  }
  email(e) {
    return this._addCheck({ kind: "email", ...ce.errToObj(e) });
  }
  url(e) {
    return this._addCheck({ kind: "url", ...ce.errToObj(e) });
  }
  emoji(e) {
    return this._addCheck({ kind: "emoji", ...ce.errToObj(e) });
  }
  uuid(e) {
    return this._addCheck({ kind: "uuid", ...ce.errToObj(e) });
  }
  cuid(e) {
    return this._addCheck({ kind: "cuid", ...ce.errToObj(e) });
  }
  cuid2(e) {
    return this._addCheck({ kind: "cuid2", ...ce.errToObj(e) });
  }
  ulid(e) {
    return this._addCheck({ kind: "ulid", ...ce.errToObj(e) });
  }
  ip(e) {
    return this._addCheck({ kind: "ip", ...ce.errToObj(e) });
  }
  datetime(e) {
    var r;
    return typeof e == "string" ? this._addCheck({
      kind: "datetime",
      precision: null,
      offset: !1,
      message: e
    }) : this._addCheck({
      kind: "datetime",
      precision: typeof (e == null ? void 0 : e.precision) > "u" ? null : e == null ? void 0 : e.precision,
      offset: (r = e == null ? void 0 : e.offset) !== null && r !== void 0 ? r : !1,
      ...ce.errToObj(e == null ? void 0 : e.message)
    });
  }
  regex(e, r) {
    return this._addCheck({
      kind: "regex",
      regex: e,
      ...ce.errToObj(r)
    });
  }
  includes(e, r) {
    return this._addCheck({
      kind: "includes",
      value: e,
      position: r == null ? void 0 : r.position,
      ...ce.errToObj(r == null ? void 0 : r.message)
    });
  }
  startsWith(e, r) {
    return this._addCheck({
      kind: "startsWith",
      value: e,
      ...ce.errToObj(r)
    });
  }
  endsWith(e, r) {
    return this._addCheck({
      kind: "endsWith",
      value: e,
      ...ce.errToObj(r)
    });
  }
  min(e, r) {
    return this._addCheck({
      kind: "min",
      value: e,
      ...ce.errToObj(r)
    });
  }
  max(e, r) {
    return this._addCheck({
      kind: "max",
      value: e,
      ...ce.errToObj(r)
    });
  }
  length(e, r) {
    return this._addCheck({
      kind: "length",
      value: e,
      ...ce.errToObj(r)
    });
  }
  get isDatetime() {
    return !!this._def.checks.find((e) => e.kind === "datetime");
  }
  get isEmail() {
    return !!this._def.checks.find((e) => e.kind === "email");
  }
  get isURL() {
    return !!this._def.checks.find((e) => e.kind === "url");
  }
  get isEmoji() {
    return !!this._def.checks.find((e) => e.kind === "emoji");
  }
  get isUUID() {
    return !!this._def.checks.find((e) => e.kind === "uuid");
  }
  get isCUID() {
    return !!this._def.checks.find((e) => e.kind === "cuid");
  }
  get isCUID2() {
    return !!this._def.checks.find((e) => e.kind === "cuid2");
  }
  get isULID() {
    return !!this._def.checks.find((e) => e.kind === "ulid");
  }
  get isIP() {
    return !!this._def.checks.find((e) => e.kind === "ip");
  }
  get minLength() {
    let e = null;
    for (const r of this._def.checks)
      r.kind === "min" && (e === null || r.value > e) && (e = r.value);
    return e;
  }
  get maxLength() {
    let e = null;
    for (const r of this._def.checks)
      r.kind === "max" && (e === null || r.value < e) && (e = r.value);
    return e;
  }
}
_r.create = (t) => {
  var e;
  return new _r({
    checks: [],
    typeName: fe.ZodString,
    coerce: (e = t == null ? void 0 : t.coerce) !== null && e !== void 0 ? e : !1,
    ...Se(t)
  });
};
function Zw(t, e) {
  const r = (t.toString().split(".")[1] || "").length, s = (e.toString().split(".")[1] || "").length, n = r > s ? r : s, i = parseInt(t.toFixed(n).replace(".", "")), o = parseInt(e.toFixed(n).replace(".", ""));
  return i % o / Math.pow(10, n);
}
class ds extends ke {
  constructor() {
    super(...arguments), this.min = this.gte, this.max = this.lte, this.step = this.multipleOf;
  }
  _parse(e) {
    if (this._def.coerce && (e.data = Number(e.data)), this._getType(e) !== te.number) {
      const n = this._getOrReturnCtx(e);
      return ne(n, {
        code: K.invalid_type,
        expected: te.number,
        received: n.parsedType
      }), be;
    }
    let r;
    const s = new Ft();
    for (const n of this._def.checks)
      n.kind === "int" ? Ge.isInteger(e.data) || (r = this._getOrReturnCtx(e, r), ne(r, {
        code: K.invalid_type,
        expected: "integer",
        received: "float",
        message: n.message
      }), s.dirty()) : n.kind === "min" ? (n.inclusive ? e.data < n.value : e.data <= n.value) && (r = this._getOrReturnCtx(e, r), ne(r, {
        code: K.too_small,
        minimum: n.value,
        type: "number",
        inclusive: n.inclusive,
        exact: !1,
        message: n.message
      }), s.dirty()) : n.kind === "max" ? (n.inclusive ? e.data > n.value : e.data >= n.value) && (r = this._getOrReturnCtx(e, r), ne(r, {
        code: K.too_big,
        maximum: n.value,
        type: "number",
        inclusive: n.inclusive,
        exact: !1,
        message: n.message
      }), s.dirty()) : n.kind === "multipleOf" ? Zw(e.data, n.value) !== 0 && (r = this._getOrReturnCtx(e, r), ne(r, {
        code: K.not_multiple_of,
        multipleOf: n.value,
        message: n.message
      }), s.dirty()) : n.kind === "finite" ? Number.isFinite(e.data) || (r = this._getOrReturnCtx(e, r), ne(r, {
        code: K.not_finite,
        message: n.message
      }), s.dirty()) : Ge.assertNever(n);
    return { status: s.value, value: e.data };
  }
  gte(e, r) {
    return this.setLimit("min", e, !0, ce.toString(r));
  }
  gt(e, r) {
    return this.setLimit("min", e, !1, ce.toString(r));
  }
  lte(e, r) {
    return this.setLimit("max", e, !0, ce.toString(r));
  }
  lt(e, r) {
    return this.setLimit("max", e, !1, ce.toString(r));
  }
  setLimit(e, r, s, n) {
    return new ds({
      ...this._def,
      checks: [
        ...this._def.checks,
        {
          kind: e,
          value: r,
          inclusive: s,
          message: ce.toString(n)
        }
      ]
    });
  }
  _addCheck(e) {
    return new ds({
      ...this._def,
      checks: [...this._def.checks, e]
    });
  }
  int(e) {
    return this._addCheck({
      kind: "int",
      message: ce.toString(e)
    });
  }
  positive(e) {
    return this._addCheck({
      kind: "min",
      value: 0,
      inclusive: !1,
      message: ce.toString(e)
    });
  }
  negative(e) {
    return this._addCheck({
      kind: "max",
      value: 0,
      inclusive: !1,
      message: ce.toString(e)
    });
  }
  nonpositive(e) {
    return this._addCheck({
      kind: "max",
      value: 0,
      inclusive: !0,
      message: ce.toString(e)
    });
  }
  nonnegative(e) {
    return this._addCheck({
      kind: "min",
      value: 0,
      inclusive: !0,
      message: ce.toString(e)
    });
  }
  multipleOf(e, r) {
    return this._addCheck({
      kind: "multipleOf",
      value: e,
      message: ce.toString(r)
    });
  }
  finite(e) {
    return this._addCheck({
      kind: "finite",
      message: ce.toString(e)
    });
  }
  safe(e) {
    return this._addCheck({
      kind: "min",
      inclusive: !0,
      value: Number.MIN_SAFE_INTEGER,
      message: ce.toString(e)
    })._addCheck({
      kind: "max",
      inclusive: !0,
      value: Number.MAX_SAFE_INTEGER,
      message: ce.toString(e)
    });
  }
  get minValue() {
    let e = null;
    for (const r of this._def.checks)
      r.kind === "min" && (e === null || r.value > e) && (e = r.value);
    return e;
  }
  get maxValue() {
    let e = null;
    for (const r of this._def.checks)
      r.kind === "max" && (e === null || r.value < e) && (e = r.value);
    return e;
  }
  get isInt() {
    return !!this._def.checks.find((e) => e.kind === "int" || e.kind === "multipleOf" && Ge.isInteger(e.value));
  }
  get isFinite() {
    let e = null, r = null;
    for (const s of this._def.checks) {
      if (s.kind === "finite" || s.kind === "int" || s.kind === "multipleOf")
        return !0;
      s.kind === "min" ? (r === null || s.value > r) && (r = s.value) : s.kind === "max" && (e === null || s.value < e) && (e = s.value);
    }
    return Number.isFinite(r) && Number.isFinite(e);
  }
}
ds.create = (t) => new ds({
  checks: [],
  typeName: fe.ZodNumber,
  coerce: (t == null ? void 0 : t.coerce) || !1,
  ...Se(t)
});
class hs extends ke {
  constructor() {
    super(...arguments), this.min = this.gte, this.max = this.lte;
  }
  _parse(e) {
    if (this._def.coerce && (e.data = BigInt(e.data)), this._getType(e) !== te.bigint) {
      const n = this._getOrReturnCtx(e);
      return ne(n, {
        code: K.invalid_type,
        expected: te.bigint,
        received: n.parsedType
      }), be;
    }
    let r;
    const s = new Ft();
    for (const n of this._def.checks)
      n.kind === "min" ? (n.inclusive ? e.data < n.value : e.data <= n.value) && (r = this._getOrReturnCtx(e, r), ne(r, {
        code: K.too_small,
        type: "bigint",
        minimum: n.value,
        inclusive: n.inclusive,
        message: n.message
      }), s.dirty()) : n.kind === "max" ? (n.inclusive ? e.data > n.value : e.data >= n.value) && (r = this._getOrReturnCtx(e, r), ne(r, {
        code: K.too_big,
        type: "bigint",
        maximum: n.value,
        inclusive: n.inclusive,
        message: n.message
      }), s.dirty()) : n.kind === "multipleOf" ? e.data % n.value !== BigInt(0) && (r = this._getOrReturnCtx(e, r), ne(r, {
        code: K.not_multiple_of,
        multipleOf: n.value,
        message: n.message
      }), s.dirty()) : Ge.assertNever(n);
    return { status: s.value, value: e.data };
  }
  gte(e, r) {
    return this.setLimit("min", e, !0, ce.toString(r));
  }
  gt(e, r) {
    return this.setLimit("min", e, !1, ce.toString(r));
  }
  lte(e, r) {
    return this.setLimit("max", e, !0, ce.toString(r));
  }
  lt(e, r) {
    return this.setLimit("max", e, !1, ce.toString(r));
  }
  setLimit(e, r, s, n) {
    return new hs({
      ...this._def,
      checks: [
        ...this._def.checks,
        {
          kind: e,
          value: r,
          inclusive: s,
          message: ce.toString(n)
        }
      ]
    });
  }
  _addCheck(e) {
    return new hs({
      ...this._def,
      checks: [...this._def.checks, e]
    });
  }
  positive(e) {
    return this._addCheck({
      kind: "min",
      value: BigInt(0),
      inclusive: !1,
      message: ce.toString(e)
    });
  }
  negative(e) {
    return this._addCheck({
      kind: "max",
      value: BigInt(0),
      inclusive: !1,
      message: ce.toString(e)
    });
  }
  nonpositive(e) {
    return this._addCheck({
      kind: "max",
      value: BigInt(0),
      inclusive: !0,
      message: ce.toString(e)
    });
  }
  nonnegative(e) {
    return this._addCheck({
      kind: "min",
      value: BigInt(0),
      inclusive: !0,
      message: ce.toString(e)
    });
  }
  multipleOf(e, r) {
    return this._addCheck({
      kind: "multipleOf",
      value: e,
      message: ce.toString(r)
    });
  }
  get minValue() {
    let e = null;
    for (const r of this._def.checks)
      r.kind === "min" && (e === null || r.value > e) && (e = r.value);
    return e;
  }
  get maxValue() {
    let e = null;
    for (const r of this._def.checks)
      r.kind === "max" && (e === null || r.value < e) && (e = r.value);
    return e;
  }
}
hs.create = (t) => {
  var e;
  return new hs({
    checks: [],
    typeName: fe.ZodBigInt,
    coerce: (e = t == null ? void 0 : t.coerce) !== null && e !== void 0 ? e : !1,
    ...Se(t)
  });
};
class Mn extends ke {
  _parse(e) {
    if (this._def.coerce && (e.data = !!e.data), this._getType(e) !== te.boolean) {
      const r = this._getOrReturnCtx(e);
      return ne(r, {
        code: K.invalid_type,
        expected: te.boolean,
        received: r.parsedType
      }), be;
    }
    return Xt(e.data);
  }
}
Mn.create = (t) => new Mn({
  typeName: fe.ZodBoolean,
  coerce: (t == null ? void 0 : t.coerce) || !1,
  ...Se(t)
});
class Ns extends ke {
  _parse(e) {
    if (this._def.coerce && (e.data = new Date(e.data)), this._getType(e) !== te.date) {
      const n = this._getOrReturnCtx(e);
      return ne(n, {
        code: K.invalid_type,
        expected: te.date,
        received: n.parsedType
      }), be;
    }
    if (isNaN(e.data.getTime())) {
      const n = this._getOrReturnCtx(e);
      return ne(n, {
        code: K.invalid_date
      }), be;
    }
    const r = new Ft();
    let s;
    for (const n of this._def.checks)
      n.kind === "min" ? e.data.getTime() < n.value && (s = this._getOrReturnCtx(e, s), ne(s, {
        code: K.too_small,
        message: n.message,
        inclusive: !0,
        exact: !1,
        minimum: n.value,
        type: "date"
      }), r.dirty()) : n.kind === "max" ? e.data.getTime() > n.value && (s = this._getOrReturnCtx(e, s), ne(s, {
        code: K.too_big,
        message: n.message,
        inclusive: !0,
        exact: !1,
        maximum: n.value,
        type: "date"
      }), r.dirty()) : Ge.assertNever(n);
    return {
      status: r.value,
      value: new Date(e.data.getTime())
    };
  }
  _addCheck(e) {
    return new Ns({
      ...this._def,
      checks: [...this._def.checks, e]
    });
  }
  min(e, r) {
    return this._addCheck({
      kind: "min",
      value: e.getTime(),
      message: ce.toString(r)
    });
  }
  max(e, r) {
    return this._addCheck({
      kind: "max",
      value: e.getTime(),
      message: ce.toString(r)
    });
  }
  get minDate() {
    let e = null;
    for (const r of this._def.checks)
      r.kind === "min" && (e === null || r.value > e) && (e = r.value);
    return e != null ? new Date(e) : null;
  }
  get maxDate() {
    let e = null;
    for (const r of this._def.checks)
      r.kind === "max" && (e === null || r.value < e) && (e = r.value);
    return e != null ? new Date(e) : null;
  }
}
Ns.create = (t) => new Ns({
  checks: [],
  coerce: (t == null ? void 0 : t.coerce) || !1,
  typeName: fe.ZodDate,
  ...Se(t)
});
class Ji extends ke {
  _parse(e) {
    if (this._getType(e) !== te.symbol) {
      const r = this._getOrReturnCtx(e);
      return ne(r, {
        code: K.invalid_type,
        expected: te.symbol,
        received: r.parsedType
      }), be;
    }
    return Xt(e.data);
  }
}
Ji.create = (t) => new Ji({
  typeName: fe.ZodSymbol,
  ...Se(t)
});
class Dn extends ke {
  _parse(e) {
    if (this._getType(e) !== te.undefined) {
      const r = this._getOrReturnCtx(e);
      return ne(r, {
        code: K.invalid_type,
        expected: te.undefined,
        received: r.parsedType
      }), be;
    }
    return Xt(e.data);
  }
}
Dn.create = (t) => new Dn({
  typeName: fe.ZodUndefined,
  ...Se(t)
});
class Un extends ke {
  _parse(e) {
    if (this._getType(e) !== te.null) {
      const r = this._getOrReturnCtx(e);
      return ne(r, {
        code: K.invalid_type,
        expected: te.null,
        received: r.parsedType
      }), be;
    }
    return Xt(e.data);
  }
}
Un.create = (t) => new Un({
  typeName: fe.ZodNull,
  ...Se(t)
});
class nn extends ke {
  constructor() {
    super(...arguments), this._any = !0;
  }
  _parse(e) {
    return Xt(e.data);
  }
}
nn.create = (t) => new nn({
  typeName: fe.ZodAny,
  ...Se(t)
});
class Ps extends ke {
  constructor() {
    super(...arguments), this._unknown = !0;
  }
  _parse(e) {
    return Xt(e.data);
  }
}
Ps.create = (t) => new Ps({
  typeName: fe.ZodUnknown,
  ...Se(t)
});
class Jr extends ke {
  _parse(e) {
    const r = this._getOrReturnCtx(e);
    return ne(r, {
      code: K.invalid_type,
      expected: te.never,
      received: r.parsedType
    }), be;
  }
}
Jr.create = (t) => new Jr({
  typeName: fe.ZodNever,
  ...Se(t)
});
class Xi extends ke {
  _parse(e) {
    if (this._getType(e) !== te.undefined) {
      const r = this._getOrReturnCtx(e);
      return ne(r, {
        code: K.invalid_type,
        expected: te.void,
        received: r.parsedType
      }), be;
    }
    return Xt(e.data);
  }
}
Xi.create = (t) => new Xi({
  typeName: fe.ZodVoid,
  ...Se(t)
});
class Er extends ke {
  _parse(e) {
    const { ctx: r, status: s } = this._processInputParams(e), n = this._def;
    if (r.parsedType !== te.array)
      return ne(r, {
        code: K.invalid_type,
        expected: te.array,
        received: r.parsedType
      }), be;
    if (n.exactLength !== null) {
      const o = r.data.length > n.exactLength.value, a = r.data.length < n.exactLength.value;
      (o || a) && (ne(r, {
        code: o ? K.too_big : K.too_small,
        minimum: a ? n.exactLength.value : void 0,
        maximum: o ? n.exactLength.value : void 0,
        type: "array",
        inclusive: !0,
        exact: !0,
        message: n.exactLength.message
      }), s.dirty());
    }
    if (n.minLength !== null && r.data.length < n.minLength.value && (ne(r, {
      code: K.too_small,
      minimum: n.minLength.value,
      type: "array",
      inclusive: !0,
      exact: !1,
      message: n.minLength.message
    }), s.dirty()), n.maxLength !== null && r.data.length > n.maxLength.value && (ne(r, {
      code: K.too_big,
      maximum: n.maxLength.value,
      type: "array",
      inclusive: !0,
      exact: !1,
      message: n.maxLength.message
    }), s.dirty()), r.common.async)
      return Promise.all([...r.data].map((o, a) => n.type._parseAsync(new Dr(r, o, r.path, a)))).then((o) => Ft.mergeArray(s, o));
    const i = [...r.data].map((o, a) => n.type._parseSync(new Dr(r, o, r.path, a)));
    return Ft.mergeArray(s, i);
  }
  get element() {
    return this._def.type;
  }
  min(e, r) {
    return new Er({
      ...this._def,
      minLength: { value: e, message: ce.toString(r) }
    });
  }
  max(e, r) {
    return new Er({
      ...this._def,
      maxLength: { value: e, message: ce.toString(r) }
    });
  }
  length(e, r) {
    return new Er({
      ...this._def,
      exactLength: { value: e, message: ce.toString(r) }
    });
  }
  nonempty(e) {
    return this.min(1, e);
  }
}
Er.create = (t, e) => new Er({
  type: t,
  minLength: null,
  maxLength: null,
  exactLength: null,
  typeName: fe.ZodArray,
  ...Se(e)
});
function Gs(t) {
  if (t instanceof lt) {
    const e = {};
    for (const r in t.shape) {
      const s = t.shape[r];
      e[r] = Gr.create(Gs(s));
    }
    return new lt({
      ...t._def,
      shape: () => e
    });
  } else
    return t instanceof Er ? new Er({
      ...t._def,
      type: Gs(t.element)
    }) : t instanceof Gr ? Gr.create(Gs(t.unwrap())) : t instanceof Rs ? Rs.create(Gs(t.unwrap())) : t instanceof Ur ? Ur.create(t.items.map((e) => Gs(e))) : t;
}
class lt extends ke {
  constructor() {
    super(...arguments), this._cached = null, this.nonstrict = this.passthrough, this.augment = this.extend;
  }
  _getCached() {
    if (this._cached !== null)
      return this._cached;
    const e = this._def.shape(), r = Ge.objectKeys(e);
    return this._cached = { shape: e, keys: r };
  }
  _parse(e) {
    if (this._getType(e) !== te.object) {
      const u = this._getOrReturnCtx(e);
      return ne(u, {
        code: K.invalid_type,
        expected: te.object,
        received: u.parsedType
      }), be;
    }
    const { status: r, ctx: s } = this._processInputParams(e), { shape: n, keys: i } = this._getCached(), o = [];
    if (!(this._def.catchall instanceof Jr && this._def.unknownKeys === "strip"))
      for (const u in s.data)
        i.includes(u) || o.push(u);
    const a = [];
    for (const u of i) {
      const c = n[u], h = s.data[u];
      a.push({
        key: { status: "valid", value: u },
        value: c._parse(new Dr(s, h, s.path, u)),
        alwaysSet: u in s.data
      });
    }
    if (this._def.catchall instanceof Jr) {
      const u = this._def.unknownKeys;
      if (u === "passthrough")
        for (const c of o)
          a.push({
            key: { status: "valid", value: c },
            value: { status: "valid", value: s.data[c] }
          });
      else if (u === "strict")
        o.length > 0 && (ne(s, {
          code: K.unrecognized_keys,
          keys: o
        }), r.dirty());
      else if (u !== "strip")
        throw new Error("Internal ZodObject error: invalid unknownKeys value.");
    } else {
      const u = this._def.catchall;
      for (const c of o) {
        const h = s.data[c];
        a.push({
          key: { status: "valid", value: c },
          value: u._parse(
            new Dr(s, h, s.path, c)
            //, ctx.child(key), value, getParsedType(value)
          ),
          alwaysSet: c in s.data
        });
      }
    }
    return s.common.async ? Promise.resolve().then(async () => {
      const u = [];
      for (const c of a) {
        const h = await c.key;
        u.push({
          key: h,
          value: await c.value,
          alwaysSet: c.alwaysSet
        });
      }
      return u;
    }).then((u) => Ft.mergeObjectSync(r, u)) : Ft.mergeObjectSync(r, a);
  }
  get shape() {
    return this._def.shape();
  }
  strict(e) {
    return ce.errToObj, new lt({
      ...this._def,
      unknownKeys: "strict",
      ...e !== void 0 ? {
        errorMap: (r, s) => {
          var n, i, o, a;
          const u = (o = (i = (n = this._def).errorMap) === null || i === void 0 ? void 0 : i.call(n, r, s).message) !== null && o !== void 0 ? o : s.defaultError;
          return r.code === "unrecognized_keys" ? {
            message: (a = ce.errToObj(e).message) !== null && a !== void 0 ? a : u
          } : {
            message: u
          };
        }
      } : {}
    });
  }
  strip() {
    return new lt({
      ...this._def,
      unknownKeys: "strip"
    });
  }
  passthrough() {
    return new lt({
      ...this._def,
      unknownKeys: "passthrough"
    });
  }
  // const AugmentFactory =
  //   <Def extends ZodObjectDef>(def: Def) =>
  //   <Augmentation extends ZodRawShape>(
  //     augmentation: Augmentation
  //   ): ZodObject<
  //     extendShape<ReturnType<Def["shape"]>, Augmentation>,
  //     Def["unknownKeys"],
  //     Def["catchall"]
  //   > => {
  //     return new ZodObject({
  //       ...def,
  //       shape: () => ({
  //         ...def.shape(),
  //         ...augmentation,
  //       }),
  //     }) as any;
  //   };
  extend(e) {
    return new lt({
      ...this._def,
      shape: () => ({
        ...this._def.shape(),
        ...e
      })
    });
  }
  /**
   * Prior to zod@1.0.12 there was a bug in the
   * inferred type of merged objects. Please
   * upgrade if you are experiencing issues.
   */
  merge(e) {
    return new lt({
      unknownKeys: e._def.unknownKeys,
      catchall: e._def.catchall,
      shape: () => ({
        ...this._def.shape(),
        ...e._def.shape()
      }),
      typeName: fe.ZodObject
    });
  }
  // merge<
  //   Incoming extends AnyZodObject,
  //   Augmentation extends Incoming["shape"],
  //   NewOutput extends {
  //     [k in keyof Augmentation | keyof Output]: k extends keyof Augmentation
  //       ? Augmentation[k]["_output"]
  //       : k extends keyof Output
  //       ? Output[k]
  //       : never;
  //   },
  //   NewInput extends {
  //     [k in keyof Augmentation | keyof Input]: k extends keyof Augmentation
  //       ? Augmentation[k]["_input"]
  //       : k extends keyof Input
  //       ? Input[k]
  //       : never;
  //   }
  // >(
  //   merging: Incoming
  // ): ZodObject<
  //   extendShape<T, ReturnType<Incoming["_def"]["shape"]>>,
  //   Incoming["_def"]["unknownKeys"],
  //   Incoming["_def"]["catchall"],
  //   NewOutput,
  //   NewInput
  // > {
  //   const merged: any = new ZodObject({
  //     unknownKeys: merging._def.unknownKeys,
  //     catchall: merging._def.catchall,
  //     shape: () =>
  //       objectUtil.mergeShapes(this._def.shape(), merging._def.shape()),
  //     typeName: ZodFirstPartyTypeKind.ZodObject,
  //   }) as any;
  //   return merged;
  // }
  setKey(e, r) {
    return this.augment({ [e]: r });
  }
  // merge<Incoming extends AnyZodObject>(
  //   merging: Incoming
  // ): //ZodObject<T & Incoming["_shape"], UnknownKeys, Catchall> = (merging) => {
  // ZodObject<
  //   extendShape<T, ReturnType<Incoming["_def"]["shape"]>>,
  //   Incoming["_def"]["unknownKeys"],
  //   Incoming["_def"]["catchall"]
  // > {
  //   // const mergedShape = objectUtil.mergeShapes(
  //   //   this._def.shape(),
  //   //   merging._def.shape()
  //   // );
  //   const merged: any = new ZodObject({
  //     unknownKeys: merging._def.unknownKeys,
  //     catchall: merging._def.catchall,
  //     shape: () =>
  //       objectUtil.mergeShapes(this._def.shape(), merging._def.shape()),
  //     typeName: ZodFirstPartyTypeKind.ZodObject,
  //   }) as any;
  //   return merged;
  // }
  catchall(e) {
    return new lt({
      ...this._def,
      catchall: e
    });
  }
  pick(e) {
    const r = {};
    return Ge.objectKeys(e).forEach((s) => {
      e[s] && this.shape[s] && (r[s] = this.shape[s]);
    }), new lt({
      ...this._def,
      shape: () => r
    });
  }
  omit(e) {
    const r = {};
    return Ge.objectKeys(this.shape).forEach((s) => {
      e[s] || (r[s] = this.shape[s]);
    }), new lt({
      ...this._def,
      shape: () => r
    });
  }
  /**
   * @deprecated
   */
  deepPartial() {
    return Gs(this);
  }
  partial(e) {
    const r = {};
    return Ge.objectKeys(this.shape).forEach((s) => {
      const n = this.shape[s];
      e && !e[s] ? r[s] = n : r[s] = n.optional();
    }), new lt({
      ...this._def,
      shape: () => r
    });
  }
  required(e) {
    const r = {};
    return Ge.objectKeys(this.shape).forEach((s) => {
      if (e && !e[s])
        r[s] = this.shape[s];
      else {
        let n = this.shape[s];
        for (; n instanceof Gr; )
          n = n._def.innerType;
        r[s] = n;
      }
    }), new lt({
      ...this._def,
      shape: () => r
    });
  }
  keyof() {
    return Gd(Ge.objectKeys(this.shape));
  }
}
lt.create = (t, e) => new lt({
  shape: () => t,
  unknownKeys: "strip",
  catchall: Jr.create(),
  typeName: fe.ZodObject,
  ...Se(e)
});
lt.strictCreate = (t, e) => new lt({
  shape: () => t,
  unknownKeys: "strict",
  catchall: Jr.create(),
  typeName: fe.ZodObject,
  ...Se(e)
});
lt.lazycreate = (t, e) => new lt({
  shape: t,
  unknownKeys: "strip",
  catchall: Jr.create(),
  typeName: fe.ZodObject,
  ...Se(e)
});
class zn extends ke {
  _parse(e) {
    const { ctx: r } = this._processInputParams(e), s = this._def.options;
    function n(i) {
      for (const a of i)
        if (a.result.status === "valid")
          return a.result;
      for (const a of i)
        if (a.result.status === "dirty")
          return r.common.issues.push(...a.ctx.common.issues), a.result;
      const o = i.map((a) => new wr(a.ctx.common.issues));
      return ne(r, {
        code: K.invalid_union,
        unionErrors: o
      }), be;
    }
    if (r.common.async)
      return Promise.all(s.map(async (i) => {
        const o = {
          ...r,
          common: {
            ...r.common,
            issues: []
          },
          parent: null
        };
        return {
          result: await i._parseAsync({
            data: r.data,
            path: r.path,
            parent: o
          }),
          ctx: o
        };
      })).then(n);
    {
      let i;
      const o = [];
      for (const u of s) {
        const c = {
          ...r,
          common: {
            ...r.common,
            issues: []
          },
          parent: null
        }, h = u._parseSync({
          data: r.data,
          path: r.path,
          parent: c
        });
        if (h.status === "valid")
          return h;
        h.status === "dirty" && !i && (i = { result: h, ctx: c }), c.common.issues.length && o.push(c.common.issues);
      }
      if (i)
        return r.common.issues.push(...i.ctx.common.issues), i.result;
      const a = o.map((u) => new wr(u));
      return ne(r, {
        code: K.invalid_union,
        unionErrors: a
      }), be;
    }
  }
  get options() {
    return this._def.options;
  }
}
zn.create = (t, e) => new zn({
  options: t,
  typeName: fe.ZodUnion,
  ...Se(e)
});
const Li = (t) => t instanceof qn ? Li(t.schema) : t instanceof Or ? Li(t.innerType()) : t instanceof Zn ? [t.value] : t instanceof ps ? t.options : t instanceof Fn ? Object.keys(t.enum) : t instanceof Wn ? Li(t._def.innerType) : t instanceof Dn ? [void 0] : t instanceof Un ? [null] : null;
class Ia extends ke {
  _parse(e) {
    const { ctx: r } = this._processInputParams(e);
    if (r.parsedType !== te.object)
      return ne(r, {
        code: K.invalid_type,
        expected: te.object,
        received: r.parsedType
      }), be;
    const s = this.discriminator, n = r.data[s], i = this.optionsMap.get(n);
    return i ? r.common.async ? i._parseAsync({
      data: r.data,
      path: r.path,
      parent: r
    }) : i._parseSync({
      data: r.data,
      path: r.path,
      parent: r
    }) : (ne(r, {
      code: K.invalid_union_discriminator,
      options: Array.from(this.optionsMap.keys()),
      path: [s]
    }), be);
  }
  get discriminator() {
    return this._def.discriminator;
  }
  get options() {
    return this._def.options;
  }
  get optionsMap() {
    return this._def.optionsMap;
  }
  /**
   * The constructor of the discriminated union schema. Its behaviour is very similar to that of the normal z.union() constructor.
   * However, it only allows a union of objects, all of which need to share a discriminator property. This property must
   * have a different value for each object in the union.
   * @param discriminator the name of the discriminator property
   * @param types an array of object schemas
   * @param params
   */
  static create(e, r, s) {
    const n = /* @__PURE__ */ new Map();
    for (const i of r) {
      const o = Li(i.shape[e]);
      if (!o)
        throw new Error(`A discriminator value for key \`${e}\` could not be extracted from all schema options`);
      for (const a of o) {
        if (n.has(a))
          throw new Error(`Discriminator property ${String(e)} has duplicate value ${String(a)}`);
        n.set(a, i);
      }
    }
    return new Ia({
      typeName: fe.ZodDiscriminatedUnion,
      discriminator: e,
      options: r,
      optionsMap: n,
      ...Se(s)
    });
  }
}
function vo(t, e) {
  const r = as(t), s = as(e);
  if (t === e)
    return { valid: !0, data: t };
  if (r === te.object && s === te.object) {
    const n = Ge.objectKeys(e), i = Ge.objectKeys(t).filter((a) => n.indexOf(a) !== -1), o = { ...t, ...e };
    for (const a of i) {
      const u = vo(t[a], e[a]);
      if (!u.valid)
        return { valid: !1 };
      o[a] = u.data;
    }
    return { valid: !0, data: o };
  } else if (r === te.array && s === te.array) {
    if (t.length !== e.length)
      return { valid: !1 };
    const n = [];
    for (let i = 0; i < t.length; i++) {
      const o = t[i], a = e[i], u = vo(o, a);
      if (!u.valid)
        return { valid: !1 };
      n.push(u.data);
    }
    return { valid: !0, data: n };
  } else
    return r === te.date && s === te.date && +t == +e ? { valid: !0, data: t } : { valid: !1 };
}
class $n extends ke {
  _parse(e) {
    const { status: r, ctx: s } = this._processInputParams(e), n = (i, o) => {
      if (mo(i) || mo(o))
        return be;
      const a = vo(i.value, o.value);
      return a.valid ? ((yo(i) || yo(o)) && r.dirty(), { status: r.value, value: a.data }) : (ne(s, {
        code: K.invalid_intersection_types
      }), be);
    };
    return s.common.async ? Promise.all([
      this._def.left._parseAsync({
        data: s.data,
        path: s.path,
        parent: s
      }),
      this._def.right._parseAsync({
        data: s.data,
        path: s.path,
        parent: s
      })
    ]).then(([i, o]) => n(i, o)) : n(this._def.left._parseSync({
      data: s.data,
      path: s.path,
      parent: s
    }), this._def.right._parseSync({
      data: s.data,
      path: s.path,
      parent: s
    }));
  }
}
$n.create = (t, e, r) => new $n({
  left: t,
  right: e,
  typeName: fe.ZodIntersection,
  ...Se(r)
});
class Ur extends ke {
  _parse(e) {
    const { status: r, ctx: s } = this._processInputParams(e);
    if (s.parsedType !== te.array)
      return ne(s, {
        code: K.invalid_type,
        expected: te.array,
        received: s.parsedType
      }), be;
    if (s.data.length < this._def.items.length)
      return ne(s, {
        code: K.too_small,
        minimum: this._def.items.length,
        inclusive: !0,
        exact: !1,
        type: "array"
      }), be;
    !this._def.rest && s.data.length > this._def.items.length && (ne(s, {
      code: K.too_big,
      maximum: this._def.items.length,
      inclusive: !0,
      exact: !1,
      type: "array"
    }), r.dirty());
    const n = [...s.data].map((i, o) => {
      const a = this._def.items[o] || this._def.rest;
      return a ? a._parse(new Dr(s, i, s.path, o)) : null;
    }).filter((i) => !!i);
    return s.common.async ? Promise.all(n).then((i) => Ft.mergeArray(r, i)) : Ft.mergeArray(r, n);
  }
  get items() {
    return this._def.items;
  }
  rest(e) {
    return new Ur({
      ...this._def,
      rest: e
    });
  }
}
Ur.create = (t, e) => {
  if (!Array.isArray(t))
    throw new Error("You must pass an array of schemas to z.tuple([ ... ])");
  return new Ur({
    items: t,
    typeName: fe.ZodTuple,
    rest: null,
    ...Se(e)
  });
};
class Vn extends ke {
  get keySchema() {
    return this._def.keyType;
  }
  get valueSchema() {
    return this._def.valueType;
  }
  _parse(e) {
    const { status: r, ctx: s } = this._processInputParams(e);
    if (s.parsedType !== te.object)
      return ne(s, {
        code: K.invalid_type,
        expected: te.object,
        received: s.parsedType
      }), be;
    const n = [], i = this._def.keyType, o = this._def.valueType;
    for (const a in s.data)
      n.push({
        key: i._parse(new Dr(s, a, s.path, a)),
        value: o._parse(new Dr(s, s.data[a], s.path, a))
      });
    return s.common.async ? Ft.mergeObjectAsync(r, n) : Ft.mergeObjectSync(r, n);
  }
  get element() {
    return this._def.valueType;
  }
  static create(e, r, s) {
    return r instanceof ke ? new Vn({
      keyType: e,
      valueType: r,
      typeName: fe.ZodRecord,
      ...Se(s)
    }) : new Vn({
      keyType: _r.create(),
      valueType: e,
      typeName: fe.ZodRecord,
      ...Se(r)
    });
  }
}
class Qi extends ke {
  _parse(e) {
    const { status: r, ctx: s } = this._processInputParams(e);
    if (s.parsedType !== te.map)
      return ne(s, {
        code: K.invalid_type,
        expected: te.map,
        received: s.parsedType
      }), be;
    const n = this._def.keyType, i = this._def.valueType, o = [...s.data.entries()].map(([a, u], c) => ({
      key: n._parse(new Dr(s, a, s.path, [c, "key"])),
      value: i._parse(new Dr(s, u, s.path, [c, "value"]))
    }));
    if (s.common.async) {
      const a = /* @__PURE__ */ new Map();
      return Promise.resolve().then(async () => {
        for (const u of o) {
          const c = await u.key, h = await u.value;
          if (c.status === "aborted" || h.status === "aborted")
            return be;
          (c.status === "dirty" || h.status === "dirty") && r.dirty(), a.set(c.value, h.value);
        }
        return { status: r.value, value: a };
      });
    } else {
      const a = /* @__PURE__ */ new Map();
      for (const u of o) {
        const c = u.key, h = u.value;
        if (c.status === "aborted" || h.status === "aborted")
          return be;
        (c.status === "dirty" || h.status === "dirty") && r.dirty(), a.set(c.value, h.value);
      }
      return { status: r.value, value: a };
    }
  }
}
Qi.create = (t, e, r) => new Qi({
  valueType: e,
  keyType: t,
  typeName: fe.ZodMap,
  ...Se(r)
});
class ks extends ke {
  _parse(e) {
    const { status: r, ctx: s } = this._processInputParams(e);
    if (s.parsedType !== te.set)
      return ne(s, {
        code: K.invalid_type,
        expected: te.set,
        received: s.parsedType
      }), be;
    const n = this._def;
    n.minSize !== null && s.data.size < n.minSize.value && (ne(s, {
      code: K.too_small,
      minimum: n.minSize.value,
      type: "set",
      inclusive: !0,
      exact: !1,
      message: n.minSize.message
    }), r.dirty()), n.maxSize !== null && s.data.size > n.maxSize.value && (ne(s, {
      code: K.too_big,
      maximum: n.maxSize.value,
      type: "set",
      inclusive: !0,
      exact: !1,
      message: n.maxSize.message
    }), r.dirty());
    const i = this._def.valueType;
    function o(u) {
      const c = /* @__PURE__ */ new Set();
      for (const h of u) {
        if (h.status === "aborted")
          return be;
        h.status === "dirty" && r.dirty(), c.add(h.value);
      }
      return { status: r.value, value: c };
    }
    const a = [...s.data.values()].map((u, c) => i._parse(new Dr(s, u, s.path, c)));
    return s.common.async ? Promise.all(a).then((u) => o(u)) : o(a);
  }
  min(e, r) {
    return new ks({
      ...this._def,
      minSize: { value: e, message: ce.toString(r) }
    });
  }
  max(e, r) {
    return new ks({
      ...this._def,
      maxSize: { value: e, message: ce.toString(r) }
    });
  }
  size(e, r) {
    return this.min(e, r).max(e, r);
  }
  nonempty(e) {
    return this.min(1, e);
  }
}
ks.create = (t, e) => new ks({
  valueType: t,
  minSize: null,
  maxSize: null,
  typeName: fe.ZodSet,
  ...Se(e)
});
class tn extends ke {
  constructor() {
    super(...arguments), this.validate = this.implement;
  }
  _parse(e) {
    const { ctx: r } = this._processInputParams(e);
    if (r.parsedType !== te.function)
      return ne(r, {
        code: K.invalid_type,
        expected: te.function,
        received: r.parsedType
      }), be;
    function s(a, u) {
      return Bi({
        data: a,
        path: r.path,
        errorMaps: [
          r.common.contextualErrorMap,
          r.schemaErrorMap,
          Hi(),
          Ln
        ].filter((c) => !!c),
        issueData: {
          code: K.invalid_arguments,
          argumentsError: u
        }
      });
    }
    function n(a, u) {
      return Bi({
        data: a,
        path: r.path,
        errorMaps: [
          r.common.contextualErrorMap,
          r.schemaErrorMap,
          Hi(),
          Ln
        ].filter((c) => !!c),
        issueData: {
          code: K.invalid_return_type,
          returnTypeError: u
        }
      });
    }
    const i = { errorMap: r.common.contextualErrorMap }, o = r.data;
    return this._def.returns instanceof an ? Xt(async (...a) => {
      const u = new wr([]), c = await this._def.args.parseAsync(a, i).catch((p) => {
        throw u.addIssue(s(a, p)), u;
      }), h = await o(...c);
      return await this._def.returns._def.type.parseAsync(h, i).catch((p) => {
        throw u.addIssue(n(h, p)), u;
      });
    }) : Xt((...a) => {
      const u = this._def.args.safeParse(a, i);
      if (!u.success)
        throw new wr([s(a, u.error)]);
      const c = o(...u.data), h = this._def.returns.safeParse(c, i);
      if (!h.success)
        throw new wr([n(c, h.error)]);
      return h.data;
    });
  }
  parameters() {
    return this._def.args;
  }
  returnType() {
    return this._def.returns;
  }
  args(...e) {
    return new tn({
      ...this._def,
      args: Ur.create(e).rest(Ps.create())
    });
  }
  returns(e) {
    return new tn({
      ...this._def,
      returns: e
    });
  }
  implement(e) {
    return this.parse(e);
  }
  strictImplement(e) {
    return this.parse(e);
  }
  static create(e, r, s) {
    return new tn({
      args: e || Ur.create([]).rest(Ps.create()),
      returns: r || Ps.create(),
      typeName: fe.ZodFunction,
      ...Se(s)
    });
  }
}
class qn extends ke {
  get schema() {
    return this._def.getter();
  }
  _parse(e) {
    const { ctx: r } = this._processInputParams(e);
    return this._def.getter()._parse({ data: r.data, path: r.path, parent: r });
  }
}
qn.create = (t, e) => new qn({
  getter: t,
  typeName: fe.ZodLazy,
  ...Se(e)
});
class Zn extends ke {
  _parse(e) {
    if (e.data !== this._def.value) {
      const r = this._getOrReturnCtx(e);
      return ne(r, {
        received: r.data,
        code: K.invalid_literal,
        expected: this._def.value
      }), be;
    }
    return { status: "valid", value: e.data };
  }
  get value() {
    return this._def.value;
  }
}
Zn.create = (t, e) => new Zn({
  value: t,
  typeName: fe.ZodLiteral,
  ...Se(e)
});
function Gd(t, e) {
  return new ps({
    values: t,
    typeName: fe.ZodEnum,
    ...Se(e)
  });
}
class ps extends ke {
  _parse(e) {
    if (typeof e.data != "string") {
      const r = this._getOrReturnCtx(e), s = this._def.values;
      return ne(r, {
        expected: Ge.joinValues(s),
        received: r.parsedType,
        code: K.invalid_type
      }), be;
    }
    if (this._def.values.indexOf(e.data) === -1) {
      const r = this._getOrReturnCtx(e), s = this._def.values;
      return ne(r, {
        received: r.data,
        code: K.invalid_enum_value,
        options: s
      }), be;
    }
    return Xt(e.data);
  }
  get options() {
    return this._def.values;
  }
  get enum() {
    const e = {};
    for (const r of this._def.values)
      e[r] = r;
    return e;
  }
  get Values() {
    const e = {};
    for (const r of this._def.values)
      e[r] = r;
    return e;
  }
  get Enum() {
    const e = {};
    for (const r of this._def.values)
      e[r] = r;
    return e;
  }
  extract(e) {
    return ps.create(e);
  }
  exclude(e) {
    return ps.create(this.options.filter((r) => !e.includes(r)));
  }
}
ps.create = Gd;
class Fn extends ke {
  _parse(e) {
    const r = Ge.getValidEnumValues(this._def.values), s = this._getOrReturnCtx(e);
    if (s.parsedType !== te.string && s.parsedType !== te.number) {
      const n = Ge.objectValues(r);
      return ne(s, {
        expected: Ge.joinValues(n),
        received: s.parsedType,
        code: K.invalid_type
      }), be;
    }
    if (r.indexOf(e.data) === -1) {
      const n = Ge.objectValues(r);
      return ne(s, {
        received: s.data,
        code: K.invalid_enum_value,
        options: n
      }), be;
    }
    return Xt(e.data);
  }
  get enum() {
    return this._def.values;
  }
}
Fn.create = (t, e) => new Fn({
  values: t,
  typeName: fe.ZodNativeEnum,
  ...Se(e)
});
class an extends ke {
  unwrap() {
    return this._def.type;
  }
  _parse(e) {
    const { ctx: r } = this._processInputParams(e);
    if (r.parsedType !== te.promise && r.common.async === !1)
      return ne(r, {
        code: K.invalid_type,
        expected: te.promise,
        received: r.parsedType
      }), be;
    const s = r.parsedType === te.promise ? r.data : Promise.resolve(r.data);
    return Xt(s.then((n) => this._def.type.parseAsync(n, {
      path: r.path,
      errorMap: r.common.contextualErrorMap
    })));
  }
}
an.create = (t, e) => new an({
  type: t,
  typeName: fe.ZodPromise,
  ...Se(e)
});
class Or extends ke {
  innerType() {
    return this._def.schema;
  }
  sourceType() {
    return this._def.schema._def.typeName === fe.ZodEffects ? this._def.schema.sourceType() : this._def.schema;
  }
  _parse(e) {
    const { status: r, ctx: s } = this._processInputParams(e), n = this._def.effect || null;
    if (n.type === "preprocess") {
      const o = n.transform(s.data);
      return s.common.async ? Promise.resolve(o).then((a) => this._def.schema._parseAsync({
        data: a,
        path: s.path,
        parent: s
      })) : this._def.schema._parseSync({
        data: o,
        path: s.path,
        parent: s
      });
    }
    const i = {
      addIssue: (o) => {
        ne(s, o), o.fatal ? r.abort() : r.dirty();
      },
      get path() {
        return s.path;
      }
    };
    if (i.addIssue = i.addIssue.bind(i), n.type === "refinement") {
      const o = (a) => {
        const u = n.refinement(a, i);
        if (s.common.async)
          return Promise.resolve(u);
        if (u instanceof Promise)
          throw new Error("Async refinement encountered during synchronous parse operation. Use .parseAsync instead.");
        return a;
      };
      if (s.common.async === !1) {
        const a = this._def.schema._parseSync({
          data: s.data,
          path: s.path,
          parent: s
        });
        return a.status === "aborted" ? be : (a.status === "dirty" && r.dirty(), o(a.value), { status: r.value, value: a.value });
      } else
        return this._def.schema._parseAsync({ data: s.data, path: s.path, parent: s }).then((a) => a.status === "aborted" ? be : (a.status === "dirty" && r.dirty(), o(a.value).then(() => ({ status: r.value, value: a.value }))));
    }
    if (n.type === "transform")
      if (s.common.async === !1) {
        const o = this._def.schema._parseSync({
          data: s.data,
          path: s.path,
          parent: s
        });
        if (!Gi(o))
          return o;
        const a = n.transform(o.value, i);
        if (a instanceof Promise)
          throw new Error("Asynchronous transform encountered during synchronous parse operation. Use .parseAsync instead.");
        return { status: r.value, value: a };
      } else
        return this._def.schema._parseAsync({ data: s.data, path: s.path, parent: s }).then((o) => Gi(o) ? Promise.resolve(n.transform(o.value, i)).then((a) => ({ status: r.value, value: a })) : o);
    Ge.assertNever(n);
  }
}
Or.create = (t, e, r) => new Or({
  schema: t,
  typeName: fe.ZodEffects,
  effect: e,
  ...Se(r)
});
Or.createWithPreprocess = (t, e, r) => new Or({
  schema: e,
  effect: { type: "preprocess", transform: t },
  typeName: fe.ZodEffects,
  ...Se(r)
});
class Gr extends ke {
  _parse(e) {
    return this._getType(e) === te.undefined ? Xt(void 0) : this._def.innerType._parse(e);
  }
  unwrap() {
    return this._def.innerType;
  }
}
Gr.create = (t, e) => new Gr({
  innerType: t,
  typeName: fe.ZodOptional,
  ...Se(e)
});
class Rs extends ke {
  _parse(e) {
    return this._getType(e) === te.null ? Xt(null) : this._def.innerType._parse(e);
  }
  unwrap() {
    return this._def.innerType;
  }
}
Rs.create = (t, e) => new Rs({
  innerType: t,
  typeName: fe.ZodNullable,
  ...Se(e)
});
class Wn extends ke {
  _parse(e) {
    const { ctx: r } = this._processInputParams(e);
    let s = r.data;
    return r.parsedType === te.undefined && (s = this._def.defaultValue()), this._def.innerType._parse({
      data: s,
      path: r.path,
      parent: r
    });
  }
  removeDefault() {
    return this._def.innerType;
  }
}
Wn.create = (t, e) => new Wn({
  innerType: t,
  typeName: fe.ZodDefault,
  defaultValue: typeof e.default == "function" ? e.default : () => e.default,
  ...Se(e)
});
class ea extends ke {
  _parse(e) {
    const { ctx: r } = this._processInputParams(e), s = {
      ...r,
      common: {
        ...r.common,
        issues: []
      }
    }, n = this._def.innerType._parse({
      data: s.data,
      path: s.path,
      parent: {
        ...s
      }
    });
    return Yi(n) ? n.then((i) => ({
      status: "valid",
      value: i.status === "valid" ? i.value : this._def.catchValue({
        get error() {
          return new wr(s.common.issues);
        }
      })
    })) : {
      status: "valid",
      value: n.status === "valid" ? n.value : this._def.catchValue({
        get error() {
          return new wr(s.common.issues);
        }
      })
    };
  }
  removeCatch() {
    return this._def.innerType;
  }
}
ea.create = (t, e) => new ea({
  innerType: t,
  typeName: fe.ZodCatch,
  catchValue: typeof e.catch == "function" ? e.catch : () => e.catch,
  ...Se(e)
});
class ta extends ke {
  _parse(e) {
    if (this._getType(e) !== te.nan) {
      const r = this._getOrReturnCtx(e);
      return ne(r, {
        code: K.invalid_type,
        expected: te.nan,
        received: r.parsedType
      }), be;
    }
    return { status: "valid", value: e.data };
  }
}
ta.create = (t) => new ta({
  typeName: fe.ZodNaN,
  ...Se(t)
});
const Fw = Symbol("zod_brand");
class Yd extends ke {
  _parse(e) {
    const { ctx: r } = this._processInputParams(e), s = r.data;
    return this._def.type._parse({
      data: s,
      path: r.path,
      parent: r
    });
  }
  unwrap() {
    return this._def.type;
  }
}
class fi extends ke {
  _parse(e) {
    const { status: r, ctx: s } = this._processInputParams(e);
    if (s.common.async)
      return (async () => {
        const n = await this._def.in._parseAsync({
          data: s.data,
          path: s.path,
          parent: s
        });
        return n.status === "aborted" ? be : n.status === "dirty" ? (r.dirty(), Bd(n.value)) : this._def.out._parseAsync({
          data: n.value,
          path: s.path,
          parent: s
        });
      })();
    {
      const n = this._def.in._parseSync({
        data: s.data,
        path: s.path,
        parent: s
      });
      return n.status === "aborted" ? be : n.status === "dirty" ? (r.dirty(), {
        status: "dirty",
        value: n.value
      }) : this._def.out._parseSync({
        data: n.value,
        path: s.path,
        parent: s
      });
    }
  }
  static create(e, r) {
    return new fi({
      in: e,
      out: r,
      typeName: fe.ZodPipeline
    });
  }
}
const Jd = (t, e = {}, r) => t ? nn.create().superRefine((s, n) => {
  var i, o;
  if (!t(s)) {
    const a = typeof e == "function" ? e(s) : e, u = (o = (i = a.fatal) !== null && i !== void 0 ? i : r) !== null && o !== void 0 ? o : !0, c = typeof a == "string" ? { message: a } : a;
    n.addIssue({ code: "custom", ...c, fatal: u });
  }
}) : nn.create(), Ww = {
  object: lt.lazycreate
};
var fe;
(function(t) {
  t.ZodString = "ZodString", t.ZodNumber = "ZodNumber", t.ZodNaN = "ZodNaN", t.ZodBigInt = "ZodBigInt", t.ZodBoolean = "ZodBoolean", t.ZodDate = "ZodDate", t.ZodSymbol = "ZodSymbol", t.ZodUndefined = "ZodUndefined", t.ZodNull = "ZodNull", t.ZodAny = "ZodAny", t.ZodUnknown = "ZodUnknown", t.ZodNever = "ZodNever", t.ZodVoid = "ZodVoid", t.ZodArray = "ZodArray", t.ZodObject = "ZodObject", t.ZodUnion = "ZodUnion", t.ZodDiscriminatedUnion = "ZodDiscriminatedUnion", t.ZodIntersection = "ZodIntersection", t.ZodTuple = "ZodTuple", t.ZodRecord = "ZodRecord", t.ZodMap = "ZodMap", t.ZodSet = "ZodSet", t.ZodFunction = "ZodFunction", t.ZodLazy = "ZodLazy", t.ZodLiteral = "ZodLiteral", t.ZodEnum = "ZodEnum", t.ZodEffects = "ZodEffects", t.ZodNativeEnum = "ZodNativeEnum", t.ZodOptional = "ZodOptional", t.ZodNullable = "ZodNullable", t.ZodDefault = "ZodDefault", t.ZodCatch = "ZodCatch", t.ZodPromise = "ZodPromise", t.ZodBranded = "ZodBranded", t.ZodPipeline = "ZodPipeline";
})(fe || (fe = {}));
const Kw = (t, e = {
  message: `Input not instance of ${t.name}`
}) => Jd((r) => r instanceof t, e), Xd = _r.create, Qd = ds.create, Hw = ta.create, Bw = hs.create, eh = Mn.create, Gw = Ns.create, Yw = Ji.create, Jw = Dn.create, Xw = Un.create, Qw = nn.create, e1 = Ps.create, t1 = Jr.create, r1 = Xi.create, s1 = Er.create, n1 = lt.create, i1 = lt.strictCreate, a1 = zn.create, o1 = Ia.create, c1 = $n.create, u1 = Ur.create, l1 = Vn.create, d1 = Qi.create, h1 = ks.create, p1 = tn.create, f1 = qn.create, g1 = Zn.create, m1 = ps.create, y1 = Fn.create, v1 = an.create, ol = Or.create, _1 = Gr.create, b1 = Rs.create, w1 = Or.createWithPreprocess, E1 = fi.create, S1 = () => Xd().optional(), I1 = () => Qd().optional(), x1 = () => eh().optional(), O1 = {
  string: (t) => _r.create({ ...t, coerce: !0 }),
  number: (t) => ds.create({ ...t, coerce: !0 }),
  boolean: (t) => Mn.create({
    ...t,
    coerce: !0
  }),
  bigint: (t) => hs.create({ ...t, coerce: !0 }),
  date: (t) => Ns.create({ ...t, coerce: !0 })
}, T1 = be;
var Cr = /* @__PURE__ */ Object.freeze({
  __proto__: null,
  defaultErrorMap: Ln,
  setErrorMap: kw,
  getErrorMap: Hi,
  makeIssue: Bi,
  EMPTY_PATH: Rw,
  addIssueToContext: ne,
  ParseStatus: Ft,
  INVALID: be,
  DIRTY: Bd,
  OK: Xt,
  isAborted: mo,
  isDirty: yo,
  isValid: Gi,
  isAsync: Yi,
  get util() {
    return Ge;
  },
  get objectUtil() {
    return go;
  },
  ZodParsedType: te,
  getParsedType: as,
  ZodType: ke,
  ZodString: _r,
  ZodNumber: ds,
  ZodBigInt: hs,
  ZodBoolean: Mn,
  ZodDate: Ns,
  ZodSymbol: Ji,
  ZodUndefined: Dn,
  ZodNull: Un,
  ZodAny: nn,
  ZodUnknown: Ps,
  ZodNever: Jr,
  ZodVoid: Xi,
  ZodArray: Er,
  ZodObject: lt,
  ZodUnion: zn,
  ZodDiscriminatedUnion: Ia,
  ZodIntersection: $n,
  ZodTuple: Ur,
  ZodRecord: Vn,
  ZodMap: Qi,
  ZodSet: ks,
  ZodFunction: tn,
  ZodLazy: qn,
  ZodLiteral: Zn,
  ZodEnum: ps,
  ZodNativeEnum: Fn,
  ZodPromise: an,
  ZodEffects: Or,
  ZodTransformer: Or,
  ZodOptional: Gr,
  ZodNullable: Rs,
  ZodDefault: Wn,
  ZodCatch: ea,
  ZodNaN: ta,
  BRAND: Fw,
  ZodBranded: Yd,
  ZodPipeline: fi,
  custom: Jd,
  Schema: ke,
  ZodSchema: ke,
  late: Ww,
  get ZodFirstPartyTypeKind() {
    return fe;
  },
  coerce: O1,
  any: Qw,
  array: s1,
  bigint: Bw,
  boolean: eh,
  date: Gw,
  discriminatedUnion: o1,
  effect: ol,
  enum: m1,
  function: p1,
  instanceof: Kw,
  intersection: c1,
  lazy: f1,
  literal: g1,
  map: d1,
  nan: Hw,
  nativeEnum: y1,
  never: t1,
  null: Xw,
  nullable: b1,
  number: Qd,
  object: n1,
  oboolean: x1,
  onumber: I1,
  optional: _1,
  ostring: S1,
  pipeline: E1,
  preprocess: w1,
  promise: v1,
  record: l1,
  set: h1,
  strictObject: i1,
  string: Xd,
  symbol: Yw,
  transformer: ol,
  tuple: u1,
  undefined: Jw,
  union: a1,
  unknown: e1,
  void: r1,
  NEVER: T1,
  ZodIssueCode: K,
  quotelessJson: Nw,
  ZodError: wr
});
const P1 = /^aleo1[a-z0-9]{58}$/i, C1 = /^AViewKey1[a-z0-9]{44}$/i, N1 = /^APrivateKey1[a-z0-9]{47}$/i, k1 = /^at1[a-z0-9]{58}$/i, R1 = /^\d+field$/, A1 = /^\d+u32$/, j1 = /^\d+u64$/;
Cr.string().regex(P1);
Cr.string().regex(C1);
Cr.string().regex(N1);
Cr.string().regex(k1);
Cr.string().regex(R1);
Cr.string().regex(A1);
Cr.string().regex(j1);
var cl;
(function(t) {
  t.Record = "record", t.OutputRecord = "outputRecord", t.Public = "public", t.Private = "private", t.Constant = "constant", t.Future = "future", t.ExternalRecord = "external_record";
})(cl || (cl = {}));
var _o;
(function(t) {
  t.Deploy = "Deploy", t.Execute = "Execute", t.Send = "Send", t.Receive = "Receive", t.Join = "Join", t.Split = "Split", t.Shield = "Shield", t.Unshield = "Unshield";
})(_o || (_o = {}));
var bo;
(function(t) {
  t.Creating = "Creating", t.Pending = "Pending", t.Settled = "Settled", t.Failed = "Failed";
})(bo || (bo = {}));
var wo;
(function(t) {
  t.Private = "Private", t.Public = "Public";
})(wo || (wo = {}));
var Eo;
(function(t) {
  t.AleoTestnet = "AleoTestnet", t.AleoMainnet = "AleoMainnet";
})(Eo || (Eo = {}));
var ul;
(function(t) {
  t[t.ALEO = 0] = "ALEO";
})(ul || (ul = {}));
Cr.nativeEnum(_o);
Cr.nativeEnum(bo);
Cr.nativeEnum(Eo);
Cr.nativeEnum(wo);
var So = { exports: {} }, qa, ll;
function L1() {
  if (ll)
    return qa;
  ll = 1;
  var t = 1e3, e = t * 60, r = e * 60, s = r * 24, n = s * 7, i = s * 365.25;
  qa = function(h, p) {
    p = p || {};
    var g = typeof h;
    if (g === "string" && h.length > 0)
      return o(h);
    if (g === "number" && isFinite(h))
      return p.long ? u(h) : a(h);
    throw new Error(
      "val is not a non-empty string or a valid number. val=" + JSON.stringify(h)
    );
  };
  function o(h) {
    if (h = String(h), !(h.length > 100)) {
      var p = /^(-?(?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(
        h
      );
      if (p) {
        var g = parseFloat(p[1]), v = (p[2] || "ms").toLowerCase();
        switch (v) {
          case "years":
          case "year":
          case "yrs":
          case "yr":
          case "y":
            return g * i;
          case "weeks":
          case "week":
          case "w":
            return g * n;
          case "days":
          case "day":
          case "d":
            return g * s;
          case "hours":
          case "hour":
          case "hrs":
          case "hr":
          case "h":
            return g * r;
          case "minutes":
          case "minute":
          case "mins":
          case "min":
          case "m":
            return g * e;
          case "seconds":
          case "second":
          case "secs":
          case "sec":
          case "s":
            return g * t;
          case "milliseconds":
          case "millisecond":
          case "msecs":
          case "msec":
          case "ms":
            return g;
          default:
            return;
        }
      }
    }
  }
  function a(h) {
    var p = Math.abs(h);
    return p >= s ? Math.round(h / s) + "d" : p >= r ? Math.round(h / r) + "h" : p >= e ? Math.round(h / e) + "m" : p >= t ? Math.round(h / t) + "s" : h + "ms";
  }
  function u(h) {
    var p = Math.abs(h);
    return p >= s ? c(h, p, s, "day") : p >= r ? c(h, p, r, "hour") : p >= e ? c(h, p, e, "minute") : p >= t ? c(h, p, t, "second") : h + " ms";
  }
  function c(h, p, g, v) {
    var b = p >= g * 1.5;
    return Math.round(h / g) + " " + v + (b ? "s" : "");
  }
  return qa;
}
function M1(t) {
  r.debug = r, r.default = r, r.coerce = u, r.disable = i, r.enable = n, r.enabled = o, r.humanize = L1(), r.destroy = c, Object.keys(t).forEach((h) => {
    r[h] = t[h];
  }), r.names = [], r.skips = [], r.formatters = {};
  function e(h) {
    let p = 0;
    for (let g = 0; g < h.length; g++)
      p = (p << 5) - p + h.charCodeAt(g), p |= 0;
    return r.colors[Math.abs(p) % r.colors.length];
  }
  r.selectColor = e;
  function r(h) {
    let p, g = null, v, b;
    function S(...C) {
      if (!S.enabled)
        return;
      const M = S, _ = Number(/* @__PURE__ */ new Date()), T = _ - (p || _);
      M.diff = T, M.prev = p, M.curr = _, p = _, C[0] = r.coerce(C[0]), typeof C[0] != "string" && C.unshift("%O");
      let E = 0;
      C[0] = C[0].replace(/%([a-zA-Z%])/g, (I, m) => {
        if (I === "%%")
          return "%";
        E++;
        const l = r.formatters[m];
        if (typeof l == "function") {
          const f = C[E];
          I = l.call(M, f), C.splice(E, 1), E--;
        }
        return I;
      }), r.formatArgs.call(M, C), (M.log || r.log).apply(M, C);
    }
    return S.namespace = h, S.useColors = r.useColors(), S.color = r.selectColor(h), S.extend = s, S.destroy = r.destroy, Object.defineProperty(S, "enabled", {
      enumerable: !0,
      configurable: !1,
      get: () => g !== null ? g : (v !== r.namespaces && (v = r.namespaces, b = r.enabled(h)), b),
      set: (C) => {
        g = C;
      }
    }), typeof r.init == "function" && r.init(S), S;
  }
  function s(h, p) {
    const g = r(this.namespace + (typeof p > "u" ? ":" : p) + h);
    return g.log = this.log, g;
  }
  function n(h) {
    r.save(h), r.namespaces = h, r.names = [], r.skips = [];
    let p;
    const g = (typeof h == "string" ? h : "").split(/[\s,]+/), v = g.length;
    for (p = 0; p < v; p++)
      g[p] && (h = g[p].replace(/\*/g, ".*?"), h[0] === "-" ? r.skips.push(new RegExp("^" + h.slice(1) + "$")) : r.names.push(new RegExp("^" + h + "$")));
  }
  function i() {
    const h = [
      ...r.names.map(a),
      ...r.skips.map(a).map((p) => "-" + p)
    ].join(",");
    return r.enable(""), h;
  }
  function o(h) {
    if (h[h.length - 1] === "*")
      return !0;
    let p, g;
    for (p = 0, g = r.skips.length; p < g; p++)
      if (r.skips[p].test(h))
        return !1;
    for (p = 0, g = r.names.length; p < g; p++)
      if (r.names[p].test(h))
        return !0;
    return !1;
  }
  function a(h) {
    return h.toString().substring(2, h.toString().length - 2).replace(/\.\*\?$/, "*");
  }
  function u(h) {
    return h instanceof Error ? h.stack || h.message : h;
  }
  function c() {
    console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.");
  }
  return r.enable(r.load()), r;
}
var D1 = M1;
(function(t, e) {
  e.formatArgs = s, e.save = n, e.load = i, e.useColors = r, e.storage = o(), e.destroy = /* @__PURE__ */ (() => {
    let u = !1;
    return () => {
      u || (u = !0, console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`."));
    };
  })(), e.colors = [
    "#0000CC",
    "#0000FF",
    "#0033CC",
    "#0033FF",
    "#0066CC",
    "#0066FF",
    "#0099CC",
    "#0099FF",
    "#00CC00",
    "#00CC33",
    "#00CC66",
    "#00CC99",
    "#00CCCC",
    "#00CCFF",
    "#3300CC",
    "#3300FF",
    "#3333CC",
    "#3333FF",
    "#3366CC",
    "#3366FF",
    "#3399CC",
    "#3399FF",
    "#33CC00",
    "#33CC33",
    "#33CC66",
    "#33CC99",
    "#33CCCC",
    "#33CCFF",
    "#6600CC",
    "#6600FF",
    "#6633CC",
    "#6633FF",
    "#66CC00",
    "#66CC33",
    "#9900CC",
    "#9900FF",
    "#9933CC",
    "#9933FF",
    "#99CC00",
    "#99CC33",
    "#CC0000",
    "#CC0033",
    "#CC0066",
    "#CC0099",
    "#CC00CC",
    "#CC00FF",
    "#CC3300",
    "#CC3333",
    "#CC3366",
    "#CC3399",
    "#CC33CC",
    "#CC33FF",
    "#CC6600",
    "#CC6633",
    "#CC9900",
    "#CC9933",
    "#CCCC00",
    "#CCCC33",
    "#FF0000",
    "#FF0033",
    "#FF0066",
    "#FF0099",
    "#FF00CC",
    "#FF00FF",
    "#FF3300",
    "#FF3333",
    "#FF3366",
    "#FF3399",
    "#FF33CC",
    "#FF33FF",
    "#FF6600",
    "#FF6633",
    "#FF9900",
    "#FF9933",
    "#FFCC00",
    "#FFCC33"
  ];
  function r() {
    return typeof window < "u" && window.process && (window.process.type === "renderer" || window.process.__nwjs) ? !0 : typeof navigator < "u" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/) ? !1 : typeof document < "u" && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance || // Is firebug? http://stackoverflow.com/a/398120/376773
    typeof window < "u" && window.console && (window.console.firebug || window.console.exception && window.console.table) || // Is firefox >= v31?
    // https://developer.mozilla.org/en-US/docs/Tools/Web_Console#Styling_messages
    typeof navigator < "u" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31 || // Double check webkit in userAgent just in case we are in a worker
    typeof navigator < "u" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/);
  }
  function s(u) {
    if (u[0] = (this.useColors ? "%c" : "") + this.namespace + (this.useColors ? " %c" : " ") + u[0] + (this.useColors ? "%c " : " ") + "+" + t.exports.humanize(this.diff), !this.useColors)
      return;
    const c = "color: " + this.color;
    u.splice(1, 0, c, "color: inherit");
    let h = 0, p = 0;
    u[0].replace(/%[a-zA-Z%]/g, (g) => {
      g !== "%%" && (h++, g === "%c" && (p = h));
    }), u.splice(p, 0, c);
  }
  e.log = console.debug || console.log || (() => {
  });
  function n(u) {
    try {
      u ? e.storage.setItem("debug", u) : e.storage.removeItem("debug");
    } catch {
    }
  }
  function i() {
    let u;
    try {
      u = e.storage.getItem("debug");
    } catch {
    }
    return !u && typeof process < "u" && "env" in process && (u = process.env.DEBUG), u;
  }
  function o() {
    try {
      return localStorage;
    } catch {
    }
  }
  t.exports = D1(e);
  const { formatters: a } = t.exports;
  a.j = function(u) {
    try {
      return JSON.stringify(u);
    } catch (c) {
      return "[UnexpectedJSONParseError]: " + c.message;
    }
  };
})(So, So.exports);
var U1 = So.exports;
const z1 = /* @__PURE__ */ da(U1), xa = z1("wallet:sdk");
xa.enabled = !0;
function a5() {
  const e = !!pr(), { data: r, error: s, loading: n, setData: i, setError: o, setLoading: a } = jo(), [u] = us((h) => [h.setAccount]);
  async function c() {
    try {
      a(!0), o(void 0);
      const p = await (await Kd()).connect({
        requiredNamespaces: {
          aleo: {
            methods: xw,
            chains: Fd,
            events: Ow
          }
        }
      });
      i(p);
      const g = p.namespaces.aleo.accounts[0].split(":");
      return u({
        network: g[0],
        chainId: g[1],
        address: g[2],
        shortenedAddress: Za(g[2])
      }), Wd.emit("session_change"), window.localStorage.removeItem("WALLETCONNECT_DEEPLINK_CHOICE"), p;
    } catch (h) {
      throw o(h), h;
    } finally {
      a(!1);
    }
  }
  return { data: r, error: s, loading: n, isConnected: e, connect: c };
}
const o5 = () => {
  const t = pr(), { request: e, data: r, error: s, loading: n } = ii({
    topic: (t == null ? void 0 : t.topic) ?? "",
    chainId: "aleo:1",
    request: {
      jsonrpc: "2.0",
      method: "createSharedState",
      params: {}
    }
  }), i = s ? s.message : r && r.error, o = r;
  return { createSharedState: () => {
    t && !n && e();
  }, data: o == null ? void 0 : o.data, loading: n, error: i };
}, c5 = (t) => {
  xa("useDecrypt", t);
  const e = pr(), { request: r, data: s, error: n, loading: i } = ii({
    topic: (e == null ? void 0 : e.topic) ?? "",
    chainId: "aleo:1",
    request: {
      jsonrpc: "2.0",
      method: "decrypt",
      params: {
        ciphertexts: t
      }
    }
  }), o = n ? n.message : s && s.error, a = s;
  return { decrypt: () => {
    t && e && !i && r();
  }, plaintexts: a == null ? void 0 : a.plaintexts, loading: i, error: o };
};
function u5() {
  const t = pr(), [e] = us((a) => [a.onDisconnect]), { error: r, loading: s, setError: n, setLoading: i } = jo();
  async function o() {
    if (!t || s) {
      t || e();
      return;
    }
    try {
      i(!0), n(void 0);
      try {
        await (await Kd()).disconnect({
          topic: t.topic,
          reason: bl("USER_DISCONNECTED")
        }), Wd.emit("session_change");
      } catch (a) {
        console.warn(a);
      }
      us.getState().onDisconnect();
    } catch (a) {
      throw n(a), a;
    } finally {
      i(!1);
    }
  }
  return { error: r, loading: s, disconnect: o };
}
const l5 = ({ id: t, address: e, multisig: r = !1 }) => {
  const s = pr(), [n] = us((S) => [S.account]), i = t !== void 0 && t !== "" && !!s && !!n && (r ? !!e : !0), { refetch: o, data: a, error: u, isLoading: c } = ni({
    queryKey: ["useEvent", n == null ? void 0 : n.address, e, r, t, s == null ? void 0 : s.topic],
    enabled: i,
    wcParams: {
      topic: s == null ? void 0 : s.topic,
      chainId: "aleo:1",
      request: {
        jsonrpc: "2.0",
        method: "getEvent",
        params: {
          id: t ?? "",
          address: e
        }
      }
    }
  });
  si(({ params: S, topic: C }) => {
    const M = S.event.name, _ = S.event.address ?? S.event.data.address;
    (t && M === "selectedAccountSynced" && !r || M === "sharedAccountSynced" && r && _ === e) && o();
  });
  const h = !!s && !!n && !!t && (r ? !!e : !0);
  xr(() => {
    h && !c && o();
  }, [h]);
  const p = () => {
    h && !c && o();
  }, g = u ? u.message : a && a.error, v = a, b = v == null ? void 0 : v.event;
  return { fetchEvent: p, event: b, error: g, loading: c };
}, d5 = ({ filter: t, page: e }) => {
  const r = pr(), [s] = us((b) => [b.account]);
  (t == null ? void 0 : t.programId) === "" && (t.programId = void 0);
  const { refetch: n, data: i, error: o, isLoading: a } = ni({
    queryKey: ["useEvents", s == null ? void 0 : s.address, t, e, r == null ? void 0 : r.topic],
    enabled: !!r && !!s,
    wcParams: {
      topic: (r == null ? void 0 : r.topic) ?? "",
      chainId: "aleo:1",
      request: {
        jsonrpc: "2.0",
        method: "getEvents",
        params: {
          filter: t,
          page: e
        }
      }
    }
  });
  si(({ id: b, params: S, topic: C }) => {
    S.event.name === "selectedAccountSynced" && n();
  });
  const u = !!r && !!s;
  xr(() => {
    u && !a && n();
  }, [u]);
  const c = () => {
    u && !a && n();
  }, h = o ? o.message : i && i.error, p = i, g = p == null ? void 0 : p.events, v = (p == null ? void 0 : p.pageCount) ?? 0;
  return { fetchPage: c, events: g, error: h, loading: a, page: e, pageCount: v };
}, h5 = (t) => {
  const e = pr(), { request: r, data: s, error: n, loading: i } = ii({
    topic: (e == null ? void 0 : e.topic) ?? "",
    chainId: "aleo:1",
    request: {
      jsonrpc: "2.0",
      method: "importSharedState",
      params: {
        seed: t
      }
    }
  }), o = n ? n.message : s && s.error, a = s;
  return { importSharedState: () => {
    e && !i && r();
  }, data: a == null ? void 0 : a.data, loading: i, error: o };
}, p5 = (t) => {
  try {
    return JSON.stringify(t, null, 2).replaceAll('"', "") ?? "";
  } catch {
    return "";
  }
}, f5 = ({ address: t, multisig: e = !1, filter: r, page: s }) => {
  const n = pr(), [i] = us((C) => [
    C.account
  ]), { refetch: o, data: a, error: u, isLoading: c } = ni({
    queryKey: ["useRecords", i == null ? void 0 : i.address, t, e, r, s, n == null ? void 0 : n.topic],
    enabled: (e ? !!t : !0) && !!n && !!i,
    wcParams: {
      topic: n == null ? void 0 : n.topic,
      chainId: "aleo:1",
      request: {
        jsonrpc: "2.0",
        method: "getRecords",
        params: {
          address: t,
          filter: r,
          page: s
        }
      }
    }
  }), h = !!n && !!i && (e ? !!t : !0);
  si(({ params: C }) => {
    const M = C.event.name, _ = C.event.address ?? C.event.data.address;
    (M === "selectedAccountSynced" && !e || M === "sharedAccountSynced" && e && _ === t) && o();
  });
  const p = () => {
    h && !c && (xa("useRecords refetching...", [t, e, r, s]), o());
  }, g = u ? u.message : a && a.error, v = a, b = v == null ? void 0 : v.records, S = (v == null ? void 0 : v.pageCount) ?? 0;
  return { fetchPage: p, records: b, error: g, loading: c, page: s, pageCount: S };
}, g5 = (t) => {
  const e = pr(), r = t == null ? void 0 : t.inputs.map((h) => typeof h == "string" ? h : h.plaintext), { request: s, data: n, error: i, loading: o } = ii({
    topic: (e == null ? void 0 : e.topic) ?? "",
    chainId: "aleo:1",
    request: {
      jsonrpc: "2.0",
      method: "requestCreateEvent",
      params: {
        ...t,
        inputs: r
      }
    }
  }), a = i ? i.message : n && n.error, u = n;
  return { createEvent: () => {
    t && e && !o && (xa("useCreateEvent requesting...", t), s());
  }, eventId: u == null ? void 0 : u.eventId, loading: o, error: a };
};
var Ye;
(function(t) {
  t.assertEqual = (n) => n;
  function e(n) {
  }
  t.assertIs = e;
  function r(n) {
    throw new Error();
  }
  t.assertNever = r, t.arrayToEnum = (n) => {
    const i = {};
    for (const o of n)
      i[o] = o;
    return i;
  }, t.getValidEnumValues = (n) => {
    const i = t.objectKeys(n).filter((a) => typeof n[n[a]] != "number"), o = {};
    for (const a of i)
      o[a] = n[a];
    return t.objectValues(o);
  }, t.objectValues = (n) => t.objectKeys(n).map(function(i) {
    return n[i];
  }), t.objectKeys = typeof Object.keys == "function" ? (n) => Object.keys(n) : (n) => {
    const i = [];
    for (const o in n)
      Object.prototype.hasOwnProperty.call(n, o) && i.push(o);
    return i;
  }, t.find = (n, i) => {
    for (const o of n)
      if (i(o))
        return o;
  }, t.isInteger = typeof Number.isInteger == "function" ? (n) => Number.isInteger(n) : (n) => typeof n == "number" && isFinite(n) && Math.floor(n) === n;
  function s(n, i = " | ") {
    return n.map((o) => typeof o == "string" ? `'${o}'` : o).join(i);
  }
  t.joinValues = s, t.jsonStringifyReplacer = (n, i) => typeof i == "bigint" ? i.toString() : i;
})(Ye || (Ye = {}));
var Io;
(function(t) {
  t.mergeShapes = (e, r) => ({
    ...e,
    ...r
    // second overwrites first
  });
})(Io || (Io = {}));
const re = Ye.arrayToEnum([
  "string",
  "nan",
  "number",
  "integer",
  "float",
  "boolean",
  "date",
  "bigint",
  "symbol",
  "function",
  "undefined",
  "null",
  "array",
  "object",
  "unknown",
  "promise",
  "void",
  "never",
  "map",
  "set"
]), os = (t) => {
  switch (typeof t) {
    case "undefined":
      return re.undefined;
    case "string":
      return re.string;
    case "number":
      return isNaN(t) ? re.nan : re.number;
    case "boolean":
      return re.boolean;
    case "function":
      return re.function;
    case "bigint":
      return re.bigint;
    case "symbol":
      return re.symbol;
    case "object":
      return Array.isArray(t) ? re.array : t === null ? re.null : t.then && typeof t.then == "function" && t.catch && typeof t.catch == "function" ? re.promise : typeof Map < "u" && t instanceof Map ? re.map : typeof Set < "u" && t instanceof Set ? re.set : typeof Date < "u" && t instanceof Date ? re.date : re.object;
    default:
      return re.unknown;
  }
}, H = Ye.arrayToEnum([
  "invalid_type",
  "invalid_literal",
  "custom",
  "invalid_union",
  "invalid_union_discriminator",
  "invalid_enum_value",
  "unrecognized_keys",
  "invalid_arguments",
  "invalid_return_type",
  "invalid_date",
  "invalid_string",
  "too_small",
  "too_big",
  "invalid_intersection_types",
  "not_multiple_of",
  "not_finite"
]), $1 = (t) => JSON.stringify(t, null, 2).replace(/"([^"]+)":/g, "$1:");
class Sr extends Error {
  constructor(e) {
    super(), this.issues = [], this.addIssue = (s) => {
      this.issues = [...this.issues, s];
    }, this.addIssues = (s = []) => {
      this.issues = [...this.issues, ...s];
    };
    const r = new.target.prototype;
    Object.setPrototypeOf ? Object.setPrototypeOf(this, r) : this.__proto__ = r, this.name = "ZodError", this.issues = e;
  }
  get errors() {
    return this.issues;
  }
  format(e) {
    const r = e || function(i) {
      return i.message;
    }, s = { _errors: [] }, n = (i) => {
      for (const o of i.issues)
        if (o.code === "invalid_union")
          o.unionErrors.map(n);
        else if (o.code === "invalid_return_type")
          n(o.returnTypeError);
        else if (o.code === "invalid_arguments")
          n(o.argumentsError);
        else if (o.path.length === 0)
          s._errors.push(r(o));
        else {
          let a = s, u = 0;
          for (; u < o.path.length; ) {
            const c = o.path[u];
            u === o.path.length - 1 ? (a[c] = a[c] || { _errors: [] }, a[c]._errors.push(r(o))) : a[c] = a[c] || { _errors: [] }, a = a[c], u++;
          }
        }
    };
    return n(this), s;
  }
  toString() {
    return this.message;
  }
  get message() {
    return JSON.stringify(this.issues, Ye.jsonStringifyReplacer, 2);
  }
  get isEmpty() {
    return this.issues.length === 0;
  }
  flatten(e = (r) => r.message) {
    const r = {}, s = [];
    for (const n of this.issues)
      n.path.length > 0 ? (r[n.path[0]] = r[n.path[0]] || [], r[n.path[0]].push(e(n))) : s.push(e(n));
    return { formErrors: s, fieldErrors: r };
  }
  get formErrors() {
    return this.flatten();
  }
}
Sr.create = (t) => new Sr(t);
const Kn = (t, e) => {
  let r;
  switch (t.code) {
    case H.invalid_type:
      t.received === re.undefined ? r = "Required" : r = `Expected ${t.expected}, received ${t.received}`;
      break;
    case H.invalid_literal:
      r = `Invalid literal value, expected ${JSON.stringify(t.expected, Ye.jsonStringifyReplacer)}`;
      break;
    case H.unrecognized_keys:
      r = `Unrecognized key(s) in object: ${Ye.joinValues(t.keys, ", ")}`;
      break;
    case H.invalid_union:
      r = "Invalid input";
      break;
    case H.invalid_union_discriminator:
      r = `Invalid discriminator value. Expected ${Ye.joinValues(t.options)}`;
      break;
    case H.invalid_enum_value:
      r = `Invalid enum value. Expected ${Ye.joinValues(t.options)}, received '${t.received}'`;
      break;
    case H.invalid_arguments:
      r = "Invalid function arguments";
      break;
    case H.invalid_return_type:
      r = "Invalid function return type";
      break;
    case H.invalid_date:
      r = "Invalid date";
      break;
    case H.invalid_string:
      typeof t.validation == "object" ? "includes" in t.validation ? (r = `Invalid input: must include "${t.validation.includes}"`, typeof t.validation.position == "number" && (r = `${r} at one or more positions greater than or equal to ${t.validation.position}`)) : "startsWith" in t.validation ? r = `Invalid input: must start with "${t.validation.startsWith}"` : "endsWith" in t.validation ? r = `Invalid input: must end with "${t.validation.endsWith}"` : Ye.assertNever(t.validation) : t.validation !== "regex" ? r = `Invalid ${t.validation}` : r = "Invalid";
      break;
    case H.too_small:
      t.type === "array" ? r = `Array must contain ${t.exact ? "exactly" : t.inclusive ? "at least" : "more than"} ${t.minimum} element(s)` : t.type === "string" ? r = `String must contain ${t.exact ? "exactly" : t.inclusive ? "at least" : "over"} ${t.minimum} character(s)` : t.type === "number" ? r = `Number must be ${t.exact ? "exactly equal to " : t.inclusive ? "greater than or equal to " : "greater than "}${t.minimum}` : t.type === "date" ? r = `Date must be ${t.exact ? "exactly equal to " : t.inclusive ? "greater than or equal to " : "greater than "}${new Date(Number(t.minimum))}` : r = "Invalid input";
      break;
    case H.too_big:
      t.type === "array" ? r = `Array must contain ${t.exact ? "exactly" : t.inclusive ? "at most" : "less than"} ${t.maximum} element(s)` : t.type === "string" ? r = `String must contain ${t.exact ? "exactly" : t.inclusive ? "at most" : "under"} ${t.maximum} character(s)` : t.type === "number" ? r = `Number must be ${t.exact ? "exactly" : t.inclusive ? "less than or equal to" : "less than"} ${t.maximum}` : t.type === "bigint" ? r = `BigInt must be ${t.exact ? "exactly" : t.inclusive ? "less than or equal to" : "less than"} ${t.maximum}` : t.type === "date" ? r = `Date must be ${t.exact ? "exactly" : t.inclusive ? "smaller than or equal to" : "smaller than"} ${new Date(Number(t.maximum))}` : r = "Invalid input";
      break;
    case H.custom:
      r = "Invalid input";
      break;
    case H.invalid_intersection_types:
      r = "Intersection results could not be merged";
      break;
    case H.not_multiple_of:
      r = `Number must be a multiple of ${t.multipleOf}`;
      break;
    case H.not_finite:
      r = "Number must be finite";
      break;
    default:
      r = e.defaultError, Ye.assertNever(t);
  }
  return { message: r };
};
let th = Kn;
function V1(t) {
  th = t;
}
function ra() {
  return th;
}
const sa = (t) => {
  const { data: e, path: r, errorMaps: s, issueData: n } = t, i = [...r, ...n.path || []], o = {
    ...n,
    path: i
  };
  let a = "";
  const u = s.filter((c) => !!c).slice().reverse();
  for (const c of u)
    a = c(o, { data: e, defaultError: a }).message;
  return {
    ...n,
    path: i,
    message: n.message || a
  };
}, q1 = [];
function ie(t, e) {
  const r = sa({
    issueData: e,
    data: t.data,
    path: t.path,
    errorMaps: [
      t.common.contextualErrorMap,
      t.schemaErrorMap,
      ra(),
      Kn
      // then global default map
    ].filter((s) => !!s)
  });
  t.common.issues.push(r);
}
class Wt {
  constructor() {
    this.value = "valid";
  }
  dirty() {
    this.value === "valid" && (this.value = "dirty");
  }
  abort() {
    this.value !== "aborted" && (this.value = "aborted");
  }
  static mergeArray(e, r) {
    const s = [];
    for (const n of r) {
      if (n.status === "aborted")
        return ve;
      n.status === "dirty" && e.dirty(), s.push(n.value);
    }
    return { status: e.value, value: s };
  }
  static async mergeObjectAsync(e, r) {
    const s = [];
    for (const n of r)
      s.push({
        key: await n.key,
        value: await n.value
      });
    return Wt.mergeObjectSync(e, s);
  }
  static mergeObjectSync(e, r) {
    const s = {};
    for (const n of r) {
      const { key: i, value: o } = n;
      if (i.status === "aborted" || o.status === "aborted")
        return ve;
      i.status === "dirty" && e.dirty(), o.status === "dirty" && e.dirty(), (typeof o.value < "u" || n.alwaysSet) && (s[i.value] = o.value);
    }
    return { status: e.value, value: s };
  }
}
const ve = Object.freeze({
  status: "aborted"
}), rh = (t) => ({ status: "dirty", value: t }), Qt = (t) => ({ status: "valid", value: t }), xo = (t) => t.status === "aborted", Oo = (t) => t.status === "dirty", na = (t) => t.status === "valid", ia = (t) => typeof Promise < "u" && t instanceof Promise;
var ue;
(function(t) {
  t.errToObj = (e) => typeof e == "string" ? { message: e } : e || {}, t.toString = (e) => typeof e == "string" ? e : e == null ? void 0 : e.message;
})(ue || (ue = {}));
class zr {
  constructor(e, r, s, n) {
    this._cachedPath = [], this.parent = e, this.data = r, this._path = s, this._key = n;
  }
  get path() {
    return this._cachedPath.length || (this._key instanceof Array ? this._cachedPath.push(...this._path, ...this._key) : this._cachedPath.push(...this._path, this._key)), this._cachedPath;
  }
}
const dl = (t, e) => {
  if (na(e))
    return { success: !0, data: e.value };
  if (!t.common.issues.length)
    throw new Error("Validation failed but no issues detected.");
  return {
    success: !1,
    get error() {
      if (this._error)
        return this._error;
      const r = new Sr(t.common.issues);
      return this._error = r, this._error;
    }
  };
};
function Ie(t) {
  if (!t)
    return {};
  const { errorMap: e, invalid_type_error: r, required_error: s, description: n } = t;
  if (e && (r || s))
    throw new Error(`Can't use "invalid_type_error" or "required_error" in conjunction with custom error map.`);
  return e ? { errorMap: e, description: n } : { errorMap: (o, a) => o.code !== "invalid_type" ? { message: a.defaultError } : typeof a.data > "u" ? { message: s ?? a.defaultError } : { message: r ?? a.defaultError }, description: n };
}
class Re {
  constructor(e) {
    this.spa = this.safeParseAsync, this._def = e, this.parse = this.parse.bind(this), this.safeParse = this.safeParse.bind(this), this.parseAsync = this.parseAsync.bind(this), this.safeParseAsync = this.safeParseAsync.bind(this), this.spa = this.spa.bind(this), this.refine = this.refine.bind(this), this.refinement = this.refinement.bind(this), this.superRefine = this.superRefine.bind(this), this.optional = this.optional.bind(this), this.nullable = this.nullable.bind(this), this.nullish = this.nullish.bind(this), this.array = this.array.bind(this), this.promise = this.promise.bind(this), this.or = this.or.bind(this), this.and = this.and.bind(this), this.transform = this.transform.bind(this), this.brand = this.brand.bind(this), this.default = this.default.bind(this), this.catch = this.catch.bind(this), this.describe = this.describe.bind(this), this.pipe = this.pipe.bind(this), this.isNullable = this.isNullable.bind(this), this.isOptional = this.isOptional.bind(this);
  }
  get description() {
    return this._def.description;
  }
  _getType(e) {
    return os(e.data);
  }
  _getOrReturnCtx(e, r) {
    return r || {
      common: e.parent.common,
      data: e.data,
      parsedType: os(e.data),
      schemaErrorMap: this._def.errorMap,
      path: e.path,
      parent: e.parent
    };
  }
  _processInputParams(e) {
    return {
      status: new Wt(),
      ctx: {
        common: e.parent.common,
        data: e.data,
        parsedType: os(e.data),
        schemaErrorMap: this._def.errorMap,
        path: e.path,
        parent: e.parent
      }
    };
  }
  _parseSync(e) {
    const r = this._parse(e);
    if (ia(r))
      throw new Error("Synchronous parse encountered promise.");
    return r;
  }
  _parseAsync(e) {
    const r = this._parse(e);
    return Promise.resolve(r);
  }
  parse(e, r) {
    const s = this.safeParse(e, r);
    if (s.success)
      return s.data;
    throw s.error;
  }
  safeParse(e, r) {
    var s;
    const n = {
      common: {
        issues: [],
        async: (s = r == null ? void 0 : r.async) !== null && s !== void 0 ? s : !1,
        contextualErrorMap: r == null ? void 0 : r.errorMap
      },
      path: (r == null ? void 0 : r.path) || [],
      schemaErrorMap: this._def.errorMap,
      parent: null,
      data: e,
      parsedType: os(e)
    }, i = this._parseSync({ data: e, path: n.path, parent: n });
    return dl(n, i);
  }
  async parseAsync(e, r) {
    const s = await this.safeParseAsync(e, r);
    if (s.success)
      return s.data;
    throw s.error;
  }
  async safeParseAsync(e, r) {
    const s = {
      common: {
        issues: [],
        contextualErrorMap: r == null ? void 0 : r.errorMap,
        async: !0
      },
      path: (r == null ? void 0 : r.path) || [],
      schemaErrorMap: this._def.errorMap,
      parent: null,
      data: e,
      parsedType: os(e)
    }, n = this._parse({ data: e, path: s.path, parent: s }), i = await (ia(n) ? n : Promise.resolve(n));
    return dl(s, i);
  }
  refine(e, r) {
    const s = (n) => typeof r == "string" || typeof r > "u" ? { message: r } : typeof r == "function" ? r(n) : r;
    return this._refinement((n, i) => {
      const o = e(n), a = () => i.addIssue({
        code: H.custom,
        ...s(n)
      });
      return typeof Promise < "u" && o instanceof Promise ? o.then((u) => u ? !0 : (a(), !1)) : o ? !0 : (a(), !1);
    });
  }
  refinement(e, r) {
    return this._refinement((s, n) => e(s) ? !0 : (n.addIssue(typeof r == "function" ? r(s, n) : r), !1));
  }
  _refinement(e) {
    return new Tr({
      schema: this,
      typeName: ge.ZodEffects,
      effect: { type: "refinement", refinement: e }
    });
  }
  superRefine(e) {
    return this._refinement(e);
  }
  optional() {
    return Yr.create(this, this._def);
  }
  nullable() {
    return Ls.create(this, this._def);
  }
  nullish() {
    return this.nullable().optional();
  }
  array() {
    return Ir.create(this, this._def);
  }
  promise() {
    return cn.create(this, this._def);
  }
  or(e) {
    return Yn.create([this, e], this._def);
  }
  and(e) {
    return Jn.create(this, e, this._def);
  }
  transform(e) {
    return new Tr({
      ...Ie(this._def),
      schema: this,
      typeName: ge.ZodEffects,
      effect: { type: "transform", transform: e }
    });
  }
  default(e) {
    const r = typeof e == "function" ? e : () => e;
    return new ri({
      ...Ie(this._def),
      innerType: this,
      defaultValue: r,
      typeName: ge.ZodDefault
    });
  }
  brand() {
    return new nh({
      typeName: ge.ZodBranded,
      type: this,
      ...Ie(this._def)
    });
  }
  catch(e) {
    const r = typeof e == "function" ? e : () => e;
    return new ua({
      ...Ie(this._def),
      innerType: this,
      catchValue: r,
      typeName: ge.ZodCatch
    });
  }
  describe(e) {
    const r = this.constructor;
    return new r({
      ...this._def,
      description: e
    });
  }
  pipe(e) {
    return gi.create(this, e);
  }
  isOptional() {
    return this.safeParse(void 0).success;
  }
  isNullable() {
    return this.safeParse(null).success;
  }
}
const Z1 = /^c[^\s-]{8,}$/i, F1 = /^[a-z][a-z0-9]*$/, W1 = /[0-9A-HJKMNP-TV-Z]{26}/, K1 = /^([a-f0-9]{8}-[a-f0-9]{4}-[1-5][a-f0-9]{3}-[a-f0-9]{4}-[a-f0-9]{12}|00000000-0000-0000-0000-000000000000)$/i, H1 = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[(((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2}))\.){3}((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2}))\])|(\[IPv6:(([a-f0-9]{1,4}:){7}|::([a-f0-9]{1,4}:){0,6}|([a-f0-9]{1,4}:){1}:([a-f0-9]{1,4}:){0,5}|([a-f0-9]{1,4}:){2}:([a-f0-9]{1,4}:){0,4}|([a-f0-9]{1,4}:){3}:([a-f0-9]{1,4}:){0,3}|([a-f0-9]{1,4}:){4}:([a-f0-9]{1,4}:){0,2}|([a-f0-9]{1,4}:){5}:([a-f0-9]{1,4}:){0,1})([a-f0-9]{1,4}|(((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2}))\.){3}((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2})))\])|([A-Za-z0-9]([A-Za-z0-9-]*[A-Za-z0-9])*(\.[A-Za-z]{2,})+))$/, B1 = new RegExp("^(\\p{Extended_Pictographic}|\\p{Emoji_Component})+$", "u"), G1 = /^(((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2}))\.){3}((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2}))$/, Y1 = /^(([a-f0-9]{1,4}:){7}|::([a-f0-9]{1,4}:){0,6}|([a-f0-9]{1,4}:){1}:([a-f0-9]{1,4}:){0,5}|([a-f0-9]{1,4}:){2}:([a-f0-9]{1,4}:){0,4}|([a-f0-9]{1,4}:){3}:([a-f0-9]{1,4}:){0,3}|([a-f0-9]{1,4}:){4}:([a-f0-9]{1,4}:){0,2}|([a-f0-9]{1,4}:){5}:([a-f0-9]{1,4}:){0,1})([a-f0-9]{1,4}|(((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2}))\.){3}((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2})))$/, J1 = (t) => t.precision ? t.offset ? new RegExp(`^\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}\\.\\d{${t.precision}}(([+-]\\d{2}(:?\\d{2})?)|Z)$`) : new RegExp(`^\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}\\.\\d{${t.precision}}Z$`) : t.precision === 0 ? t.offset ? new RegExp("^\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(([+-]\\d{2}(:?\\d{2})?)|Z)$") : new RegExp("^\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}Z$") : t.offset ? new RegExp("^\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(\\.\\d+)?(([+-]\\d{2}(:?\\d{2})?)|Z)$") : new RegExp("^\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(\\.\\d+)?Z$");
function X1(t, e) {
  return !!((e === "v4" || !e) && G1.test(t) || (e === "v6" || !e) && Y1.test(t));
}
class br extends Re {
  constructor() {
    super(...arguments), this._regex = (e, r, s) => this.refinement((n) => e.test(n), {
      validation: r,
      code: H.invalid_string,
      ...ue.errToObj(s)
    }), this.nonempty = (e) => this.min(1, ue.errToObj(e)), this.trim = () => new br({
      ...this._def,
      checks: [...this._def.checks, { kind: "trim" }]
    }), this.toLowerCase = () => new br({
      ...this._def,
      checks: [...this._def.checks, { kind: "toLowerCase" }]
    }), this.toUpperCase = () => new br({
      ...this._def,
      checks: [...this._def.checks, { kind: "toUpperCase" }]
    });
  }
  _parse(e) {
    if (this._def.coerce && (e.data = String(e.data)), this._getType(e) !== re.string) {
      const i = this._getOrReturnCtx(e);
      return ie(
        i,
        {
          code: H.invalid_type,
          expected: re.string,
          received: i.parsedType
        }
        //
      ), ve;
    }
    const s = new Wt();
    let n;
    for (const i of this._def.checks)
      if (i.kind === "min")
        e.data.length < i.value && (n = this._getOrReturnCtx(e, n), ie(n, {
          code: H.too_small,
          minimum: i.value,
          type: "string",
          inclusive: !0,
          exact: !1,
          message: i.message
        }), s.dirty());
      else if (i.kind === "max")
        e.data.length > i.value && (n = this._getOrReturnCtx(e, n), ie(n, {
          code: H.too_big,
          maximum: i.value,
          type: "string",
          inclusive: !0,
          exact: !1,
          message: i.message
        }), s.dirty());
      else if (i.kind === "length") {
        const o = e.data.length > i.value, a = e.data.length < i.value;
        (o || a) && (n = this._getOrReturnCtx(e, n), o ? ie(n, {
          code: H.too_big,
          maximum: i.value,
          type: "string",
          inclusive: !0,
          exact: !0,
          message: i.message
        }) : a && ie(n, {
          code: H.too_small,
          minimum: i.value,
          type: "string",
          inclusive: !0,
          exact: !0,
          message: i.message
        }), s.dirty());
      } else if (i.kind === "email")
        H1.test(e.data) || (n = this._getOrReturnCtx(e, n), ie(n, {
          validation: "email",
          code: H.invalid_string,
          message: i.message
        }), s.dirty());
      else if (i.kind === "emoji")
        B1.test(e.data) || (n = this._getOrReturnCtx(e, n), ie(n, {
          validation: "emoji",
          code: H.invalid_string,
          message: i.message
        }), s.dirty());
      else if (i.kind === "uuid")
        K1.test(e.data) || (n = this._getOrReturnCtx(e, n), ie(n, {
          validation: "uuid",
          code: H.invalid_string,
          message: i.message
        }), s.dirty());
      else if (i.kind === "cuid")
        Z1.test(e.data) || (n = this._getOrReturnCtx(e, n), ie(n, {
          validation: "cuid",
          code: H.invalid_string,
          message: i.message
        }), s.dirty());
      else if (i.kind === "cuid2")
        F1.test(e.data) || (n = this._getOrReturnCtx(e, n), ie(n, {
          validation: "cuid2",
          code: H.invalid_string,
          message: i.message
        }), s.dirty());
      else if (i.kind === "ulid")
        W1.test(e.data) || (n = this._getOrReturnCtx(e, n), ie(n, {
          validation: "ulid",
          code: H.invalid_string,
          message: i.message
        }), s.dirty());
      else if (i.kind === "url")
        try {
          new URL(e.data);
        } catch {
          n = this._getOrReturnCtx(e, n), ie(n, {
            validation: "url",
            code: H.invalid_string,
            message: i.message
          }), s.dirty();
        }
      else
        i.kind === "regex" ? (i.regex.lastIndex = 0, i.regex.test(e.data) || (n = this._getOrReturnCtx(e, n), ie(n, {
          validation: "regex",
          code: H.invalid_string,
          message: i.message
        }), s.dirty())) : i.kind === "trim" ? e.data = e.data.trim() : i.kind === "includes" ? e.data.includes(i.value, i.position) || (n = this._getOrReturnCtx(e, n), ie(n, {
          code: H.invalid_string,
          validation: { includes: i.value, position: i.position },
          message: i.message
        }), s.dirty()) : i.kind === "toLowerCase" ? e.data = e.data.toLowerCase() : i.kind === "toUpperCase" ? e.data = e.data.toUpperCase() : i.kind === "startsWith" ? e.data.startsWith(i.value) || (n = this._getOrReturnCtx(e, n), ie(n, {
          code: H.invalid_string,
          validation: { startsWith: i.value },
          message: i.message
        }), s.dirty()) : i.kind === "endsWith" ? e.data.endsWith(i.value) || (n = this._getOrReturnCtx(e, n), ie(n, {
          code: H.invalid_string,
          validation: { endsWith: i.value },
          message: i.message
        }), s.dirty()) : i.kind === "datetime" ? J1(i).test(e.data) || (n = this._getOrReturnCtx(e, n), ie(n, {
          code: H.invalid_string,
          validation: "datetime",
          message: i.message
        }), s.dirty()) : i.kind === "ip" ? X1(e.data, i.version) || (n = this._getOrReturnCtx(e, n), ie(n, {
          validation: "ip",
          code: H.invalid_string,
          message: i.message
        }), s.dirty()) : Ye.assertNever(i);
    return { status: s.value, value: e.data };
  }
  _addCheck(e) {
    return new br({
      ...this._def,
      checks: [...this._def.checks, e]
    });
  }
  email(e) {
    return this._addCheck({ kind: "email", ...ue.errToObj(e) });
  }
  url(e) {
    return this._addCheck({ kind: "url", ...ue.errToObj(e) });
  }
  emoji(e) {
    return this._addCheck({ kind: "emoji", ...ue.errToObj(e) });
  }
  uuid(e) {
    return this._addCheck({ kind: "uuid", ...ue.errToObj(e) });
  }
  cuid(e) {
    return this._addCheck({ kind: "cuid", ...ue.errToObj(e) });
  }
  cuid2(e) {
    return this._addCheck({ kind: "cuid2", ...ue.errToObj(e) });
  }
  ulid(e) {
    return this._addCheck({ kind: "ulid", ...ue.errToObj(e) });
  }
  ip(e) {
    return this._addCheck({ kind: "ip", ...ue.errToObj(e) });
  }
  datetime(e) {
    var r;
    return typeof e == "string" ? this._addCheck({
      kind: "datetime",
      precision: null,
      offset: !1,
      message: e
    }) : this._addCheck({
      kind: "datetime",
      precision: typeof (e == null ? void 0 : e.precision) > "u" ? null : e == null ? void 0 : e.precision,
      offset: (r = e == null ? void 0 : e.offset) !== null && r !== void 0 ? r : !1,
      ...ue.errToObj(e == null ? void 0 : e.message)
    });
  }
  regex(e, r) {
    return this._addCheck({
      kind: "regex",
      regex: e,
      ...ue.errToObj(r)
    });
  }
  includes(e, r) {
    return this._addCheck({
      kind: "includes",
      value: e,
      position: r == null ? void 0 : r.position,
      ...ue.errToObj(r == null ? void 0 : r.message)
    });
  }
  startsWith(e, r) {
    return this._addCheck({
      kind: "startsWith",
      value: e,
      ...ue.errToObj(r)
    });
  }
  endsWith(e, r) {
    return this._addCheck({
      kind: "endsWith",
      value: e,
      ...ue.errToObj(r)
    });
  }
  min(e, r) {
    return this._addCheck({
      kind: "min",
      value: e,
      ...ue.errToObj(r)
    });
  }
  max(e, r) {
    return this._addCheck({
      kind: "max",
      value: e,
      ...ue.errToObj(r)
    });
  }
  length(e, r) {
    return this._addCheck({
      kind: "length",
      value: e,
      ...ue.errToObj(r)
    });
  }
  get isDatetime() {
    return !!this._def.checks.find((e) => e.kind === "datetime");
  }
  get isEmail() {
    return !!this._def.checks.find((e) => e.kind === "email");
  }
  get isURL() {
    return !!this._def.checks.find((e) => e.kind === "url");
  }
  get isEmoji() {
    return !!this._def.checks.find((e) => e.kind === "emoji");
  }
  get isUUID() {
    return !!this._def.checks.find((e) => e.kind === "uuid");
  }
  get isCUID() {
    return !!this._def.checks.find((e) => e.kind === "cuid");
  }
  get isCUID2() {
    return !!this._def.checks.find((e) => e.kind === "cuid2");
  }
  get isULID() {
    return !!this._def.checks.find((e) => e.kind === "ulid");
  }
  get isIP() {
    return !!this._def.checks.find((e) => e.kind === "ip");
  }
  get minLength() {
    let e = null;
    for (const r of this._def.checks)
      r.kind === "min" && (e === null || r.value > e) && (e = r.value);
    return e;
  }
  get maxLength() {
    let e = null;
    for (const r of this._def.checks)
      r.kind === "max" && (e === null || r.value < e) && (e = r.value);
    return e;
  }
}
br.create = (t) => {
  var e;
  return new br({
    checks: [],
    typeName: ge.ZodString,
    coerce: (e = t == null ? void 0 : t.coerce) !== null && e !== void 0 ? e : !1,
    ...Ie(t)
  });
};
function Q1(t, e) {
  const r = (t.toString().split(".")[1] || "").length, s = (e.toString().split(".")[1] || "").length, n = r > s ? r : s, i = parseInt(t.toFixed(n).replace(".", "")), o = parseInt(e.toFixed(n).replace(".", ""));
  return i % o / Math.pow(10, n);
}
class fs extends Re {
  constructor() {
    super(...arguments), this.min = this.gte, this.max = this.lte, this.step = this.multipleOf;
  }
  _parse(e) {
    if (this._def.coerce && (e.data = Number(e.data)), this._getType(e) !== re.number) {
      const i = this._getOrReturnCtx(e);
      return ie(i, {
        code: H.invalid_type,
        expected: re.number,
        received: i.parsedType
      }), ve;
    }
    let s;
    const n = new Wt();
    for (const i of this._def.checks)
      i.kind === "int" ? Ye.isInteger(e.data) || (s = this._getOrReturnCtx(e, s), ie(s, {
        code: H.invalid_type,
        expected: "integer",
        received: "float",
        message: i.message
      }), n.dirty()) : i.kind === "min" ? (i.inclusive ? e.data < i.value : e.data <= i.value) && (s = this._getOrReturnCtx(e, s), ie(s, {
        code: H.too_small,
        minimum: i.value,
        type: "number",
        inclusive: i.inclusive,
        exact: !1,
        message: i.message
      }), n.dirty()) : i.kind === "max" ? (i.inclusive ? e.data > i.value : e.data >= i.value) && (s = this._getOrReturnCtx(e, s), ie(s, {
        code: H.too_big,
        maximum: i.value,
        type: "number",
        inclusive: i.inclusive,
        exact: !1,
        message: i.message
      }), n.dirty()) : i.kind === "multipleOf" ? Q1(e.data, i.value) !== 0 && (s = this._getOrReturnCtx(e, s), ie(s, {
        code: H.not_multiple_of,
        multipleOf: i.value,
        message: i.message
      }), n.dirty()) : i.kind === "finite" ? Number.isFinite(e.data) || (s = this._getOrReturnCtx(e, s), ie(s, {
        code: H.not_finite,
        message: i.message
      }), n.dirty()) : Ye.assertNever(i);
    return { status: n.value, value: e.data };
  }
  gte(e, r) {
    return this.setLimit("min", e, !0, ue.toString(r));
  }
  gt(e, r) {
    return this.setLimit("min", e, !1, ue.toString(r));
  }
  lte(e, r) {
    return this.setLimit("max", e, !0, ue.toString(r));
  }
  lt(e, r) {
    return this.setLimit("max", e, !1, ue.toString(r));
  }
  setLimit(e, r, s, n) {
    return new fs({
      ...this._def,
      checks: [
        ...this._def.checks,
        {
          kind: e,
          value: r,
          inclusive: s,
          message: ue.toString(n)
        }
      ]
    });
  }
  _addCheck(e) {
    return new fs({
      ...this._def,
      checks: [...this._def.checks, e]
    });
  }
  int(e) {
    return this._addCheck({
      kind: "int",
      message: ue.toString(e)
    });
  }
  positive(e) {
    return this._addCheck({
      kind: "min",
      value: 0,
      inclusive: !1,
      message: ue.toString(e)
    });
  }
  negative(e) {
    return this._addCheck({
      kind: "max",
      value: 0,
      inclusive: !1,
      message: ue.toString(e)
    });
  }
  nonpositive(e) {
    return this._addCheck({
      kind: "max",
      value: 0,
      inclusive: !0,
      message: ue.toString(e)
    });
  }
  nonnegative(e) {
    return this._addCheck({
      kind: "min",
      value: 0,
      inclusive: !0,
      message: ue.toString(e)
    });
  }
  multipleOf(e, r) {
    return this._addCheck({
      kind: "multipleOf",
      value: e,
      message: ue.toString(r)
    });
  }
  finite(e) {
    return this._addCheck({
      kind: "finite",
      message: ue.toString(e)
    });
  }
  safe(e) {
    return this._addCheck({
      kind: "min",
      inclusive: !0,
      value: Number.MIN_SAFE_INTEGER,
      message: ue.toString(e)
    })._addCheck({
      kind: "max",
      inclusive: !0,
      value: Number.MAX_SAFE_INTEGER,
      message: ue.toString(e)
    });
  }
  get minValue() {
    let e = null;
    for (const r of this._def.checks)
      r.kind === "min" && (e === null || r.value > e) && (e = r.value);
    return e;
  }
  get maxValue() {
    let e = null;
    for (const r of this._def.checks)
      r.kind === "max" && (e === null || r.value < e) && (e = r.value);
    return e;
  }
  get isInt() {
    return !!this._def.checks.find((e) => e.kind === "int" || e.kind === "multipleOf" && Ye.isInteger(e.value));
  }
  get isFinite() {
    let e = null, r = null;
    for (const s of this._def.checks) {
      if (s.kind === "finite" || s.kind === "int" || s.kind === "multipleOf")
        return !0;
      s.kind === "min" ? (r === null || s.value > r) && (r = s.value) : s.kind === "max" && (e === null || s.value < e) && (e = s.value);
    }
    return Number.isFinite(r) && Number.isFinite(e);
  }
}
fs.create = (t) => new fs({
  checks: [],
  typeName: ge.ZodNumber,
  coerce: (t == null ? void 0 : t.coerce) || !1,
  ...Ie(t)
});
class gs extends Re {
  constructor() {
    super(...arguments), this.min = this.gte, this.max = this.lte;
  }
  _parse(e) {
    if (this._def.coerce && (e.data = BigInt(e.data)), this._getType(e) !== re.bigint) {
      const i = this._getOrReturnCtx(e);
      return ie(i, {
        code: H.invalid_type,
        expected: re.bigint,
        received: i.parsedType
      }), ve;
    }
    let s;
    const n = new Wt();
    for (const i of this._def.checks)
      i.kind === "min" ? (i.inclusive ? e.data < i.value : e.data <= i.value) && (s = this._getOrReturnCtx(e, s), ie(s, {
        code: H.too_small,
        type: "bigint",
        minimum: i.value,
        inclusive: i.inclusive,
        message: i.message
      }), n.dirty()) : i.kind === "max" ? (i.inclusive ? e.data > i.value : e.data >= i.value) && (s = this._getOrReturnCtx(e, s), ie(s, {
        code: H.too_big,
        type: "bigint",
        maximum: i.value,
        inclusive: i.inclusive,
        message: i.message
      }), n.dirty()) : i.kind === "multipleOf" ? e.data % i.value !== BigInt(0) && (s = this._getOrReturnCtx(e, s), ie(s, {
        code: H.not_multiple_of,
        multipleOf: i.value,
        message: i.message
      }), n.dirty()) : Ye.assertNever(i);
    return { status: n.value, value: e.data };
  }
  gte(e, r) {
    return this.setLimit("min", e, !0, ue.toString(r));
  }
  gt(e, r) {
    return this.setLimit("min", e, !1, ue.toString(r));
  }
  lte(e, r) {
    return this.setLimit("max", e, !0, ue.toString(r));
  }
  lt(e, r) {
    return this.setLimit("max", e, !1, ue.toString(r));
  }
  setLimit(e, r, s, n) {
    return new gs({
      ...this._def,
      checks: [
        ...this._def.checks,
        {
          kind: e,
          value: r,
          inclusive: s,
          message: ue.toString(n)
        }
      ]
    });
  }
  _addCheck(e) {
    return new gs({
      ...this._def,
      checks: [...this._def.checks, e]
    });
  }
  positive(e) {
    return this._addCheck({
      kind: "min",
      value: BigInt(0),
      inclusive: !1,
      message: ue.toString(e)
    });
  }
  negative(e) {
    return this._addCheck({
      kind: "max",
      value: BigInt(0),
      inclusive: !1,
      message: ue.toString(e)
    });
  }
  nonpositive(e) {
    return this._addCheck({
      kind: "max",
      value: BigInt(0),
      inclusive: !0,
      message: ue.toString(e)
    });
  }
  nonnegative(e) {
    return this._addCheck({
      kind: "min",
      value: BigInt(0),
      inclusive: !0,
      message: ue.toString(e)
    });
  }
  multipleOf(e, r) {
    return this._addCheck({
      kind: "multipleOf",
      value: e,
      message: ue.toString(r)
    });
  }
  get minValue() {
    let e = null;
    for (const r of this._def.checks)
      r.kind === "min" && (e === null || r.value > e) && (e = r.value);
    return e;
  }
  get maxValue() {
    let e = null;
    for (const r of this._def.checks)
      r.kind === "max" && (e === null || r.value < e) && (e = r.value);
    return e;
  }
}
gs.create = (t) => {
  var e;
  return new gs({
    checks: [],
    typeName: ge.ZodBigInt,
    coerce: (e = t == null ? void 0 : t.coerce) !== null && e !== void 0 ? e : !1,
    ...Ie(t)
  });
};
class Hn extends Re {
  _parse(e) {
    if (this._def.coerce && (e.data = !!e.data), this._getType(e) !== re.boolean) {
      const s = this._getOrReturnCtx(e);
      return ie(s, {
        code: H.invalid_type,
        expected: re.boolean,
        received: s.parsedType
      }), ve;
    }
    return Qt(e.data);
  }
}
Hn.create = (t) => new Hn({
  typeName: ge.ZodBoolean,
  coerce: (t == null ? void 0 : t.coerce) || !1,
  ...Ie(t)
});
class As extends Re {
  _parse(e) {
    if (this._def.coerce && (e.data = new Date(e.data)), this._getType(e) !== re.date) {
      const i = this._getOrReturnCtx(e);
      return ie(i, {
        code: H.invalid_type,
        expected: re.date,
        received: i.parsedType
      }), ve;
    }
    if (isNaN(e.data.getTime())) {
      const i = this._getOrReturnCtx(e);
      return ie(i, {
        code: H.invalid_date
      }), ve;
    }
    const s = new Wt();
    let n;
    for (const i of this._def.checks)
      i.kind === "min" ? e.data.getTime() < i.value && (n = this._getOrReturnCtx(e, n), ie(n, {
        code: H.too_small,
        message: i.message,
        inclusive: !0,
        exact: !1,
        minimum: i.value,
        type: "date"
      }), s.dirty()) : i.kind === "max" ? e.data.getTime() > i.value && (n = this._getOrReturnCtx(e, n), ie(n, {
        code: H.too_big,
        message: i.message,
        inclusive: !0,
        exact: !1,
        maximum: i.value,
        type: "date"
      }), s.dirty()) : Ye.assertNever(i);
    return {
      status: s.value,
      value: new Date(e.data.getTime())
    };
  }
  _addCheck(e) {
    return new As({
      ...this._def,
      checks: [...this._def.checks, e]
    });
  }
  min(e, r) {
    return this._addCheck({
      kind: "min",
      value: e.getTime(),
      message: ue.toString(r)
    });
  }
  max(e, r) {
    return this._addCheck({
      kind: "max",
      value: e.getTime(),
      message: ue.toString(r)
    });
  }
  get minDate() {
    let e = null;
    for (const r of this._def.checks)
      r.kind === "min" && (e === null || r.value > e) && (e = r.value);
    return e != null ? new Date(e) : null;
  }
  get maxDate() {
    let e = null;
    for (const r of this._def.checks)
      r.kind === "max" && (e === null || r.value < e) && (e = r.value);
    return e != null ? new Date(e) : null;
  }
}
As.create = (t) => new As({
  checks: [],
  coerce: (t == null ? void 0 : t.coerce) || !1,
  typeName: ge.ZodDate,
  ...Ie(t)
});
class aa extends Re {
  _parse(e) {
    if (this._getType(e) !== re.symbol) {
      const s = this._getOrReturnCtx(e);
      return ie(s, {
        code: H.invalid_type,
        expected: re.symbol,
        received: s.parsedType
      }), ve;
    }
    return Qt(e.data);
  }
}
aa.create = (t) => new aa({
  typeName: ge.ZodSymbol,
  ...Ie(t)
});
class Bn extends Re {
  _parse(e) {
    if (this._getType(e) !== re.undefined) {
      const s = this._getOrReturnCtx(e);
      return ie(s, {
        code: H.invalid_type,
        expected: re.undefined,
        received: s.parsedType
      }), ve;
    }
    return Qt(e.data);
  }
}
Bn.create = (t) => new Bn({
  typeName: ge.ZodUndefined,
  ...Ie(t)
});
class Gn extends Re {
  _parse(e) {
    if (this._getType(e) !== re.null) {
      const s = this._getOrReturnCtx(e);
      return ie(s, {
        code: H.invalid_type,
        expected: re.null,
        received: s.parsedType
      }), ve;
    }
    return Qt(e.data);
  }
}
Gn.create = (t) => new Gn({
  typeName: ge.ZodNull,
  ...Ie(t)
});
class on extends Re {
  constructor() {
    super(...arguments), this._any = !0;
  }
  _parse(e) {
    return Qt(e.data);
  }
}
on.create = (t) => new on({
  typeName: ge.ZodAny,
  ...Ie(t)
});
class Cs extends Re {
  constructor() {
    super(...arguments), this._unknown = !0;
  }
  _parse(e) {
    return Qt(e.data);
  }
}
Cs.create = (t) => new Cs({
  typeName: ge.ZodUnknown,
  ...Ie(t)
});
class Xr extends Re {
  _parse(e) {
    const r = this._getOrReturnCtx(e);
    return ie(r, {
      code: H.invalid_type,
      expected: re.never,
      received: r.parsedType
    }), ve;
  }
}
Xr.create = (t) => new Xr({
  typeName: ge.ZodNever,
  ...Ie(t)
});
class oa extends Re {
  _parse(e) {
    if (this._getType(e) !== re.undefined) {
      const s = this._getOrReturnCtx(e);
      return ie(s, {
        code: H.invalid_type,
        expected: re.void,
        received: s.parsedType
      }), ve;
    }
    return Qt(e.data);
  }
}
oa.create = (t) => new oa({
  typeName: ge.ZodVoid,
  ...Ie(t)
});
class Ir extends Re {
  _parse(e) {
    const { ctx: r, status: s } = this._processInputParams(e), n = this._def;
    if (r.parsedType !== re.array)
      return ie(r, {
        code: H.invalid_type,
        expected: re.array,
        received: r.parsedType
      }), ve;
    if (n.exactLength !== null) {
      const o = r.data.length > n.exactLength.value, a = r.data.length < n.exactLength.value;
      (o || a) && (ie(r, {
        code: o ? H.too_big : H.too_small,
        minimum: a ? n.exactLength.value : void 0,
        maximum: o ? n.exactLength.value : void 0,
        type: "array",
        inclusive: !0,
        exact: !0,
        message: n.exactLength.message
      }), s.dirty());
    }
    if (n.minLength !== null && r.data.length < n.minLength.value && (ie(r, {
      code: H.too_small,
      minimum: n.minLength.value,
      type: "array",
      inclusive: !0,
      exact: !1,
      message: n.minLength.message
    }), s.dirty()), n.maxLength !== null && r.data.length > n.maxLength.value && (ie(r, {
      code: H.too_big,
      maximum: n.maxLength.value,
      type: "array",
      inclusive: !0,
      exact: !1,
      message: n.maxLength.message
    }), s.dirty()), r.common.async)
      return Promise.all([...r.data].map((o, a) => n.type._parseAsync(new zr(r, o, r.path, a)))).then((o) => Wt.mergeArray(s, o));
    const i = [...r.data].map((o, a) => n.type._parseSync(new zr(r, o, r.path, a)));
    return Wt.mergeArray(s, i);
  }
  get element() {
    return this._def.type;
  }
  min(e, r) {
    return new Ir({
      ...this._def,
      minLength: { value: e, message: ue.toString(r) }
    });
  }
  max(e, r) {
    return new Ir({
      ...this._def,
      maxLength: { value: e, message: ue.toString(r) }
    });
  }
  length(e, r) {
    return new Ir({
      ...this._def,
      exactLength: { value: e, message: ue.toString(r) }
    });
  }
  nonempty(e) {
    return this.min(1, e);
  }
}
Ir.create = (t, e) => new Ir({
  type: t,
  minLength: null,
  maxLength: null,
  exactLength: null,
  typeName: ge.ZodArray,
  ...Ie(e)
});
function Ys(t) {
  if (t instanceof dt) {
    const e = {};
    for (const r in t.shape) {
      const s = t.shape[r];
      e[r] = Yr.create(Ys(s));
    }
    return new dt({
      ...t._def,
      shape: () => e
    });
  } else
    return t instanceof Ir ? new Ir({
      ...t._def,
      type: Ys(t.element)
    }) : t instanceof Yr ? Yr.create(Ys(t.unwrap())) : t instanceof Ls ? Ls.create(Ys(t.unwrap())) : t instanceof $r ? $r.create(t.items.map((e) => Ys(e))) : t;
}
class dt extends Re {
  constructor() {
    super(...arguments), this._cached = null, this.nonstrict = this.passthrough, this.augment = this.extend;
  }
  _getCached() {
    if (this._cached !== null)
      return this._cached;
    const e = this._def.shape(), r = Ye.objectKeys(e);
    return this._cached = { shape: e, keys: r };
  }
  _parse(e) {
    if (this._getType(e) !== re.object) {
      const c = this._getOrReturnCtx(e);
      return ie(c, {
        code: H.invalid_type,
        expected: re.object,
        received: c.parsedType
      }), ve;
    }
    const { status: s, ctx: n } = this._processInputParams(e), { shape: i, keys: o } = this._getCached(), a = [];
    if (!(this._def.catchall instanceof Xr && this._def.unknownKeys === "strip"))
      for (const c in n.data)
        o.includes(c) || a.push(c);
    const u = [];
    for (const c of o) {
      const h = i[c], p = n.data[c];
      u.push({
        key: { status: "valid", value: c },
        value: h._parse(new zr(n, p, n.path, c)),
        alwaysSet: c in n.data
      });
    }
    if (this._def.catchall instanceof Xr) {
      const c = this._def.unknownKeys;
      if (c === "passthrough")
        for (const h of a)
          u.push({
            key: { status: "valid", value: h },
            value: { status: "valid", value: n.data[h] }
          });
      else if (c === "strict")
        a.length > 0 && (ie(n, {
          code: H.unrecognized_keys,
          keys: a
        }), s.dirty());
      else if (c !== "strip")
        throw new Error("Internal ZodObject error: invalid unknownKeys value.");
    } else {
      const c = this._def.catchall;
      for (const h of a) {
        const p = n.data[h];
        u.push({
          key: { status: "valid", value: h },
          value: c._parse(
            new zr(n, p, n.path, h)
            //, ctx.child(key), value, getParsedType(value)
          ),
          alwaysSet: h in n.data
        });
      }
    }
    return n.common.async ? Promise.resolve().then(async () => {
      const c = [];
      for (const h of u) {
        const p = await h.key;
        c.push({
          key: p,
          value: await h.value,
          alwaysSet: h.alwaysSet
        });
      }
      return c;
    }).then((c) => Wt.mergeObjectSync(s, c)) : Wt.mergeObjectSync(s, u);
  }
  get shape() {
    return this._def.shape();
  }
  strict(e) {
    return ue.errToObj, new dt({
      ...this._def,
      unknownKeys: "strict",
      ...e !== void 0 ? {
        errorMap: (r, s) => {
          var n, i, o, a;
          const u = (o = (i = (n = this._def).errorMap) === null || i === void 0 ? void 0 : i.call(n, r, s).message) !== null && o !== void 0 ? o : s.defaultError;
          return r.code === "unrecognized_keys" ? {
            message: (a = ue.errToObj(e).message) !== null && a !== void 0 ? a : u
          } : {
            message: u
          };
        }
      } : {}
    });
  }
  strip() {
    return new dt({
      ...this._def,
      unknownKeys: "strip"
    });
  }
  passthrough() {
    return new dt({
      ...this._def,
      unknownKeys: "passthrough"
    });
  }
  // const AugmentFactory =
  //   <Def extends ZodObjectDef>(def: Def) =>
  //   <Augmentation extends ZodRawShape>(
  //     augmentation: Augmentation
  //   ): ZodObject<
  //     extendShape<ReturnType<Def["shape"]>, Augmentation>,
  //     Def["unknownKeys"],
  //     Def["catchall"]
  //   > => {
  //     return new ZodObject({
  //       ...def,
  //       shape: () => ({
  //         ...def.shape(),
  //         ...augmentation,
  //       }),
  //     }) as any;
  //   };
  extend(e) {
    return new dt({
      ...this._def,
      shape: () => ({
        ...this._def.shape(),
        ...e
      })
    });
  }
  /**
   * Prior to zod@1.0.12 there was a bug in the
   * inferred type of merged objects. Please
   * upgrade if you are experiencing issues.
   */
  merge(e) {
    return new dt({
      unknownKeys: e._def.unknownKeys,
      catchall: e._def.catchall,
      shape: () => ({
        ...this._def.shape(),
        ...e._def.shape()
      }),
      typeName: ge.ZodObject
    });
  }
  // merge<
  //   Incoming extends AnyZodObject,
  //   Augmentation extends Incoming["shape"],
  //   NewOutput extends {
  //     [k in keyof Augmentation | keyof Output]: k extends keyof Augmentation
  //       ? Augmentation[k]["_output"]
  //       : k extends keyof Output
  //       ? Output[k]
  //       : never;
  //   },
  //   NewInput extends {
  //     [k in keyof Augmentation | keyof Input]: k extends keyof Augmentation
  //       ? Augmentation[k]["_input"]
  //       : k extends keyof Input
  //       ? Input[k]
  //       : never;
  //   }
  // >(
  //   merging: Incoming
  // ): ZodObject<
  //   extendShape<T, ReturnType<Incoming["_def"]["shape"]>>,
  //   Incoming["_def"]["unknownKeys"],
  //   Incoming["_def"]["catchall"],
  //   NewOutput,
  //   NewInput
  // > {
  //   const merged: any = new ZodObject({
  //     unknownKeys: merging._def.unknownKeys,
  //     catchall: merging._def.catchall,
  //     shape: () =>
  //       objectUtil.mergeShapes(this._def.shape(), merging._def.shape()),
  //     typeName: ZodFirstPartyTypeKind.ZodObject,
  //   }) as any;
  //   return merged;
  // }
  setKey(e, r) {
    return this.augment({ [e]: r });
  }
  // merge<Incoming extends AnyZodObject>(
  //   merging: Incoming
  // ): //ZodObject<T & Incoming["_shape"], UnknownKeys, Catchall> = (merging) => {
  // ZodObject<
  //   extendShape<T, ReturnType<Incoming["_def"]["shape"]>>,
  //   Incoming["_def"]["unknownKeys"],
  //   Incoming["_def"]["catchall"]
  // > {
  //   // const mergedShape = objectUtil.mergeShapes(
  //   //   this._def.shape(),
  //   //   merging._def.shape()
  //   // );
  //   const merged: any = new ZodObject({
  //     unknownKeys: merging._def.unknownKeys,
  //     catchall: merging._def.catchall,
  //     shape: () =>
  //       objectUtil.mergeShapes(this._def.shape(), merging._def.shape()),
  //     typeName: ZodFirstPartyTypeKind.ZodObject,
  //   }) as any;
  //   return merged;
  // }
  catchall(e) {
    return new dt({
      ...this._def,
      catchall: e
    });
  }
  pick(e) {
    const r = {};
    return Ye.objectKeys(e).forEach((s) => {
      e[s] && this.shape[s] && (r[s] = this.shape[s]);
    }), new dt({
      ...this._def,
      shape: () => r
    });
  }
  omit(e) {
    const r = {};
    return Ye.objectKeys(this.shape).forEach((s) => {
      e[s] || (r[s] = this.shape[s]);
    }), new dt({
      ...this._def,
      shape: () => r
    });
  }
  /**
   * @deprecated
   */
  deepPartial() {
    return Ys(this);
  }
  partial(e) {
    const r = {};
    return Ye.objectKeys(this.shape).forEach((s) => {
      const n = this.shape[s];
      e && !e[s] ? r[s] = n : r[s] = n.optional();
    }), new dt({
      ...this._def,
      shape: () => r
    });
  }
  required(e) {
    const r = {};
    return Ye.objectKeys(this.shape).forEach((s) => {
      if (e && !e[s])
        r[s] = this.shape[s];
      else {
        let i = this.shape[s];
        for (; i instanceof Yr; )
          i = i._def.innerType;
        r[s] = i;
      }
    }), new dt({
      ...this._def,
      shape: () => r
    });
  }
  keyof() {
    return sh(Ye.objectKeys(this.shape));
  }
}
dt.create = (t, e) => new dt({
  shape: () => t,
  unknownKeys: "strip",
  catchall: Xr.create(),
  typeName: ge.ZodObject,
  ...Ie(e)
});
dt.strictCreate = (t, e) => new dt({
  shape: () => t,
  unknownKeys: "strict",
  catchall: Xr.create(),
  typeName: ge.ZodObject,
  ...Ie(e)
});
dt.lazycreate = (t, e) => new dt({
  shape: t,
  unknownKeys: "strip",
  catchall: Xr.create(),
  typeName: ge.ZodObject,
  ...Ie(e)
});
class Yn extends Re {
  _parse(e) {
    const { ctx: r } = this._processInputParams(e), s = this._def.options;
    function n(i) {
      for (const a of i)
        if (a.result.status === "valid")
          return a.result;
      for (const a of i)
        if (a.result.status === "dirty")
          return r.common.issues.push(...a.ctx.common.issues), a.result;
      const o = i.map((a) => new Sr(a.ctx.common.issues));
      return ie(r, {
        code: H.invalid_union,
        unionErrors: o
      }), ve;
    }
    if (r.common.async)
      return Promise.all(s.map(async (i) => {
        const o = {
          ...r,
          common: {
            ...r.common,
            issues: []
          },
          parent: null
        };
        return {
          result: await i._parseAsync({
            data: r.data,
            path: r.path,
            parent: o
          }),
          ctx: o
        };
      })).then(n);
    {
      let i;
      const o = [];
      for (const u of s) {
        const c = {
          ...r,
          common: {
            ...r.common,
            issues: []
          },
          parent: null
        }, h = u._parseSync({
          data: r.data,
          path: r.path,
          parent: c
        });
        if (h.status === "valid")
          return h;
        h.status === "dirty" && !i && (i = { result: h, ctx: c }), c.common.issues.length && o.push(c.common.issues);
      }
      if (i)
        return r.common.issues.push(...i.ctx.common.issues), i.result;
      const a = o.map((u) => new Sr(u));
      return ie(r, {
        code: H.invalid_union,
        unionErrors: a
      }), ve;
    }
  }
  get options() {
    return this._def.options;
  }
}
Yn.create = (t, e) => new Yn({
  options: t,
  typeName: ge.ZodUnion,
  ...Ie(e)
});
const Mi = (t) => t instanceof Qn ? Mi(t.schema) : t instanceof Tr ? Mi(t.innerType()) : t instanceof ei ? [t.value] : t instanceof ms ? t.options : t instanceof ti ? Object.keys(t.enum) : t instanceof ri ? Mi(t._def.innerType) : t instanceof Bn ? [void 0] : t instanceof Gn ? [null] : null;
class Oa extends Re {
  _parse(e) {
    const { ctx: r } = this._processInputParams(e);
    if (r.parsedType !== re.object)
      return ie(r, {
        code: H.invalid_type,
        expected: re.object,
        received: r.parsedType
      }), ve;
    const s = this.discriminator, n = r.data[s], i = this.optionsMap.get(n);
    return i ? r.common.async ? i._parseAsync({
      data: r.data,
      path: r.path,
      parent: r
    }) : i._parseSync({
      data: r.data,
      path: r.path,
      parent: r
    }) : (ie(r, {
      code: H.invalid_union_discriminator,
      options: Array.from(this.optionsMap.keys()),
      path: [s]
    }), ve);
  }
  get discriminator() {
    return this._def.discriminator;
  }
  get options() {
    return this._def.options;
  }
  get optionsMap() {
    return this._def.optionsMap;
  }
  /**
   * The constructor of the discriminated union schema. Its behaviour is very similar to that of the normal z.union() constructor.
   * However, it only allows a union of objects, all of which need to share a discriminator property. This property must
   * have a different value for each object in the union.
   * @param discriminator the name of the discriminator property
   * @param types an array of object schemas
   * @param params
   */
  static create(e, r, s) {
    const n = /* @__PURE__ */ new Map();
    for (const i of r) {
      const o = Mi(i.shape[e]);
      if (!o)
        throw new Error(`A discriminator value for key \`${e}\` could not be extracted from all schema options`);
      for (const a of o) {
        if (n.has(a))
          throw new Error(`Discriminator property ${String(e)} has duplicate value ${String(a)}`);
        n.set(a, i);
      }
    }
    return new Oa({
      typeName: ge.ZodDiscriminatedUnion,
      discriminator: e,
      options: r,
      optionsMap: n,
      ...Ie(s)
    });
  }
}
function To(t, e) {
  const r = os(t), s = os(e);
  if (t === e)
    return { valid: !0, data: t };
  if (r === re.object && s === re.object) {
    const n = Ye.objectKeys(e), i = Ye.objectKeys(t).filter((a) => n.indexOf(a) !== -1), o = { ...t, ...e };
    for (const a of i) {
      const u = To(t[a], e[a]);
      if (!u.valid)
        return { valid: !1 };
      o[a] = u.data;
    }
    return { valid: !0, data: o };
  } else if (r === re.array && s === re.array) {
    if (t.length !== e.length)
      return { valid: !1 };
    const n = [];
    for (let i = 0; i < t.length; i++) {
      const o = t[i], a = e[i], u = To(o, a);
      if (!u.valid)
        return { valid: !1 };
      n.push(u.data);
    }
    return { valid: !0, data: n };
  } else
    return r === re.date && s === re.date && +t == +e ? { valid: !0, data: t } : { valid: !1 };
}
class Jn extends Re {
  _parse(e) {
    const { status: r, ctx: s } = this._processInputParams(e), n = (i, o) => {
      if (xo(i) || xo(o))
        return ve;
      const a = To(i.value, o.value);
      return a.valid ? ((Oo(i) || Oo(o)) && r.dirty(), { status: r.value, value: a.data }) : (ie(s, {
        code: H.invalid_intersection_types
      }), ve);
    };
    return s.common.async ? Promise.all([
      this._def.left._parseAsync({
        data: s.data,
        path: s.path,
        parent: s
      }),
      this._def.right._parseAsync({
        data: s.data,
        path: s.path,
        parent: s
      })
    ]).then(([i, o]) => n(i, o)) : n(this._def.left._parseSync({
      data: s.data,
      path: s.path,
      parent: s
    }), this._def.right._parseSync({
      data: s.data,
      path: s.path,
      parent: s
    }));
  }
}
Jn.create = (t, e, r) => new Jn({
  left: t,
  right: e,
  typeName: ge.ZodIntersection,
  ...Ie(r)
});
class $r extends Re {
  _parse(e) {
    const { status: r, ctx: s } = this._processInputParams(e);
    if (s.parsedType !== re.array)
      return ie(s, {
        code: H.invalid_type,
        expected: re.array,
        received: s.parsedType
      }), ve;
    if (s.data.length < this._def.items.length)
      return ie(s, {
        code: H.too_small,
        minimum: this._def.items.length,
        inclusive: !0,
        exact: !1,
        type: "array"
      }), ve;
    !this._def.rest && s.data.length > this._def.items.length && (ie(s, {
      code: H.too_big,
      maximum: this._def.items.length,
      inclusive: !0,
      exact: !1,
      type: "array"
    }), r.dirty());
    const i = [...s.data].map((o, a) => {
      const u = this._def.items[a] || this._def.rest;
      return u ? u._parse(new zr(s, o, s.path, a)) : null;
    }).filter((o) => !!o);
    return s.common.async ? Promise.all(i).then((o) => Wt.mergeArray(r, o)) : Wt.mergeArray(r, i);
  }
  get items() {
    return this._def.items;
  }
  rest(e) {
    return new $r({
      ...this._def,
      rest: e
    });
  }
}
$r.create = (t, e) => {
  if (!Array.isArray(t))
    throw new Error("You must pass an array of schemas to z.tuple([ ... ])");
  return new $r({
    items: t,
    typeName: ge.ZodTuple,
    rest: null,
    ...Ie(e)
  });
};
class Xn extends Re {
  get keySchema() {
    return this._def.keyType;
  }
  get valueSchema() {
    return this._def.valueType;
  }
  _parse(e) {
    const { status: r, ctx: s } = this._processInputParams(e);
    if (s.parsedType !== re.object)
      return ie(s, {
        code: H.invalid_type,
        expected: re.object,
        received: s.parsedType
      }), ve;
    const n = [], i = this._def.keyType, o = this._def.valueType;
    for (const a in s.data)
      n.push({
        key: i._parse(new zr(s, a, s.path, a)),
        value: o._parse(new zr(s, s.data[a], s.path, a))
      });
    return s.common.async ? Wt.mergeObjectAsync(r, n) : Wt.mergeObjectSync(r, n);
  }
  get element() {
    return this._def.valueType;
  }
  static create(e, r, s) {
    return r instanceof Re ? new Xn({
      keyType: e,
      valueType: r,
      typeName: ge.ZodRecord,
      ...Ie(s)
    }) : new Xn({
      keyType: br.create(),
      valueType: e,
      typeName: ge.ZodRecord,
      ...Ie(r)
    });
  }
}
class ca extends Re {
  _parse(e) {
    const { status: r, ctx: s } = this._processInputParams(e);
    if (s.parsedType !== re.map)
      return ie(s, {
        code: H.invalid_type,
        expected: re.map,
        received: s.parsedType
      }), ve;
    const n = this._def.keyType, i = this._def.valueType, o = [...s.data.entries()].map(([a, u], c) => ({
      key: n._parse(new zr(s, a, s.path, [c, "key"])),
      value: i._parse(new zr(s, u, s.path, [c, "value"]))
    }));
    if (s.common.async) {
      const a = /* @__PURE__ */ new Map();
      return Promise.resolve().then(async () => {
        for (const u of o) {
          const c = await u.key, h = await u.value;
          if (c.status === "aborted" || h.status === "aborted")
            return ve;
          (c.status === "dirty" || h.status === "dirty") && r.dirty(), a.set(c.value, h.value);
        }
        return { status: r.value, value: a };
      });
    } else {
      const a = /* @__PURE__ */ new Map();
      for (const u of o) {
        const c = u.key, h = u.value;
        if (c.status === "aborted" || h.status === "aborted")
          return ve;
        (c.status === "dirty" || h.status === "dirty") && r.dirty(), a.set(c.value, h.value);
      }
      return { status: r.value, value: a };
    }
  }
}
ca.create = (t, e, r) => new ca({
  valueType: e,
  keyType: t,
  typeName: ge.ZodMap,
  ...Ie(r)
});
class js extends Re {
  _parse(e) {
    const { status: r, ctx: s } = this._processInputParams(e);
    if (s.parsedType !== re.set)
      return ie(s, {
        code: H.invalid_type,
        expected: re.set,
        received: s.parsedType
      }), ve;
    const n = this._def;
    n.minSize !== null && s.data.size < n.minSize.value && (ie(s, {
      code: H.too_small,
      minimum: n.minSize.value,
      type: "set",
      inclusive: !0,
      exact: !1,
      message: n.minSize.message
    }), r.dirty()), n.maxSize !== null && s.data.size > n.maxSize.value && (ie(s, {
      code: H.too_big,
      maximum: n.maxSize.value,
      type: "set",
      inclusive: !0,
      exact: !1,
      message: n.maxSize.message
    }), r.dirty());
    const i = this._def.valueType;
    function o(u) {
      const c = /* @__PURE__ */ new Set();
      for (const h of u) {
        if (h.status === "aborted")
          return ve;
        h.status === "dirty" && r.dirty(), c.add(h.value);
      }
      return { status: r.value, value: c };
    }
    const a = [...s.data.values()].map((u, c) => i._parse(new zr(s, u, s.path, c)));
    return s.common.async ? Promise.all(a).then((u) => o(u)) : o(a);
  }
  min(e, r) {
    return new js({
      ...this._def,
      minSize: { value: e, message: ue.toString(r) }
    });
  }
  max(e, r) {
    return new js({
      ...this._def,
      maxSize: { value: e, message: ue.toString(r) }
    });
  }
  size(e, r) {
    return this.min(e, r).max(e, r);
  }
  nonempty(e) {
    return this.min(1, e);
  }
}
js.create = (t, e) => new js({
  valueType: t,
  minSize: null,
  maxSize: null,
  typeName: ge.ZodSet,
  ...Ie(e)
});
class rn extends Re {
  constructor() {
    super(...arguments), this.validate = this.implement;
  }
  _parse(e) {
    const { ctx: r } = this._processInputParams(e);
    if (r.parsedType !== re.function)
      return ie(r, {
        code: H.invalid_type,
        expected: re.function,
        received: r.parsedType
      }), ve;
    function s(a, u) {
      return sa({
        data: a,
        path: r.path,
        errorMaps: [
          r.common.contextualErrorMap,
          r.schemaErrorMap,
          ra(),
          Kn
        ].filter((c) => !!c),
        issueData: {
          code: H.invalid_arguments,
          argumentsError: u
        }
      });
    }
    function n(a, u) {
      return sa({
        data: a,
        path: r.path,
        errorMaps: [
          r.common.contextualErrorMap,
          r.schemaErrorMap,
          ra(),
          Kn
        ].filter((c) => !!c),
        issueData: {
          code: H.invalid_return_type,
          returnTypeError: u
        }
      });
    }
    const i = { errorMap: r.common.contextualErrorMap }, o = r.data;
    return this._def.returns instanceof cn ? Qt(async (...a) => {
      const u = new Sr([]), c = await this._def.args.parseAsync(a, i).catch((g) => {
        throw u.addIssue(s(a, g)), u;
      }), h = await o(...c);
      return await this._def.returns._def.type.parseAsync(h, i).catch((g) => {
        throw u.addIssue(n(h, g)), u;
      });
    }) : Qt((...a) => {
      const u = this._def.args.safeParse(a, i);
      if (!u.success)
        throw new Sr([s(a, u.error)]);
      const c = o(...u.data), h = this._def.returns.safeParse(c, i);
      if (!h.success)
        throw new Sr([n(c, h.error)]);
      return h.data;
    });
  }
  parameters() {
    return this._def.args;
  }
  returnType() {
    return this._def.returns;
  }
  args(...e) {
    return new rn({
      ...this._def,
      args: $r.create(e).rest(Cs.create())
    });
  }
  returns(e) {
    return new rn({
      ...this._def,
      returns: e
    });
  }
  implement(e) {
    return this.parse(e);
  }
  strictImplement(e) {
    return this.parse(e);
  }
  static create(e, r, s) {
    return new rn({
      args: e || $r.create([]).rest(Cs.create()),
      returns: r || Cs.create(),
      typeName: ge.ZodFunction,
      ...Ie(s)
    });
  }
}
class Qn extends Re {
  get schema() {
    return this._def.getter();
  }
  _parse(e) {
    const { ctx: r } = this._processInputParams(e);
    return this._def.getter()._parse({ data: r.data, path: r.path, parent: r });
  }
}
Qn.create = (t, e) => new Qn({
  getter: t,
  typeName: ge.ZodLazy,
  ...Ie(e)
});
class ei extends Re {
  _parse(e) {
    if (e.data !== this._def.value) {
      const r = this._getOrReturnCtx(e);
      return ie(r, {
        received: r.data,
        code: H.invalid_literal,
        expected: this._def.value
      }), ve;
    }
    return { status: "valid", value: e.data };
  }
  get value() {
    return this._def.value;
  }
}
ei.create = (t, e) => new ei({
  value: t,
  typeName: ge.ZodLiteral,
  ...Ie(e)
});
function sh(t, e) {
  return new ms({
    values: t,
    typeName: ge.ZodEnum,
    ...Ie(e)
  });
}
class ms extends Re {
  _parse(e) {
    if (typeof e.data != "string") {
      const r = this._getOrReturnCtx(e), s = this._def.values;
      return ie(r, {
        expected: Ye.joinValues(s),
        received: r.parsedType,
        code: H.invalid_type
      }), ve;
    }
    if (this._def.values.indexOf(e.data) === -1) {
      const r = this._getOrReturnCtx(e), s = this._def.values;
      return ie(r, {
        received: r.data,
        code: H.invalid_enum_value,
        options: s
      }), ve;
    }
    return Qt(e.data);
  }
  get options() {
    return this._def.values;
  }
  get enum() {
    const e = {};
    for (const r of this._def.values)
      e[r] = r;
    return e;
  }
  get Values() {
    const e = {};
    for (const r of this._def.values)
      e[r] = r;
    return e;
  }
  get Enum() {
    const e = {};
    for (const r of this._def.values)
      e[r] = r;
    return e;
  }
  extract(e) {
    return ms.create(e);
  }
  exclude(e) {
    return ms.create(this.options.filter((r) => !e.includes(r)));
  }
}
ms.create = sh;
class ti extends Re {
  _parse(e) {
    const r = Ye.getValidEnumValues(this._def.values), s = this._getOrReturnCtx(e);
    if (s.parsedType !== re.string && s.parsedType !== re.number) {
      const n = Ye.objectValues(r);
      return ie(s, {
        expected: Ye.joinValues(n),
        received: s.parsedType,
        code: H.invalid_type
      }), ve;
    }
    if (r.indexOf(e.data) === -1) {
      const n = Ye.objectValues(r);
      return ie(s, {
        received: s.data,
        code: H.invalid_enum_value,
        options: n
      }), ve;
    }
    return Qt(e.data);
  }
  get enum() {
    return this._def.values;
  }
}
ti.create = (t, e) => new ti({
  values: t,
  typeName: ge.ZodNativeEnum,
  ...Ie(e)
});
class cn extends Re {
  unwrap() {
    return this._def.type;
  }
  _parse(e) {
    const { ctx: r } = this._processInputParams(e);
    if (r.parsedType !== re.promise && r.common.async === !1)
      return ie(r, {
        code: H.invalid_type,
        expected: re.promise,
        received: r.parsedType
      }), ve;
    const s = r.parsedType === re.promise ? r.data : Promise.resolve(r.data);
    return Qt(s.then((n) => this._def.type.parseAsync(n, {
      path: r.path,
      errorMap: r.common.contextualErrorMap
    })));
  }
}
cn.create = (t, e) => new cn({
  type: t,
  typeName: ge.ZodPromise,
  ...Ie(e)
});
class Tr extends Re {
  innerType() {
    return this._def.schema;
  }
  sourceType() {
    return this._def.schema._def.typeName === ge.ZodEffects ? this._def.schema.sourceType() : this._def.schema;
  }
  _parse(e) {
    const { status: r, ctx: s } = this._processInputParams(e), n = this._def.effect || null;
    if (n.type === "preprocess") {
      const o = n.transform(s.data);
      return s.common.async ? Promise.resolve(o).then((a) => this._def.schema._parseAsync({
        data: a,
        path: s.path,
        parent: s
      })) : this._def.schema._parseSync({
        data: o,
        path: s.path,
        parent: s
      });
    }
    const i = {
      addIssue: (o) => {
        ie(s, o), o.fatal ? r.abort() : r.dirty();
      },
      get path() {
        return s.path;
      }
    };
    if (i.addIssue = i.addIssue.bind(i), n.type === "refinement") {
      const o = (a) => {
        const u = n.refinement(a, i);
        if (s.common.async)
          return Promise.resolve(u);
        if (u instanceof Promise)
          throw new Error("Async refinement encountered during synchronous parse operation. Use .parseAsync instead.");
        return a;
      };
      if (s.common.async === !1) {
        const a = this._def.schema._parseSync({
          data: s.data,
          path: s.path,
          parent: s
        });
        return a.status === "aborted" ? ve : (a.status === "dirty" && r.dirty(), o(a.value), { status: r.value, value: a.value });
      } else
        return this._def.schema._parseAsync({ data: s.data, path: s.path, parent: s }).then((a) => a.status === "aborted" ? ve : (a.status === "dirty" && r.dirty(), o(a.value).then(() => ({ status: r.value, value: a.value }))));
    }
    if (n.type === "transform")
      if (s.common.async === !1) {
        const o = this._def.schema._parseSync({
          data: s.data,
          path: s.path,
          parent: s
        });
        if (!na(o))
          return o;
        const a = n.transform(o.value, i);
        if (a instanceof Promise)
          throw new Error("Asynchronous transform encountered during synchronous parse operation. Use .parseAsync instead.");
        return { status: r.value, value: a };
      } else
        return this._def.schema._parseAsync({ data: s.data, path: s.path, parent: s }).then((o) => na(o) ? Promise.resolve(n.transform(o.value, i)).then((a) => ({ status: r.value, value: a })) : o);
    Ye.assertNever(n);
  }
}
Tr.create = (t, e, r) => new Tr({
  schema: t,
  typeName: ge.ZodEffects,
  effect: e,
  ...Ie(r)
});
Tr.createWithPreprocess = (t, e, r) => new Tr({
  schema: e,
  effect: { type: "preprocess", transform: t },
  typeName: ge.ZodEffects,
  ...Ie(r)
});
class Yr extends Re {
  _parse(e) {
    return this._getType(e) === re.undefined ? Qt(void 0) : this._def.innerType._parse(e);
  }
  unwrap() {
    return this._def.innerType;
  }
}
Yr.create = (t, e) => new Yr({
  innerType: t,
  typeName: ge.ZodOptional,
  ...Ie(e)
});
class Ls extends Re {
  _parse(e) {
    return this._getType(e) === re.null ? Qt(null) : this._def.innerType._parse(e);
  }
  unwrap() {
    return this._def.innerType;
  }
}
Ls.create = (t, e) => new Ls({
  innerType: t,
  typeName: ge.ZodNullable,
  ...Ie(e)
});
class ri extends Re {
  _parse(e) {
    const { ctx: r } = this._processInputParams(e);
    let s = r.data;
    return r.parsedType === re.undefined && (s = this._def.defaultValue()), this._def.innerType._parse({
      data: s,
      path: r.path,
      parent: r
    });
  }
  removeDefault() {
    return this._def.innerType;
  }
}
ri.create = (t, e) => new ri({
  innerType: t,
  typeName: ge.ZodDefault,
  defaultValue: typeof e.default == "function" ? e.default : () => e.default,
  ...Ie(e)
});
class ua extends Re {
  _parse(e) {
    const { ctx: r } = this._processInputParams(e), s = {
      ...r,
      common: {
        ...r.common,
        issues: []
      }
    }, n = this._def.innerType._parse({
      data: s.data,
      path: s.path,
      parent: {
        ...s
      }
    });
    return ia(n) ? n.then((i) => ({
      status: "valid",
      value: i.status === "valid" ? i.value : this._def.catchValue({
        get error() {
          return new Sr(s.common.issues);
        }
      })
    })) : {
      status: "valid",
      value: n.status === "valid" ? n.value : this._def.catchValue({
        get error() {
          return new Sr(s.common.issues);
        }
      })
    };
  }
  removeCatch() {
    return this._def.innerType;
  }
}
ua.create = (t, e) => new ua({
  innerType: t,
  typeName: ge.ZodCatch,
  catchValue: typeof e.catch == "function" ? e.catch : () => e.catch,
  ...Ie(e)
});
class la extends Re {
  _parse(e) {
    if (this._getType(e) !== re.nan) {
      const s = this._getOrReturnCtx(e);
      return ie(s, {
        code: H.invalid_type,
        expected: re.nan,
        received: s.parsedType
      }), ve;
    }
    return { status: "valid", value: e.data };
  }
}
la.create = (t) => new la({
  typeName: ge.ZodNaN,
  ...Ie(t)
});
const eE = Symbol("zod_brand");
class nh extends Re {
  _parse(e) {
    const { ctx: r } = this._processInputParams(e), s = r.data;
    return this._def.type._parse({
      data: s,
      path: r.path,
      parent: r
    });
  }
  unwrap() {
    return this._def.type;
  }
}
class gi extends Re {
  _parse(e) {
    const { status: r, ctx: s } = this._processInputParams(e);
    if (s.common.async)
      return (async () => {
        const i = await this._def.in._parseAsync({
          data: s.data,
          path: s.path,
          parent: s
        });
        return i.status === "aborted" ? ve : i.status === "dirty" ? (r.dirty(), rh(i.value)) : this._def.out._parseAsync({
          data: i.value,
          path: s.path,
          parent: s
        });
      })();
    {
      const n = this._def.in._parseSync({
        data: s.data,
        path: s.path,
        parent: s
      });
      return n.status === "aborted" ? ve : n.status === "dirty" ? (r.dirty(), {
        status: "dirty",
        value: n.value
      }) : this._def.out._parseSync({
        data: n.value,
        path: s.path,
        parent: s
      });
    }
  }
  static create(e, r) {
    return new gi({
      in: e,
      out: r,
      typeName: ge.ZodPipeline
    });
  }
}
const ih = (t, e = {}, r) => t ? on.create().superRefine((s, n) => {
  var i, o;
  if (!t(s)) {
    const a = typeof e == "function" ? e(s) : e, u = (o = (i = a.fatal) !== null && i !== void 0 ? i : r) !== null && o !== void 0 ? o : !0, c = typeof a == "string" ? { message: a } : a;
    n.addIssue({ code: "custom", ...c, fatal: u });
  }
}) : on.create(), tE = {
  object: dt.lazycreate
};
var ge;
(function(t) {
  t.ZodString = "ZodString", t.ZodNumber = "ZodNumber", t.ZodNaN = "ZodNaN", t.ZodBigInt = "ZodBigInt", t.ZodBoolean = "ZodBoolean", t.ZodDate = "ZodDate", t.ZodSymbol = "ZodSymbol", t.ZodUndefined = "ZodUndefined", t.ZodNull = "ZodNull", t.ZodAny = "ZodAny", t.ZodUnknown = "ZodUnknown", t.ZodNever = "ZodNever", t.ZodVoid = "ZodVoid", t.ZodArray = "ZodArray", t.ZodObject = "ZodObject", t.ZodUnion = "ZodUnion", t.ZodDiscriminatedUnion = "ZodDiscriminatedUnion", t.ZodIntersection = "ZodIntersection", t.ZodTuple = "ZodTuple", t.ZodRecord = "ZodRecord", t.ZodMap = "ZodMap", t.ZodSet = "ZodSet", t.ZodFunction = "ZodFunction", t.ZodLazy = "ZodLazy", t.ZodLiteral = "ZodLiteral", t.ZodEnum = "ZodEnum", t.ZodEffects = "ZodEffects", t.ZodNativeEnum = "ZodNativeEnum", t.ZodOptional = "ZodOptional", t.ZodNullable = "ZodNullable", t.ZodDefault = "ZodDefault", t.ZodCatch = "ZodCatch", t.ZodPromise = "ZodPromise", t.ZodBranded = "ZodBranded", t.ZodPipeline = "ZodPipeline";
})(ge || (ge = {}));
const rE = (t, e = {
  message: `Input not instance of ${t.name}`
}) => ih((r) => r instanceof t, e), ah = br.create, oh = fs.create, sE = la.create, nE = gs.create, ch = Hn.create, iE = As.create, aE = aa.create, oE = Bn.create, cE = Gn.create, uE = on.create, lE = Cs.create, dE = Xr.create, hE = oa.create, pE = Ir.create, fE = dt.create, gE = dt.strictCreate, mE = Yn.create, yE = Oa.create, vE = Jn.create, _E = $r.create, bE = Xn.create, wE = ca.create, EE = js.create, SE = rn.create, IE = Qn.create, xE = ei.create, OE = ms.create, TE = ti.create, PE = cn.create, hl = Tr.create, CE = Yr.create, NE = Ls.create, kE = Tr.createWithPreprocess, RE = gi.create, AE = () => ah().optional(), jE = () => oh().optional(), LE = () => ch().optional(), ME = {
  string: (t) => br.create({ ...t, coerce: !0 }),
  number: (t) => fs.create({ ...t, coerce: !0 }),
  boolean: (t) => Hn.create({
    ...t,
    coerce: !0
  }),
  bigint: (t) => gs.create({ ...t, coerce: !0 }),
  date: (t) => As.create({ ...t, coerce: !0 })
}, DE = ve;
var Nr = /* @__PURE__ */ Object.freeze({
  __proto__: null,
  defaultErrorMap: Kn,
  setErrorMap: V1,
  getErrorMap: ra,
  makeIssue: sa,
  EMPTY_PATH: q1,
  addIssueToContext: ie,
  ParseStatus: Wt,
  INVALID: ve,
  DIRTY: rh,
  OK: Qt,
  isAborted: xo,
  isDirty: Oo,
  isValid: na,
  isAsync: ia,
  get util() {
    return Ye;
  },
  get objectUtil() {
    return Io;
  },
  ZodParsedType: re,
  getParsedType: os,
  ZodType: Re,
  ZodString: br,
  ZodNumber: fs,
  ZodBigInt: gs,
  ZodBoolean: Hn,
  ZodDate: As,
  ZodSymbol: aa,
  ZodUndefined: Bn,
  ZodNull: Gn,
  ZodAny: on,
  ZodUnknown: Cs,
  ZodNever: Xr,
  ZodVoid: oa,
  ZodArray: Ir,
  ZodObject: dt,
  ZodUnion: Yn,
  ZodDiscriminatedUnion: Oa,
  ZodIntersection: Jn,
  ZodTuple: $r,
  ZodRecord: Xn,
  ZodMap: ca,
  ZodSet: js,
  ZodFunction: rn,
  ZodLazy: Qn,
  ZodLiteral: ei,
  ZodEnum: ms,
  ZodNativeEnum: ti,
  ZodPromise: cn,
  ZodEffects: Tr,
  ZodTransformer: Tr,
  ZodOptional: Yr,
  ZodNullable: Ls,
  ZodDefault: ri,
  ZodCatch: ua,
  ZodNaN: la,
  BRAND: eE,
  ZodBranded: nh,
  ZodPipeline: gi,
  custom: ih,
  Schema: Re,
  ZodSchema: Re,
  late: tE,
  get ZodFirstPartyTypeKind() {
    return ge;
  },
  coerce: ME,
  any: uE,
  array: pE,
  bigint: nE,
  boolean: ch,
  date: iE,
  discriminatedUnion: yE,
  effect: hl,
  enum: OE,
  function: SE,
  instanceof: rE,
  intersection: vE,
  lazy: IE,
  literal: xE,
  map: wE,
  nan: sE,
  nativeEnum: TE,
  never: dE,
  null: cE,
  nullable: NE,
  number: oh,
  object: fE,
  oboolean: LE,
  onumber: jE,
  optional: CE,
  ostring: AE,
  pipeline: RE,
  preprocess: kE,
  promise: PE,
  record: bE,
  set: EE,
  strictObject: gE,
  string: ah,
  symbol: aE,
  transformer: hl,
  tuple: _E,
  undefined: oE,
  union: mE,
  unknown: lE,
  void: hE,
  NEVER: DE,
  ZodIssueCode: H,
  quotelessJson: $1,
  ZodError: Sr
});
const ic = /^aleo1[a-z0-9]{58}$/i, UE = /^AViewKey1[a-z0-9]{44}$/i, zE = /^APrivateKey1[a-z0-9]{47}$/i, $E = /^at1[a-z0-9]{58}$/i, VE = /^\d+field$/, qE = /^\d+u32$/, ZE = /^\d+u64$/, m5 = Nr.string().regex(ic), y5 = Nr.string().regex(UE), v5 = Nr.string().regex(zE), _5 = Nr.string().regex($E), b5 = Nr.string().regex(VE), w5 = Nr.string().regex(qE), E5 = Nr.string().regex(ZE);
var pl;
(function(t) {
  t.Record = "record", t.OutputRecord = "outputRecord", t.Public = "public", t.Private = "private", t.Constant = "constant", t.Future = "future", t.ExternalRecord = "external_record";
})(pl || (pl = {}));
var Po;
(function(t) {
  t.Deploy = "Deploy", t.Execute = "Execute", t.Send = "Send", t.Receive = "Receive", t.Join = "Join", t.Split = "Split", t.Shield = "Shield", t.Unshield = "Unshield";
})(Po || (Po = {}));
var Co;
(function(t) {
  t.Creating = "Creating", t.Pending = "Pending", t.Settled = "Settled", t.Failed = "Failed";
})(Co || (Co = {}));
var No;
(function(t) {
  t.Private = "Private", t.Public = "Public";
})(No || (No = {}));
var ko;
(function(t) {
  t.AleoTestnet = "AleoTestnet", t.AleoMainnet = "AleoMainnet";
})(ko || (ko = {}));
var fl;
(function(t) {
  t[t.ALEO = 0] = "ALEO";
})(fl || (fl = {}));
const S5 = Nr.nativeEnum(Po), I5 = Nr.nativeEnum(Co), x5 = Nr.nativeEnum(ko), O5 = Nr.nativeEnum(No), uh = Kh("wallet:sdk");
uh.enabled = !0;
const T5 = (t, e) => {
  const r = pr(), { request: s, data: n, error: i, loading: o } = ii({
    topic: (r == null ? void 0 : r.topic) ?? "",
    chainId: "aleo:1",
    request: {
      jsonrpc: "2.0",
      method: "requestSignature",
      params: {
        message: t,
        address: ic.test(e ?? "") ? e : void 0
      }
    }
  }), a = i ? i.message : n && n.error;
  return { requestSignature: () => {
    r && !o && (uh("useRequestSignature requesting...", [t, e]), s());
  }, response: n, loading: o, error: a };
};
var Ro = { exports: {} }, In = {};
/**
 * @license React
 * react-jsx-runtime.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var gl;
function FE() {
  return gl || (gl = 1, process.env.NODE_ENV !== "production" && function() {
    var t = vl, e = Symbol.for("react.element"), r = Symbol.for("react.portal"), s = Symbol.for("react.fragment"), n = Symbol.for("react.strict_mode"), i = Symbol.for("react.profiler"), o = Symbol.for("react.provider"), a = Symbol.for("react.context"), u = Symbol.for("react.forward_ref"), c = Symbol.for("react.suspense"), h = Symbol.for("react.suspense_list"), p = Symbol.for("react.memo"), g = Symbol.for("react.lazy"), v = Symbol.for("react.offscreen"), b = Symbol.iterator, S = "@@iterator";
    function C(w) {
      if (w === null || typeof w != "object")
        return null;
      var D = b && w[b] || w[S];
      return typeof D == "function" ? D : null;
    }
    var M = t.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
    function _(w) {
      {
        for (var D = arguments.length, X = new Array(D > 1 ? D - 1 : 0), pe = 1; pe < D; pe++)
          X[pe - 1] = arguments[pe];
        T("error", w, X);
      }
    }
    function T(w, D, X) {
      {
        var pe = M.ReactDebugCurrentFrame, Ke = pe.getStackAddendum();
        Ke !== "" && (D += "%s", X = X.concat([Ke]));
        var ze = X.map(function(Ve) {
          return String(Ve);
        });
        ze.unshift("Warning: " + D), Function.prototype.apply.call(console[w], console, ze);
      }
    }
    var E = !1, I = !1, m = !1, l = !1, f = !1, L;
    L = Symbol.for("react.module.reference");
    function A(w) {
      return !!(typeof w == "string" || typeof w == "function" || w === s || w === i || f || w === n || w === c || w === h || l || w === v || E || I || m || typeof w == "object" && w !== null && (w.$$typeof === g || w.$$typeof === p || w.$$typeof === o || w.$$typeof === a || w.$$typeof === u || // This needs to include all possible module reference object
      // types supported by any Flight configuration anywhere since
      // we don't know which Flight build this will end up being used
      // with.
      w.$$typeof === L || w.getModuleId !== void 0));
    }
    function V(w, D, X) {
      var pe = w.displayName;
      if (pe)
        return pe;
      var Ke = D.displayName || D.name || "";
      return Ke !== "" ? X + "(" + Ke + ")" : X;
    }
    function J(w) {
      return w.displayName || "Context";
    }
    function G(w) {
      if (w == null)
        return null;
      if (typeof w.tag == "number" && _("Received an unexpected object in getComponentNameFromType(). This is likely a bug in React. Please file an issue."), typeof w == "function")
        return w.displayName || w.name || null;
      if (typeof w == "string")
        return w;
      switch (w) {
        case s:
          return "Fragment";
        case r:
          return "Portal";
        case i:
          return "Profiler";
        case n:
          return "StrictMode";
        case c:
          return "Suspense";
        case h:
          return "SuspenseList";
      }
      if (typeof w == "object")
        switch (w.$$typeof) {
          case a:
            var D = w;
            return J(D) + ".Consumer";
          case o:
            var X = w;
            return J(X._context) + ".Provider";
          case u:
            return V(w, w.render, "ForwardRef");
          case p:
            var pe = w.displayName || null;
            return pe !== null ? pe : G(w.type) || "Memo";
          case g: {
            var Ke = w, ze = Ke._payload, Ve = Ke._init;
            try {
              return G(Ve(ze));
            } catch {
              return null;
            }
          }
        }
      return null;
    }
    var O = Object.assign, k = 0, Q, Z, z, q, U, F, me;
    function W() {
    }
    W.__reactDisabledLog = !0;
    function de() {
      {
        if (k === 0) {
          Q = console.log, Z = console.info, z = console.warn, q = console.error, U = console.group, F = console.groupCollapsed, me = console.groupEnd;
          var w = {
            configurable: !0,
            enumerable: !0,
            value: W,
            writable: !0
          };
          Object.defineProperties(console, {
            info: w,
            log: w,
            warn: w,
            error: w,
            group: w,
            groupCollapsed: w,
            groupEnd: w
          });
        }
        k++;
      }
    }
    function se() {
      {
        if (k--, k === 0) {
          var w = {
            configurable: !0,
            enumerable: !0,
            writable: !0
          };
          Object.defineProperties(console, {
            log: O({}, w, {
              value: Q
            }),
            info: O({}, w, {
              value: Z
            }),
            warn: O({}, w, {
              value: z
            }),
            error: O({}, w, {
              value: q
            }),
            group: O({}, w, {
              value: U
            }),
            groupCollapsed: O({}, w, {
              value: F
            }),
            groupEnd: O({}, w, {
              value: me
            })
          });
        }
        k < 0 && _("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
      }
    }
    var le = M.ReactCurrentDispatcher, j;
    function R(w, D, X) {
      {
        if (j === void 0)
          try {
            throw Error();
          } catch (Ke) {
            var pe = Ke.stack.trim().match(/\n( *(at )?)/);
            j = pe && pe[1] || "";
          }
        return `
` + j + w;
      }
    }
    var P = !1, d;
    {
      var x = typeof WeakMap == "function" ? WeakMap : Map;
      d = new x();
    }
    function B(w, D) {
      if (!w || P)
        return "";
      {
        var X = d.get(w);
        if (X !== void 0)
          return X;
      }
      var pe;
      P = !0;
      var Ke = Error.prepareStackTrace;
      Error.prepareStackTrace = void 0;
      var ze;
      ze = le.current, le.current = null, de();
      try {
        if (D) {
          var Ve = function() {
            throw Error();
          };
          if (Object.defineProperty(Ve.prototype, "props", {
            set: function() {
              throw Error();
            }
          }), typeof Reflect == "object" && Reflect.construct) {
            try {
              Reflect.construct(Ve, []);
            } catch (fr) {
              pe = fr;
            }
            Reflect.construct(w, [], Ve);
          } else {
            try {
              Ve.call();
            } catch (fr) {
              pe = fr;
            }
            w.call(Ve.prototype);
          }
        } else {
          try {
            throw Error();
          } catch (fr) {
            pe = fr;
          }
          w();
        }
      } catch (fr) {
        if (fr && pe && typeof fr.stack == "string") {
          for (var Me = fr.stack.split(`
`), At = pe.stack.split(`
`), ct = Me.length - 1, gt = At.length - 1; ct >= 1 && gt >= 0 && Me[ct] !== At[gt]; )
            gt--;
          for (; ct >= 1 && gt >= 0; ct--, gt--)
            if (Me[ct] !== At[gt]) {
              if (ct !== 1 || gt !== 1)
                do
                  if (ct--, gt--, gt < 0 || Me[ct] !== At[gt]) {
                    var Ot = `
` + Me[ct].replace(" at new ", " at ");
                    return w.displayName && Ot.includes("<anonymous>") && (Ot = Ot.replace("<anonymous>", w.displayName)), typeof w == "function" && d.set(w, Ot), Ot;
                  }
                while (ct >= 1 && gt >= 0);
              break;
            }
        }
      } finally {
        P = !1, le.current = ze, se(), Error.prepareStackTrace = Ke;
      }
      var es = w ? w.displayName || w.name : "", mi = es ? R(es) : "";
      return typeof w == "function" && d.set(w, mi), mi;
    }
    function ee(w, D, X) {
      return B(w, !1);
    }
    function Ae(w) {
      var D = w.prototype;
      return !!(D && D.isReactComponent);
    }
    function je(w, D, X) {
      if (w == null)
        return "";
      if (typeof w == "function")
        return B(w, Ae(w));
      if (typeof w == "string")
        return R(w);
      switch (w) {
        case c:
          return R("Suspense");
        case h:
          return R("SuspenseList");
      }
      if (typeof w == "object")
        switch (w.$$typeof) {
          case u:
            return ee(w.render);
          case p:
            return je(w.type, D, X);
          case g: {
            var pe = w, Ke = pe._payload, ze = pe._init;
            try {
              return je(ze(Ke), D, X);
            } catch {
            }
          }
        }
      return "";
    }
    var xe = Object.prototype.hasOwnProperty, qe = {}, nt = M.ReactDebugCurrentFrame;
    function Xe(w) {
      if (w) {
        var D = w._owner, X = je(w.type, w._source, D ? D.type : null);
        nt.setExtraStackFrame(X);
      } else
        nt.setExtraStackFrame(null);
    }
    function $e(w, D, X, pe, Ke) {
      {
        var ze = Function.call.bind(xe);
        for (var Ve in w)
          if (ze(w, Ve)) {
            var Me = void 0;
            try {
              if (typeof w[Ve] != "function") {
                var At = Error((pe || "React class") + ": " + X + " type `" + Ve + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof w[Ve] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
                throw At.name = "Invariant Violation", At;
              }
              Me = w[Ve](D, Ve, pe, X, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
            } catch (ct) {
              Me = ct;
            }
            Me && !(Me instanceof Error) && (Xe(Ke), _("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", pe || "React class", X, Ve, typeof Me), Xe(null)), Me instanceof Error && !(Me.message in qe) && (qe[Me.message] = !0, Xe(Ke), _("Failed %s type: %s", X, Me.message), Xe(null));
          }
      }
    }
    var De = Array.isArray;
    function Oe(w) {
      return De(w);
    }
    function Ce(w) {
      {
        var D = typeof Symbol == "function" && Symbol.toStringTag, X = D && w[Symbol.toStringTag] || w.constructor.name || "Object";
        return X;
      }
    }
    function Te(w) {
      try {
        return we(w), !1;
      } catch {
        return !0;
      }
    }
    function we(w) {
      return "" + w;
    }
    function _e(w) {
      if (Te(w))
        return _("The provided key is an unsupported type %s. This value must be coerced to a string before before using it here.", Ce(w)), we(w);
    }
    var he = M.ReactCurrentOwner, Ne = {
      key: !0,
      ref: !0,
      __self: !0,
      __source: !0
    }, Le, ye, Ue;
    Ue = {};
    function Ze(w) {
      if (xe.call(w, "ref")) {
        var D = Object.getOwnPropertyDescriptor(w, "ref").get;
        if (D && D.isReactWarning)
          return !1;
      }
      return w.ref !== void 0;
    }
    function He(w) {
      if (xe.call(w, "key")) {
        var D = Object.getOwnPropertyDescriptor(w, "key").get;
        if (D && D.isReactWarning)
          return !1;
      }
      return w.key !== void 0;
    }
    function Be(w, D) {
      if (typeof w.ref == "string" && he.current && D && he.current.stateNode !== D) {
        var X = G(he.current.type);
        Ue[X] || (_('Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. This case cannot be automatically converted to an arrow function. We ask you to manually fix this case by using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', G(he.current.type), w.ref), Ue[X] = !0);
      }
    }
    function We(w, D) {
      {
        var X = function() {
          Le || (Le = !0, _("%s: `key` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", D));
        };
        X.isReactWarning = !0, Object.defineProperty(w, "key", {
          get: X,
          configurable: !0
        });
      }
    }
    function sr(w, D) {
      {
        var X = function() {
          ye || (ye = !0, _("%s: `ref` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", D));
        };
        X.isReactWarning = !0, Object.defineProperty(w, "ref", {
          get: X,
          configurable: !0
        });
      }
    }
    var cr = function(w, D, X, pe, Ke, ze, Ve) {
      var Me = {
        // This tag allows us to uniquely identify this as a React Element
        $$typeof: e,
        // Built-in properties that belong on the element
        type: w,
        key: D,
        ref: X,
        props: Ve,
        // Record the component responsible for creating this element.
        _owner: ze
      };
      return Me._store = {}, Object.defineProperty(Me._store, "validated", {
        configurable: !1,
        enumerable: !1,
        writable: !0,
        value: !1
      }), Object.defineProperty(Me, "_self", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: pe
      }), Object.defineProperty(Me, "_source", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: Ke
      }), Object.freeze && (Object.freeze(Me.props), Object.freeze(Me)), Me;
    };
    function kr(w, D, X, pe, Ke) {
      {
        var ze, Ve = {}, Me = null, At = null;
        X !== void 0 && (_e(X), Me = "" + X), He(D) && (_e(D.key), Me = "" + D.key), Ze(D) && (At = D.ref, Be(D, Ke));
        for (ze in D)
          xe.call(D, ze) && !Ne.hasOwnProperty(ze) && (Ve[ze] = D[ze]);
        if (w && w.defaultProps) {
          var ct = w.defaultProps;
          for (ze in ct)
            Ve[ze] === void 0 && (Ve[ze] = ct[ze]);
        }
        if (Me || At) {
          var gt = typeof w == "function" ? w.displayName || w.name || "Unknown" : w;
          Me && We(Ve, gt), At && sr(Ve, gt);
        }
        return cr(w, Me, At, Ke, pe, he.current, Ve);
      }
    }
    var Rt = M.ReactCurrentOwner, Rr = M.ReactDebugCurrentFrame;
    function ur(w) {
      if (w) {
        var D = w._owner, X = je(w.type, w._source, D ? D.type : null);
        Rr.setExtraStackFrame(X);
      } else
        Rr.setExtraStackFrame(null);
    }
    var Qr;
    Qr = !1;
    function it(w) {
      return typeof w == "object" && w !== null && w.$$typeof === e;
    }
    function tt() {
      {
        if (Rt.current) {
          var w = G(Rt.current.type);
          if (w)
            return `

Check the render method of \`` + w + "`.";
        }
        return "";
      }
    }
    function ht(w) {
      {
        if (w !== void 0) {
          var D = w.fileName.replace(/^.*[\\\/]/, ""), X = w.lineNumber;
          return `

Check your code at ` + D + ":" + X + ".";
        }
        return "";
      }
    }
    var ot = {};
    function pt(w) {
      {
        var D = tt();
        if (!D) {
          var X = typeof w == "string" ? w : w.displayName || w.name;
          X && (D = `

Check the top-level render call using <` + X + ">.");
        }
        return D;
      }
    }
    function rt(w, D) {
      {
        if (!w._store || w._store.validated || w.key != null)
          return;
        w._store.validated = !0;
        var X = pt(D);
        if (ot[X])
          return;
        ot[X] = !0;
        var pe = "";
        w && w._owner && w._owner !== Rt.current && (pe = " It was passed a child from " + G(w._owner.type) + "."), ur(w), _('Each child in a list should have a unique "key" prop.%s%s See https://reactjs.org/link/warning-keys for more information.', X, pe), ur(null);
      }
    }
    function vt(w, D) {
      {
        if (typeof w != "object")
          return;
        if (Oe(w))
          for (var X = 0; X < w.length; X++) {
            var pe = w[X];
            it(pe) && rt(pe, D);
          }
        else if (it(w))
          w._store && (w._store.validated = !0);
        else if (w) {
          var Ke = C(w);
          if (typeof Ke == "function" && Ke !== w.entries)
            for (var ze = Ke.call(w), Ve; !(Ve = ze.next()).done; )
              it(Ve.value) && rt(Ve.value, D);
        }
      }
    }
    function St(w) {
      {
        var D = w.type;
        if (D == null || typeof D == "string")
          return;
        var X;
        if (typeof D == "function")
          X = D.propTypes;
        else if (typeof D == "object" && (D.$$typeof === u || // Note: Memo only checks outer props here.
        // Inner props are checked in the reconciler.
        D.$$typeof === p))
          X = D.propTypes;
        else
          return;
        if (X) {
          var pe = G(D);
          $e(X, w.props, "prop", pe, w);
        } else if (D.PropTypes !== void 0 && !Qr) {
          Qr = !0;
          var Ke = G(D);
          _("Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?", Ke || "Unknown");
        }
        typeof D.getDefaultProps == "function" && !D.getDefaultProps.isReactClassApproved && _("getDefaultProps is only used on classic React.createClass definitions. Use a static property named `defaultProps` instead.");
      }
    }
    function It(w) {
      {
        for (var D = Object.keys(w.props), X = 0; X < D.length; X++) {
          var pe = D[X];
          if (pe !== "children" && pe !== "key") {
            ur(w), _("Invalid prop `%s` supplied to `React.Fragment`. React.Fragment can only have `key` and `children` props.", pe), ur(null);
            break;
          }
        }
        w.ref !== null && (ur(w), _("Invalid attribute `ref` supplied to `React.Fragment`."), ur(null));
      }
    }
    function _t(w, D, X, pe, Ke, ze) {
      {
        var Ve = A(w);
        if (!Ve) {
          var Me = "";
          (w === void 0 || typeof w == "object" && w !== null && Object.keys(w).length === 0) && (Me += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.");
          var At = ht(Ke);
          At ? Me += At : Me += tt();
          var ct;
          w === null ? ct = "null" : Oe(w) ? ct = "array" : w !== void 0 && w.$$typeof === e ? (ct = "<" + (G(w.type) || "Unknown") + " />", Me = " Did you accidentally export a JSX literal instead of a component?") : ct = typeof w, _("React.jsx: type is invalid -- expected a string (for built-in components) or a class/function (for composite components) but got: %s.%s", ct, Me);
        }
        var gt = kr(w, D, X, Ke, ze);
        if (gt == null)
          return gt;
        if (Ve) {
          var Ot = D.children;
          if (Ot !== void 0)
            if (pe)
              if (Oe(Ot)) {
                for (var es = 0; es < Ot.length; es++)
                  vt(Ot[es], w);
                Object.freeze && Object.freeze(Ot);
              } else
                _("React.jsx: Static children should always be an array. You are likely explicitly calling React.jsxs or React.jsxDEV. Use the Babel transform instead.");
            else
              vt(Ot, w);
        }
        return w === s ? It(gt) : St(gt), gt;
      }
    }
    function xt(w, D, X) {
      return _t(w, D, X, !0);
    }
    function bt(w, D, X) {
      return _t(w, D, X, !1);
    }
    var ft = bt, Qe = xt;
    In.Fragment = s, In.jsx = ft, In.jsxs = Qe;
  }()), In;
}
var xn = {};
/**
 * @license React
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var ml;
function WE() {
  if (ml)
    return xn;
  ml = 1;
  var t = vl, e = Symbol.for("react.element"), r = Symbol.for("react.fragment"), s = Object.prototype.hasOwnProperty, n = t.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, i = { key: !0, ref: !0, __self: !0, __source: !0 };
  function o(a, u, c) {
    var h, p = {}, g = null, v = null;
    c !== void 0 && (g = "" + c), u.key !== void 0 && (g = "" + u.key), u.ref !== void 0 && (v = u.ref);
    for (h in u)
      s.call(u, h) && !i.hasOwnProperty(h) && (p[h] = u[h]);
    if (a && a.defaultProps)
      for (h in u = a.defaultProps, u)
        p[h] === void 0 && (p[h] = u[h]);
    return { $$typeof: e, type: a, key: g, ref: v, props: p, _owner: n.current };
  }
  return xn.Fragment = r, xn.jsx = o, xn.jsxs = o, xn;
}
process.env.NODE_ENV === "production" ? Ro.exports = WE() : Ro.exports = FE();
var yl = Ro.exports;
const lh = new Fh(), P5 = ({ dAppName: t, dAppDescription: e, dAppUrl: r, dAppIconURL: s, children: n, debugQuery: i = !1 }) => (xr(() => {
  Cw({
    dAppName: t,
    dAppDescription: e,
    dAppUrl: r,
    dAppIconURL: s
  }), _l.defaultMaxListeners = 100;
}, []), /* @__PURE__ */ yl.jsxs(Wh, { client: lh, children: [
  i && /* @__PURE__ */ yl.jsx(Hh, { initialIsOpen: !1 }),
  n
] })), C5 = async () => {
  const t = await yt(), e = await t.getSession();
  if (!e || !t)
    return { error: "no session or connection" };
  try {
    return await t.request({
      topic: e.topic,
      chainId: "aleo:1",
      request: {
        jsonrpc: "2.0",
        method: "getSelectedAccount"
      }
    });
  } catch (r) {
    const s = r.message;
    return console.error("getAccount error", s), { error: s };
  }
}, N5 = async ({ address: t }) => {
  const e = await yt(), r = await e.getSession();
  if (!r || !e)
    return { error: "no session or connection" };
  try {
    return await e.request({
      topic: r.topic,
      chainId: "aleo:1",
      request: {
        jsonrpc: "2.0",
        method: "getBalance",
        params: {
          assetId: void 0,
          address: t
        }
      }
    });
  } catch (s) {
    const n = s.message;
    return console.error("getBalance error", n), { error: n };
  }
}, k5 = async () => {
  const t = await yt();
  if (!t)
    throw new Error("call setConnection() first!");
  const e = await t.getSession();
  if (e)
    return console.log("Already connected!", e), e;
  try {
    const r = await t.connect({
      requiredNamespaces: {
        aleo: {
          methods: wl,
          chains: Ao,
          events: El
        }
      }
    });
    return Di.emit("session_change"), window.localStorage.removeItem("WALLETCONNECT_DEEPLINK_CHOICE"), r;
  } catch (r) {
    console.error("connect error", r.message);
  }
}, R5 = async (t) => {
  const e = await yt(), r = await (e == null ? void 0 : e.getSession());
  if (!r || !e)
    return { error: "no session or connection" };
  const s = t == null ? void 0 : t.inputs.map((n) => typeof n == "string" ? n : n.plaintext);
  try {
    return await e.request({
      topic: r.topic,
      chainId: "aleo:1",
      request: {
        jsonrpc: "2.0",
        method: "requestCreateEvent",
        params: {
          ...t,
          inputs: s
        }
      }
    });
  } catch (n) {
    const i = n.message;
    return console.error("createEvent error", i), { error: i };
  }
}, A5 = async () => {
  const t = await yt(), e = await (t == null ? void 0 : t.getSession());
  if (!e || !t)
    return { error: "no session or connection" };
  try {
    return await t.request({
      topic: e.topic,
      chainId: "aleo:1",
      request: {
        jsonrpc: "2.0",
        method: "createSharedState",
        params: {}
      }
    });
  } catch (r) {
    const s = r.message;
    return console.error("createSharedState error", s), { error: s };
  }
}, j5 = async (t) => {
  const e = await yt(), r = await (e == null ? void 0 : e.getSession());
  if (!r || !e)
    return { error: "no session or connection" };
  try {
    return await e.request({
      topic: r.topic,
      chainId: "aleo:1",
      request: {
        jsonrpc: "2.0",
        method: "decrypt",
        params: {
          ciphertexts: t
        }
      }
    });
  } catch (s) {
    return console.error("decrypt error", s.message), { error: s.message };
  }
}, L5 = async () => {
  const t = await yt(), e = await (t == null ? void 0 : t.getSession());
  if (!e || !t)
    return { error: "no session or connection" };
  try {
    try {
      await t.disconnect({
        reason: bl("USER_DISCONNECTED"),
        topic: e.topic
      }), Di.emit("session_change");
    } catch (r) {
      console.warn(r);
    }
    return {};
  } catch (r) {
    const s = r.message;
    return console.error("error disconnecting", s), { error: s };
  }
}, M5 = async ({
  id: t,
  address: e
}) => {
  const r = await yt(), s = await (r == null ? void 0 : r.getSession());
  if (!s || !r)
    return { event: void 0, error: "no session or connection" };
  const n = async () => await r.request({
    topic: s.topic,
    chainId: "aleo:1",
    request: {
      jsonrpc: "2.0",
      method: "getEvent",
      params: {
        id: t,
        address: e
      }
    }
  });
  try {
    return await n();
  } catch (i) {
    const o = i.message;
    return console.error("getEvents error", o), { error: o };
  }
}, D5 = async (t) => {
  const e = await yt(), r = await (e == null ? void 0 : e.getSession());
  if (!r || !e)
    return { events: void 0, error: "no session or connection" };
  (t == null ? void 0 : t.programId) === "" && (t.programId = void 0);
  const s = async (n = 0) => await e.request({
    topic: r.topic,
    chainId: "aleo:1",
    request: {
      jsonrpc: "2.0",
      method: "getEvents",
      params: {
        filter: t,
        page: n
      }
    }
  });
  try {
    return await s();
  } catch (n) {
    const i = n.message;
    return console.error("getEvents error", i), { error: i };
  }
}, U5 = async (t) => {
  const e = await yt(), r = await (e == null ? void 0 : e.getSession());
  if (!r || !e)
    return { error: "no session or connection" };
  try {
    return await e.request({
      topic: r.topic,
      chainId: "aleo:1",
      request: {
        jsonrpc: "2.0",
        method: "importSharedState",
        params: {
          seed: t
        }
      }
    });
  } catch (s) {
    const n = s.message;
    return console.error("importSharedState error", n), { error: n };
  }
}, z5 = async ({
  address: t,
  filter: e,
  page: r = 0
}) => {
  const s = await yt(), n = await (s == null ? void 0 : s.getSession());
  if (!n || !s)
    return { error: "no session or connection" };
  const i = async (o = 0) => await s.request({
    topic: n.topic,
    chainId: "aleo:1",
    request: {
      jsonrpc: "2.0",
      method: "getRecords",
      params: {
        address: t,
        filter: e,
        page: o
      }
    }
  });
  try {
    return await i();
  } catch (o) {
    const a = o.message;
    return console.error("getRecords error", a), { error: a };
  }
}, $5 = async ({
  message: t,
  address: e
}) => {
  const r = await yt(), s = await (r == null ? void 0 : r.getSession());
  if (!s || !r)
    return { error: "no session or connection" };
  try {
    return await r.request({
      topic: s.topic,
      chainId: "aleo:1",
      request: {
        jsonrpc: "2.0",
        method: "requestSignature",
        params: {
          message: t,
          address: ic.test(e ?? "") ? e : void 0
        }
      }
    });
  } catch (n) {
    const i = n.message;
    return console.error("signature error", i), { error: i };
  }
}, V5 = 20;
export {
  V5 as $,
  fl as A,
  VE as B,
  zE as C,
  i5 as D,
  Co as E,
  $E as F,
  qE as G,
  vr as H,
  ZE as I,
  lp as J,
  UE as K,
  m5 as L,
  I5 as M,
  ko as N,
  Ol as O,
  P5 as P,
  S5 as Q,
  b5 as R,
  x5 as S,
  v5 as T,
  _5 as U,
  No as V,
  xc as W,
  w5 as X,
  E5 as Y,
  y5 as Z,
  O5 as _,
  s5 as a,
  C5 as a0,
  N5 as a1,
  k5 as a2,
  R5 as a3,
  A5 as a4,
  j5 as a5,
  L5 as a6,
  M5 as a7,
  D5 as a8,
  U5 as a9,
  z5 as aa,
  $5 as ab,
  wl as ac,
  Ao as ad,
  El as ae,
  Bh as af,
  Gh as ag,
  e5 as ah,
  uh as ai,
  Di as aj,
  t5 as ak,
  yt as al,
  a5 as b,
  o5 as c,
  c5 as d,
  u5 as e,
  l5 as f,
  d5 as g,
  sn as h,
  h5 as i,
  p5 as j,
  f5 as k,
  g5 as l,
  T5 as m,
  Sl as n,
  si as o,
  Yh as p,
  Il as q,
  Ca as r,
  Za as s,
  pr as t,
  r5 as u,
  lh as v,
  qt as w,
  n5 as x,
  Po as y,
  ic as z
};
